package examples.montecarlo;

import jsl.utilities.random.distributions.DUniform;
import jsl.utilities.random.distributions.Distribution;

public class Dice {

	private int qty;
	private Distribution d;
	private int size;
	private static final int REG_SIZE=6;
	private static final int REG_QTY=6;
	
	public Dice(){
		this(REG_SIZE,REG_QTY,new DUniform(1,REG_SIZE));
	}
	
	public Dice(int qty){
		this(REG_SIZE,qty,new DUniform(1,REG_SIZE));
	}
	
	public Dice(int size,int qty,Distribution d){
		this.qty=qty;
		this.size=size;
		this.d=d;
	}
	int roll(){
		int firstDice=(int)d.getValue();
		int secondDice=(int)d.getValue();
		System.out.println("firstDice="+firstDice+" SecondDice="+secondDice);
		return firstDice+secondDice;
	}
	
	public static void main(String[] args) {

		Dice d = new Dice();
		
		System.out.println("5 rolls");
		diceRolls(d, 5);
		System.out.println("---------------");
		System.out.println("2 runs of 5 rolls");
		for (int i=1;i<=2;i++){
			diceRolls(d,5);
			System.out.println("---------------");
		}
		
	}
	
	public static void diceRolls(Dice d, int n){
		for (int i=1;i<=n;i++){
			int roll = d.roll();
			System.out.println("The dice sum was " + roll);
		}		
	}
	
}

