package examples.montecarlo;

import jsl.utilities.random.RandomIfc;
import jsl.utilities.random.distributions.DUniform;
import jsl.utilities.statistic.Statistic;

public class MatchProblem {

	private boolean[] myMatches;
	
	private RandomIfc myMatchNum;
	
	public MatchProblem(int numMatches){
		myMatches = new boolean[numMatches];
		myMatchNum = new DUniform(0,numMatches-1);
	}
	
	public void initialize(){
		for(int i=0; i<myMatches.length;i++)
			myMatches[i] = false;
	}
	
	public int getNumberOfTrialsUntilAllMatch(){
		int count = 0;
		int matchesFound = 0;
		while (matchesFound < myMatches.length){
			count++;
			int match = (int)myMatchNum.getValue();
			if (myMatches[match] == false){
				matchesFound++;
			}
			myMatches[match] = true;
		}
		return(count);
	}
	
	public static void main(String[] args) {
	
		Statistic s = new Statistic("Number Of Trials Until All Matches Found");
		MatchProblem m = new MatchProblem(365);
		int numReplications = 100000;
		for(int i=1;i<=numReplications;i++){
			m.initialize();
			s.collect(m.getNumberOfTrialsUntilAllMatch());
		}
		
		System.out.println(s);
	}
}
