/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package examples.practice;

import jsl.modeling.Experiment;
import jsl.modeling.JSLEvent;
import jsl.modeling.Model;
import jsl.modeling.ModelElement;
import jsl.modeling.SchedulingElement;
import jsl.modeling.elements.variable.Counter;
import jsl.modeling.elements.variable.RandomVariable;
import jsl.utilities.random.distributions.Exponential;

/**
 *
 * @author rossetti
 */
public class SimplePoissonProcess extends SchedulingElement {

    protected RandomVariable myTBE;

    protected Counter myCount;

    protected int n = 0;

    public SimplePoissonProcess(ModelElement parent) {
        this(parent, null);
    }

    public SimplePoissonProcess(ModelElement parent, String name) {
        super(parent, name);

        Exponential e = new Exponential();
        myTBE = new RandomVariable(this, e);

        myCount = new Counter(this, "Counts events");

    }

    @Override
    protected void initialize() {
        super.initialize();
        // schedule the first event to start the process
        // get the time until next event
        double t = myTBE.getValue();
        this.scheduleEvent(t);
    }

    @Override
    protected void handleEvent(JSLEvent event) {
        super.handleEvent(event);
        myCount.increment();
        n++;
        System.out.println("replication = " + this.getModel().getReplication().getReplicationNumber());
        System.out.println("n = " + n);
        System.out.println("counter = " + myCount.getValue());
        System.out.println("event at time t = " + event.getTime());

        double t = myTBE.getValue();
        this.scheduleEvent(t);
    }


    public static void main(String[] args) {

        Model m = Model.createModel("Simple PP");

        SimplePoissonProcess spp = new SimplePoissonProcess(m);

        Experiment e = new Experiment(m);

        e.setLengthOfReplication(100.0);
        e.setNumberOfReplications(2);
        e.turnOnExperimentConsoleOutput();
        e.turnOnExperimentReport("manuel");
		e.runAll();
		System.out.println("Done!");

    }


}
