package jsl.modeling.elements.variable;

import jsl.utilities.statistic.StatisticAccessorIfc;

public interface WithinReplicationStatisticIfc {

	/** Returns a StatisticAccessorIfc for the within replication statistics
	 *  that have been collected on this ResponseVariable
	 * 
	 * @return
	 */
	public abstract StatisticAccessorIfc getWithinReplicationStatistic();

	/** A convenience method to get the within replication average from
	 *  the underlying StatisticalObserver.  For other statistics use
	 *  getWithinReplicationStatistic()
	 * 
	 * @return
	 */
	public abstract double getWithinReplicationAverage();

	/**
	 * @param name
	 * @see jsl.observers.variable.StatisticalObserver#setWithinReplicationStatisticName(java.lang.String)
	 */
	public abstract void setWithinReplicationStatisticName(String name);

}