/*
* Created on Feb 21, 2007
* Copyright (c) 2007, Manuel D. Rossetti (rossetti@uark.edu)
*
* Contact:
*	Manuel D. Rossetti, Ph.D., P.E. 
*	Department of Industrial Engineering 
*	University of Arkansas 
*	4207 Bell Engineering Center 
*	Fayetteville, AR 72701 
*	Phone: (479) 575-6756 
*	Email: rossetti@uark.edu 
*	Web: www.uark.edu/~rossetti
*
* This file is part of the JSL (a Java Simulation Library). The JSL is a framework
* of Java classes that permit the easy development and execution of discrete event
* simulation programs.
*
* The JSL is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* The JSL is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with the JSL (see file COPYING in the distribution); 
* if not, write to the Free Software Foundation, Inc., 51 Franklin St, Fifth Floor, 
* Boston, MA  02110-1301  USA, or see www.fsf.org
* 
*/
package jsl.utilities.statistic;

import jsl.utilities.random.distributions.DistributionIfc;
import jsl.utilities.random.distributions.Gamma;
import jsl.utilities.random.distributions.Uniform;


/**
 * @author rossetti
 *
 */
public class TestStatistic {

	/**
	 * @param args
	 */
	public static void main(String[] args) {


		DistributionIfc r = new Gamma(23.0, 9.0);
		
		double[] data = r.getSample(365);
		for(double d:data)
			System.out.println(d);
		System.out.println();

        Statistic stat = new Statistic();
		stat.collect(data);
		System.out.println(stat);

        /*
		System.out.println("Median = " + Statistic.getMedian(data));
		for(double d:data)
			System.out.println(d);
		System.out.println();
		
		
		Statistic stat = new Statistic();
		stat.setSaveDataOption(true);
		stat.collect(data);
		System.out.println(stat);
		System.out.println();
		StringBuilder sb = new StringBuilder();
		stat.makeCSVStatistic(sb);
		System.out.println(sb);
		System.out.println();
		double[] x = stat.getSavedData();
		for(double d:x)
			System.out.println(d);
		
		//double[] y = {9,6,9,6,9,6,9,6,9,6,9,6,9,6,9,6,9,6,9,6,9,6,9,6,9,6,9,6,9,6,9,6,9,6,9,6};
		double[] y = {9,6,9};
		//double[] y = {47,64,23,71,38,64,55,41,59,48,71,35,57,40,58,44,80,55,37,74,51,57,50,60,45,57,50,45,25,59,50,71,56,74,50,58,45,54,36,54,48,55,45,57,50,62,44,64,43,52,38,59,55,41,53,49,34,35,54,45,68,38,50,60,39,59,40,57,54,23};
		Statistic yStat = new Statistic(y);
		System.out.println(yStat);
 */

 /*		
        double[] x = stat.getStatistics();
    	stat.getStatistics(x);
    	StringBuilder sb = new StringBuilder();
    	for(int i=0; i< x.length; i++){
    		if (Double.isNaN(x[i]) || Double.isInfinite(x[i]))
    			sb.append("");
    		else
    			sb.append(x[i]);
    		if (i < x.length - 1)
    			sb.append(",");
    	}
    	
    	System.out.println(sb.toString());
*/  
	}

}
