/**
 * 
 */
package jslx.forecasting;

import java.util.Observable;
import java.util.Observer;

/**
 * @author rossetti
 *
 */
public class ForecastPrinter implements Observer {


	/* (non-Javadoc)
	 * @see java.util.Observer#update(java.util.Observable, java.lang.Object)
	 */
	public void update(Observable o, Object arg) {
		ForecastTechnique ft = (ForecastTechnique)o;
		
		// get the current observer state, message
		int cs = ft.getObserverState();	
		
		/*  forecast can be either U = uninitialized or I = initialized
		 *  message can be either RESET or NEW_DATA
		 *  NEW_DATA and U: 
		 *  NEW_DATA and I:
		 *  RESET and U:
		 *  RESET and I: Not possible
		 *  
		 */
		
		int t = ft.getTimeIndex();
		double px = ft.getPrevObservation();
		double x = ft.getObservation();
		double pf = ft.getCurrentPeriodForecast();
		double f = ft.getNextPeriodForecast();
		double e = ft.getError();

		if ((cs == ForecastTechnique.RESET)){
			System.out.println("State \t t \t x(t-1) \t x(t) \t f(t) \t e(t)  \t f(t+1)");
			System.out.println("Reset \t " + t + "\t " + px + "\t " + x + "\t " + pf + "\t " + e + "\t " + f);						
		}

		if (cs == ForecastTechnique.NEW_DATA){
			System.out.println("New \t " + t + "\t " + px + "\t " + x + "\t " + pf + "\t " + e + "\t " + f);			
		}
		
	}

}
