/**
 * 
 */
package jslx.forecasting;



import jsl.utilities.random.distributions.Normal;

/**
 * @author rossetti
 *
 */
public class ForecastTester {


	
	/**
	 * @param args
	 */
	public static void main(String[] args) {

//		test1SimpleExponentialSmoothing();
//	    test2SimpleExponentialSmoothing();
//		test3SimpleExponentialSmoothing();
//		test4aMovingAverage();
		test4bMovingAverage();
// 		test5aCroston();
// 		test5bCroston();
//		test6SyntetosBoylan();
//		test7AverageDemand();
//		test8MCARTA();		
//		test9Croston();
		
	}
	
	public static void test1SimpleExponentialSmoothing(){
		System.out.println("Forecast Testing");
		Normal n = new Normal(10.0, 2.0);
		
		double[] data = n.getSample(10);
		
		System.out.println("The data");
		for (double x: data)
			System.out.println(x);
		
		System.out.println();
		
		DataSourceArray ds = new DataSourceArray(data);
		
		System.out.println(ds);
		
		SimpleExponentialSmoothing ft = new SimpleExponentialSmoothing();
		
		ForecastPrinter fp = new ForecastPrinter();
		
		ft.addObserver(fp);
		
		/*ds.addObserver(ft);		
		ds.iterateAll();*/
		
		ds.reset();
		while(ds.hasNext()){
			double d = ds.next();
			ft.collect(d);
		}
		
		System.out.println("MAD: "+ft.getMAD());
		System.out.println("MSE: "+ft.getMSE());
		System.out.println("MAPE: "+ft.getMAPE());
		
	}
	
	public static void test2SimpleExponentialSmoothing(){
		System.out.println("Forecast Testing");
		
		double[] data = {200, 250, 175, 186, 225, 285, 305, 190};
		
		System.out.println("The data");
		
		for (double x: data)
			System.out.println(x);
		
		System.out.println();
		
		
		SimpleExponentialSmoothing ft = new SimpleExponentialSmoothing(0.1);
		
		System.out.println("i \t t \t x(t-1) \t x(t) \t f(t) \t e(t)  \t f(t+1)");
		for (int i = 0;i < data.length; i++){
			ft.collect(data[i]);
			int t = ft.getTimeIndex();
			double px = ft.getPrevObservation();
			double x = ft.getObservation();
			double pf = ft.getCurrentPeriodForecast();
			double f = ft.getNextPeriodForecast();
			double e = ft.getError();
			System.out.println(i + "\t " + t + "\t " + px + "\t " + x + "\t " + pf + "\t " + e + "\t " + f);			
		}
	}

	public static void test3SimpleExponentialSmoothing(){
		System.out.println("Forecast Testing");
		
		//double[] data = {200, 250, 175, 186, 225, 285, 305, 190};
		
		double[] data1 = {200};
		double[] data2 = {250, 175, 186, 225, 285, 305, 190};
		
		System.out.println("The data");
		
		for (double x: data2)
			System.out.println(x);
		
		System.out.println();
		
		DataSourceArray ds = new DataSourceArray(data2);
		
		System.out.println(ds);
		
		SimpleExponentialSmoothing ft = new SimpleExponentialSmoothing(0.1);
		
		ft.initializeHistory(data1, null, null);
		//System.out.println(ft.myNextPeriodForecast);
				
		ForecastPrinter fp = new ForecastPrinter();		
		ft.addObserver(fp);			
		
		/*ds.addObserver(ft);		
		ds.iterateAll();*/
		
		while(ds.hasNext()){
			double d = ds.next();
			ft.collect(d);
		}
		
		
	}

	public static void test4aMovingAverage(){
		System.out.println("Forecast Testing");
		
		double[] data = {200, 250, 175, 186, 225, 285, 305, 190};
		
		System.out.println("The data");
		for (double x: data)
			System.out.println(x);
		System.out.println();
		
		DataSourceArray ds = new DataSourceArray(data);
		
		System.out.println(ds);
		
		MovingAverage ft = new MovingAverage(3);
		//ft.initializeHistory(data, data, null);
		ds.addObserver(ft);
		
		ForecastPrinter fp = new ForecastPrinter();
		
		ft.addObserver(fp);
		
		ds.iterateAll();	
	}

	public static void test4bMovingAverage(){
		System.out.println("Forecast Testing: Croston");
		
		double[] data1 = {0,	1,	0,	1,	0,	2,	
                0,	2,	0,	1,	0,	0,	2,	0,	
                2,	0,	2,	0,	2,	0,	0,	2,	
                0,	0,	3,	0,	2,	0,	0,	1,	
                0,	2,	0,	1,	0,	2,	0,	0,	
                3,	0,	2,	0,	1,	0,	2,	0,	
                2,	0,	2,	1,	0,	3,	0,	2,	
                0,	1,	0,	2,	0,	3,	0,	1,	
                0,	1,	0,	1,	0,	1,	0,	4,	
                0,	2,	0,	1,	0,	1,	0,	3,	
                0,	0,	1,	0,	0,	1,	0,	2,	
                0,	2,	0,	1,	2,	0,	1,	0,	
                3,	0,	1,	0,	2,	4,	0};
                
		double[] data2 = {3,	0,	0,	2,	0,	1,	
                0,	1,	0,	4,	0,	1,	0,	2,	
                0,	2,	0,	1,	0,	4,	3,	3,	
                0,	2,	0,	1,	0,	1,	0,	1,	
                0,	3,	0,	3,	0,	1,	2,	0,	
                1,	0,	2,	0,	2,	0,	1,	0,	
                2,	0,	3,	0,	1,	0,	1,	0,	
                2,	0,	2,	0,	1,	0,	1,	0,	
                2,	0,	5,	0,	1,	0,	1,	1,	
                0,	1,	0,	1,	0,	2,	1,	0,	
                2,	0,	1,	0,	1,	0,	3,	0,	
                1,	0,	1,	0,	1,	0,	0,	2,	
                0,	2,	0,	2,	0,	1,	0,	3,	
                0,	1,	0,	0,	3,	0,	2,	0,	
                1,	0,	3,	0,	3,	0,	3,	0,	
                3,	0,	2,	2,	0,	2,	1,	0,	
                2,	0,	1,	0,	3,	0,	0,	4,	
                0,	2,	0,	0,	2,	0,	2,	0,	
                2,	0,	3,	0,	1,	3,	0,	1,	
                0,	2,	0,	1,	0,	1,	2,	0,	
                1,	1,	0,	1,	0,	1,	0,	2,	
                0,	2,	0,	3,	0,	0,	2,	0,	
                0,	3,	0,	1,	0,	2,	0,	1,	
                0,	3,	0,	2,	0,	0,	3,	0,	
                1,	0,	3,	0,	1,	0,	2,	0,	
                1,	0};
		
		System.out.println("The history");
		for (double x: data1)
			System.out.println(x);
		System.out.println();
		
		System.out.println("The data");
		for (double x: data2)
			System.out.println(x);
		System.out.println();
		
		DataSourceArray ds = new DataSourceArray(data2);
		
		System.out.println(ds);
		
		MovingAverage ft = new MovingAverage(19);
		ft.initializeHistory(data1, null, ft.estimateInitialForecastParameter(data1));
				
		ForecastPrinter fp = new ForecastPrinter();
		
		ft.addObserver(fp);
		
		/*ds.addObserver(ft);		
		ds.iterateAll();*/	
		
		while(ds.hasNext()){
			double d = ds.next();
			ft.collect(d);
                        //System.out.println(ft.getNextPeriodForecast());
		}
		
		
	}

	public static void test5aCroston(){
		System.out.println("Forecast Testing: Croston");
		
		double[] data = {37, 5, 0, 14, 5, 0, 10, 10, 0, 0, 6, 20, 32, 5, 25, 38, 15, 6, 70, 0, 0, 0, 10, 0};
		
		System.out.println("The data");
		for (double x: data)
			System.out.println(x);
		System.out.println();
		
		DataSourceArray ds = new DataSourceArray(data);
		
		System.out.println(ds);
		
		Croston ft = new Croston(0.1);
		//ft.initializeHistory(data, data, null);
		ds.addObserver(ft);
		
		ForecastPrinter fp = new ForecastPrinter();
		
		ft.addObserver(fp);
		
		ds.iterateAll();	
	}

	public static void test5bCroston(){
		System.out.println("Forecast Testing: Croston");
		
		double[] data1 = {37, 5, 0, 14};
		double[] data2 = {5, 0, 10, 10, 0, 0, 6, 20, 32, 5, 25, 38, 15, 6, 70, 0, 0, 0, 10, 0};
		
		System.out.println("The data");
		for (double x: data2)
			System.out.println(x);
		System.out.println();
		
		DataSourceArray ds = new DataSourceArray(data2);
		
		System.out.println(ds);
		
		Croston ft = new Croston(0.1);
		ft.initializeHistory(data1, null, null);
				
		ForecastPrinter fp = new ForecastPrinter();
		
		ft.addObserver(fp);
		
		/*ds.addObserver(ft);		
		ds.iterateAll();*/	
		
		while(ds.hasNext()){
			double d = ds.next();
			ft.collect(d);
		}
		
		
	}

	public static void test6SyntetosBoylan(){
		System.out.println("Forecast Testing: Syntetos Boylan");
		
		double[] data = {37, 5, 5, 14, 5, 0, 10, 10, 0, 0, 6, 20, 32, 5, 25, 38, 15, 6, 70, 0, 0, 0, 10, 0};
		
		System.out.println("The data");
		for (double x: data)
			System.out.println(x);
		System.out.println();
		
		DataSourceArray ds = new DataSourceArray(data);
		
		System.out.println(ds);
		
		SyntetosBoylan ft = new SyntetosBoylan(0.1);
		//ft.initializeHistory(data, data, null);
		ds.addObserver(ft);
		
		ForecastPrinter fp = new ForecastPrinter();
		
		ft.addObserver(fp);
		
		ds.iterateAll();	
	}

	public static void test7AverageDemand(){
		System.out.println("Forecast Testing: Average Demand");
		
		double[] data = {37, 5, 0, 14, 5, 0, 10, 10, 0, 0, 6, 20, 32, 5, 25, 38, 15, 6, 70, 0, 0, 0, 10, 0};
		
		System.out.println("The data");
		for (double x: data)
			System.out.println(x);
		System.out.println();
		
		DataSourceArray ds = new DataSourceArray(data);
		
		System.out.println(ds);
		
		AverageDemand ft = new AverageDemand(0.1);
		//ft.initializeHistory(data, data, null);
		ds.addObserver(ft);
		
		ForecastPrinter fp = new ForecastPrinter();
		
		ft.addObserver(fp);
		
		ds.iterateAll();
		
		System.out.println(ft.getMapParameterLabelToValue());
	}
	


	public static void test8MCARTA(){
		System.out.println("Forecast Testing: Average Demand");
		
		/*double[] data = {37, 0, 0, 0, 0, 0, 5, 0, 0, 0, 14, 5, 0, 10, 0, 0, 
				10, 0, 0, 6, 20, 32, 5, 25, 0, 0, 0, 0, 38, 15, 6, 70, 0, 0, 0, 10, 0, 
				37, 5, 0, 14, 0, 0, 0, 0, 5, 0, 10, 0, 0, 0, 0, 10, 0, 0, 6, 20, 0, 0, 
				0, 32, 0, 5, 25, 38, 0, 0, 15, 0, 0, 6, 70, 0, 0, 0, 10, 0};*/
		double[] data = {9.0, 0.0, 6.0, 0.0, 9.0, 0.0, 11.0, 0.0, 10.0, 0.0, 9.0, 
				0.0, 11.0, 0.0, 2.0, 0.0, 7.0, 0.0, 0.0, 8.0, 0.0, 8.0, 0.0, 3.0, 
				0.0, 6.0, 0.0, 0.0, 9.0, 0.0, 9.0, 0.0, 8.0, 0.0, 9.0, 0.0, 0.0, 
				7.0, 0.0, 6.0, 0.0, 3.0, 0.0, 12.0, 0.0, 7.0, 0.0, 10.0, 0.0, 
				8.0, 0.0, 8.0, 0.0, 10.0, 0.0, 8.0, 0.0, 0.0, 10.0, 0.0, 6.0, 
				0.0, 5.0, 11.0, 0.0, 8.0, 0.0, 7.0, 0.0, 9.0, 0.0, 5.0, 0.0, 
				5.0, 0.0, 9.0, 0.0, 6.0, 0.0, 7.0, 0.0, 6.0, 0.0, 4.0, 0.0, 5.0, 
				0.0, 4.0, 0.0, 6.0, 0.0, 8.0, 0.0, 6.0, 0.0, 5.0, 0.0, 10.0, 0.0, 
				12.0, 0.0, 5.0, 0.0, 7.0, 0.0, 5.0, 0.0, 7.0, 0.0, 0.0, 6.0, 0.0, 
				10.0, 0.0, 7.0, 0.0, 8.0, 0.0, 7.0, 0.0, 6.0, 0.0, 11.0, 0.0, 4.0, 
				0.0, 6.0, 7.0, 0.0, 10.0, 0.0, 8.0, 0.0, 7.0, 0.0, 5.0, 0.0, 0.0, 0.0, 
				7.0, 0.0, 12.0, 0.0, 10.0, 0.0, 13.0, 0.0, 8.0, 0.0, 6.0, 0.0, 6.0, 0.0, 
				10.0, 0.0, 7.0, 0.0, 0.0, 6.0, 0.0, 8.0, 0.0, 11.0, 0.0, 7.0, 0.0, 8.0, 
				0.0, 7.0, 0.0, 9.0, 9.0, 8.0, 0.0, 5.0, 0.0, 7.0, 0.0, 11.0, 0.0, 4.0, 
				0.0, 15.0, 0.0, 13.0, 6.0, 0.0, 4.0, 0.0, 10.0, 0.0, 6.0, 0.0, 8.0, 0.0, 
				6.0, 0.0, 0.0, 5.0, 0.0, 9.0, 0.0, 6.0, 0.0, 6.0, 0.0, 11.0, 7.0, 0.0, 
				8.0, 0.0, 4.0, 0.0, 8.0, 0.0, 10.0, 0.0, 8.0, 0.0, 7.0, 0.0, 12.0, 7.0, 
				0.0, 6.0, 0.0, 11.0, 0.0, 6.0, 3.0, 0.0, 6.0, 0.0, 0.0, 8.0, 0.0, 13.0, 
				0.0, 13.0, 0.0, 6.0, 0.0, 5.0, 9.0, 0.0, 9.0, 0.0, 5.0, 0.0, 7.0, 0.0, 4.0, 
				0.0, 6.0, 0.0, 5.0, 0.0, 15.0, 0.0, 9.0, 0.0, 7.0, 0.0, 10.0, 0.0, 6.0, 9.0, 
				0.0, 11.0, 0.0, 11.0, 0.0, 0.0, 11.0, 0.0, 11.0, 0.0, 11.0, 0.0, 4.0, 0.0, 
				3.0, 0.0, 13.0, 0.0, 8.0, 0.0, 4.0, 0.0, 7.0, 0.0, 8.0, 0.0, 11.0, 0.0, 6.0, 
				0.0, 11.0, 0.0, 7.0, 0.0, 9.0, 0.0, 11.0, 0.0, 12.0, 0.0, 7.0, 0.0, 8.0, 0.0, 
				8.0, 0.0, 7.0, 0.0, 8.0, 0.0, 11.0, 0.0, 4.0, 0.0, 7.0, 0.0, 10.0, 0.0, 8.0, 
				0.0, 7.0, 0.0, 7.0, 0.0, 0.0, 4.0, 0.0, 4.0, 0.0, 5.0, 0.0, 8.0, 0.0, 8.0, 
				0.0, 0.0, 7.0, 0.0, 8.0, 0.0, 6.0, 0.0, 7.0, 0.0, 10.0, 0.0, 6.0, 0.0, 4.0, 
				0.0, 9.0, 0.0, 9.0, 0.0, 13.0, 0.0, 11.0, 0.0, 11.0, 0.0, 4.0, 0.0, 7.0, 0.0, 
				5.0, 0.0, 11.0, 0.0, 12.0, 0.0, 8.0, 0.0, 3.0, 0.0, 13.0, 0.0, 13.0, 0.0, 9.0, 
				0.0, 6.0, 0.0, 5.0, 0.0, 9.0, 0.0, 9.0, 7.0, 0.0, 9.0, 0.0, 7.0, 0.0, 6.0, 0.0, 
				8.0, 0.0, 7.0, 0.0, 6.0, 7.0, 0.0, 6.0, 0.0, 0.0, 0.0, 11.0, 0.0, 9.0, 0.0, 6.0, 
				0.0, 5.0, 0.0, 0.0, 6.0, 0.0, 13.0, 0.0, 11.0, 0.0, 6.0, 0.0, 0.0, 8.0, 0.0, 7.0, 
				0.0, 14.0, 0.0, 3.0, 0.0, 6.0, 0.0, 8.0, 6.0, 0.0, 6.0, 0.0, 13.0, 0.0, 5.0, 0.0, 
				5.0, 0.0, 10.0, 0.0, 7.0, 0.0, 0.0, 6.0, 0.0, 8.0, 0.0, 8.0, 0.0, 12.0, 0.0, 5.0, 
				0.0, 9.0, 16.0, 0.0, 6.0, 0.0, 5.0, 0.0, 3.0, 0.0, 14.0, 0.0, 9.0, 0.0, 3.0, 0.0, 
				9.0, 0.0, 9.0, 0.0, 5.0, 0.0, 7.0, 0.0, 5.0, 0.0, 8.0, 0.0, 6.0, 0.0, 8.0, 0.0, 8.0, 
				0.0};
		
		
		System.out.println("The data");
		for (double x: data)
			System.out.println(x);
		System.out.println();
		
		DataSourceArray ds = new DataSourceArray(data);		
		System.out.println(ds);
		
		double [] controlparameters = new double[4];
        double bootstrapsize = 1000;
        double reqdtrans = 3;
        double updatefreq = 1;
        double artamatchingfreq = 1;

        controlparameters[0] = bootstrapsize;
        controlparameters[1] = reqdtrans;
        controlparameters[2] = updatefreq;
        controlparameters[3] = artamatchingfreq;
		
		MCARTA ft = new MCARTA(controlparameters);
		
		ForecastPrinter fp = new ForecastPrinter();		
		ft.addObserver(fp);	
		
		ds.reset();
		while(ds.hasNext()){
			double d = ds.next();
			ft.collect(d);
		}
		
		System.out.println("MAD: "+ft.getMAD());
		System.out.println("MSE: "+ft.getMSE());
		System.out.println("MAPE: "+ft.getMAPE());
	}
	

	

	


	public static void test9Croston(){
		System.out.println("Croston 1972 Demand Series");
		
		double[] data = {5,0,0,0,3,2,5,0,0,0,0,3,0,0,0,0,0,0,0,0,
				0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,6,0,0,5,0,0,0,
				0,2,0,0,0,0,0,0,0,0,1,0,2,0,1,0,0,0,0,0,0,3,0,0,0,
				2,4,6,0,0,0,0,2,0,0,0,0,0,3,0,0,0,0,2,0,0,0,0,6,0,
				0,0,3,0,0,0,0,0,4,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,
				0,0,0,0,0,0,0,0,0,6,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,
				0,0,0,0,0,0,0,0,0,6,0,0,0,2,0,0,0,0,0,0,0,0,0,0,4,
				0,0,0,0,0,5,0,0,0,0};
		
		System.out.println("The data");
		for (double x: data)
			System.out.println(x);
		System.out.println();
		
		DataSourceArray ds = new DataSourceArray(data);
		
		System.out.println(ds);
		
		IntermittentDemandStatistic stat = new IntermittentDemandStatistic("Croston1972");
		
		Croston c = new Croston(0.1);
		
		ForecastPrinter fp = new ForecastPrinter();
		
		c.addObserver(fp);
		
		while(ds.hasNext()){
			double d = ds.next();
			c.collect(d);
			stat.collect(d);
		}
		
		/*System.out.println(stat.getDemandStat());
		
		System.out.println(stat.getNonZeroDemandStat());
		
		System.out.println(stat.getIntervalBetweenNonZeroDemandStat());
		
		System.out.println("Probabilities:");
		
		System.out.println(stat.getProbFailure());
		
		System.out.println(stat.getProbSuccessAfterFailure());
		
		System.out.println(stat.getProbSuccessAfterSuccess());
		
		System.out.println();
		
		double [] nzdemanddata = stat.getIntervalBetweenZeroDemandsData();
		
		for (double nz: nzdemanddata)
			System.out.println(nz);
		
		System.out.println();*/
		
	}


}
