package jslx.forecasting.demandgeneration;

import java.io.BufferedWriter;
import java.io.FileWriter;
import java.io.IOException;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.Statement;

import jslx.forecasting.IntermittentDemandStatistic;

/*
 * This class read from a text file with columns: niins, time index, demand
 * 
 */

public class ReadDemandDatabase {
	
	public Connection myConnection;
    public Statement myShareStatement;
    public Statement myUpdateStatement;
    private ResultSet myAllRecords;
    public String myNIIN;
        
    public ReadDemandDatabase(){
    	try{ 
        	String URL="jdbc:odbc:demanddata";
            Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");
            myConnection=DriverManager.getConnection(URL,"namp","namp");
            myShareStatement=myConnection.createStatement(ResultSet.TYPE_SCROLL_INSENSITIVE,ResultSet.CONCUR_READ_ONLY);
            myAllRecords=myShareStatement.executeQuery("SELECT * FROM NavSupDemand");            
        }       
        catch(Exception myError){
        	myError.printStackTrace();
            System.err.println(myError.getMessage());
            System.exit(-1);
        }        
        
        try {
	        BufferedWriter out = new BufferedWriter(new FileWriter("NZDemand" + ".csv"));
	        out.write("NIIN,NZDemand");
	        out.close();
	    }
		catch (IOException e1){
	    }
        try {
	        BufferedWriter out = new BufferedWriter(new FileWriter("IntervalBtwnNZDemands" + ".csv"));
	        out.write("NIIN,IntervalBtwnNZDemands");
	        out.close();
	    }
		catch (IOException e1){
	    }
        try {
	        BufferedWriter out = new BufferedWriter(new FileWriter("IntervalBtwnZDemands" + ".csv"));
	        out.write("NIIN,IntervalBtwnZDemands");
	        out.close();
	    }
		catch (IOException e1){
	    }
        try {
	        BufferedWriter out = new BufferedWriter(new FileWriter("DemandStatistics" + ".csv"));
	        out.write("NIIN,Count,Mean,Variance,Lag1Corr,NZCount,NZMean,NZVariance,NZLag1Corr,IntvlBtwnNZDemandsCount,IntvlBtwnNZDemandsMean," +
	        		"IntvlBtwnNZDemandsVariance,IntvlBtwnNZDemandsLag1Corr,IntvlBtwnZDemandsCount,IntvlBtwnZDemandsMean," +
	        		"IntvlBtwnZDemandsVariance,IntvlBtwnZDemandsLag1Corr,p11,p01,p0");
	        out.close();
	    }
		catch (IOException e1){
	    }
        
        for(int i=1; i<=9092; i++){
        	putDemand(i);
        }       
    }
    
    public void putDemand(int i){
    	try{
    		myAllRecords.absolute(i);
        	myNIIN = myAllRecords.getString("NIIN");
        	
        	IntermittentDemandStatistic stat = new IntermittentDemandStatistic();
                stat.setSaveDataOption(true);
                
        	for(int j=1;j<=127;j++){        		
        		double k=myAllRecords.getFloat("t"+j);
        		stat.collect(k);
        	}
        	
        	if((stat.getNonZeroDemandsData()!= null)&&(stat.getIntervalBetweenNonZeroDemandsData()!=null)
        			&& (stat.getIntervalBetweenZeroDemandsData()!=null)
        			&& (stat.getNonZeroDemandStat().getCount()>=38.0)
        			&& (stat.getIntervalBetweenNonZeroDemandStat().getCount()>=37.0)
        			&& (stat.getIntervalBetweenZeroDemandsStat().getCount()>=48)){
        		System.out.println(i+": X"+myNIIN +" READ");            	
            	double [] nzdemand = stat.getNonZeroDemandsData();
            	double [] intervalbtwnnzdemand = stat.getIntervalBetweenNonZeroDemandsData();
            	double [] intervalbtwnzdemand = stat.getIntervalBetweenZeroDemandsData();
        		updateTable(myNIIN, nzdemand, intervalbtwnnzdemand, intervalbtwnzdemand);
                try {
        	        BufferedWriter out = new BufferedWriter(new FileWriter("DemandStatistics" + ".csv",true));
        	        out.newLine();
        	        out.write("X"+myNIIN+","+stat.getStatistics()[0]+","+stat.getStatistics()[1]+","+stat.getStatistics()[2]+","+stat.getStatistics()[17]+
        	        		","+stat.getStatistics()[21]+","+stat.getStatistics()[22]+","+stat.getStatistics()[23]+","+stat.getStatistics()[38]+
        	        		","+stat.getStatistics()[42]+","+stat.getStatistics()[43]+","+stat.getStatistics()[44]+","+stat.getStatistics()[59]+
        	        		","+stat.getStatistics()[63]+","+stat.getStatistics()[64]+","+stat.getStatistics()[65]+","+stat.getStatistics()[80]+
        	        		","+stat.getProbSuccessAfterSuccess()+","+stat.getProbSuccessAfterFailure()+","+stat.getProbFailure());
        	        out.close();
        	    }
        		catch (IOException e1){
        	    }
        		
        	}else{
        		System.out.println(i+": X"+myNIIN +" NOT READ");       		
        	}
        	
        }       
        catch(Exception myError){
        	myError.printStackTrace();
            System.err.println(myError.getMessage());
        }
    }
    
    public void updateTable(String s, double [] nzd, double [] ibnzd, double [] ibzd){
    	for(int i = 0; i<nzd.length; i++){
    		try {
    	        BufferedWriter out = new BufferedWriter(new FileWriter("NZDemand" + ".csv",true));
    	        out.newLine();
    	        out.write("X"+s+","+nzd[i]);
    	        out.close();
    	    } 
    		catch (IOException e1){	
    	    }
    		
    	}
    	for(int i = 0; i<ibnzd.length; i++){
    		try {
    	        BufferedWriter out = new BufferedWriter(new FileWriter("IntervalBtwnNZDemands" + ".csv",true));
    	        out.newLine();
    	        out.write("X"+s+","+ibnzd[i]);
    	        out.close();
    	    } 
    		catch (IOException e1){	
    	    }
    		
    	}
    	for(int i = 0; i<ibzd.length; i++){
    		try {
    	        BufferedWriter out = new BufferedWriter(new FileWriter("IntervalBtwnZDemands" + ".csv",true));
    	        out.newLine();
    	        out.write("X"+s+","+ibzd[i]);
    	        out.close();
    	    } 
    		catch (IOException e1){	
    	    }    		
    	}
    	
    }


	

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		ReadDemandDatabase n1=new ReadDemandDatabase();
		try{
			n1.myConnection.close();                      
        }       
        catch(Exception myError){
        	myError.printStackTrace();
            System.err.println(myError.getMessage());
        }

	}

}
