package jslx.forecasting.demandgeneration;

import java.io.BufferedWriter;
import java.io.FileWriter;
import java.io.IOException;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.Statement;

import jsl.utilities.statistic.Statistic;
import jslx.forecasting.IntermittentDemandStatistic;

/*
 * This class read from a text file with columns: niins, time index, demand
 * 
 */

public class TestBatchOnOffDG {
	
	public Connection myConnection;
    public Statement myShareStatement;
    public Statement myUpdateStatement;
    private ResultSet myAllRecords;
    public String myNIIN; 
    
    public int myRunLength = 500;
    public int myReplications = 100;
    
    public String [] myArrayNIIN;
    
        
    public TestBatchOnOffDG(){
    	try{ 
        	String URL="jdbc:odbc:demanddata";
            Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");
            myConnection=DriverManager.getConnection(URL,"namp","namp");
            myShareStatement=myConnection.createStatement(ResultSet.TYPE_SCROLL_INSENSITIVE,ResultSet.CONCUR_READ_ONLY);
            //myAllRecords=myShareStatement.executeQuery("SELECT * FROM DemandStatisticsLong");            
        }       
        catch(Exception myError){
        	myError.printStackTrace();
            System.err.println(myError.getMessage());
            System.exit(-1);
        } 
        try {
	        BufferedWriter out = new BufferedWriter(new FileWriter("TestBatchOnOffDGShortFile" + ".csv"));
	        out.write("NIIN,IPNZMean,IPIntvlBtwnNZDemandsMean," + "IPIntvlBtwnZDemandsMean," +
	        		"OPNZMean,OPIntvlBtwnNZDemandsMean,OPIntvlBtwnZDemandsMean,");

	        out.close();
	    }
		catch (IOException e1){
	    }
		try {
	        BufferedWriter out = new BufferedWriter(new FileWriter("TestBatchOnOffDGLongFile" + ".csv"));
	        out.write("NIIN,Real_Count,Real_Mean,Real_Variance,Real_Lag1CorrCoeff,Real_CoeffOfVar,Real_VarToMeanRatio," +
	        		"Real_NZ_Count,Real_NZ_Mean,Real_NZ_Variance,Real_NZ_Lag1CorrCoeff,Real_NZ_CoeffOfVar,Real_NZ_VarToMeanRatio," +
	        		"Real_IdlePeriod_Count,Real_IdlePeriod_Mean,Real_IdlePeriod_Variance,Real_IdlePeriod_Lag1CorrCoeff,Real_IdlePeriod_CoeffOfVar,Real_IdlePeriod_VarToMeanRatio," +
	        		"Real_BusyPeriod_Count,Real_BusyPeriod_Mean,Real_BusyPeriod_Variance,Real_BusyPeriod_Lag1CorrCeoff,Real_BusyPeriod_CoeffOfVar,Real_BusyPeriod_VarToMeanRatio,"+
	        		"Real_p11,Real_p01,Real_p0,"+
	        		"Generated_Mean,Generated_Variance,Generated_Lag1CorrCoeff,Generated_CoeffOfVar,Generated_VarToMeanRatio," +
	        		"Generated_NZ_Mean,Generated_NZ_Variance,Generated_NZ_Lag1CorrCoeff,Generated_NZ_CoeffOfVar,Generated_NZ_VarToMeanRatio," +
	        		"Generated_IdlePeriod_Mean,Generated_IdlePeriod_Variance,Generated_IdlePeriod_Lag1CorrCoeff,Generated_IdlePeriod_CoeffOfVar,Generated_IdlePeriod_VarToMeanRatio," +
	        		"Generated_BusyPeriod_Mean,Generated_BusyPeriod_Variance,Generated_BusyPeriod_Lag1CorrCeoff,Generated_BusyPeriod_CoeffOfVar,Generated_BusyPeriod_VarToMeanRatio,"+
	        		"Generated_p11,Generated_p01,Generated_p0");	        
	        out.close();
	    }
		catch (IOException e1){
	    }
		//GeneratedDataForJohn 
        /*try {
	        BufferedWriter out = new BufferedWriter(new FileWriter("GeneratedDataForJohn" + ".csv"));
	        out.write("NIIN,Demand,Period");
	        out.close();
	    }
		catch (IOException e1){
	    }
		myArrayNIIN = new String [50];
		
		myArrayNIIN [	0	] = 	"X000581477"	;
		myArrayNIIN [	1	] = 	"X004214546"	;
		myArrayNIIN [	2	] = 	"X004929461"	;
		myArrayNIIN [	3	] = 	"X007635908"	;
		myArrayNIIN [	4	] = 	"X009931485"	;
		myArrayNIIN [	5	] = 	"X010030724"	;
		myArrayNIIN [	6	] = 	"X010298005"	;
		myArrayNIIN [	7	] = 	"X010621688"	;
		myArrayNIIN [	8	] = 	"X010865940"	;
		myArrayNIIN [	9	] = 	"X010896812"	;
		myArrayNIIN [	10	] = 	"X010961056"	;
		myArrayNIIN [	11	] = 	"X010975071"	;
		myArrayNIIN [	12	] = 	"X011046488"	;
		myArrayNIIN [	13	] = 	"X011168734"	;
		myArrayNIIN [	14	] = 	"X011247929"	;
		myArrayNIIN [	15	] = 	"X011302850"	;
		myArrayNIIN [	16	] = 	"X011395571"	;
		myArrayNIIN [	17	] = 	"X011472150"	;
		myArrayNIIN [	18	] = 	"X011520840"	;
		myArrayNIIN [	19	] = 	"X011547593"	;
		myArrayNIIN [	20	] = 	"X011574980"	;
		myArrayNIIN [	21	] = 	"X011708225"	;
		myArrayNIIN [	22	] = 	"X011708226"	;
		myArrayNIIN [	23	] = 	"X011741962"	;
		myArrayNIIN [	24	] = 	"X011827975"	;
		myArrayNIIN [	25	] = 	"X012005345"	;
		myArrayNIIN [	26	] = 	"X012007282"	;
		myArrayNIIN [	27	] = 	"X012049148"	;
		myArrayNIIN [	28	] = 	"X012061959"	;
		myArrayNIIN [	29	] = 	"X012185561"	;
		myArrayNIIN [	30	] = 	"X012185661"	;
		myArrayNIIN [	31	] = 	"X012200386"	;
		myArrayNIIN [	32	] = 	"X012204907"	;
		myArrayNIIN [	33	] = 	"X012224316"	;
		myArrayNIIN [	34	] = 	"X012241871"	;
		myArrayNIIN [	35	] = 	"X012241969"	;
		myArrayNIIN [	36	] = 	"X012274431"	;
		myArrayNIIN [	37	] = 	"X012316437"	;
		myArrayNIIN [	38	] = 	"X012417595"	;
		myArrayNIIN [	39	] = 	"X012466434"	;
		myArrayNIIN [	40	] = 	"X012519095"	;
		myArrayNIIN [	41	] = 	"X012653513"	;
		myArrayNIIN [	42	] = 	"X012682525"	;
		myArrayNIIN [	43	] = 	"X012700323"	;
		myArrayNIIN [	44	] = 	"X012711253"	;
		myArrayNIIN [	45	] = 	"X012766066"	;
		myArrayNIIN [	46	] = 	"X013298002"	;
		myArrayNIIN [	47	] = 	"X013342676"	;
		myArrayNIIN [	48	] = 	"X013375159"	;
		myArrayNIIN [	49	] = 	"X013690999"	;*/



    	try{ 
        	myAllRecords=myShareStatement.executeQuery("SELECT * FROM DemandStatisticsLong");            
        }       
        catch(Exception myError){
        	myError.printStackTrace();
            System.err.println(myError.getMessage());
            System.exit(-1);
        }
        
        for(int i=1; i<=1146; i++){
        	getDemandAttributes(i);
        }
        
        //GeneratedDataForJohn
        /*for(int i = 0; i < myArrayNIIN.length - 1; i++){
        	getDemandAttributes(myArrayNIIN[i]);       	
        }*/
        
    }
    
    public void getDemandAttributes(int i){
    	
    	try{
    		myAllRecords.absolute(i);
        	myNIIN = myAllRecords.getString("NIIN"); 
        	
        	double cCount = myAllRecords.getDouble("Count");
        	double cMean = myAllRecords.getDouble("Mean");
        	double cVariance = myAllRecords.getDouble("Variance");
        	double cLag1Corr = myAllRecords.getDouble("Lag1Corr");
        	double cNZCount = myAllRecords.getDouble("NZCount");
        	double cNZMean = myAllRecords.getDouble("NZMean");
        	double cNZVariance = myAllRecords.getDouble("NZVariance");
        	double cNZLag1Corr = myAllRecords.getDouble("NZLag1Corr");
        	double cIntvlBtwnNZDemandsCount = myAllRecords.getDouble("IntvlBtwnNZDemandsCount");
        	double cIntvlBtwnNZDemandsMean = myAllRecords.getDouble("IntvlBtwnNZDemandsMean");
        	double cIntvlBtwnNZDemandsVariance = myAllRecords.getDouble("IntvlBtwnNZDemandsVariance");
        	double cIntvlBtwnNZDemandsLag1Corr = myAllRecords.getDouble("IntvlBtwnNZDemandsLag1Corr");   		
        	double cIntvlBtwnZDemandsCount = myAllRecords.getDouble("IntvlBtwnZDemandsCount");
        	double cIntvlBtwnZDemandsMean = myAllRecords.getDouble("IntvlBtwnZDemandsMean");
        	double cIntvlBtwnZDemandsVariance = myAllRecords.getDouble("IntvlBtwnZDemandsVariance");
        	double cIntvlBtwnZDemandsLag1Corr = myAllRecords.getDouble("IntvlBtwnZDemandsLag1Corr");
    		double cp11 = myAllRecords.getDouble("p11");
    		double cp01 = myAllRecords.getDouble("p01");
    		double cp0 = myAllRecords.getDouble("p0");
    		
    		Statistic statMean = new Statistic("Mean");
        	Statistic statVariance = new Statistic("Variance");
        	Statistic statLag1Corr = new Statistic("Lag1Corr");
        	Statistic statNZMean = new Statistic("NZMean");
        	Statistic statNZVariance = new Statistic("NZVariance");
        	Statistic statNZLag1Corr = new Statistic("NZLag1Corr");
        	Statistic statIntvlBtwnNZDemandsMean = new Statistic("IntvlBtwnNZDemandsMean");
        	Statistic statIntvlBtwnNZDemandsVariance = new Statistic("IntvlBtwnNZDemandsVariance");
        	Statistic statIntvlBtwnNZDemandsLag1Corr = new Statistic("IntvlBtwnNZDemandsLag1Corr");   		
        	Statistic statIntvlBtwnZDemandsMean = new Statistic("IntvlBtwnZDemandsMean");
        	Statistic statIntvlBtwnZDemandsVariance = new Statistic("IntvlBtwnZDemandsVariance");
        	Statistic statIntvlBtwnZDemandsLag1Corr = new Statistic("IntvlBtwnZDemandsLag1Corr");
    		Statistic statp11 = new Statistic("p11");
    		Statistic statp01 = new Statistic("p01");
    		Statistic statp0 = new Statistic("p0");
        	
        	System.out.println(i +" -> "+"Reading NIIN "+myNIIN);
        	
        	/*BatchOnOffDemandGenerator dg = BatchOnOffDemandGenerator.getDefaultBatchOnOffDemandGenerator(cIntvlBtwnZDemandsMean, cIntvlBtwnZDemandsVariance,
        			cIntvlBtwnNZDemandsMean, cIntvlBtwnNZDemandsVariance, cNZMean, cNZVariance, myNIIN);*/
        	
        	BatchOnOffDemandGenerator dg = BatchOnOffDemandGenerator.getDefaultBatchOnOffDemandGenerator(cIntvlBtwnZDemandsMean, 
        			cIntvlBtwnNZDemandsMean, cNZMean, myNIIN);
        	
        	for(int j = 1; j <= myReplications; j ++){ 
        		
        		IntermittentDemandStatistic stat = new IntermittentDemandStatistic();            	
            	for(int m = 1; m <= myRunLength; m ++){        		
            		double k = dg.getValue();
            		stat.collect(k);
            	}
            	statMean.collect(stat.getStatistics()[1]);
            	statVariance.collect(stat.getStatistics()[2]);
            	statLag1Corr.collect(stat.getStatistics()[17]);
            	statNZMean.collect(stat.getStatistics()[22]);
            	statNZVariance.collect(stat.getStatistics()[23]);
            	statNZLag1Corr.collect(stat.getStatistics()[38]);
            	statIntvlBtwnNZDemandsMean.collect(stat.getStatistics()[43]);
            	statIntvlBtwnNZDemandsVariance.collect(stat.getStatistics()[44]);
            	statIntvlBtwnNZDemandsLag1Corr.collect(stat.getStatistics()[59]);
            	statIntvlBtwnZDemandsMean.collect(stat.getStatistics()[64]);
            	statIntvlBtwnZDemandsVariance.collect(stat.getStatistics()[65]);
            	statIntvlBtwnZDemandsLag1Corr.collect(stat.getStatistics()[80]);
            	statp11.collect(stat.getProbSuccessAfterSuccess());
            	statp01.collect(stat.getProbSuccessAfterFailure());
            	statp0.collect(stat.getProbFailure());        		
        	}

            try {
    	        BufferedWriter out = new BufferedWriter(new FileWriter("TestBatchOnOffDGShortFile" + ".csv",true));
    	        out.newLine();
    	        out.write(myNIIN+","+cNZMean+","+cIntvlBtwnNZDemandsMean+","+cIntvlBtwnZDemandsMean+","
    	        		+statNZMean.getAverage()+","+statIntvlBtwnNZDemandsMean.getAverage()+
    	        		","+statIntvlBtwnZDemandsMean.getAverage());
    	        out.close();
    	    }
    		catch (IOException e1){
    	    }
    		try {
    	        BufferedWriter out = new BufferedWriter(new FileWriter("TestBatchOnOffDGLongFile" + ".csv", true));
    	        out.newLine();
    	        out.write(myNIIN+","+cCount+","+cMean+","+
    	        		cVariance+","+cLag1Corr+","+(Math.sqrt(cVariance)/cMean)+","+(cVariance/cMean)+","+
    	        		cNZCount+","+cNZMean+","+
    	        		cNZVariance+","+cNZLag1Corr+","+(Math.sqrt(cNZVariance)/cNZMean)+","+(cNZVariance/cNZMean)+","+
    	        		cIntvlBtwnNZDemandsCount+","+cIntvlBtwnNZDemandsMean+","+
    	        		cIntvlBtwnNZDemandsVariance+","+cIntvlBtwnNZDemandsLag1Corr+","+(Math.sqrt(cIntvlBtwnNZDemandsVariance)/cIntvlBtwnNZDemandsMean)+","+
    	        		(cIntvlBtwnNZDemandsVariance/cIntvlBtwnNZDemandsMean)+","+
    	        		cIntvlBtwnZDemandsCount+","+cIntvlBtwnZDemandsMean+","+
    	        		cIntvlBtwnZDemandsVariance+","+cIntvlBtwnZDemandsLag1Corr+","+(Math.sqrt(cIntvlBtwnZDemandsVariance)/cIntvlBtwnZDemandsMean)+","+
    	        		(cIntvlBtwnZDemandsVariance/cIntvlBtwnZDemandsMean)+","+
    	        		cp11+","+cp01+","+cp0+","+
    	        		statMean.getAverage()+","+statVariance.getAverage()+","+statLag1Corr.getAverage() +
    	        		","+(Math.sqrt(statVariance.getAverage())/statMean.getAverage())+","+(statVariance.getAverage()/statMean.getAverage())+
    	        		","+statNZMean.getAverage()+","+statNZVariance.getAverage()+","+statNZLag1Corr.getAverage()+
    	        		","+(Math.sqrt(statNZVariance.getAverage())/statNZMean.getAverage())+","+(statNZVariance.getAverage()/statNZMean.getAverage())+
    	        		","+statIntvlBtwnNZDemandsMean.getAverage()+","+statIntvlBtwnNZDemandsVariance.getAverage()+","+statIntvlBtwnNZDemandsLag1Corr.getAverage()+
    	        		","+(Math.sqrt(statIntvlBtwnNZDemandsVariance.getAverage())/statIntvlBtwnNZDemandsMean.getAverage())+","+(statIntvlBtwnNZDemandsVariance.getAverage()/statIntvlBtwnNZDemandsMean.getAverage())+
    	        		","+statIntvlBtwnZDemandsMean.getAverage()+","+statIntvlBtwnZDemandsVariance.getAverage()+","+statIntvlBtwnZDemandsLag1Corr.getAverage()+
    	        		","+(Math.sqrt(statIntvlBtwnZDemandsVariance.getAverage())/statIntvlBtwnZDemandsMean.getAverage())+","+(statIntvlBtwnZDemandsVariance.getAverage()/statIntvlBtwnZDemandsMean.getAverage())+
    	        		","+statp11.getAverage()+","+statp01.getAverage()+","+statp0.getAverage());	        
    	        out.close();
    	    }
    		catch (IOException e1){
    	    }
        	
        	
        	
        }       
        catch(Exception myError){
        	myError.printStackTrace();
            System.err.println(myError.getMessage());
        }
    }


    public void getDemandAttributes(String niin){
    	try{ 
        	myAllRecords=myShareStatement.executeQuery("SELECT * FROM DemandStatisticsLong WHERE NIIN = '"+niin+"'");            
        }       
        catch(Exception myError){
        	myError.printStackTrace();
            System.err.println(myError.getMessage());
            System.exit(-1);
        }
    	
    	try{
    		myAllRecords.absolute(1);
        	myNIIN = myAllRecords.getString("NIIN"); 
        	
        	double cCount = myAllRecords.getDouble("Count");
        	double cMean = myAllRecords.getDouble("Mean");
        	double cVariance = myAllRecords.getDouble("Variance");
        	double cLag1Corr = myAllRecords.getDouble("Lag1Corr");
        	double cNZCount = myAllRecords.getDouble("NZCount");
        	double cNZMean = myAllRecords.getDouble("NZMean");
        	double cNZVariance = myAllRecords.getDouble("NZVariance");
        	double cNZLag1Corr = myAllRecords.getDouble("NZLag1Corr");
        	double cIntvlBtwnNZDemandsCount = myAllRecords.getDouble("IntvlBtwnNZDemandsCount");
        	double cIntvlBtwnNZDemandsMean = myAllRecords.getDouble("IntvlBtwnNZDemandsMean");
        	double cIntvlBtwnNZDemandsVariance = myAllRecords.getDouble("IntvlBtwnNZDemandsVariance");
        	double cIntvlBtwnNZDemandsLag1Corr = myAllRecords.getDouble("IntvlBtwnNZDemandsLag1Corr");   		
        	double cIntvlBtwnZDemandsCount = myAllRecords.getDouble("IntvlBtwnZDemandsCount");
        	double cIntvlBtwnZDemandsMean = myAllRecords.getDouble("IntvlBtwnZDemandsMean");
        	double cIntvlBtwnZDemandsVariance = myAllRecords.getDouble("IntvlBtwnZDemandsVariance");
        	double cIntvlBtwnZDemandsLag1Corr = myAllRecords.getDouble("IntvlBtwnZDemandsLag1Corr");
    		double cp11 = myAllRecords.getDouble("p11");
    		double cp01 = myAllRecords.getDouble("p01");
    		double cp0 = myAllRecords.getDouble("p0");
    		
    		Statistic statMean = new Statistic("Mean");
        	Statistic statVariance = new Statistic("Variance");
        	Statistic statLag1Corr = new Statistic("Lag1Corr");
        	Statistic statNZMean = new Statistic("NZMean");
        	Statistic statNZVariance = new Statistic("NZVariance");
        	Statistic statNZLag1Corr = new Statistic("NZLag1Corr");
        	Statistic statIntvlBtwnNZDemandsMean = new Statistic("IntvlBtwnNZDemandsMean");
        	Statistic statIntvlBtwnNZDemandsVariance = new Statistic("IntvlBtwnNZDemandsVariance");
        	Statistic statIntvlBtwnNZDemandsLag1Corr = new Statistic("IntvlBtwnNZDemandsLag1Corr");   		
        	Statistic statIntvlBtwnZDemandsMean = new Statistic("IntvlBtwnZDemandsMean");
        	Statistic statIntvlBtwnZDemandsVariance = new Statistic("IntvlBtwnZDemandsVariance");
        	Statistic statIntvlBtwnZDemandsLag1Corr = new Statistic("IntvlBtwnZDemandsLag1Corr");
    		Statistic statp11 = new Statistic("p11");
    		Statistic statp01 = new Statistic("p01");
    		Statistic statp0 = new Statistic("p0");
        	
        	System.out.println(" -> "+"Reading NIIN "+myNIIN);
        	
        	/*BatchOnOffDemandGenerator dg = BatchOnOffDemandGenerator.getDefaultBatchOnOffDemandGenerator(cIntvlBtwnZDemandsMean, cIntvlBtwnZDemandsVariance,
        			cIntvlBtwnNZDemandsMean, cIntvlBtwnNZDemandsVariance, cNZMean, cNZVariance, myNIIN);*/
        	
        	BatchOnOffDemandGenerator dg = BatchOnOffDemandGenerator.getDefaultBatchOnOffDemandGenerator(cIntvlBtwnZDemandsMean, 
        			cIntvlBtwnNZDemandsMean, cNZMean, myNIIN);
        	
        	for(int j = 1; j <= myReplications; j ++){ 
        		
        		IntermittentDemandStatistic stat = new IntermittentDemandStatistic();            	
            	for(int m = 1; m <= myRunLength; m ++){        		
            		double k = dg.getValue();
            		stat.collect(k);            		 
                    try {
            	        BufferedWriter out = new BufferedWriter(new FileWriter("GeneratedDataForJohn" + ".csv",true));
            	        out.newLine();
            	        out.write(myNIIN+","+m+","+k);
            	        out.close();
            	    }
            		catch (IOException e1){
            	    }
            	}
            	statMean.collect(stat.getStatistics()[1]);
            	statVariance.collect(stat.getStatistics()[2]);
            	statLag1Corr.collect(stat.getStatistics()[17]);
            	statNZMean.collect(stat.getStatistics()[22]);
            	statNZVariance.collect(stat.getStatistics()[23]);
            	statNZLag1Corr.collect(stat.getStatistics()[38]);
            	statIntvlBtwnNZDemandsMean.collect(stat.getStatistics()[43]);
            	statIntvlBtwnNZDemandsVariance.collect(stat.getStatistics()[44]);
            	statIntvlBtwnNZDemandsLag1Corr.collect(stat.getStatistics()[59]);
            	statIntvlBtwnZDemandsMean.collect(stat.getStatistics()[64]);
            	statIntvlBtwnZDemandsVariance.collect(stat.getStatistics()[65]);
            	statIntvlBtwnZDemandsLag1Corr.collect(stat.getStatistics()[80]);
            	statp11.collect(stat.getProbSuccessAfterSuccess());
            	statp01.collect(stat.getProbSuccessAfterFailure());
            	statp0.collect(stat.getProbFailure());        		
        	}

            try {
    	        BufferedWriter out = new BufferedWriter(new FileWriter("TestBatchOnOffDGShortFile" + ".csv",true));
    	        out.newLine();
    	        out.write(myNIIN+","+cNZMean+","+cIntvlBtwnNZDemandsMean+","+cIntvlBtwnZDemandsMean+","
    	        		+statNZMean.getAverage()+","+statIntvlBtwnNZDemandsMean.getAverage()+
    	        		","+statIntvlBtwnZDemandsMean.getAverage());
    	        out.close();
    	    }
    		catch (IOException e1){
    	    }
    		try {
    	        BufferedWriter out = new BufferedWriter(new FileWriter("TestBatchOnOffDGLongFile" + ".csv", true));
    	        out.newLine();
    	        out.write(myNIIN+","+cCount+","+cMean+","+
    	        		cVariance+","+cLag1Corr+","+
    	        		cNZCount+","+cNZMean+","+
    	        		cNZVariance+","+cNZLag1Corr+","+
    	        		cIntvlBtwnNZDemandsCount+","+cIntvlBtwnNZDemandsMean+","+
    	        		cIntvlBtwnNZDemandsVariance+","+cIntvlBtwnNZDemandsLag1Corr+","+
    	        		cIntvlBtwnZDemandsCount+","+cIntvlBtwnZDemandsMean+","+
    	        		cIntvlBtwnZDemandsVariance+","+cIntvlBtwnZDemandsLag1Corr+","+
    	        		cp11+","+cp01+","+cp0+","+
    	        		statMean.getAverage()+","+statVariance.getAverage()+","+statLag1Corr.getAverage() +
    	        		","+statNZMean.getAverage()+","+statNZVariance.getAverage()+","+statNZLag1Corr.getAverage()+
    	        		","+statIntvlBtwnNZDemandsMean.getAverage()+","+statIntvlBtwnNZDemandsVariance.getAverage()+
    	        		","+statIntvlBtwnNZDemandsLag1Corr.getAverage()+
    	        		","+statIntvlBtwnZDemandsMean.getAverage()+","+statIntvlBtwnZDemandsVariance.getAverage()+
    	        		","+statIntvlBtwnZDemandsLag1Corr.getAverage()+
    	        		","+statp11.getAverage()+","+statp01.getAverage()+","+statp0.getAverage());	        
    	        out.close();
    	    }
    		catch (IOException e1){
    	    }
        	
        	
        	
        }       
        catch(Exception myError){
        	myError.printStackTrace();
            System.err.println(myError.getMessage());
        }
    }

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		TestBatchOnOffDG n1=new TestBatchOnOffDG();
		try{
			n1.myConnection.close();                      
        }       
        catch(Exception myError){
        	myError.printStackTrace();
            System.err.println(myError.getMessage());
        }

	}

}
