package jslx.forecasting.metrics;

/**
 * An implementation of the absolute value function.
 * @author hmedal
 *
 */
public class Absolute implements MathFunctionIfc {

	/**
	 * Gives the absolute value of a number.
	 * 
	 * @param x the input to the function
	 * @return the absolute value of x
	 */
	public double getValue(double x) {
		return Math.abs(x);
	}
	
	/**
	 * Useful when used with the forecast metrics package
	 * 
	 * @return "A"
	 */
	public String getAbbreviatedName() {
		return "A";
	}
	
	public String getName() {
		return "Absolute";
	}

}
