package jslx.forecasting.metrics;

/**
 * An interface representing a general mathematical function.
 * 
 * @author hmedal
 *
 */
public interface MathFunctionIfc {
	
	/**
	 * Gives the function value of the supplied argument
	 * 
	 * @param x the input to the function
	 * @return f(x)
	 */
	public double getValue(double x);
	
	/**
	 * Useful when used with the forecast metrics package
	 * 
	 * @return the abbreviated name
	 */
	public String getAbbreviatedName();
	
	public String getName();
	
}
