package jslx.forecasting.metrics;

/**
 * An implementation of the square function.
 * 
 * @author hmedal
 *
 */
public class Square implements MathFunctionIfc {
	
	/**
	 * Gives the square of a number.
	 * @param x the argument to the function
	 * @return x^2
	 */
	public double getValue(double x) {
		return Math.pow(x, 2);
	}
	
	/**
	 * Useful when used with the forecast metrics package
	 * 
	 * @return "S"
	 */
	public String getAbbreviatedName() {
		return "S";
	}
	
	public String getName() {
		return "Square";
	}

}
