package jslx.forecasting.metrics.calc;

import jsl.utilities.statistic.Statistic;

/**
 * Computes the geometric mean of a set of data collected by a statistic.
 * 
 * @author hmedal
 *
 */
public class GeometricMean implements StatCalculatorIfc {

	public double computeMetricValue(Statistic stat) {
		double[] data=stat.getSavedData();
		double product=1;
		for(double d:data)
			product*=d;
		return Math.pow(product, 1.0/data.length);
	}
	
	public String getAbbreviatedName() {
		return "GM";
	}
	
	public String getName() {
		return "GeometricMean";
	}

	public boolean requiresSaved() {
		return true;
	}

}
