package jslx.forecasting.metrics.calc;

import jsl.utilities.statistic.Statistic;

/**
 * Computes the arithmetic mean of a set of data collected by a statistic.
 * 
 * @author hmedal
 *
 */
public class Mean implements StatCalculatorIfc {
	
	public double computeMetricValue(Statistic stat) {
		return stat.getAverage();
	}

	public String getAbbreviatedName() {
		return "M";
	}

	public String getName() {
		return "Mean";
	}

	public boolean requiresSaved() {
		return false;
	}

}
