package jslx.forecasting.metrics.calc;

import java.util.Arrays;

import jsl.utilities.statistic.Statistic;

/**
 * Computes the median of a set of data collected by a statistic.
 * 
 * @author hmedal
 *
 */
public class Median implements StatCalculatorIfc {

	public double computeMetricValue(Statistic stat) {
		double[] data=stat.getSavedData();
		Arrays.sort(data);
		int size=data.length;
		double median=-1;
		if(size%2==0){//even
			int firstIndex=(size/2)-1;
			int secondIndex=firstIndex+1;
			double firstValue=data[firstIndex];
			double secondValue=data[secondIndex];
			median=(firstValue+secondValue)/2;
		}
		else{//odd
			int index=(int)Math.ceil(size/2);
			median=data[index];
		}
		return median;
	}
	
	public String getAbbreviatedName() {
		return "Md";
	}
	
	public boolean requiresSaved() {
		return true;
	}

	public String getName() {
		return "Median";
	}

}
