package jslx.forecasting.metrics.calc;

import jsl.utilities.statistic.Statistic;

/**
 * Computes the square root of the mean a set of data collected by a statistic.
 * 
 * @author hmedal
 *
 */
public class RootMean implements StatCalculatorIfc {

	public double computeMetricValue(Statistic stat) {
		return Math.sqrt(stat.getAverage());		
	}
	
	public String getAbbreviatedName() {
		return "RM";
	}
	
	public String getName() {
		return "RootMean";
	}

	public boolean requiresSaved() {
		return false;
	}

}
