package jslx.forecasting.metrics.calc;

import jsl.utilities.statistic.Statistic;

/**
 * Computes the square root of the median a set of data collected by a statistic.
 * 
 * @author hmedal
 *
 */
public class RootMedian implements StatCalculatorIfc {
	
	private StatCalculatorIfc medianCalculator;
	
	public RootMedian(){
		medianCalculator=new Median();
	}
	
	public double computeMetricValue(Statistic stat) {
		return Math.sqrt(medianCalculator.computeMetricValue(stat));
	}
	
	public String getAbbreviatedName() {
		return "RMd";
	}
	
	public String getName() {
		return "RootMedian";
	}

	public boolean requiresSaved() {
		return true;
	}
}
