package jslx.inventory.rqmodel;
import java.sql.*;

public class DownloadData {
	
	public String myDSN;
	public String myLoginName;
	public String myPassword;
	public String myTableName;
	private String myURL;
	
	public Connection myConnection;
	public Statement myStatement;
	public ResultSet myResultSet;
	
	public DownloadData(String DSN, String Username, String Password, String myTable){
		myDSN = DSN;
		myLoginName = Username;
		myPassword = Password;
		myTableName = myTable;
		myURL = "jdbc:odbc:"+myDSN;
		connectToDatabase();
	}
	
	public void connectToDatabase(){
		try{
			Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");
		}
		catch(java.lang.ClassNotFoundException e) {
            System.err.print("ClassNotFoundException: ");
            System.err.println(e.getMessage());
		}
		try{
			myConnection = DriverManager.getConnection(myURL, myLoginName, myPassword);
		}
		catch(Exception e){
			System.out.println("a");
			System.err.println(e.getMessage());
		}
		try{
			myStatement = myConnection.createStatement(ResultSet.TYPE_SCROLL_INSENSITIVE, ResultSet.CONCUR_READ_ONLY);
			myResultSet = myStatement.executeQuery("SELECT * FROM "+myTableName+";");
		}
		catch(Exception myError){
			System.out.println("b");
			System.err.println(myError.getMessage());
			System.err.println(myError.getStackTrace());
			System.exit(-1);
		}
	}
	
	public void close(){
		try{
			myResultSet.close();
			myStatement.close();
			myConnection.close();
		}
		catch(Exception myError){
			System.err.println(myError.getMessage());
		}
	}

}
