package jslx.inventory.rqmodel;

import jsl.utilities.random.distributions.LossFunctionDistributionIfc;

public interface ItemIfc {
	
	/** Gets the Item Number
	 * 
	 * @return
	 */
	int getItemNumber();
	
	/** Gets the unit cost
	 * 
	 * @return
	 */
	double getUnitCost();
	
	/** Gets the reorder quantity
	 * 
	 * @return
	 */
	double getReorderQty();
	
	/** Gets the reorder point
	 * 
	 * @return
	 */
	double getReorderPoint();
	
	/** Gets the demand rate
	 * 
	 * @return
	 */
	double getDemandRate();
	
	/** Gets the lead time
	 * 
	 * @return
	 */
	double getLeadTime();
	
	LossFunctionDistributionIfc getLeadTimeDemandDistribution();
	
	/** Gets the expected number of back-orders
	 * 
	 * @return
	 */
	double getExpectedBackOrders();
	
	/** Gets the expected number stock-outs per period
	 * 
	 * @return
	 */
	double getExpectedStockOutsPerPeriod();
	
	/** Gets the expected inventory on-hand
	 * 
	 * @return
	 */	
	double getExpectedOnHandInventory();
	
	/**Gets the probability of stock-out
	 * 
	 * @return
	 */
	double getProbabilityOfStockOut();
	
	/** Gets the expected customer waiting time
	 * 
	 * @return
	 */
	double getExpectedCustomerWaitTime();

}
