package jslx.inventory.rqmodel;

import java.util.List;

public interface RQItemIfc extends ItemIfc{
	
	/**Gets the total amount backordered for the item: and at the bases: getEBackOrders() + getTotalRetailerEBackOrders()
	 * 
	 * @return
	 */
	double getTotalEBackOrders();
	
	/**Gets the total amount on hand for the item: and at the retailers: getEOnHand() + getTotalretailerEOnHand()
	 * 
	 * @return
	 */
	double getTotalEOnHand();
	
	// aggregate base performance
	
	/**Gets the number of bases that this item is stocked at
	 * 
	 */
	int getNumRetailers();

	/**Gets the total expected number of backorders across the retailers for this item
	 * 
	 * @return
	 */
	double getTotalRetailerEBackOrders();

	/**Gets the total expected on hand across the retailers for this item
	 * 
	 * @return
	 */
	double getTotalRetailerEOnHand();
	
	/**Returns an unmodifiable list of the items at the bases
	 * 
	 * @return
	 */
	List<RQRetailerItem> getRetailerItems();

}
