/*
 * Created on Mar 29, 2007
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package jslx.supplychain.afosr.forecasting;

import jsl.modeling.JSLEvent;
import jsl.modeling.ModelElement;
import jslx.supplychain.inventorylayer.Demand;
import jslx.supplychain.inventorylayer.DemandArrivalListenerAbstract;
import jslx.supplychain.inventorylayer.Inventory;

/**
 * @author vvarghe
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 * 
 * This demand forecast arrival listener can be added to an inventory and it can 
 * respond appropriately as the demand and forecast arrives (as implemented in the concrete
 * implementation of this subclass)
 * 
 */
public class DemandAndForecastArrivalListenerForNetwork extends DemandArrivalListenerAbstract implements ForecastArrivalListenerIfc {
	
	protected ForecastManager myForecastManager;	
	protected double myCurrentForecastEstimate;
	protected boolean myUpdatable = false;
	
	
	public DemandAndForecastArrivalListenerForNetwork(ModelElement parent, Inventory inv) {
		this(parent, inv, null);
	}
	public DemandAndForecastArrivalListenerForNetwork(ModelElement parent,  Inventory inv, String name) {
		this(parent, inv, name, 1);
	}
	public DemandAndForecastArrivalListenerForNetwork(ModelElement parent, Inventory inv, String name, double agglevel) {
		this(parent, inv, name, agglevel, 1.0, false);
	}
	public DemandAndForecastArrivalListenerForNetwork(ModelElement parent, Inventory inv, String name, double agglevel, 
			double initforecastestimate, boolean updatable) {
		super(parent, inv, name, agglevel);
		myCurrentForecastEstimate = initforecastestimate;
		myUpdatable = updatable;
	}	
	public void initialize(){
		//System.out.println("aggregation"+this);		
		scheduleEvent(myAggregationEventTime, 1, 1, "Demand Aggregation");		
	}
	public void setForecastManager(ForecastManager demfcst){
		myForecastManager = demfcst;
		myForecastManager.addDemandArrivalListener(this);
		myForecastManager.addForecastArrivalListener(this);		
	}	
	protected void schedulePeriodicDemandProcessing(JSLEvent event){
		//System.out.println("aggregation"+this);
		double dem = sumDemandCurrentBucket;
		if(myForecastManager != null){
			if(myUpdatable){
				myForecastManager.updateForecast(dem);
			}			
		}		
		sumDemandCurrentBucket = 0.0;
		rescheduleEvent(event,myAggregationEventTime,"Demand Aggregation");
	}	
	protected void handleEvent(JSLEvent event){
		schedulePeriodicDemandProcessing(event);
	}
	public void demandArrived(Inventory inv, Demand demand) {
		if(inv != myInventory){			
			throw new IllegalArgumentException ("DemandArrivalListener can be updated by its Inventory alone");
		}else{
			myCurrentDemand = demand.getOriginalAmountDemanded();
			sumDemandAcrossBuckets = sumDemandAcrossBuckets + myCurrentDemand;
			sumDemandCurrentBucket = sumDemandCurrentBucket + myCurrentDemand;
		}
	}
	public void forecastArrived(ForecastManager forecaster, double dem) {
		if(forecaster != myForecastManager){			
			throw new IllegalArgumentException ("ForecastArrivalListener can be updated by its forecaster alone");
		}else{
			myCurrentForecastEstimate = myForecastManager.getForecast();
		}		
	}
	public double getCurrentForecastEstimate() {
		return myCurrentForecastEstimate;
	}
	public ForecastManager getForecastManager() {
		return myForecastManager;
	}	
}
