/*
 * Created on Mar 29, 2007
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package jslx.supplychain.afosr.forecasting;

import java.io.BufferedWriter;
import java.io.FileWriter;
import java.io.IOException;

import jsl.modeling.JSLEvent;
import jsl.modeling.ModelElement;
import jslx.supplychain.inventorylayer.Demand;
import jslx.supplychain.inventorylayer.DemandArrivalListenerAbstract;
import jslx.supplychain.inventorylayer.Inventory;

/**
 * @author vvarghe
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 * 
 * This demand arrival listener can be added to an inventory and all it does is 
 * aggregate the demand that arrives at the inventory and collect it
 * 
 */
public class DemandArrivalListenerDefault extends DemandArrivalListenerAbstract {
	
	/**
	 * @param parent
	 * @param inv
	 */
	public DemandArrivalListenerDefault(ModelElement parent, Inventory inv) {
		this(parent, inv, null, 1);
	}

	/**
	 * @param parent
	 * @param inv
	 * @param name
	 */
	public DemandArrivalListenerDefault(ModelElement parent,  Inventory inv, String name) {
		this(parent, inv, name, 1);
	}
	
	/**
	 * @param parent
	 * @param inv
	 * @param name
	 * @param agglevel
	 */
	public DemandArrivalListenerDefault(ModelElement parent, Inventory inv, String name, double agglevel) {
		super(parent, inv, name, agglevel);
		/*try {
	        BufferedWriter out = new BufferedWriter(new FileWriter("IndividualDemCollector" + ".csv"));
	        out.write("Inventory,Replication,Time,Demand");
	        out.close();
	    } 
		catch (IOException e1){			
	    }			
		try {
	        BufferedWriter out = new BufferedWriter(new FileWriter("AggregatedDemCollector" + ".csv"));
	        out.write("Inventory,Replication,Time,Demand");
	        out.close();
	    } 
		catch (IOException e1){			
	    }*/
	}
	
	public void initialize(){
		scheduleEvent(myAggregationEventTime, "Demand Aggregation");		
	}
	
	/** 
	 *  respond to a demand arrival by aggregating the demand wiuthin the current update period
	 *  
	 */	
	public void demandArrived(Inventory inv, Demand demand) {
		if(inv != myInventory){			
			throw new IllegalArgumentException ("DemandArrivalListener can be updated by its Inventory alone");
		}else{
			myCurrentDemand = demand.getOriginalAmountDemanded();
			/*myCurrentTime = getTime();			
			String s = myInventory.getName()+","+myInventory.getCurrentReplication()+","+myCurrentTime+","+myCurrentDemand;
			try {
		        BufferedWriter out = new BufferedWriter(new FileWriter("IndividualDemCollector" + ".csv",true));
		        out.newLine();
		        out.write(s);
		        out.close();
		    } 
			catch (IOException e2){			
		    }*/			
			sumDemandAcrossBuckets = sumDemandAcrossBuckets + myCurrentDemand;
			sumDemandCurrentBucket = sumDemandCurrentBucket + myCurrentDemand;
		}
		
	}
	
	/** 
	 *  collects the aggregated demand at the end of the update period and then 
	 *  reschedule the next update
	 *  
	 */	
	protected void schedulePeriodicDemandProcessing(JSLEvent event){
		double dem = sumDemandCurrentBucket;
		/*double time = getTime();
		double rep = getCurrentReplication().getReplicationNumber();		
		String s = this.getName()+","+rep+","+time+","+dem;
		try {
	        BufferedWriter out = new BufferedWriter(new FileWriter("AggregatedDemCollector" +".csv",true));
	        out.newLine();
	        out.write(s);
	        out.close();
	    } 
		catch (IOException e2){			
	    }*/
		sumDemandCurrentBucket = 0.0;
		rescheduleEvent(event,myAggregationEventTime,"Demand Aggregation");
	}	
	
	protected void handleEvent(JSLEvent event){
		schedulePeriodicDemandProcessing(event);
	}

	

	
}
