/*
 * Created on Mar 29, 2007
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package jslx.supplychain.afosr.forecasting;

import jsl.modeling.JSLEvent;
import jsl.modeling.ModelElement;
import jslx.supplychain.inventorylayer.Demand;
import jslx.supplychain.inventorylayer.DemandArrivalListenerAbstract;
import jslx.supplychain.inventorylayer.Inventory;

/**
 * @author vvarghe
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 * 
 * This demand arrival listener can be added to an inventory and it can 
 * aggregate the demand that arrives at the inventory and collect it and 
 * at the specified times forecast can be made.
 * 
 */
public class DemandArrivalListenerWithForecaster extends DemandArrivalListenerAbstract{
	
	/**
	 * It drives the forecasting technique that underlies the system
	 */
	protected ForecastManager myDemandForecaster;	

	protected boolean myUpdatable = false;
	
	/**
	 * @param parent
	 * @param inv
	 * @param forecaster
	 */
	public DemandArrivalListenerWithForecaster(ModelElement parent, Inventory inv, ForecastManager forecaster) {
		this(parent, inv, forecaster, null, 1);
	}

	/**
	 * @param parent
	 * @param inv
	 * @param forecaster
	 * @param name
	 */
	public DemandArrivalListenerWithForecaster(ModelElement parent,  Inventory inv, ForecastManager forecaster, String name) {
		this(parent, inv, forecaster, name, 1);
	}
	
	
	
	/**
	 * @param parent
	 * @param inv
	 * @param forecaster
	 * @param name
	 * @param agglevel
	 */
	public DemandArrivalListenerWithForecaster(ModelElement parent, Inventory inv, ForecastManager forecaster, String name, double agglevel) {
		this(parent, inv, forecaster, name, 1, false);
	}
	
	
	
	/**
	 * @param parent
	 * @param inv
	 * @param forecaster
	 * @param name
	 * @param agglevel
	 */
	public DemandArrivalListenerWithForecaster(ModelElement parent, Inventory inv, ForecastManager forecaster, String name, double agglevel, boolean updatable) {
		super(parent, inv, name, agglevel);
		setDemandForecaster(forecaster);
		myUpdatable = updatable;
	}
	
	private void setDemandForecaster(ForecastManager demfcst){
		myDemandForecaster = demfcst;
		myDemandForecaster.addDemandArrivalListener(this);
	}
		
	public void initialize(){
		scheduleEvent(myAggregationEventTime, 1, 1, "Demand Aggregation");		
	}	
	
	/** 
	 *  collects the aggregated demand at the end of the update period and then 
	 *  reschedule the next update
	 *  
	 */	
	protected void schedulePeriodicDemandProcessing(JSLEvent event){
		double dem = sumDemandCurrentBucket;
		if(myDemandForecaster != null){
			if(myUpdatable){
				myDemandForecaster.updateForecast(this, dem);
			}			
		}
		sumDemandCurrentBucket = 0.0;
		rescheduleEvent(event,myAggregationEventTime,"Demand Aggregation");
	}	
	
	protected void handleEvent(JSLEvent event){
		schedulePeriodicDemandProcessing(event);
	}
	
	/** 
	 *  respond to a demand arrival by aggregating the demand wiuthin the current update period
	 *  
	 */	
	public void demandArrived(Inventory inv, Demand demand) {
		if(inv != myInventory){			
			throw new IllegalArgumentException ("DemandArrivalListener can be updated by its Inventory alone");
		}else{
			myCurrentDemand = demand.getOriginalAmountDemanded();		
			sumDemandAcrossBuckets = sumDemandAcrossBuckets + myCurrentDemand;
			sumDemandCurrentBucket = sumDemandCurrentBucket + myCurrentDemand;
		}		
	}

	/**
	 * @return myDemandForecaster.
	 */
	public ForecastManager getDemandForecaster() {
		return myDemandForecaster;
	}	
	
}
