/*
 * Created on Mar 29, 2007
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package jslx.supplychain.afosr.forecasting;

/**
 * @author vvarghe
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 * 
 * This forecast arrival listener can be added to a demand forecaster
 * and when a forecast arrives, the listener will be notified
 * 
 */
public abstract class ForecastArrivalListenerDefaultAbstract implements ForecastArrivalListenerIfc {
	
	/** 
	 *  Assigned the current forecast estimate
	 */
	protected double myCurrentForecastEstimate;	
	/** 
	 *  Assigned the demand forecaster
	 */
	protected ForecastManager myDemandForecaster;
	
	public String myName;
	
	/**
	 * @param forecaster
	 * @param forcastestimate
	 */
	public ForecastArrivalListenerDefaultAbstract(ForecastManager forecaster, double forcastestimate) {
		this(forecaster, forcastestimate, null);
	}

	/**
	 * @param forecaster
	 * @param forcastestimate
	 * @param name
	 */
	public ForecastArrivalListenerDefaultAbstract(ForecastManager forecaster, double forcastestimate, String name) {
		setDemandForecaster(forecaster);
		myCurrentForecastEstimate = forcastestimate;
		myName = name;
	}
	
	/** 
	 *  respond to a forecast arrival 
	 *  
	 */	
	public abstract void forecastArrived(ForecastManager forecaster, double dem);
	
	/**
	 * This method adds the user specified forecaster as the demand forecaster.
	 * The demand forecaster listens to the demand arrival listener, ie. when
	 * the demand arrives and as it is aggregated the forecaster which listens
	 * (the one added) will be triggered and will be asked to forecast.
	 * 
	 * This method also adds this class as a listener to the demand forecaster.
	 * When a forecast is made, this class is triggered.
	 * 
	 * It has to be noted that this class is also a listener to the inventory
	 * class.
	 * 
	 */
	private void setDemandForecaster(ForecastManager forecaster){
		myDemandForecaster = forecaster;
		myDemandForecaster.addForecastArrivalListener(this);		
	}
	
	/**
	 * @return Returns the myCurrentForecastEstimate.
	 */
	public double getCurrentForecastEstimate() {
		return myCurrentForecastEstimate;
	}
	
}
