/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package jslx.supplychain.afosr.generation;

/**
 *
 * @author vvarghe
 */
public class BItem {    
    
    public int myItemID;
    public int myBaseID;
    public DItem myDItem;
    public double myCost;
    public int myCostLevel;
    public double myLambda;
    public double myReparability;    
    // should we have the distribution here?
    public double myRepairDelay;
    // should we have the distribution here?
    public double myShipDelay;
    // should we have the distribution here?
    public int myBaseStockLevel;
    public String myName;
    public double myBudget;
    public double myBudgetConstant;
    /*
     * Level 1 increases and then constant and then decreases
     * Level 2 constant
     * Level 3 decreases
     * Level 4 increases
     * 
     */    
    public int myPatternLevel;
    public double myHorizonSpan; //t_p
    public double myDeploymentSpan; //t_d
    public double mySustainmentSpan; //t_s
    public double myReconfigurationSpan; //t_r = t_p - (t_d + t_s)
    public double myLambdaMax;
    public double myLambdaMin = 1; // is this a good assumption
    
    
    public BItem(int item_id, int base_id, DItem d_item, 
            double cost, int costlevel, int patternlevel, double tp, double td,
            double ts, double lambda, double repairdelay, 
            double reparability, double shipdelay, double budgetconstant){
        myItemID = item_id;
        myBaseID = base_id;
        myDItem = d_item;
        myCost = cost;
        myCostLevel = costlevel;
        myLambda = lambda;
        myReparability = reparability;
        myRepairDelay = repairdelay;
        myShipDelay = shipdelay;
        myBaseStockLevel = 1;   
        myName = "BaseItem--"+myItemID+"--"+myBaseID;
        myBudgetConstant = budgetconstant;
        myBudget = myBudgetConstant * myLambda * myCost;
        myPatternLevel = patternlevel;
        myHorizonSpan = tp;
        myDeploymentSpan = td;
        mySustainmentSpan = ts;
        myReconfigurationSpan = tp - (td + ts);
        myLambdaMax = myLambdaMin + 
            (0.5 * (1/(myHorizonSpan + mySustainmentSpan)) * (myHorizonSpan*myLambda));        
    }
    
    public String toString(){
        StringBuilder sb = new StringBuilder();
        sb.append("\t\t******************************************\n");
		sb.append("\t\tBaseItem Name:\t"+myName+"\n");
		sb.append("\t\tItemID:\t"+myItemID+"\n");
		sb.append("\t\tBaseID:\t"+myBaseID+"\n");
		sb.append("\t\tCost:\t$"+myCost+"\n");
		sb.append("\t\tCostLevel:\t"+myCostLevel+"\n");
		sb.append("\t\tBaseStockLevel:\t"+myBaseStockLevel+"\n");
		sb.append("\t\tAverageDemandRate:\t"+myLambda+"\n");
		sb.append("\t\tRepairDelay:\t"+myRepairDelay+"\n");
		sb.append("\t\tReparability:\t"+myReparability+"\n");
		sb.append("\t\tShipDelay:\t"+myShipDelay+"\n");
		sb.append("\t\tBudget:\t"+myBudget+"\n");
		sb.append("\t\t\tPatternLevel:\t"+myPatternLevel+"\n");
		sb.append("\t\t\tHorizonSpan:\t"+myHorizonSpan+"\n");
		sb.append("\t\t\tDeploymentSpan:\t"+myDeploymentSpan+"\n");
		sb.append("\t\t\tSustainmentSpan:\t"+mySustainmentSpan+"\n");
		sb.append("\t\t\tReconfigurationSpan:\t"+myReconfigurationSpan+"\n");
		sb.append("\t\t\tLambdaMin:\t"+myLambdaMin+"\n");
		sb.append("\t\t\tLambdaMax:\t"+myLambdaMax+"\n");
		sb.append("\t\t******************************************\n");
        return(sb.toString());   
    }
    
    public double getBudget(){
        return myBudget;    
    }
    
    


}
