/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package jslx.supplychain.afosr.generation;

import java.util.ArrayList;
import java.util.List;

/**
 *
 * @author vvarghe
 */
public class DItem {
    
    public int myItemID;
    public double myCost;
    public int myCostLevel;
    public int myBaseStockLevel;
    public double myLambda;
    public int myNumStockedBases;
    public List<BItem> myBItems;
    public double myRepairDelay;
    public String myName;
    private double myBudget;
    public double myBudgetConstant;
    private double myBItemBudget;
    private double myDItemBudget;
    
    public DItem(int id, double cost, int costlevel, int numstockedbases, double repairdelay, double budgetconstant){
        myItemID = id;
        myCost = cost;
        myCostLevel = costlevel;
        myBaseStockLevel = 0;
        myNumStockedBases = numstockedbases;
        myBItems = new ArrayList<BItem>();
        myRepairDelay = repairdelay;
        myBudgetConstant = budgetconstant;
        myName = "DepotItem"+myItemID;    
    }
    
    public void addBItem(BItem b_item){
        if(!myBItems.contains(b_item)){
            myBItems.add(b_item);
            myBaseStockLevel++;
            estimateDepotDemand(b_item);
            estimateBItemBudget(b_item);
        }
        // should we throw an exception instead?
        myDItemBudget = myLambda * myCost * myBudgetConstant;
    
    }
    
    private void estimateDepotDemand(BItem b_item){
        myLambda = myLambda + b_item.myLambda * b_item.myReparability;
    }
    
    public double getDItemBudget(){
        return myDItemBudget;
    }
    
    private void estimateBItemBudget(BItem b_item){
        myBItemBudget = myBItemBudget + b_item.getBudget();
    }
    
    public double getBudget(){
        myBudget = getDItemBudget() + myBItemBudget;
        return myBudget;
    
    }
    
    public String toString(){
        StringBuilder sb = new StringBuilder();
        sb.append("\t******************************************\n");
		sb.append("\tDepotItem Name:\t"+myName+"\n");
		sb.append("\tItemID:\t"+myItemID+"\n");
		sb.append("\tCost:\t$"+myCost+"\n");
		sb.append("\tCostLevel:\t"+myCostLevel+"\n");
		sb.append("\tBaseStockLevel:\t"+myBaseStockLevel+"\n");
		sb.append("\tNumStockedBases:\t"+myNumStockedBases+"\n");
		sb.append("\tRepairDelay:\t"+myRepairDelay+"\n");
		sb.append("\t******************************************\n");
        for(BItem bi:myBItems){
            sb.append("\t\t------------------------------------------------------\n");
            sb.append("\t\tBase Items\n");
            sb.append(bi.toString());
            sb.append("\t\t------------------------------------------------------\n");
        }
        sb.append("\tItemLevelBudget:\t"+myBudget+"\n");
        sb.append("\t******************************************\n");
        return(sb.toString());
    
    }

}
