/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package jslx.supplychain.afosr.generation;

import java.util.ArrayList;
import java.util.List;

/**
 *
 * @author vvarghe
 */
public class NetworkConfiguration {
    
    public int myNumItems;
    public int myNumBases;
    public ItemGenerator myItemGenerator;    
    public List<DItem> myItems;
    public double myBudgetConstant;
    public double myBudget;
    public String myName;
    
    public NetworkConfiguration(int numitems, int numbases, double budgetconstant, 
            ItemGenerator itemgenerator, String name){
        myNumItems = numitems;
        myNumBases = numbases;
        myItemGenerator = itemgenerator;
        myItemGenerator.myNumBases = myNumBases;
        myBudgetConstant = budgetconstant;
        myName = name;
        myItems = new ArrayList<DItem>();
        defineNetworkConfiguration();
    }
    
    private void defineNetworkConfiguration(){
        myItemGenerator.myITemID = 0;
        for(int i = 1; i <= myNumItems; i++){
            DItem d_item = myItemGenerator.generate();
            myItems.add(d_item); 
            myBudget = myBudget + d_item.getBudget();
        }
    
    }
    
    public String toString(){
        StringBuilder sb = new StringBuilder();
		sb.append("******************************************\n");
		sb.append("Network name:\t"+myName+"\n");
		sb.append("Num of Bases:\t"+myNumBases+"\n");
		sb.append("Num of Items:\t"+myNumItems+"\n");
		sb.append("******************************************\n");
        sb.append("------------------------------------------------------\n");
        for(DItem di:myItems){
            sb.append("\t------------------------------------------------------\n");
            sb.append("\tDepot Items\n");
            sb.append("\t------------------------------------------------------\n");
            sb.append(di.toString());
            sb.append("\t------------------------------------------------------\n");        
        }
	sb.append("TotalBudget:\t"+myBudget+"\n");
	sb.append("******************************************\n");       
        return sb.toString();   
    }
    
    public String getDataString(){
        StringBuilder sb = new StringBuilder();
        for(DItem di:myItems){
            sb.append(myName+",");// network id
            sb.append(myNumBases+",");// num bases
            sb.append(myNumItems+",");// num items
            sb.append(myBudget+",");// tot n/w budget
            sb.append(0+",");// location id
            sb.append(di.myName+",");// item name
            sb.append(di.myItemID+",");// item id
            sb.append(di.myCost+",");// item cost
            sb.append(di.myCostLevel+",");// item cost level
            sb.append(di.myBaseStockLevel+","); // item stock level
            sb.append(di.myLambda+",");// average demand
            sb.append(di.myRepairDelay+",");// repair delay
            sb.append("NA,");// reparability
            sb.append("NA,");// ship delay
            sb.append(di.getDItemBudget()+",");// item budget at location
            sb.append(di.getBudget()+",");// total item level budget
            sb.append("NA,");
            sb.append("NA,");
            sb.append("NA,");
            sb.append("NA,");
            sb.append("NA,");
            sb.append("NA,");
            sb.append("NA,");
            sb.append(di.myNumStockedBases+",");// num stocked level
            sb.append("\n");
            for(BItem bi:di.myBItems){
                sb.append(myName+",");// network id
                sb.append(myNumBases+",");// num bases
                sb.append(myNumItems+",");// num items
                sb.append(myBudget+",");// tot n/w budget
                sb.append(bi.myBaseID+",");// location id
                sb.append(bi.myName+",");// item name
                sb.append(bi.myItemID+",");// item id
                sb.append(bi.myCost+",");// item cost
                sb.append(bi.myCostLevel+",");// item cost level
                sb.append(bi.myBaseStockLevel+","); // item stock level
                sb.append(bi.myLambda+",");// average demand
                sb.append(bi.myRepairDelay+",");// repair delay
                sb.append(bi.myReparability+",");// reparability
                sb.append(bi.myShipDelay+",");// ship delay
                sb.append(bi.getBudget()+",");// item budget at location
                sb.append(di.getBudget()+",");// total item level budget
                sb.append(bi.myPatternLevel+",");
                sb.append(bi.myHorizonSpan+",");
                sb.append(bi.myDeploymentSpan+",");
                sb.append(bi.mySustainmentSpan+",");
                sb.append(bi.myReconfigurationSpan+",");
                sb.append(bi.myLambdaMin+",");
                sb.append(bi.myLambdaMax+",");
                sb.append("NA,");// num stocked level
                sb.append("\n");                    
            }        
        }       
        return sb.toString();   
    }
    

}
