/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package jslx.supplychain.afosr.generation;

import java.io.BufferedWriter;
import java.io.FileWriter;
import java.io.IOException;
import jsl.utilities.random.distributions.DUniform;
import jsl.utilities.random.distributions.DistributionIfc;

/**
 *
 * @author vvarghe
 */
public class NetworkGenerator {
    
    public DistributionIfc myDistNumItems;
    public DistributionIfc myDistNumBases;
    public double [] myRatioOfCostLevels;
    public double [] myRatioOfPatternLevels;
    public double myBudgetConstant;
    public int myNetworkID;
    public ItemGenerator myItemGenerator;
    public double myHorizonSpan;
    
    public NetworkGenerator( DistributionIfc distnumitems, 
            DistributionIfc distnumbases, double budgetconstant,
            double[] ratiofcostlevels, double[] ratiofpatternlevels, 
            double tp){
        myDistNumItems = distnumitems;
        myDistNumBases = distnumbases;
        myBudgetConstant = budgetconstant;
        myRatioOfCostLevels = ratiofcostlevels;
        myRatioOfPatternLevels = ratiofpatternlevels;
        myHorizonSpan = tp;
        myItemGenerator = new ItemGenerator(myRatioOfCostLevels, 
                myRatioOfPatternLevels, myHorizonSpan, myBudgetConstant);
        // the number of bases at this point is only 1, default value
        
        
        try {
            BufferedWriter out = new BufferedWriter(new FileWriter("Network" + ".csv"));
            StringBuilder sb = new StringBuilder();
            sb.append("NeworkName,");// network id
            sb.append("NumBases,");// num bases
            sb.append("NumItems,");// num items
            sb.append("TotalNwkBudget,");// tot n/w budget
            sb.append("LocationId,");// location id
            sb.append("LocationName,");// item name
            sb.append("ItemID,");// item id
            sb.append("Cost,");// item cost
            sb.append("CostLevel,");// item cost level
            sb.append("BaseStockLevel,"); // item stock level
            sb.append("AvgDemRate,");// average demand
            sb.append("RepairDelay,");// repair delay
            sb.append("Reparability,");// reparability
            sb.append("ShipDelay,");// ship delay
            sb.append("Budget,");// item budget at location
            sb.append("TotalItemBudget,");// total item level budget
            sb.append("PatternLevel,");
            sb.append("HorizonSpan,");
            sb.append("DeploymentSpan,");
            sb.append("SustainmentSpan,");
            sb.append("ReconfigurationSpan,");
            sb.append("LambdaMin,");
            sb.append("LambdaMax,");
            sb.append("NumStockedBases,");// num stocked level
            sb.append("\n");
            out.write(sb.toString());
            out.close();
        }catch (IOException e1){
            
        }
        
    }
    
    public NetworkConfiguration getNetwork(){
        int numitems = (int) myDistNumItems.getValue();
        int numbases = (int) myDistNumBases.getValue();
        myNetworkID ++;
        
        //myItemGenerator.setNumStockedBases(numbases);
        
        NetworkConfiguration network = new NetworkConfiguration(numitems, numbases, myBudgetConstant, 
                myItemGenerator, "Network "+myNetworkID);
        
        writeData(network);
        
        return network;
    
    }
    
    private void writeData(NetworkConfiguration n){
        try {
            BufferedWriter out = new BufferedWriter(new FileWriter("Network" + ".csv",true));
            out.write(n.getDataString());
            out.close();
        } catch (IOException e1){
            
        }
    
    
    }
    
    public static void main(String[]arg){
        double [] cratio = {0.6, 0.1};
        double tp = 500;
        double [] pratio = {0.1, 0.1, 0.1};
        DUniform items = new DUniform(1, 5);
        DUniform bases = new DUniform(1, 10);
        double budgetconstant = 0.7;
        
        NetworkGenerator ng = new NetworkGenerator(items, bases, budgetconstant, 
                cratio, pratio, tp);
        
        for(int i = 1; i <= 5; i++){
            System.out.println(ng.getNetwork());
        }
    }
    
    

}
