package jslx.supplychain.afosr.varimetricsimulator;

import java.util.ArrayList;
import java.util.List;
import java.util.logging.Level;

import jsl.modeling.ExperimentProvider;
import jsl.modeling.ExperimentRunner;
import jsl.utilities.random.distributions.DUniform;
import jsl.utilities.reporting.JSL;
import jslx.forecasting.Croston;
import jslx.forecasting.ForecastTechnique;
import jslx.forecasting.MovingAverage;
import jslx.supplychain.afosr.generation.NetworkConfiguration;

public class UpdatableVMNetworkLGExperimentRunner {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		JSL.LOGGER.setLevel(Level.FINE);
	
		System.out.println("Experiment Provider");		
		 
		double [] cratio = {0.6, 0.1};
        double tp = 500;
        double [] pratio = {0.1, 0.1, 0.1};
        DUniform items = new DUniform(1, 5);
        DUniform bases = new DUniform(1, 10);
        double budgetconstant = 0.7;
		
		List<NetworkConfiguration> nwrks = UpdatableVMNetworkLGExperimentProvider.getNetwork(20, 
				cratio, tp, pratio, items, bases, budgetconstant);
		
		List<ForecastTechnique> fts = new ArrayList<ForecastTechnique>();
		fts.add(new MovingAverage(9));
		fts.add(new Croston(0.1));
		
		double [] prds = {30.0, 120.0};
		
		ExperimentProvider ep = new UpdatableVMNetworkLGExperimentProvider(nwrks, fts, prds, "EP");
		
		ExperimentRunner s = new ExperimentRunner("Test", ep);

		s.runAll();
		
		System.out.println("Done!");

	}

}
