package jslx.supplychain.facilitylayer;

import java.util.ArrayList;
import java.util.Collection;

import jslx.supplychain.inventorylayer.Order;

public class Load implements LoadIfc {

	protected Collection<Order> myOrders;
	
	protected LoadDestinationIfc myDestination;
	
	protected LoadOriginIfc myOrigin;
	
	public Load(LoadOriginIfc origin, LoadDestinationIfc destination) {
		myOrders = new ArrayList<Order>();
		setOrigin(origin);
		setDestination(destination);
	}

	public void addOrder(Order order) {//TODO make sure that added order has the same destination
		if (order == null)
			throw new IllegalArgumentException("Tried to add a null order to the Load");
		
		if (myOrders.contains(order))
			throw new IllegalArgumentException("The supplied order is already on the load");
			
		myOrders.add(order);

	}

	public Collection<Order> getOrders() {
		return myOrders;
	}

	public LoadDestinationIfc getDestination() {
		return myDestination;
	}

	public void setDestination(LoadDestinationIfc destination) {//TODO protected??
		if (destination == null)
			throw new IllegalArgumentException("Tried to set the Load's LoadDestinationIfc to null");
		myDestination = destination;
	}

	public LoadOriginIfc getOrigin() {
		return myOrigin;
	}

	public void setOrigin(LoadOriginIfc origin) {//TODO protected??
		if (origin == null)
			throw new IllegalArgumentException("Tried to set the Load's LoadOriginIfc to null");
		myOrigin = origin;	
	}

}
