package jslx.supplychain.transportlayer.testing;

import jsl.modeling.elements.queue.Queue;
import jslx.supplychain.inventorylayer.Demand;
import jslx.supplychain.transportlayer.DemandLoad;
import jslx.supplychain.transportlayer.DemandLoadBuilder;
import jslx.supplychain.transportlayer.DemandLoadFormingRuleIfc;
/**
 * @author rossetti
 * User defined LoadFormingRule: Toss a coin, if head, wrap all demands in myDemandQ into a load; if tail, do not form a load.
 * For use in DemandLoadBuildingNetworkTest3.java
 */
public class LoadFormingRule_1 implements DemandLoadFormingRuleIfc {
	public boolean formLoad(DemandLoadBuilder builder){
		Queue dq = builder.getDemandQueue();
		if (dq.isEmpty())
			return (false);
		if(Math.random()<=0.5)
			return (false);
		else{
			DemandLoad load = new DemandLoad();
			while(!dq.isEmpty()){
				Demand d = (Demand)dq.removeNext();
				load.addDemand(d);
			}
			// place load in outgoing load queue
			builder.getLoadQueue().enqueue(load);
			return (true);
		}
	}
}
