/*
 * Created on Jul 9, 2006
 *
 */
package jslx.transportlayerFinal;

import jsl.modeling.ModelElement;
import jsl.modeling.elements.spatial.CoordinateIfc;
import jsl.modeling.elements.spatial.SpatialElementIfc;
import jsl.modeling.elements.spatial.SpatialModel;
import jsl.modeling.elements.spatial.SpatialModelElement;

/**
 * @author rossetti
 *
 */
abstract public class AbstractLocation extends SpatialModelElement implements TransportLocationIfc {

	/**
	 * @param parent
	 */
	public AbstractLocation(ModelElement parent) {
		this(parent, null, null, null);
	}

	/**
	 * @param parent
	 * @param name
	 */
	public AbstractLocation(ModelElement parent, String name) {
		this(parent, name, null, null);
	}

	/**
	 * @param parent
	 * @param position
	 */
	public AbstractLocation(ModelElement parent, CoordinateIfc position) {
		this(parent, null, null, position);
	}

	/**
	 * @param parent
	 * @param position
	 */
	public AbstractLocation(ModelElement parent, SpatialElementIfc position) {
		this(parent, null, null, position.getCurrentPosition());
	}

	/**
	 * @param parent
	 * @param name
	 * @param spatialModel
	 */
	public AbstractLocation(ModelElement parent, String name, SpatialModel spatialModel) {
		this(parent, name, spatialModel, null);
	}

	/**
	 * @param parent
	 * @param spatialModel
	 */
	public AbstractLocation(ModelElement parent, SpatialModel spatialModel) {
		this(parent, null, spatialModel, null);
	}

	/**
	 * @param parent
	 * @param spatialModel
	 * @param element
	 */
	public AbstractLocation(ModelElement parent, SpatialModel spatialModel, SpatialElementIfc element) {
		this(parent, null, spatialModel, element.getCurrentPosition());
	}

	/**
	 * @param parent
	 * @param name
	 * @param spatialModel
	 * @param coordinate
	 */
	public AbstractLocation(ModelElement parent, String name, SpatialModel spatialModel, CoordinateIfc coordinate) {
		super(parent, name, spatialModel, coordinate);
	}

}
