/*
 * Created on Jul 9, 2006
 *
 */
package jslx.transportlayerFinal;

/** Lane interface allows lanes to be created and to get their destination, 
 *  origin, distance and the network of the lane 
 * 
 * @author rossetti
 *
 */
public interface LaneIfc {
	
	/** Returns destination of the lane
	 * 
	 * @return destination
	 */
	public abstract TransportLocationIfc getDestination();

	/** Returns origin of the lane
	 * 
	 * @return origin
	 */
	public abstract TransportLocationIfc getOrigin();

	/** Returns distance of the lane
	 * 
	 * @return double
	 */
	public abstract double getDistance();

	/** Returns the lane's transportation network
	 * 
	 * @return
	 */
	public abstract NetworkIfc getNetwork();
}