/*
 * Created on Jul 9, 2006
 *
 */
package jslx.transportlayerFinal;

import jsl.modeling.elements.spatial.CoordinateIfc;
import jsl.modeling.elements.spatial.SpatialElement;
import jsl.modeling.elements.spatial.SpatialModel;

/** Implements TransportLocationIfc which allows an object to be spatially located 
 *  and to receive transport tasks
 *  
 * @author rossetti
 *
 */
public class SMLocation extends SpatialElement implements TransportLocationIfc {

	/**
	 * @param spatialModel
	 */
	public SMLocation(SpatialModel spatialModel) {
		this(spatialModel, spatialModel.getDefaultCoordinate(), null);
	}

	/**
	 * @param spatialModel
	 * @param coordinate
	 */
	public SMLocation(SpatialModel spatialModel, CoordinateIfc coordinate) {
		this(spatialModel, coordinate, null);
	}

	/**
	 * @param spatialModel
	 * @param name
	 */
	public SMLocation(SpatialModel spatialModel, String name) {
		this(spatialModel, spatialModel.getDefaultCoordinate(), name);
	}

	/**
	 * @param spatialModel
	 * @param x
	 * @param y
	 */
	public SMLocation(SpatialModel spatialModel, double x, double y) {
		this(spatialModel, spatialModel.getCoordinate(x, y), null);
	}

	/**
	 * @param spatialModel
	 * @param x
	 * @param y
	 * @param name
	 */
	public SMLocation(SpatialModel spatialModel, double x, double y, String name) {
		this(spatialModel, spatialModel.getCoordinate(x, y), name);
	}

	/**
	 * @param spatialModel
	 * @param x
	 * @param y
	 * @param z
	 */
	public SMLocation(SpatialModel spatialModel, double x, double y, double z) {
		this(spatialModel, spatialModel.getCoordinate(x, y, z), null);
	}

	/**
	 * @param spatialModel
	 * @param x
	 * @param y
	 * @param z
	 * @param name
	 */
	public SMLocation(SpatialModel spatialModel, double x, double y, double z, String name) {
		this(spatialModel, spatialModel.getCoordinate(x, y, z), name);
	}

	/**
	 * @param spatialModel
	 * @param coordinate
	 * @param name
	 */
	public SMLocation(SpatialModel spatialModel, CoordinateIfc coordinate, String name) {
		super(spatialModel, coordinate, name);
	}

	/* (non-Javadoc)
	 * @see transportlayer.TransportTaskReceiverIfc#receiveTransportTask(transportlayer.TransportTask)
	 */
	public void receiveTransportTask(DispatchTask task) {
		
	}


}
