package jslx.transportlayerFinal.graph;

public class AdjMatrixGraph {
	
	private int myVcnt;
	private int myEcnt;
	private boolean myDirectedFlag;
	
	private boolean[][] myMatrix;
	
	public AdjMatrixGraph(int numVertices){
		this(numVertices, true);
	}
	
	public AdjMatrixGraph(int numVertices, boolean directed){
		myVcnt = numVertices;
		myEcnt = 0;
		myDirectedFlag = directed;
		myMatrix = new boolean[myVcnt][myVcnt];
	}
	
	public int getNumVertices(){
		return(myVcnt);
	}
	
	public int getNumEdges(){
		return(myEcnt);
	}
	
	public boolean isDirected(){
		return(myDirectedFlag);
	}
	
	public void insertEdge(int v, int w){
		if (myMatrix[v][w] == false)
			myEcnt++;
		myMatrix[v][w]= true;
		if (!myDirectedFlag)
			myMatrix[w][v] = true;
	}
	
	public void removeEdge(int v, int w){
		if (myMatrix[v][w] == true)
			myEcnt--;
		myMatrix[v][w] = false;
		if (!myDirectedFlag)
			myMatrix[w][v] = false;
	}
	
	public boolean edge(int v, int w){
		return myMatrix[v][w];
	}
	
	public boolean isAllConnected(){
		
		boolean b = true;
		
		for(int i = 0; i < myMatrix.length; i++){
			for(int j = 0; j < myMatrix[i].length; j++){
				if (i == j)
					continue;
				else {
					b = b && myMatrix[i][j];
					if (b == false) // no need to check further
						return(b);
				}
				
			}
		}
		
		return(b);
		
	}
	
	public String toString(){
		StringBuffer s = new StringBuffer();		
		for(int i = 0; i < myMatrix.length; i++){
			s.append(i + " : ");
			for(int j = 0; j < myMatrix[i].length; j++){
				if (myMatrix[i][j])
					s.append(j + " ");
			}
			s.append("\n");
		}
		s.append("\n");
		for(int i = 0; i < myMatrix.length; i++){
			for(int j = 0; j < myMatrix[i].length; j++){
				s.append("(" + i + "," + j + ") = " + myMatrix[i][j] + "\t");
			}
			s.append("\n");
		}

		s.append("\n");
		
		return(s.toString());
	}

}
