package jslx.transportlayerFinal.test;

import jsl.modeling.Experiment;
import jsl.modeling.Model;
import jsl.modeling.elements.spatial.RectangularGridSpatialModel2D;
import jsl.modeling.elements.spatial.SpatialModel;
import jsl.modeling.elements.spatial.Vector3D;
import jsl.utilities.random.distributions.Constant;
import jsl.utilities.random.distributions.DistributionIfc;
import jsl.utilities.random.distributions.Exponential;
import jslx.transportlayerFinal.AbstractDispatcherFTL;
import jslx.transportlayerFinal.DispatcherFTL;
import jslx.transportlayerFinal.Lane;
import jslx.transportlayerFinal.LaneIfc;
import jslx.transportlayerFinal.LoadGenerator;
import jslx.transportlayerFinal.Location;
import jslx.transportlayerFinal.TransportationNetwork;

public class TestDispatcher {
	
	public static void main(String[] args){
		
		System.out.println("Simple Transportation Model");
		
		test1();
		
		System.out.println("Done!");
	}
	
	public static void test1(){
		
		System.out.println("TruckLoad Transportation Network");
		
		Model m = Model.createModel();
		
		System.out.println("Model Created");
		
		SpatialModel smodel = new RectangularGridSpatialModel2D();
				
		Location l1 = new Location(m,"Kansas City",smodel, new Vector3D(0.0,0.0,0.0));
		Location l2 = new Location(m,"Chicago",smodel,new Vector3D(1.0,2.0,3.0));
		Location l3 = new Location(m,"New York",smodel, new Vector3D(5.0,4.0,0.0));
		Location l4 = new Location(m,"Boston",smodel, new Vector3D(3.0,7.0,0.0));
		Location l5 = new Location(m,"Atlanta",smodel, new Vector3D(4.0,9.0,0.0));
		Location l6 = new Location(m,"Los Angeles",smodel, new Vector3D(3.0,4.0,0.0));
		
		DistributionIfc tl = new Exponential(1.0);
		
		TransportationNetwork t=new TransportationNetwork(m, smodel);
		
		System.out.println("Here is the Transportation Network");	
		
		l1.setLoadingTimeDistribution(new Constant (2.0));
		l2.setLoadingTimeDistribution(new Constant (2.0));
		l3.setLoadingTimeDistribution(new Constant (2.0));
		l4.setLoadingTimeDistribution(new Constant (2.0));
		l5.setLoadingTimeDistribution(new Constant (2.0));
		l6.setLoadingTimeDistribution(new Constant (2.0));
		
		l1.setUnloadingTimeDistribution(new Constant (1.0));
		l2.setUnloadingTimeDistribution(new Constant (1.0));
		l3.setUnloadingTimeDistribution(new Constant (1.0));
		l4.setUnloadingTimeDistribution(new Constant (1.0));
		l5.setUnloadingTimeDistribution(new Constant (1.0));
		l6.setUnloadingTimeDistribution(new Constant (1.0));
		
		LaneIfc lane12= new Lane(t,l1,l2,Math.sqrt(5));
		LaneIfc lane13= new Lane(t,l1,l3,Math.sqrt(41));
		LaneIfc lane14= new Lane(t,l1,l4,Math.sqrt(58));
		LaneIfc lane15= new Lane(t,l1,l5,Math.sqrt(97));
		LaneIfc lane16= new Lane(t,l1,l6,Math.sqrt(25));
		
		LaneIfc lane21= new Lane(t,l2,l1,Math.sqrt(5));
		LaneIfc lane23= new Lane(t,l2,l3,Math.sqrt(20));
		LaneIfc lane24= new Lane(t,l2,l4,Math.sqrt(29));
		LaneIfc lane25= new Lane(t,l2,l5,Math.sqrt(58));
		LaneIfc lane26= new Lane(t,l2,l6,Math.sqrt(8));
		
		LaneIfc lane31= new Lane(t,l3,l1,Math.sqrt(41));
		LaneIfc lane32= new Lane(t,l3,l2,Math.sqrt(20));
		LaneIfc lane34= new Lane(t,l3,l4,Math.sqrt(13));
		LaneIfc lane35= new Lane(t,l3,l5,Math.sqrt(26));
		LaneIfc lane36= new Lane(t,l3,l6,Math.sqrt(4));
		
		LaneIfc lane41= new Lane(t,l4,l1,Math.sqrt(58));
		LaneIfc lane42= new Lane(t,l4,l2,Math.sqrt(29));
		LaneIfc lane43= new Lane(t,l4,l3,Math.sqrt(13));
		LaneIfc lane45= new Lane(t,l4,l5,Math.sqrt(5));
		LaneIfc lane46= new Lane(t,l4,l6,Math.sqrt(9));
		
		LaneIfc lane51= new Lane(t,l5,l1,Math.sqrt(97));
		LaneIfc lane52= new Lane(t,l5,l2,Math.sqrt(58));
		LaneIfc lane53= new Lane(t,l5,l3,Math.sqrt(26));
		LaneIfc lane54= new Lane(t,l5,l4,Math.sqrt(5));
		LaneIfc lane56= new Lane(t,l5,l6,Math.sqrt(26));
		
		LaneIfc lane61= new Lane(t,l6,l1,Math.sqrt(25));
		LaneIfc lane62= new Lane(t,l6,l2,Math.sqrt(8));
		LaneIfc lane63= new Lane(t,l6,l3,Math.sqrt(4));
		LaneIfc lane64= new Lane(t,l6,l4,Math.sqrt(9));
		LaneIfc lane65= new Lane(t,l6,l5,Math.sqrt(26));
		
		t.addLane(lane12);
		t.addLane(lane13);
		t.addLane(lane14);
		t.addLane(lane15);
		t.addLane(lane16);
		
		t.addLane(lane21);
		t.addLane(lane23);
		t.addLane(lane24);
		t.addLane(lane25);
		t.addLane(lane26);
		
		t.addLane(lane31);
		t.addLane(lane32);
		t.addLane(lane34);
		t.addLane(lane35);
		t.addLane(lane36);
		
		t.addLane(lane41);
		t.addLane(lane42);
		t.addLane(lane43);
		t.addLane(lane45);
		t.addLane(lane46);
		
		t.addLane(lane51);
		t.addLane(lane52);
		t.addLane(lane53);
		t.addLane(lane54);
		t.addLane(lane56);
		
		t.addLane(lane61);
		t.addLane(lane62);
		t.addLane(lane63);
		t.addLane(lane64);
		t.addLane(lane65);
		
		System.out.println(t);
		
		AbstractDispatcherFTL d = new DispatcherFTL(m,t,6.0);
		
		d.addDriver(l1,11.0,14.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),new Constant(1.0));
		d.addDriver(l2,11.0,14.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),new Constant(1.0));
		d.addDriver(l3,11.0,14.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),new Constant(1.0));
		d.addDriver(l4,11.0,14.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),new Constant(1.0));
		d.addDriver(l5,11.0,14.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),new Constant(1.0));
		d.addDriver(l6,11.0,14.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),new Constant(1.0));
		
		d.addTrailer(l1);
		d.addTrailer(l2);
		d.addTrailer(l3);
		d.addTrailer(l4);
		d.addTrailer(l5);
		d.addTrailer(l6);
		
		d.addTruck(l1);
		d.addTruck(l2);
		d.addTruck(l3);
		d.addTruck(l4);
		d.addTruck(l5);
		d.addTruck(l6);
		
		//Create the Load generator
		LoadGenerator lg = new LoadGenerator(m,t,tl,tl); 
		
		System.out.println("Here is the load generator");
		
		lg.setOriginProbability(l1, 0.2);
		lg.setOriginProbability(l2, 0.2);
		lg.setOriginProbability(l3, 0.1);
		lg.setOriginProbability(l4, 0.1);
		lg.setOriginProbability(l5, 0.1);
		lg.setLastOriginProbability(l6);
		
		System.out.println("origin probability set");
		
		lg.setDestinationProbability(lane12,0.2);
		lg.setDestinationProbability(lane13,0.2);
		lg.setDestinationProbability(lane14,0.2);
		lg.setDestinationProbability(lane15,0.1);
		lg.setLastDestinationProbability(lane16);
		
		lg.setDestinationProbability(lane21,0.2);
		lg.setDestinationProbability(lane23,0.1);
		lg.setDestinationProbability(lane24,0.2);
		lg.setDestinationProbability(lane25,0.1);
		lg.setLastDestinationProbability(lane26);
		
		lg.setDestinationProbability(lane31,0.2);
		lg.setDestinationProbability(lane32,0.1);
		lg.setDestinationProbability(lane34,0.2);
		lg.setDestinationProbability(lane35,0.1);
		lg.setLastDestinationProbability(lane36);
		
		lg.setDestinationProbability(lane41,0.2);
		lg.setDestinationProbability(lane42,0.1);
		lg.setDestinationProbability(lane43,0.2);
		lg.setDestinationProbability(lane45,0.1);
		lg.setLastDestinationProbability(lane46);
		
		lg.setDestinationProbability(lane51,0.1);
		lg.setDestinationProbability(lane52,0.1);
		lg.setDestinationProbability(lane53,0.1);
		lg.setDestinationProbability(lane54,0.1);
		lg.setLastDestinationProbability(lane56);
		
		lg.setDestinationProbability(lane61,0.2);
		lg.setDestinationProbability(lane62,0.1);
		lg.setDestinationProbability(lane63,0.2);
		lg.setDestinationProbability(lane64,0.1);
		lg.setLastDestinationProbability(lane65);
		
		System.out.println("destination probability set");
		
		m.turnOnLogReport();
		
		// create the experiment to run the model
		Experiment e = new Experiment(m);
		
		// set the parameters of the experiment
		e.setNumberOfReplications(2);
		e.setLengthOfReplication(20);
		e.setLengthOfWarmUp(0.0);
		
		// turn on the desired reporting
		/*	e.turnOnBatchReport(); 
		 e.turnOnExperimentReport();
		 e.turnOnReplicationReport();
		 e.turnOnExperimentConsoleOutput();
		 */	
		// tell the experiment to run
		e.runAll();
		
	}
	
	public static void test2(){
		
		System.out.println("Testing Bobtail Case");
		
		Model m = Model.createModel();
		
		System.out.println("Model Created");
		
		DistributionIfc tl = new Exponential(1.0);
		
		SpatialModel smodel = new RectangularGridSpatialModel2D();
		
		TransportationNetwork t=new TransportationNetwork(m, smodel);
		
		System.out.println("Here is the Transportation Network");		
		
		Location k = new Location(m,"Kansas City",smodel, new Vector3D(0.0,0.0,0.0));
		Location c = new Location(m,"Chicago",smodel,new Vector3D(1.0,2.0,3.0));
		Location n = new Location(m,"New York",smodel, new Vector3D(5.0,4.0,0.0));
		Location b = new Location(m,"Boston",smodel, new Vector3D(3.0,7.0,0.0));
		Location a = new Location(m,"Atlanta",smodel, new Vector3D(4.0,9.0,0.0));
		Location l = new Location(m,"Los Angeles",smodel, new Vector3D(3.0,4.0,0.0));
		
		LaneIfc kc= new Lane(t,k,c,Math.sqrt(5));
		LaneIfc cn = new Lane(t,c,n,Math.sqrt(20));
		LaneIfc nb = new Lane(t,n,b,Math.sqrt(13));
		LaneIfc bn = new Lane(t,b,n,Math.sqrt(13));
		LaneIfc ab = new Lane(t,a,b,Math.sqrt(5));
		LaneIfc al= new Lane(t,a,l,Math.sqrt(26));
		LaneIfc cl= new Lane(t,c,l,Math.sqrt(8));
		LaneIfc lk= new Lane(t,l,k,Math.sqrt(25));
		
		t.addLane(kc);
		t.addLane(cn);
		t.addLane(nb);
		t.addLane(bn);
		t.addLane(ab);
		t.addLane(al);
		t.addLane(cl);
		t.addLane(lk);
		
		System.out.println(t);
		
		AbstractDispatcherFTL d = new DispatcherFTL(m,t,6.0);
		
		d.addDriver(k,11.0,14.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),new Constant(1.0));
		//	d.addDriver(c);
		d.addDriver(n,11.0,14.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),new Constant(1.0));
		d.addDriver(b,11.0,14.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),new Constant(1.0));
		d.addDriver(a,11.0,14.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),new Constant(1.0));
		d.addDriver(l,11.0,14.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),new Constant(1.0));
		
		d.addTrailer(k);
		d.addTrailer(c);
		d.addTrailer(n);
		d.addTrailer(b);
		d.addTrailer(a);
		d.addTrailer(l);
		
		d.addTruck(k);
		//	d.addTruck(c);
		d.addTruck(n);
		d.addTruck(b);
		d.addTruck(a);
		d.addTruck(l);
		
//		Create the Load generator
		LoadGenerator lg = new LoadGenerator(m,t,tl,tl); 
		
		System.out.println("Here is the load generator");
		
		lg.setOriginProbability(k, 0.2);
		lg.setOriginProbability(c, 0.2);
		lg.setOriginProbability(n, 0.1);
		lg.setOriginProbability(b, 0.1);
		lg.setOriginProbability(a, 0.1);
		lg.setLastOriginProbability(l);
		
		System.out.println("origin probability set");
		
		lg.setLastDestinationProbability(kc);
		
		lg.setDestinationProbability(cn,0.2);
		lg.setLastDestinationProbability(cl);
		
		lg.setLastDestinationProbability(nb);
		
		lg.setLastDestinationProbability(bn);
		
		lg.setDestinationProbability(ab,0.1);
		lg.setLastDestinationProbability(al);
		
		lg.setLastDestinationProbability(lk);
		
		System.out.println("destination probability set");
		
		m.turnOnLogReport();
		
		// create the experiment to run the model
		Experiment e = new Experiment(m);
		
		// set the parameters of the experiment
		e.setNumberOfReplications(1);
		e.setLengthOfReplication(10);
		e.setLengthOfWarmUp(0.0);
		
		// turn on the desired reporting
//		e.turnOnBatchReport(); 
//		e.turnOnExperimentReport();
		//	e.turnOnReplicationReport();
//		e.turnOnExperimentConsoleOutput();
		
		// tell the experiment to run
		e.runAll();
		
	}
	
	public static void test3(){
		
		System.out.println("Testing Deadhead Case");
		
		Model m = Model.createModel();
		
		System.out.println("Model Created");
		
		DistributionIfc tl = new Exponential(1.0);
		
		SpatialModel smodel = new RectangularGridSpatialModel2D();
		
		TransportationNetwork t=new TransportationNetwork(m, smodel);
		
		System.out.println("Here is the Transportation Network");		
		
		Location k = new Location(m,"Kansas City",smodel, new Vector3D(0.0,0.0,0.0));
		Location c = new Location(m,"Chicago",smodel,new Vector3D(1.0,2.0,3.0));
		Location n = new Location(m,"New York",smodel, new Vector3D(5.0,4.0,0.0));
		Location b = new Location(m,"Boston",smodel, new Vector3D(3.0,7.0,0.0));
		Location a = new Location(m,"Atlanta",smodel, new Vector3D(4.0,9.0,0.0));
		Location l = new Location(m,"Los Angeles",smodel, new Vector3D(3.0,4.0,0.0));
		
		LaneIfc kc = new Lane(t,k,c,Math.sqrt(5));
		LaneIfc cn = new Lane(t,c,n,Math.sqrt(20));
		LaneIfc nb = new Lane(t,n,b,Math.sqrt(13));
		LaneIfc bn = new Lane(t,b,n,Math.sqrt(13));
		LaneIfc ab = new Lane(t,a,b,Math.sqrt(5));
		LaneIfc al= new Lane(t,a,l,Math.sqrt(26));
		LaneIfc cl= new Lane(t,c,l,Math.sqrt(8));
		LaneIfc lk= new Lane(t,l,k,Math.sqrt(25));
		
		t.addLane(kc);
		t.addLane(cn);
		t.addLane(nb);
		t.addLane(bn);
		t.addLane(ab);
		t.addLane(al);
		t.addLane(cl);
		t.addLane(lk);
		
		System.out.println(t);
		
		AbstractDispatcherFTL d = new DispatcherFTL(m,t,6.0);
		
		d.addDriver(k,11.0,14.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),new Constant(1.0));
		d.addDriver(c,11.0,14.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),new Constant(1.0));
		d.addDriver(n,11.0,14.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),new Constant(1.0));
		d.addDriver(b,11.0,14.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),new Constant(1.0));
		d.addDriver(a,11.0,14.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),new Constant(1.0));
		d.addDriver(l,11.0,14.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),new Constant(1.0));
		
		d.addTrailer(k);
		d.addTrailer(c);
		d.addTrailer(n);
		d.addTrailer(b);
		d.addTrailer(a);
		d.addTrailer(l);
		
		d.addTruck(k);
		d.addTruck(c);
		d.addTruck(n);
		d.addTruck(b);
		d.addTruck(a);
		d.addTruck(l);
		
//		Create the Load generator
		LoadGenerator lg = new LoadGenerator(m,t,tl,tl); 
		
		System.out.println("Here is the load generator");
		
		lg.setOriginProbability(k, 0.2);
		lg.setOriginProbability(c, 0.2);
		lg.setOriginProbability(n, 0.1);
		lg.setOriginProbability(b, 0.1);
		lg.setOriginProbability(a, 0.1);
		lg.setLastOriginProbability(l);
		
		System.out.println("origin probability set");
		
		lg.setLastDestinationProbability(kc);
		
		lg.setDestinationProbability(cn,0.2);
		lg.setLastDestinationProbability(cl);
		
		lg.setLastDestinationProbability(nb);
		
		lg.setLastDestinationProbability(bn);
		
		lg.setDestinationProbability(ab,0.1);
		lg.setLastDestinationProbability(al);
		
		lg.setLastDestinationProbability(lk);
		
		System.out.println("destination probability set");
		
		m.turnOnLogReport();
		
		// create the experiment to run the model
		Experiment e = new Experiment(m);
		
		// set the parameters of the experiment
		e.setNumberOfReplications(1);
		e.setLengthOfReplication(10);
		e.setLengthOfWarmUp(0.0);
		
		// turn on the desired reporting
//		e.turnOnBatchReport(); 
//		e.turnOnExperimentReport();
		//	e.turnOnReplicationReport();
//		e.turnOnExperimentConsoleOutput();
		
		// tell the experiment to run
		e.runAll();
		
	}
	/*
	public static void test6(){
		
		System.out.println("Testing 2 loads generation");
		
		Model m = Model.createModel();
		
		System.out.println("Model Created");
		
		DistributionIfc tl = new Exponential(1.0);
		
		SpatialModel smodel = new RectangularGridSpatialModel2D();
		
		TransportationNetwork t=new TransportationNetwork(m, smodel);
		
		System.out.println("Here is the Transportation Network");		
		
		Location k = new Location(m,"Kansas City",smodel, new Vector3D(0.0,0.0,0.0));
		Location c = new Location(m,"Chicago",smodel,new Vector3D(1.0,2.0,3.0));
		Location n = new Location(m,"New York",smodel, new Vector3D(5.0,4.0,0.0));
		Location b = new Location(m,"Boston",smodel, new Vector3D(3.0,7.0,0.0));
		Location a = new Location(m,"Atlanta",smodel, new Vector3D(4.0,9.0,0.0));
		Location l = new Location(m,"Los Angeles",smodel, new Vector3D(3.0,4.0,0.0));
		
		LaneIfc kc= new Lane(t,k,c,Math.sqrt(5));
		LaneIfc cn = new Lane(t,c,n,Math.sqrt(20));
		LaneIfc nb = new Lane(t,n,b,Math.sqrt(13));
		LaneIfc bn = new Lane(t,b,n,Math.sqrt(13));
		LaneIfc ab = new Lane(t,a,b,Math.sqrt(5));
		LaneIfc al= new Lane(t,a,l,Math.sqrt(26));
		LaneIfc cl= new Lane(t,c,l,Math.sqrt(8));
		LaneIfc lk= new Lane(t,l,k,Math.sqrt(25));
		
		t.addLane(kc);
		t.addLane(cn);
		t.addLane(nb);
		t.addLane(bn);
		t.addLane(ab);
		t.addLane(al);
		t.addLane(cl);
		t.addLane(lk);
		
		System.out.println(t);
		
		AbstractDispatcherFTL d = new DispatcherFTL(m,t,6.0);
		
		d.addDriver(k,11.0,14.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),new Constant(1.0));
//		d.addDriver(c);
//		d.addDriver(n);
		d.addDriver(b,11.0,14.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),new Constant(1.0));
//		d.addDriver(a);
//		d.addDriver(l);
		
		d.addTrailer(k);
//		d.addTrailer(c);
//		d.addTrailer(n);
		d.addTrailer(b);
//		d.addTrailer(a);
//		d.addTrailer(l);
		
		d.addTruck(k);
//		d.addTruck(c);
//		d.addTruck(n);
		d.addTruck(b);
//		d.addTruck(a);
//		d.addTruck(l);
		
//		Create the Load generator
		LoadGenerator lg = new LoadGenerator(m,t,tl,tl); 
		
		System.out.println("Here is the load generator");
		
		lg.setOriginProbability(k, 0.2);
		lg.setOriginProbability(c, 0.2);
		lg.setOriginProbability(n, 0.1);
		lg.setOriginProbability(b, 0.1);
		lg.setOriginProbability(a, 0.1);
		lg.setLastOriginProbability(l);
		
		System.out.println("origin probability set");
		
		lg.setLastDestinationProbability(kc);
		
		lg.setDestinationProbability(cn,0.2);
		lg.setLastDestinationProbability(cl);
		
		lg.setLastDestinationProbability(nb);
		
		lg.setLastDestinationProbability(bn);
		
		lg.setDestinationProbability(ab,0.1);
		lg.setLastDestinationProbability(al);
		
		lg.setLastDestinationProbability(lk);
		
		System.out.println("destination probability set");
		
		m.turnOnLogReport();
		
		// create the experiment to run the model
		Experiment e = new Experiment(m);
		
		// set the parameters of the experiment
		e.setNumberOfReplications(1);
		e.setLengthOfReplication(100);
		e.setLengthOfWarmUp(0.0);
		
		// turn on the desired reporting
//		e.turnOnBatchReport(); 
		e.turnOnExperimentReport();
		//	e.turnOnReplicationReport();
		e.turnOnExperimentConsoleOutput();
		
		// tell the experiment to run
		e.runAll();
		
	}
	public static void test7(){
		
		System.out.println("Testing 3 loads generation");
		
		Model m = Model.createModel();
		
		System.out.println("Model Created");
		
		DistributionIfc tl = new Exponential(1.0);
		
		SpatialModel smodel = new RectangularGridSpatialModel2D();
		
		TransportationNetwork t=new TransportationNetwork(m, smodel);
		
		System.out.println("Here is the Transportation Network");		
		
		Location k = new Location(m,"Kansas City",smodel, new Vector3D(0.0,0.0,0.0));
		Location c = new Location(m,"Chicago",smodel,new Vector3D(1.0,2.0,3.0));
		Location n = new Location(m,"New York",smodel, new Vector3D(5.0,4.0,0.0));
		Location b = new Location(m,"Boston",smodel, new Vector3D(3.0,7.0,0.0));
		Location a = new Location(m,"Atlanta",smodel, new Vector3D(4.0,9.0,0.0));
		Location l = new Location(m,"Los Angeles",smodel, new Vector3D(3.0,4.0,0.0));
		
		
		LaneIfc kc= new Lane(t,k,c,Math.sqrt(5));
		LaneIfc cn = new Lane(t,c,n,Math.sqrt(20));
		LaneIfc nb = new Lane(t,n,b,Math.sqrt(13));
		LaneIfc bn = new Lane(t,b,n,Math.sqrt(13));
		LaneIfc ab = new Lane(t,a,b,Math.sqrt(5));
		LaneIfc al= new Lane(t,a,l,Math.sqrt(26));
		LaneIfc cl= new Lane(t,c,l,Math.sqrt(8));
		LaneIfc lk= new Lane(t,l,k,Math.sqrt(25));
		LaneIfc na = new Lane(t,n,a,Math.sqrt(26));
		
		t.addLane(kc);
		t.addLane(cn);
		t.addLane(nb);
		t.addLane(bn);
		t.addLane(ab);
		t.addLane(al);
		t.addLane(cl);
		t.addLane(lk);
		t.addLane(na);
		
		System.out.println(t);
		
		AbstractDispatcherFTL d = new DispatcherFTL(m,t,6.0);
		
		d.addDriver(k,11.0,14.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),new Constant(1.0));
//		d.addDriver(c,11.0,14.0);
//		d.addDriver(n,11.0,14.0);
		d.addDriver(b,11.0,14.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),new Constant(1.0));
//		d.addDriver(a);
		d.addDriver(l,11.0,14.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),new Constant(1.0));
		
		d.addTrailer(k);
//		d.addTrailer(c);
//		d.addTrailer(n);
		d.addTrailer(b);
//		d.addTrailer(a);
//		d.addTrailer(l);
		
		d.addTruck(k);
//		d.addTruck(c);
//		d.addTruck(n);
		d.addTruck(b);
//		d.addTruck(a);
		d.addTruck(l);
		
//		Create the Load generator
		LoadGenerator lg = new LoadGenerator(m,t,tl,tl); 
		
		System.out.println("Here is the load generator");
		
		lg.setOriginProbability(k, 0.2);
		lg.setOriginProbability(c, 0.2);
		lg.setOriginProbability(n, 0.1);
		lg.setOriginProbability(b, 0.1);
		lg.setOriginProbability(a, 0.1);
		lg.setLastOriginProbability(l);
		
		System.out.println("origin probability set");
		
		lg.setLastDestinationProbability(kc);
		
		lg.setDestinationProbability(cn,0.2);
		lg.setLastDestinationProbability(cl);
		
		lg.setLastDestinationProbability(nb);
		
		lg.setLastDestinationProbability(bn);
		
		lg.setLastDestinationProbability(na);
		
		lg.setDestinationProbability(ab,0.1);
		lg.setLastDestinationProbability(al);
		
		lg.setLastDestinationProbability(lk);
		
		System.out.println("destination probability set");
		
		m.turnOnLogReport();
		
		// create the experiment to run the model
		Experiment e = new Experiment(m);
		
		// set the parameters of the experiment
		e.setNumberOfReplications(1);
		e.setLengthOfReplication(100);
		e.setLengthOfWarmUp(0.0);
		
		// turn on the desired reporting
		e.turnOnBatchReport(); 
		e.turnOnExperimentReport();
		//	e.turnOnReplicationReport();
		e.turnOnExperimentConsoleOutput();
		
		// tell the experiment to run
		e.runAll();
	}
	
	public static void test8(){
		
		System.out.println("Testing 4 loads generation");
		
		Model m = Model.createModel();
		
		System.out.println("Model Created");
		
		DistributionIfc tl = new Exponential(1.0);
		
		SpatialModel smodel = new RectangularGridSpatialModel2D();
		
		TransportationNetwork t=new TransportationNetwork(m, smodel);
		
		System.out.println("Here is the Transportation Network");		
		
		Location k = new Location(m,"Kansas City",smodel, new Vector3D(0.0,0.0,0.0));
		Location c = new Location(m,"Chicago",smodel,new Vector3D(1.0,2.0,3.0));
		Location n = new Location(m,"New York",smodel, new Vector3D(5.0,4.0,0.0));
		Location b = new Location(m,"Boston",smodel, new Vector3D(3.0,7.0,0.0));
		Location a = new Location(m,"Atlanta",smodel, new Vector3D(4.0,9.0,0.0));
		Location l = new Location(m,"Los Angeles",smodel, new Vector3D(3.0,4.0,0.0));
		
		k.setLoadingTimeDistribution(new Constant (1.0));
		c.setLoadingTimeDistribution(new Constant (1.0));
		n.setLoadingTimeDistribution(new Constant (1.0));
		b.setLoadingTimeDistribution(new Constant (1.0));
		a.setLoadingTimeDistribution(new Constant (1.0));
		l.setLoadingTimeDistribution(new Constant (1.0));
		
		k.setUnloadingTimeDistribution(new Constant (1.0));
		c.setUnloadingTimeDistribution(new Constant (1.0));
		n.setUnloadingTimeDistribution(new Constant (1.0));
		b.setUnloadingTimeDistribution(new Constant (1.0));
		a.setUnloadingTimeDistribution(new Constant (1.0));
		l.setUnloadingTimeDistribution(new Constant (1.0));
		
		LaneIfc kc= new Lane(t,k,c,Math.sqrt(5));
		LaneIfc cn = new Lane(t,c,n,Math.sqrt(20));
		LaneIfc nb = new Lane(t,n,b,Math.sqrt(13));
		LaneIfc bn = new Lane(t,b,n,Math.sqrt(13));
		LaneIfc ab = new Lane(t,a,b,Math.sqrt(5));
		LaneIfc al= new Lane(t,a,l,Math.sqrt(26));
		LaneIfc cl= new Lane(t,c,l,Math.sqrt(8));
		LaneIfc lk= new Lane(t,l,k,Math.sqrt(25));
		LaneIfc na = new Lane(t,n,a,Math.sqrt(26));
		
		t.addLane(kc);
		t.addLane(cn);
		t.addLane(nb);
		t.addLane(bn);
		t.addLane(ab);
		t.addLane(al);
		t.addLane(cl);
		t.addLane(lk);
		t.addLane(na);
		
		System.out.println(t);
		
		AbstractDispatcherFTL d = new DispatcherFTL(m,t,6.0);
		
		d.addDriver(k,11.0,14.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),new Constant(1.0));
//		d.addDriver(c);
//		d.addDriver(n);
		d.addDriver(b,11.0,14.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),new Constant(1.0));
//		d.addDriver(a);
//		d.addDriver(l);
		
		d.addTrailer(k);
//		d.addTrailer(c);
//		d.addTrailer(n);
		d.addTrailer(b);
//		d.addTrailer(a);
//		d.addTrailer(l);
		
		d.addTruck(k);
//		d.addTruck(c);
//		d.addTruck(n);
		d.addTruck(b);
//		d.addTruck(a);
//		d.addTruck(l);
		
//		Create the Load generator
		LoadGenerator lg = new LoadGenerator(m,t,tl,tl); 
		
		System.out.println("Here is the load generator");
		
		lg.setOriginProbability(k, 0.2);
		lg.setOriginProbability(c, 0.2);
		lg.setOriginProbability(n, 0.1);
		lg.setOriginProbability(b, 0.1);
		lg.setOriginProbability(a, 0.1);
		lg.setLastOriginProbability(l);
		
		System.out.println("origin probability set");
		
		lg.setLastDestinationProbability(kc);
		
		lg.setDestinationProbability(cn,0.2);
		lg.setLastDestinationProbability(cl);
		
		lg.setLastDestinationProbability(nb);
		
		lg.setLastDestinationProbability(bn);
		
		lg.setLastDestinationProbability(na);
		
		lg.setDestinationProbability(ab,0.1);
		lg.setLastDestinationProbability(al);
		
		lg.setLastDestinationProbability(lk);
		
		System.out.println("destination probability set");
		
		m.turnOnLogReport();
		
		// create the experiment to run the model
		Experiment e = new Experiment(m);
		
		// set the parameters of the experiment
		e.setNumberOfReplications(1);
		e.setLengthOfReplication(100);
		e.setLengthOfWarmUp(0.0);
		
		// turn on the desired reporting
//		e.turnOnBatchReport(); 
//		e.turnOnExperimentReport();
//		e.turnOnReplicationReport();
//		e.turnOnExperimentConsoleOutput();
		
		// tell the experiment to run
		e.runAll();
		
	}
	public static void test9(){
		
		System.out.println("Testing Initialization");
		
		Model m = Model.createModel();
		
		System.out.println("Model Created");
		
		DistributionIfc tl = new Exponential(1.0);
		
		SpatialModel smodel = new RectangularGridSpatialModel2D();
		
		TransportationNetwork t=new TransportationNetwork(m, smodel);
		
		System.out.println("Here is the Transportation Network");		
		
		Location k = new Location(m,"Kansas City",smodel, new Vector3D(0.0,0.0,0.0));
		Location c = new Location(m,"Chicago",smodel,new Vector3D(1.0,2.0,3.0));
		Location n = new Location(m,"New York",smodel, new Vector3D(5.0,4.0,0.0));
		Location b = new Location(m,"Boston",smodel, new Vector3D(3.0,7.0,0.0));
		Location a = new Location(m,"Atlanta",smodel, new Vector3D(4.0,9.0,0.0));
		Location l = new Location(m,"Los Angeles",smodel, new Vector3D(3.0,4.0,0.0));
		
		k.setLoadingTimeDistribution(new Constant (1.0));
		c.setLoadingTimeDistribution(new Constant (1.0));
		n.setLoadingTimeDistribution(new Constant (1.0));
		b.setLoadingTimeDistribution(new Constant (1.0));
		a.setLoadingTimeDistribution(new Constant (1.0));
		l.setLoadingTimeDistribution(new Constant (1.0));
		
		k.setUnloadingTimeDistribution(new Constant (1.0));
		c.setUnloadingTimeDistribution(new Constant (1.0));
		n.setUnloadingTimeDistribution(new Constant (1.0));
		b.setUnloadingTimeDistribution(new Constant (1.0));
		a.setUnloadingTimeDistribution(new Constant (1.0));
		l.setUnloadingTimeDistribution(new Constant (1.0));
		
		LaneIfc kc= new Lane(t,k,c,Math.sqrt(5));
		LaneIfc cn = new Lane(t,c,n,Math.sqrt(20));
		LaneIfc nb = new Lane(t,n,b,Math.sqrt(13));
		//LaneIfc bn = new Lane(t,b,n,Math.sqrt(13));
		LaneIfc bn = new Lane(t,b,n,20.0);
		LaneIfc ab = new Lane(t,a,b,Math.sqrt(5));
		LaneIfc al= new Lane(t,a,l,Math.sqrt(26));
		LaneIfc cl= new Lane(t,c,l,Math.sqrt(8));
		LaneIfc lk= new Lane(t,l,k,Math.sqrt(25));
		LaneIfc na = new Lane(t,n,a,Math.sqrt(26));
		LaneIfc kl= new Lane(t,k,l,Math.sqrt(25));
		
		t.addLane(kc);
		t.addLane(cn);
		t.addLane(nb);
		t.addLane(bn);
		t.addLane(ab);
		t.addLane(al);
		t.addLane(cl);
		t.addLane(lk);
		t.addLane(na);
		t.addLane(kl);
		
		System.out.println(t);
		
		AbstractDispatcherFTL d = new DispatcherFTL(m,t,6.0);
		
//		d.addDriver(k);
		d.addDriver(c,11.0,14.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),new Constant(1.0));
//		d.addDriver(n);
		d.addDriver(b,11.0,14.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),new Constant(1.0));
//		d.addDriver(a);
		d.addDriver(l,11.0,14.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),new Constant(1.0));
		
//		d.addTrailer(k);
		d.addTrailer(c);
//		d.addTrailer(n);
		d.addTrailer(b);
//		d.addTrailer(a);
		d.addTrailer(l);
		
//		d.addTruck(k);
		d.addTruck(c);
//		d.addTruck(n);
		d.addTruck(b);
//		d.addTruck(a);
		d.addTruck(l);
		
//		Create the Load generator
		LoadGenerator lg = new LoadGenerator(m,t,tl,tl); 
		
		System.out.println("Here is the load generator");
		
		lg.setOriginProbability(k, 0.2);
		lg.setOriginProbability(c, 0.2);
		lg.setOriginProbability(n, 0.1);
		lg.setOriginProbability(b, 0.1);
		lg.setOriginProbability(a, 0.1);
		lg.setLastOriginProbability(l);
		
		System.out.println("origin probability set");
		lg.setDestinationProbability(kl,0.1);
		lg.setLastDestinationProbability(kc);
		
		lg.setDestinationProbability(cn,0.2);
		lg.setLastDestinationProbability(cl);
		
		lg.setLastDestinationProbability(nb);
		
		lg.setLastDestinationProbability(bn);
		
		lg.setLastDestinationProbability(na);
		
		lg.setDestinationProbability(ab,0.1);
		lg.setLastDestinationProbability(al);
		
		lg.setLastDestinationProbability(lk);
		
		System.out.println("destination probability set");
		
		m.turnOnLogReport();
		
		// create the experiment to run the model
		Experiment e = new Experiment(m);
		
		// set the parameters of the experiment
		e.setNumberOfReplications(1);
		e.setLengthOfReplication(100);
		e.setLengthOfWarmUp(0.0);
		
		// turn on the desired reporting
		/*	e.turnOnBatchReport(); 
		 e.turnOnExperimentReport();
		 e.turnOnReplicationReport();
		 e.turnOnExperimentConsoleOutput();
		 
		// tell the experiment to run
		e.runAll();
	}
	
	public static void test10(){
		
		System.out.println("Test Case for Driver");
		
		Model m = Model.createModel();
		
		System.out.println("Model Created");
		
		DistributionIfc tl = new Exponential(1.0);
		
		SpatialModel smodel = new RectangularGridSpatialModel2D();
		
		TransportationNetwork t=new TransportationNetwork(m, smodel);
		
		System.out.println("Here is the Transportation Network");		
		
		Location k = new Location(m,"Kansas City",smodel, new Vector3D(0.0,0.0,0.0));
		Location c = new Location(m,"Chicago",smodel,new Vector3D(1.0,2.0,3.0));
		Location n = new Location(m,"New York",smodel, new Vector3D(5.0,4.0,0.0));
		Location b = new Location(m,"Boston",smodel, new Vector3D(3.0,7.0,0.0));
		Location a = new Location(m,"Atlanta",smodel, new Vector3D(4.0,9.0,0.0));
		Location l = new Location(m,"Los Angeles",smodel, new Vector3D(3.0,4.0,0.0));
		
		k.setLoadingTimeDistribution(new Constant (1.0));
		c.setLoadingTimeDistribution(new Constant (1.0));
		n.setLoadingTimeDistribution(new Constant (1.0));
		b.setLoadingTimeDistribution(new Constant (1.0));
		a.setLoadingTimeDistribution(new Constant (1.0));
		l.setLoadingTimeDistribution(new Constant (1.0));
		
		k.setUnloadingTimeDistribution(new Constant (1.0));
		c.setUnloadingTimeDistribution(new Constant (1.0));
		n.setUnloadingTimeDistribution(new Constant (1.0));
		b.setUnloadingTimeDistribution(new Constant (1.0));
		a.setUnloadingTimeDistribution(new Constant (1.0));
		l.setUnloadingTimeDistribution(new Constant (1.0));
		
		LaneIfc kc= new Lane(t,k,c,Math.sqrt(5));
		LaneIfc cn = new Lane(t,c,n,Math.sqrt(20));
		LaneIfc nb = new Lane(t,n,b,Math.sqrt(13));
		LaneIfc bn = new Lane(t,b,n,Math.sqrt(13));
		LaneIfc ab = new Lane(t,a,b,Math.sqrt(5));
		LaneIfc al= new Lane(t,a,l,Math.sqrt(26));
		LaneIfc cl= new Lane(t,c,l,Math.sqrt(8));
		LaneIfc lk= new Lane(t,l,k,Math.sqrt(25));
		LaneIfc na = new Lane(t,n,a,Math.sqrt(26));
		
		t.addLane(kc);
		t.addLane(cn);
		t.addLane(nb);
		t.addLane(bn);
		t.addLane(ab);
		t.addLane(al);
		t.addLane(cl);
		t.addLane(lk);
		t.addLane(na);
		
		System.out.println(t);
		
		AbstractDispatcherFTL d = new DispatcherFTL(m,t,6.0);
		
		d.addDriver(k,11.0,14.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),new Constant(1.0));
//		d.addDriver(c);
//		d.addDriver(n);
		d.addDriver(b,11.0,14.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),new Constant(1.0));
//		d.addDriver(a);
//		d.addDriver(l);
		
		d.addTrailer(k);
//		d.addTrailer(c);
//		d.addTrailer(n);
		d.addTrailer(b);
//		d.addTrailer(a);
//		d.addTrailer(l);
		
		d.addTruck(k);
//		d.addTruck(c);
//		d.addTruck(n);
		d.addTruck(b);
//		d.addTruck(a);
//		d.addTruck(l);
		
//		Create the Load generator
		LoadGenerator lg = new LoadGenerator(m,t,tl,tl); 
		
		System.out.println("Here is the load generator");
		
		lg.setOriginProbability(k, 0.2);
		lg.setOriginProbability(c, 0.2);
		lg.setOriginProbability(n, 0.1);
		lg.setOriginProbability(b, 0.1);
		lg.setOriginProbability(a, 0.1);
		lg.setLastOriginProbability(l);
		
		System.out.println("origin probability set");
		
		lg.setLastDestinationProbability(kc);
		
		lg.setDestinationProbability(cn,0.2);
		lg.setLastDestinationProbability(cl);
		
		lg.setLastDestinationProbability(nb);
		
		lg.setLastDestinationProbability(bn);
		
		lg.setLastDestinationProbability(na);
		
		lg.setDestinationProbability(ab,0.1);
		lg.setLastDestinationProbability(al);
		
		lg.setLastDestinationProbability(lk);
		
		System.out.println("destination probability set");
		
		m.turnOnLogReport();
		
		// create the experiment to run the model
		Experiment e = new Experiment(m);
		
		// set the parameters of the experiment
		e.setNumberOfReplications(1);
		e.setLengthOfReplication(100);
		e.setLengthOfWarmUp(0.0);
		
		// turn on the desired reporting
//		e.turnOnBatchReport(); 
//		e.turnOnExperimentReport();
//		e.turnOnReplicationReport();
//		e.turnOnExperimentConsoleOutput();
		
		// tell the experiment to run
		e.runAll();
	}
	
	public static void testDriver1(){
		
		System.out.println("Test Case for Driver");
		
		Model m = Model.createModel();
		
		System.out.println("Model Created");
		
		DistributionIfc tl = new Exponential(1.0);
		
		SpatialModel smodel = new RectangularGridSpatialModel2D();
		
		TransportationNetwork t=new TransportationNetwork(m, smodel);
		
		System.out.println("Here is the Transportation Network");		
		
		Location k = new Location(m,"Kansas City",smodel, new Vector3D(0.0,0.0,0.0));
		Location c = new Location(m,"Chicago",smodel,new Vector3D(1.0,2.0,3.0));
		Location n = new Location(m,"New York",smodel, new Vector3D(5.0,4.0,0.0));
		Location b = new Location(m,"Boston",smodel, new Vector3D(3.0,7.0,0.0));
		Location a = new Location(m,"Atlanta",smodel, new Vector3D(4.0,9.0,0.0));
		Location l = new Location(m,"Los Angeles",smodel, new Vector3D(3.0,4.0,0.0));
		
		k.setLoadingTimeDistribution(new Constant (1.0));
		c.setLoadingTimeDistribution(new Constant (1.0));
		n.setLoadingTimeDistribution(new Constant (1.0));
		b.setLoadingTimeDistribution(new Constant (1.0));
		a.setLoadingTimeDistribution(new Constant (1.0));
		l.setLoadingTimeDistribution(new Constant (1.0));
		
		k.setUnloadingTimeDistribution(new Constant (1.0));
		c.setUnloadingTimeDistribution(new Constant (1.0));
		n.setUnloadingTimeDistribution(new Constant (1.0));
		b.setUnloadingTimeDistribution(new Constant (1.0));
		a.setUnloadingTimeDistribution(new Constant (1.0));
		l.setUnloadingTimeDistribution(new Constant (1.0));
		
		//LaneIfc kc= new Lane(t,k,c,Math.sqrt(5));
		LaneIfc kc= new Lane(t,k,c,Math.sqrt(4));
		LaneIfc cn = new Lane(t,c,n,Math.sqrt(20));
		LaneIfc nb = new Lane(t,n,b,Math.sqrt(13));
//		LaneIfc bn = new Lane(t,b,n,Math.sqrt(25));
		LaneIfc bn = new Lane(t,b,n,Math.sqrt(9));
		LaneIfc ab = new Lane(t,a,b,Math.sqrt(5));
		LaneIfc al= new Lane(t,a,l,Math.sqrt(26));
		LaneIfc cl= new Lane(t,c,l,Math.sqrt(8));
//		LaneIfc lk= new Lane(t,l,k,Math.sqrt(25));
		LaneIfc lk= new Lane(t,l,k,Math.sqrt(169));
		LaneIfc lc= new Lane(t,l,c,Math.sqrt(81));
//		LaneIfc lk= new Lane(t,l,k,Math.sqrt(9));
		LaneIfc na = new Lane(t,n,a,Math.sqrt(26));
		t.addLane(lc);
		t.addLane(kc);
		t.addLane(cn);
		t.addLane(nb);
		t.addLane(bn);
		t.addLane(ab);
		t.addLane(al);
		t.addLane(cl);
		t.addLane(lk);
		t.addLane(na);
		
		System.out.println(t);
		
		AbstractDispatcherFTL d = new DispatcherFTL(m,t,20.0);
		
//		d.addDriver(k,14.0,11.0);
//		d.addDriver(c,14.0,11.0);
		d.addDriver(n,14.0,11.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),new Constant(1.0));
		d.addDriver(b,14.0,11.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),new Constant(1.0));
//		d.addDriver(a,14.0,11.0);
//		d.addDriver(l,14.0,11.0);
		
		d.addTrailer(k);
		d.addTrailer(c);
		d.addTrailer(n);
		d.addTrailer(b);
		d.addTrailer(a);
		d.addTrailer(l);
		
		d.addTruck(k);
		d.addTruck(c);
		d.addTruck(n);
//		d.addTruck(b);
		d.addTruck(a);
		d.addTruck(l);
		
//		Create the Load generator
		LoadGenerator lg = new LoadGenerator(m,t,tl,tl); 
		
		System.out.println("Here is the load generator");
		
		lg.setOriginProbability(k, 0.2);
		lg.setOriginProbability(c, 0.2);
		lg.setOriginProbability(n, 0.1);
		lg.setOriginProbability(b, 0.1);
		lg.setOriginProbability(a, 0.1);
		lg.setLastOriginProbability(l);
		
		System.out.println("origin probability set");
		
		lg.setLastDestinationProbability(kc);
		
		lg.setDestinationProbability(cn,0.2);
		lg.setLastDestinationProbability(cl);
		
		lg.setLastDestinationProbability(nb);
		
		lg.setLastDestinationProbability(bn);
		
		lg.setLastDestinationProbability(na);
		
		lg.setDestinationProbability(ab,0.1);
		lg.setLastDestinationProbability(al);
		
		lg.setDestinationProbability(lc,0.1);
		lg.setLastDestinationProbability(lk);
		
		System.out.println("destination probability set");
		
		m.turnOnLogReport();
		
		// create the experiment to run the model
		Experiment e = new Experiment(m);
		
		// set the parameters of the experiment
		e.setNumberOfReplications(1);
		e.setLengthOfReplication(200);
		e.setLengthOfWarmUp(0.0);
		
		// turn on the desired reporting
//		e.turnOnBatchReport(); 
//		e.turnOnExperimentReport();
//		e.turnOnReplicationReport();
//		e.turnOnExperimentConsoleOutput();
		
		// tell the experiment to run
		e.runAll();
	}
	
	public static void testDriver2(){
		
		System.out.println("Test Case for Driver:Bobtail");
		
		Model m = Model.createModel();
		
		System.out.println("Model Created");
		
		DistributionIfc tl = new Exponential(1.0);
		
		SpatialModel smodel = new RectangularGridSpatialModel2D();
		
		TransportationNetwork t=new TransportationNetwork(m, smodel);
		
		System.out.println("Here is the Transportation Network");		
		
		Location k = new Location(m,"Kansas City",smodel, new Vector3D(0.0,0.0,0.0));
		Location c = new Location(m,"Chicago",smodel,new Vector3D(1.0,2.0,3.0));
		Location n = new Location(m,"New York",smodel, new Vector3D(5.0,4.0,0.0));
		Location b = new Location(m,"Boston",smodel, new Vector3D(3.0,7.0,0.0));
		Location a = new Location(m,"Atlanta",smodel, new Vector3D(4.0,9.0,0.0));
		Location l = new Location(m,"Los Angeles",smodel, new Vector3D(3.0,4.0,0.0));
		
		k.setLoadingTimeDistribution(new Constant (1.0));
		c.setLoadingTimeDistribution(new Constant (1.0));
		n.setLoadingTimeDistribution(new Constant (1.0));
		b.setLoadingTimeDistribution(new Constant (1.0));
		a.setLoadingTimeDistribution(new Constant (1.0));
		l.setLoadingTimeDistribution(new Constant (1.0));
		
		k.setUnloadingTimeDistribution(new Constant (1.0));
		c.setUnloadingTimeDistribution(new Constant (1.0));
		n.setUnloadingTimeDistribution(new Constant (1.0));
		b.setUnloadingTimeDistribution(new Constant (1.0));
		a.setUnloadingTimeDistribution(new Constant (1.0));
		l.setUnloadingTimeDistribution(new Constant (1.0));
		
		//LaneIfc kc= new Lane(t,k,c,Math.sqrt(5));
		LaneIfc kc= new Lane(t,k,c,Math.sqrt(4));
		LaneIfc cn = new Lane(t,c,n,Math.sqrt(20));
		LaneIfc nb = new Lane(t,n,b,Math.sqrt(169));
		LaneIfc bn = new Lane(t,b,n,Math.sqrt(169));
//		LaneIfc ab = new Lane(t,a,b,Math.sqrt(5));
		LaneIfc ab = new Lane(t,a,b,Math.sqrt(81));
		LaneIfc al= new Lane(t,a,l,Math.sqrt(26));
		LaneIfc cl= new Lane(t,c,l,Math.sqrt(81));
//		LaneIfc lk= new Lane(t,l,k,Math.sqrt(25));
		LaneIfc lk= new Lane(t,l,k,Math.sqrt(169));
//		LaneIfc lk= new Lane(t,l,k,Math.sqrt(9));
		LaneIfc na = new Lane(t,n,a,Math.sqrt(26));
		
		t.addLane(kc);
		t.addLane(cn);
		t.addLane(nb);
		t.addLane(bn);
		t.addLane(ab);
		t.addLane(al);
		t.addLane(cl);
		t.addLane(lk);
		t.addLane(na);
		
		System.out.println(t);
		
		AbstractDispatcherFTL d = new DispatcherFTL(m,t,20.0);
		
//		d.addDriver(k,14.0,11.0);
//		d.addDriver(c,14.0,11.0);
//		d.addDriver(n,14.0,11.0);
		d.addDriver(b,14.0,11.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),new Constant(1.0));
		d.addDriver(a,14.0,11.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),new Constant(1.0));
//		d.addDriver(a,14.0,11.0);
		d.addDriver(l,14.0,11.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),new Constant(1.0));
		
		d.addTrailer(k);
		d.addTrailer(c);
		d.addTrailer(n);
		d.addTrailer(b);
		d.addTrailer(a);
//		d.addTrailer(l);
		
		d.addTruck(k);
		d.addTruck(c);
		d.addTruck(n);
//		d.addTruck(b);
		d.addTruck(a);
		d.addTruck(l);
		
//		Create the Load generator
		LoadGenerator lg = new LoadGenerator(m,t,tl,tl); 
		
		System.out.println("Here is the load generator");
		
		lg.setOriginProbability(k, 0.2);
		lg.setOriginProbability(c, 0.2);
		lg.setOriginProbability(n, 0.1);
		lg.setOriginProbability(b, 0.1);
		lg.setOriginProbability(a, 0.1);
		lg.setLastOriginProbability(l);
		
		System.out.println("origin probability set");
		
		lg.setLastDestinationProbability(kc);
		
		lg.setDestinationProbability(cn,0.2);
		lg.setLastDestinationProbability(cl);
		
		lg.setLastDestinationProbability(nb);
		
		lg.setLastDestinationProbability(bn);
		
		lg.setLastDestinationProbability(na);
		
		lg.setDestinationProbability(ab,0.1);
		lg.setLastDestinationProbability(al);
		
		lg.setLastDestinationProbability(lk);
		
		System.out.println("destination probability set");
		
		m.turnOnLogReport();
		
		// create the experiment to run the model
		Experiment e = new Experiment(m);
		
		// set the parameters of the experiment
		e.setNumberOfReplications(1);
		e.setLengthOfReplication(200);
		e.setLengthOfWarmUp(0.0);
		
		// turn on the desired reporting
//		e.turnOnBatchReport(); 
//		e.turnOnExperimentReport();
//		e.turnOnReplicationReport();
//		e.turnOnExperimentConsoleOutput();
		
		// tell the experiment to run
		e.runAll();
	}
	
	public static void testDriver3(){
		
		System.out.println("Test Case for Driver");
		
		Model m = Model.createModel();
		
		System.out.println("Model Created");
		
		DistributionIfc tl = new Exponential(1.0);
		
		SpatialModel smodel = new RectangularGridSpatialModel2D();
		
		TransportationNetwork t=new TransportationNetwork(m, smodel);
		
		System.out.println("Here is the Transportation Network");		
		
		Location k = new Location(m,"Kansas City",smodel, new Vector3D(0.0,0.0,0.0));
		Location c = new Location(m,"Chicago",smodel,new Vector3D(1.0,2.0,3.0));
		Location n = new Location(m,"New York",smodel, new Vector3D(5.0,4.0,0.0));
		Location b = new Location(m,"Boston",smodel, new Vector3D(3.0,7.0,0.0));
		Location a = new Location(m,"Atlanta",smodel, new Vector3D(4.0,9.0,0.0));
		Location l = new Location(m,"Los Angeles",smodel, new Vector3D(3.0,4.0,0.0));
		
		k.setLoadingTimeDistribution(new Constant (1.0));
		c.setLoadingTimeDistribution(new Constant (1.0));
		n.setLoadingTimeDistribution(new Constant (1.0));
		b.setLoadingTimeDistribution(new Constant (1.0));
		a.setLoadingTimeDistribution(new Constant (1.0));
		l.setLoadingTimeDistribution(new Constant (1.0));
		
		k.setUnloadingTimeDistribution(new Constant (1.0));
		c.setUnloadingTimeDistribution(new Constant (1.0));
		n.setUnloadingTimeDistribution(new Constant (1.0));
		b.setUnloadingTimeDistribution(new Constant (1.0));
		a.setUnloadingTimeDistribution(new Constant (1.0));
		l.setUnloadingTimeDistribution(new Constant (1.0));
		
		//LaneIfc kc= new Lane(t,k,c,Math.sqrt(5));
		LaneIfc kc= new Lane(t,k,c,Math.sqrt(4));
		LaneIfc cn = new Lane(t,c,n,Math.sqrt(25));
		LaneIfc nb = new Lane(t,n,b,Math.sqrt(169));
		LaneIfc bn = new Lane(t,b,n,Math.sqrt(169));
//		LaneIfc ab = new Lane(t,a,b,Math.sqrt(5));
		LaneIfc ab = new Lane(t,a,b,Math.sqrt(81));
		LaneIfc al= new Lane(t,a,l,Math.sqrt(25));
		LaneIfc cl= new Lane(t,c,l,Math.sqrt(81));
//		LaneIfc lk= new Lane(t,l,k,Math.sqrt(25));
		LaneIfc lk= new Lane(t,l,k,Math.sqrt(169));
//		LaneIfc lk= new Lane(t,l,k,Math.sqrt(9));
		LaneIfc nc = new Lane(t,n,c,Math.sqrt(25));
		LaneIfc la = new Lane(t,l,a,Math.sqrt(25));
		
		t.addLane(kc);
		t.addLane(cn);
		t.addLane(nb);
		t.addLane(bn);
		t.addLane(ab);
		t.addLane(al);
		t.addLane(cl);
		t.addLane(lk);
		t.addLane(nc);
		t.addLane(la);
		
		System.out.println(t);
		
		AbstractDispatcherFTL d = new DispatcherFTL(m,t,20.0);
		
//		d.addDriver(k,14.0,11.0);
//		d.addDriver(c,14.0,11.0);
		d.addDriver(n,14.0,11.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),new Constant(1.0));
//		d.addDriver(b,14.0,11.0);
//		d.addDriver(a,14.0,11.0);
//		d.addDriver(a,14.0,11.0);
		d.addDriver(l,14.0,11.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),new Constant(1.0));
		
		d.addTrailer(k);
		d.addTrailer(c);
		d.addTrailer(n);
		d.addTrailer(b);
		d.addTrailer(a);
//		d.addTrailer(l);
		
		d.addTruck(k);
		d.addTruck(c);
		d.addTruck(n);
		d.addTruck(b);
		d.addTruck(a);
		d.addTruck(l);
		
//		Create the Load generator
		LoadGenerator lg = new LoadGenerator(m,t,tl,tl); 
		
		System.out.println("Here is the load generator");
		
		lg.setOriginProbability(k, 0.2);
		lg.setOriginProbability(c, 0.2);
		lg.setOriginProbability(n, 0.1);
		lg.setOriginProbability(b, 0.1);
		lg.setOriginProbability(a, 0.1);
		lg.setLastOriginProbability(l);
		
		System.out.println("origin probability set");
		
		lg.setLastDestinationProbability(kc);
		
		lg.setLastDestinationProbability(la);
		
		lg.setDestinationProbability(cn,0.2);
		lg.setLastDestinationProbability(cl);
		
		lg.setLastDestinationProbability(nb);
		
		lg.setLastDestinationProbability(bn);
		
		lg.setLastDestinationProbability(nc);
		
		lg.setDestinationProbability(ab,0.5);
		lg.setLastDestinationProbability(al);
		
		lg.setLastDestinationProbability(lk);
		
		System.out.println("destination probability set");
		
		m.turnOnLogReport();
		
		// create the experiment to run the model
		Experiment e = new Experiment(m);
		
		// set the parameters of the experiment
		e.setNumberOfReplications(1);
		e.setLengthOfReplication(200);
		e.setLengthOfWarmUp(0.0);
		
		// turn on the desired reporting
//		e.turnOnBatchReport(); 
//		e.turnOnExperimentReport();
//		e.turnOnReplicationReport();
//		e.turnOnExperimentConsoleOutput();
		
		// tell the experiment to run
		e.runAll();
	}
	
	public static void testDriver4(){
		
		System.out.println("Test Case for Driver:Bobtail");
		
		Model m = Model.createModel();
		
		System.out.println("Model Created");
		
		DistributionIfc tl = new Exponential(1.0);
		
		SpatialModel smodel = new RectangularGridSpatialModel2D();
		
		TransportationNetwork t=new TransportationNetwork(m, smodel);
		
		System.out.println("Here is the Transportation Network");		
		
		Location k = new Location(m,"Kansas City",smodel, new Vector3D(0.0,0.0,0.0));
		Location c = new Location(m,"Chicago",smodel,new Vector3D(1.0,2.0,3.0));
		Location n = new Location(m,"New York",smodel, new Vector3D(5.0,4.0,0.0));
		Location b = new Location(m,"Boston",smodel, new Vector3D(3.0,7.0,0.0));
		Location a = new Location(m,"Atlanta",smodel, new Vector3D(4.0,9.0,0.0));
		Location l = new Location(m,"Los Angeles",smodel, new Vector3D(3.0,4.0,0.0));
		
		k.setLoadingTimeDistribution(new Constant (1.0));
		c.setLoadingTimeDistribution(new Constant (1.0));
		n.setLoadingTimeDistribution(new Constant (1.0));
		b.setLoadingTimeDistribution(new Constant (1.0));
		a.setLoadingTimeDistribution(new Constant (1.0));
		l.setLoadingTimeDistribution(new Constant (1.0));
		
		k.setUnloadingTimeDistribution(new Constant (1.0));
		c.setUnloadingTimeDistribution(new Constant (1.0));
		n.setUnloadingTimeDistribution(new Constant (1.0));
		b.setUnloadingTimeDistribution(new Constant (1.0));
		a.setUnloadingTimeDistribution(new Constant (1.0));
		l.setUnloadingTimeDistribution(new Constant (1.0));
		
		//LaneIfc kc= new Lane(t,k,c,Math.sqrt(5));
		LaneIfc kc= new Lane(t,k,c,Math.sqrt(49));
		LaneIfc cn = new Lane(t,c,n,Math.sqrt(20));
		LaneIfc nb = new Lane(t,n,b,Math.sqrt(169));
		LaneIfc bn = new Lane(t,b,n,Math.sqrt(169));
//		LaneIfc ab = new Lane(t,a,b,Math.sqrt(5));
		LaneIfc ab = new Lane(t,a,b,Math.sqrt(81));
		LaneIfc al= new Lane(t,a,l,Math.sqrt(169));
		LaneIfc cl= new Lane(t,c,l,Math.sqrt(81));
//		LaneIfc lk= new Lane(t,l,k,Math.sqrt(25));
		LaneIfc lk= new Lane(t,l,k,Math.sqrt(169));
//		LaneIfc lk= new Lane(t,l,k,Math.sqrt(9));
		LaneIfc na = new Lane(t,n,a,Math.sqrt(169));
		LaneIfc lc = new Lane(t,l,c,Math.sqrt(81));
		LaneIfc ck = new Lane(t,c,k,Math.sqrt(4));
		LaneIfc la = new Lane(t,l,a,Math.sqrt(81));
		LaneIfc nk = new Lane(t,n,c,Math.sqrt(25));
		LaneIfc ca = new Lane(t,c,a,Math.sqrt(25));
		LaneIfc lb = new Lane(t,l,b,Math.sqrt(196));
		
		t.addLane(lb);
		t.addLane(la);
		t.addLane(kc);
		t.addLane(cn);
		t.addLane(nk);
		t.addLane(bn);
		t.addLane(ab);
		t.addLane(al);
		t.addLane(cl);
		t.addLane(lk);
		
		t.addLane(lc);
		t.addLane(ck);
		t.addLane(nk);
		t.addLane(ca);
		
		
		System.out.println(t);
		
		AbstractDispatcherFTL d = new DispatcherFTL(m,t,20.0);
	
//		d.addDriver(k,14.0,11.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),new Constant(1.0));
		d.addDriver(c,14.0,11.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),new Constant(1.0));
//		d.addDriver(n,14.0,11.0);
//		d.addDriver(b,14.0,11.0);
		d.addDriver(a,14.0,11.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),new Constant(1.0));
//		d.addDriver(l,14.0,11.0);

//		d.addDriver(a,14.0,11.0);
//		d.addDriver(k,14.0,11.0);
//		d.addDriver(c,14.0,11.0);
		
		d.addTrailer(k);
		d.addTrailer(c);
		d.addTrailer(n);
		d.addTrailer(b);
		d.addTrailer(a);
		d.addTrailer(l);
		
		d.addTruck(k);
		d.addTruck(c);
		d.addTruck(n);
		d.addTruck(b);
		d.addTruck(a);
		d.addTruck(l);
		
//		Create the Load generator
		LoadGenerator lg = new LoadGenerator(m,t,tl,tl); 
		
		System.out.println("Here is the load generator");
		
		lg.setOriginProbability(k, 0.2);
		lg.setOriginProbability(c, 0.2);
		lg.setOriginProbability(n, 0.1);
		lg.setOriginProbability(b, 0.1);
		lg.setOriginProbability(a, 0.1);
		lg.setLastOriginProbability(l);
		
		System.out.println("origin probability set");
		
		lg.setLastDestinationProbability(kc);
		
		lg.setDestinationProbability(cn,0.2);
		lg.setLastDestinationProbability(cl);
		
		lg.setLastDestinationProbability(nb);
		
		lg.setLastDestinationProbability(bn);
		
		lg.setLastDestinationProbability(na);
		
		lg.setDestinationProbability(ab,0.5);
		lg.setLastDestinationProbability(al);
		
		lg.setLastDestinationProbability(lk);
		
		System.out.println("destination probability set");
		
		m.turnOnLogReport();
		
		// create the experiment to run the model
		Experiment e = new Experiment(m);
		
		// set the parameters of the experiment
		e.setNumberOfReplications(2);
		e.setLengthOfReplication(100);
		e.setLengthOfWarmUp(0.0);
		
		// turn on the desired reporting
//		e.turnOnBatchReport(); 
//		e.turnOnExperimentReport();
//		e.turnOnReplicationReport();
//		e.turnOnExperimentConsoleOutput();
		
		// tell the experiment to run
		e.runAll();
	}
	/*
	public static void testDriver5(){
		
		System.out.println("Test Case for Driver");
		
		Model m = Model.createModel();
		
		System.out.println("Model Created");
		
		DistributionIfc tl = new Exponential(1.0);
		
		SpatialModel smodel = new RectangularGridSpatialModel2D();
		
		TransportationNetwork t=new TransportationNetwork(m, smodel);
		
		System.out.println("Here is the Transportation Network");		
		
		Location k = new Location(m,"Kansas City",smodel, new Vector3D(0.0,0.0,0.0));
		Location c = new Location(m,"Chicago",smodel,new Vector3D(1.0,2.0,3.0));
		Location n = new Location(m,"New York",smodel, new Vector3D(5.0,4.0,0.0));
		Location b = new Location(m,"Boston",smodel, new Vector3D(3.0,7.0,0.0));
		Location a = new Location(m,"Atlanta",smodel, new Vector3D(4.0,9.0,0.0));
		Location l = new Location(m,"Los Angeles",smodel, new Vector3D(3.0,4.0,0.0));
		
		k.setLoadingTimeDistribution(new Constant (1.0));
		c.setLoadingTimeDistribution(new Constant (1.0));
		n.setLoadingTimeDistribution(new Constant (1.0));
		b.setLoadingTimeDistribution(new Constant (1.0));
		a.setLoadingTimeDistribution(new Constant (1.0));
		l.setLoadingTimeDistribution(new Constant (1.0));
		
		k.setUnloadingTimeDistribution(new Constant (1.0));
		c.setUnloadingTimeDistribution(new Constant (1.0));
		n.setUnloadingTimeDistribution(new Constant (1.0));
		b.setUnloadingTimeDistribution(new Constant (1.0));
		a.setUnloadingTimeDistribution(new Constant (1.0));
		l.setUnloadingTimeDistribution(new Constant (1.0));
		
		//LaneIfc kc= new Lane(t,k,c,Math.sqrt(5));
		LaneIfc kc= new Lane(t,k,c,Math.sqrt(4));
		LaneIfc cn = new Lane(t,c,n,Math.sqrt(25));
		LaneIfc nb = new Lane(t,n,b,Math.sqrt(169));
		LaneIfc bn = new Lane(t,b,n,Math.sqrt(169));
//		LaneIfc ab = new Lane(t,a,b,Math.sqrt(5));
		LaneIfc ab = new Lane(t,a,b,Math.sqrt(81));
		LaneIfc al= new Lane(t,a,l,Math.sqrt(25));
		LaneIfc cl= new Lane(t,c,l,Math.sqrt(81));
//		LaneIfc lk= new Lane(t,l,k,Math.sqrt(25));
		LaneIfc lk= new Lane(t,l,k,Math.sqrt(169));
//		LaneIfc lk= new Lane(t,l,k,Math.sqrt(9));
		LaneIfc nc = new Lane(t,n,c,Math.sqrt(25));
		LaneIfc la = new Lane(t,l,a,Math.sqrt(25));
		
		t.addLane(kc);
		t.addLane(cn);
		t.addLane(nb);
		t.addLane(bn);
		t.addLane(ab);
		t.addLane(al);
		t.addLane(cl);
		t.addLane(lk);
		t.addLane(nc);
		t.addLane(la);
		
		System.out.println(t);
		
		AbstractDispatcherFTL d = new DispatcherFTL(m,t,20.0);
		
		d.addDriver(k,14.0,11.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),new Constant(1.0));
		d.addDriver(c,14.0,11.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),new Constant(1.0));
		d.addDriver(c,14.0,11.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),new Constant(1.0));
		d.addDriver(n,14.0,11.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),new Constant(1.0));
		d.addDriver(b,14.0,11.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),new Constant(1.0));
		d.addDriver(a,14.0,11.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),new Constant(1.0));
//		d.addDriver(a,14.0,11.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),new Constant(1.0));
		d.addDriver(l,14.0,11.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),new Constant(1.0));
		
		d.addTrailer(k);
		d.addTrailer(c);
	//	d.addTrailer(n);
		d.addTrailer(b);
	//	d.addTrailer(a);
		d.addTrailer(l);
		
		d.addTruck(k);
		d.addTruck(c);
		d.addTruck(n);
		d.addTruck(b);
		d.addTruck(a);
		d.addTruck(l);
		
		//	Create the Load generator
	//	LoadGenerator lg = new LoadGenerator(m,t,tl,tl); 
		
		LoadGenerator lg = new LoadGenerator(m,t,tl,tl,new Constant(3.0)," "); 
		
		System.out.println("Here is the load generator");
		
		lg.setOriginProbability(k, 0.2);
		lg.setOriginProbability(c, 0.2);
		lg.setOriginProbability(n, 0.1);
		lg.setOriginProbability(b, 0.1);
		lg.setOriginProbability(a, 0.1);
		lg.setLastOriginProbability(l);
		
		System.out.println("origin probability set");
		
		lg.setLastDestinationProbability(kc);
		
		lg.setLastDestinationProbability(la);
		
		lg.setDestinationProbability(cn,0.2);
		lg.setLastDestinationProbability(cl);
		
		lg.setLastDestinationProbability(nb);
		
		lg.setLastDestinationProbability(bn);
		
		lg.setLastDestinationProbability(nc);
		
		lg.setDestinationProbability(ab,0.5);
		lg.setLastDestinationProbability(al);
		
		lg.setLastDestinationProbability(lk);
		
		System.out.println("destination probability set");
		
		m.turnOnLogReport();
		
		// create the experiment to run the model
		Experiment e = new Experiment(m);
		
		// set the parameters of the experiment
		e.setNumberOfReplications(1);
		e.setLengthOfReplication(100);
		e.setLengthOfWarmUp(0.0);
		
		// turn on the desired reporting
//		e.turnOnBatchReport(); 
//		e.turnOnExperimentReport();
//		e.turnOnReplicationReport();
//		e.turnOnExperimentConsoleOutput();
		
		// tell the experiment to run
		e.runAll();
	}*/
}



