package jslx.transportlayerFinal.test;

import jsl.modeling.elements.spatial.RectangularGridSpatialModel2D;
import jsl.modeling.elements.spatial.SpatialModel;
import jsl.modeling.elements.spatial.Vector3D;
import jslx.transportlayer.Lane;
import jslx.transportlayer.LaneIfc;
import jslx.transportlayer.Network;
import jslx.transportlayer.SMLocation;


/**
 * @author snangia
 *
 *
 */
public class TestNetwork {
	
	public static void main(String[] args){
		
		System.out.println("Simple Transportation Model");
				
		test2();
		
		System.out.println("Done!");
	}
	
	public static void test1(){
		System.out.println("Testing Network Class");
				
		SpatialModel smodel = new RectangularGridSpatialModel2D();
		
		Network t= new Network();
		
		SMLocation l1 = new SMLocation(smodel, new Vector3D(0.0,0.0,0.0),"Kansas City");
		SMLocation l2 = new SMLocation(smodel, new Vector3D(1.0,2.0,3.0),"Chicago");
		SMLocation l3 = new SMLocation(smodel, new Vector3D(5.0,4.0,0.0),"New York");
		SMLocation l4 = new SMLocation(smodel, new Vector3D(3.0,7.0,0.0),"Boston");
		SMLocation l5 = new SMLocation(smodel, new Vector3D(4.0,9.0,0.0),"Atlanta");
		SMLocation l6 = new SMLocation(smodel, new Vector3D(3.0,4.0,0.0),"Los Angeles");
		
		LaneIfc lane12= new Lane(t,l1,l2,1.0);
		LaneIfc lane13= new Lane(t,l1,l3,2.0);
		LaneIfc lane14= new Lane(t,l1,l4,3.0);
		LaneIfc lane15= new Lane(t,l1,l5,4.0);
		LaneIfc lane16= new Lane(t,l1,l6,5.0);
		
		LaneIfc lane21= new Lane(t,l2,l1,1.0);
		LaneIfc lane23= new Lane(t,l2,l3,2.0);
		LaneIfc lane24= new Lane(t,l2,l4,3.0);
		LaneIfc lane25= new Lane(t,l2,l5,4.0);
		LaneIfc lane26= new Lane(t,l2,l6,5.0);
		
		LaneIfc lane31= new Lane(t,l3,l1,1.0);
		LaneIfc lane32= new Lane(t,l3,l2,2.0);
		LaneIfc lane34= new Lane(t,l3,l4,3.0);
		LaneIfc lane35= new Lane(t,l3,l5,4.0);
		LaneIfc lane36= new Lane(t,l3,l6,5.0);
		
		LaneIfc lane41= new Lane(t,l4,l1,1.0);
		LaneIfc lane42= new Lane(t,l4,l2,2.0);
		LaneIfc lane43= new Lane(t,l4,l3,3.0);
		LaneIfc lane45= new Lane(t,l4,l5,4.0);
		LaneIfc lane46= new Lane(t,l4,l6,5.0);
		
		LaneIfc lane51= new Lane(t,l5,l1,1.0);
		LaneIfc lane52= new Lane(t,l5,l2,2.0);
		LaneIfc lane53= new Lane(t,l5,l3,3.0);
		LaneIfc lane54= new Lane(t,l5,l4,4.0);
		LaneIfc lane56= new Lane(t,l5,l6,5.0);
		
		LaneIfc lane61= new Lane(t,l6,l1,1.0);
		LaneIfc lane62= new Lane(t,l6,l2,2.0);
		LaneIfc lane63= new Lane(t,l6,l3,3.0);
		LaneIfc lane64= new Lane(t,l6,l4,4.0);
		LaneIfc lane65= new Lane(t,l6,l5,5.0);
		
//		t.addLane(lane12);
		t.addLane(lane13);
//		t.addLane(lane14);
		t.addLane(lane15);
//		t.addLane(lane16);
		
//		t.addLane(lane21);
		t.addLane(lane23);
		t.addLane(lane24);
//		t.addLane(lane25);
//		t.addLane(lane26);
		
//		t.addLane(lane31);
//		t.addLane(lane32);
//		t.addLane(lane34);
//		t.addLane(lane35);
		t.addLane(lane36);
		
//		t.addLane(lane41);
//		t.addLane(lane42);
//		t.addLane(lane43);
		t.addLane(lane45);
//		t.addLane(lane46);
		
//		t.addLane(lane51);
//		t.addLane(lane52);
//		t.addLane(lane53);
		t.addLane(lane54);
//		t.addLane(lane56);
		
		t.addLane(lane61);
//		t.addLane(lane62);
//		t.addLane(lane63);
//		t.addLane(lane64);
//		t.addLane(lane65);
		
		System.out.println(t);
		
	}
	
	
	public static void test2(){
		System.out.println("Testing Network Class");
				
		SpatialModel smodel = new RectangularGridSpatialModel2D();
		
		Network t= new Network();
		
		SMLocation k = new SMLocation(smodel, "K");
		SMLocation c = new SMLocation(smodel, "C");
		SMLocation n = new SMLocation(smodel, "N");
		SMLocation b = new SMLocation(smodel, "B");
		SMLocation a = new SMLocation(smodel, "A");
		SMLocation l = new SMLocation(smodel, "L");
		
		LaneIfc kc= new Lane(t,k,c);
		LaneIfc cn = new Lane(t,c,n);
		LaneIfc nb = new Lane(t,n,b);
		LaneIfc bn = new Lane(t,b,n);
		LaneIfc ab = new Lane(t,a,b);
		LaneIfc al= new Lane(t,a,l);
		LaneIfc cl= new Lane(t,c,l);
		LaneIfc lk= new Lane(t,l,k);
		
		t.addLane(kc);
		t.addLane(cn);
		t.addLane(nb);
		t.addLane(bn);
		t.addLane(ab);
		t.addLane(al);
		t.addLane(cl);
		t.addLane(lk);
		
		System.out.println(t);
		
	}
}
