/*
* Copyright (c) 2007, Manuel D. Rossetti (rossetti@uark.edu)
*
* Contact:
*	Manuel D. Rossetti, Ph.D., P.E. 
*	Department of Industrial Engineering 
*	University of Arkansas 
*	4207 Bell Engineering Center 
*	Fayetteville, AR 72701 
*	Phone: (479) 575-6756 
*	Email: rossetti@uark.edu 
*	Web: www.uark.edu/~rossetti
*
* This file is part of the JSL (a Java Simulation Library). The JSL is a framework
* of Java classes that permit the easy development and execution of discrete event
* simulation programs.
*
* The JSL is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* The JSL is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with the JSL (see file COPYING in the distribution); 
* if not, write to the Free Software Foundation, Inc., 51 Franklin St, Fifth Floor, 
* Boston, MA  02110-1301  USA, or see www.fsf.org
* 
*/

package jslx.utilities.queueing;

import jsl.utilities.random.*;
import jsl.utilities.random.distributions.Distribution;

/**
 *
 * @author  rossetti
 */
public class QParameterSet {
    
    public double mtba;
    public double c2va;
    public double mst;
    public double c2vs;
    public int numServers;
    public double rho;
    public int acdfType;
    public int scdfType;
    public Distribution acdf;
    public Distribution scdf;
    public double aP1;
    public double aP2;
    public double aP3;
    public double sP1;
    public double sP2;
    public double sP3;
    
    /** Creates a new instance of TestCase */
    public QParameterSet() {
    }
    
    public String toString(){
        String s = mtba + "\t" + c2va + "\t" + mst + "\t" + c2vs + "\t" + numServers + "\t" + rho
                 + "\t" + acdfType + "\t" + scdfType 
                 + "\t" + aP1 + "\t" + aP2 + "\t" + aP3
                 + "\t" + sP1 + "\t" + sP2 + "\t" + sP3;
        return(s);            
    }
    
}
