/*
* Copyright (c) 2007, Manuel D. Rossetti (rossetti@uark.edu)
*
* Contact:
*	Manuel D. Rossetti, Ph.D., P.E. 
*	Department of Industrial Engineering 
*	University of Arkansas 
*	4207 Bell Engineering Center 
*	Fayetteville, AR 72701 
*	Phone: (479) 575-6756 
*	Email: rossetti@uark.edu 
*	Web: www.uark.edu/~rossetti
*
* This file is part of the JSL (a Java Simulation Library). The JSL is a framework
* of Java classes that permit the easy development and execution of discrete event
* simulation programs.
*
* The JSL is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* The JSL is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with the JSL (see file COPYING in the distribution); 
* if not, write to the Free Software Foundation, Inc., 51 Franklin St, Fifth Floor, 
* Boston, MA  02110-1301  USA, or see www.fsf.org
* 
*/

package testing.misc;

import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;

/**
 */
public class TestFiles {

	public static void main(String[] args) {
		
		String workingDirectory;
		String directory;
		String name = "test.txt";
        try{
            workingDirectory = System.getProperty("user.dir");
            System.out.println(workingDirectory);
        }
        catch (SecurityException noAccess){
            System.out.println("Access to system information denied");
        }
        
        try{
        	File dir = new File("jslOutput");
        	dir.mkdir();
        	File myFile = new File(dir, name);
            
            PrintWriter myWriter = new PrintWriter(new FileWriter(myFile),true);
            myWriter.println("Testing 1, 2, 3...");

        } catch(IOException e){
            System.out.println("I/O exception opening file " + name);
            System.exit(1);
        } 
       
        System.out.println("Done!");
	}
}
