/*
* Copyright (c) 2007, Manuel D. Rossetti (rossetti@uark.edu)
*
* Contact:
*	Manuel D. Rossetti, Ph.D., P.E. 
*	Department of Industrial Engineering 
*	University of Arkansas 
*	4207 Bell Engineering Center 
*	Fayetteville, AR 72701 
*	Phone: (479) 575-6756 
*	Email: rossetti@uark.edu 
*	Web: www.uark.edu/~rossetti
*
* This file is part of the JSL (a Java Simulation Library). The JSL is a framework
* of Java classes that permit the easy development and execution of discrete event
* simulation programs.
*
* The JSL is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* The JSL is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with the JSL (see file COPYING in the distribution); 
* if not, write to the Free Software Foundation, Inc., 51 Franklin St, Fifth Floor, 
* Boston, MA  02110-1301  USA, or see www.fsf.org
* 
*/

package testing.misc;

import java.util.logging.*;
import java.io.*;
import jsl.utilities.reporting.*;

/**
 */
public class TestLogger {

	private static Logger logger = Logger.getLogger("jsl.examples.testing.TestLogger");
	private static FileHandler fh;
	
	static {
		try {
			fh 	 = new FileHandler("mylog.txt");
			fh.setFormatter(new SimpleFormatter());

		} catch (IOException ex) {
			System.out.println("error");
		}

	}

	/**
	 * 
	 */
	public TestLogger() {
		super();
	}

	public static void main(String[] args) {
		// Send logger output to our FileHandler.
		logger.addHandler(fh);
		// Request that every detail gets logged.
		logger.setLevel(Level.ALL);
		// Log a simple INFO message.
		logger.info("doing stuff");

		logger.fine("done");

		JSL.LOGGER.setLevel(Level.ALL);
		JSL.LOGGER.info("testing info");
		JSL.LOGGER.fine("testing fine");
		
		JSL.OUTPUT.info("Test output log info");
		JSL.OUTPUT.fine("test output log fine");
	}
}
