package testing.parameters;

import jsl.modeling.elements.queue.Queue;
import jsl.modeling.elements.queue.QueueDiscipline;
import testing.parameters.GetResponsesIfc;
import testing.parameters.Responses;
import jslx.supplychain.inventorylayer.BackLogQueue;
import jslx.supplychain.inventorylayer.Inventory;

public class BackLogQueueGetResponses extends BackLogQueue implements
		GetResponsesIfc {

	/** Creates a backlog queue for processing backlogs with a FIFO discipline.
	 * @param parent
	 */
	public BackLogQueueGetResponses(Inventory inventory) {
		this(inventory, Queue.FIFO, null);
	}
	
	/** Creates a backlog queue for processing backlogs
	 * 
	 * @param parent
	 * @param discipline
	 */
	public BackLogQueueGetResponses(Inventory inventory, QueueDiscipline discipline) {
		this(inventory, discipline, null);
	}

	/**
	 * @param parent
	 * @param discipline
	 * @param name
	 */
	public BackLogQueueGetResponses(Inventory inventory, String name) {
		this(inventory, Queue.FIFO, name);
	}
	
	public BackLogQueueGetResponses(Inventory inventory, QueueDiscipline discipline, String name) {
		super(inventory, name);
		setBackLoggedDemandQueue(new QueueGetResponses(this, getName() + "-DemandBackLogQ", discipline));
	}
	
	/**
	 * @param queue The queue to set.
	 */
	private final void setBackLoggedDemandQueue(Queue queue) {
        if (queue == null)
            throw new IllegalArgumentException("The Queue must be non-null");
		myBackLogQ = queue;
	}
	
	public Responses getResponses() {
		Responses r=new Responses();
		r.setResponse("Average amount backlogged", this.myAmtBackLogged.getAcrossReplicationAverage());
		r.setResponse("Average time in backlog",
				((GetResponsesIfc)this.myBackLogQ).getResponses().getResponse("Average time in queue"));
		return null;
	}

}
