/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package testing.parameters;

import jsl.modeling.JSLEvent;
import jsl.modeling.ModelElement;
import jsl.utilities.random.distributions.Constant;
import jslx.forecasting.DataSourceArray;
import jslx.forecasting.IterativeDataSource;
import jslx.supplychain.inventorylayer.Demand;
import jslx.supplychain.inventorylayer.DemandGenerator;
import jslx.supplychain.inventorylayer.ItemType;

/**
 *
 * @author hmedal
 */
public class DataDemandGenerator extends DemandGenerator{
    
	//private int[] demandData;
        private IterativeDataSource data;
	private double sum;
        private int count;
	/**
	 * @param parent
	 * @param name
	 * @param timeUntilFirst
	 * @param timeUntilNext
	 * @param maxNum
	 * @param timeUntilLast
	 */
	public DataDemandGenerator(ModelElement parent, ItemType type, double periodLength,double[] data,String name) {
		this(parent, type, periodLength,new DataSourceArray(data),name);
		//this.demandData=data;
	}
        
        /**
	 * @param parent
	 * @param name
	 * @param timeUntilFirst
	 * @param timeUntilNext
	 * @param maxNum
	 * @param timeUntilLast
	 */
	public DataDemandGenerator(ModelElement parent, ItemType type, double periodLength,IterativeDataSource data,String name) {
		super(parent, type, new Constant(periodLength),new Constant(periodLength),name);
		this.data=data;
	}
        
        public double getAverage(){
            //System.out.println("sum= "+sum+"\tcount "+count);
            return sum/count;
        }
    /** If there is no filler available then a NoDemandFillerFoundException exception is thrown
	 *  
	 * @param event
	 */
	protected void generate(JSLEvent event){
		// create the demand
                //System.out.println("GEN");
                int amt=0;
                if(data.hasNext()){
                    amt=(int)data.next();
                    //System.out.println("gen has next="+amt);
                    sum+=amt;
                    count++;
                    //System.out.println("count= "+count);
                }
                else{
                    this.turnOffGenerator();
                    return;
                }
		boolean a=this.isGeneratorDone();
		boolean b=this.isCurrentReplicationRunning();
		if(amt!=0){
			Demand demand = createDemand(amt);
			// set the filler
			setFillerOnDemand(demand);
			// set the listeners
			setDemandListeners(demand);
			// send the demand to the filler
			sendDemand(demand);
		}
	}
	
	@Override
	protected void initialize() {
		super.initialize();
	}
}
