/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package testing.parameters;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.logging.Level;
import java.util.logging.Logger;
import jsl.utilities.IdentityIfc;
import jslx.forecasting.IterativeDataSource;

/**
 *
 * @author hmedal
 */
public class FileDataSource extends IterativeDataSource implements IdentityIfc{

    private ArrayList<Double> values;
    private Iterator<Double> iterator;
    String filename;
    
    public FileDataSource(String filename) {
        this.filename=filename;
        setName(filename);
        BufferedReader input = null;
        values=new ArrayList<Double>();
        try {
            FileReader fr = new FileReader(new File(filename));
            input = new BufferedReader(fr);
            String line = null;
            int lineNumber = 0;
            while ((line = input.readLine()) != null) {
                //System.out.println("line= "+line);
                line.matches("0.0");
                double value=Double.parseDouble(line);
                lineNumber++;
                values.add(value);
            }
        } catch (Exception e) {
            System.err.println(e.toString());
        }
        iterator=values.iterator();
    }
    
    public FileDataSource(File f) {
        this.filename=f.toString();
        setName(f.toString());
        BufferedReader input = null;
        values=new ArrayList<Double>();
        try {
            FileReader fr = new FileReader(f);
            input = new BufferedReader(fr);
            String line = null;
            int lineNumber = 0;
            while ((line = input.readLine()) != null) {
                //System.out.println("line= "+line);
                double value=Double.parseDouble(line);
                lineNumber++;
                values.add(value);
            }
        } catch (Exception e) {
            System.err.println(e.toString());
        }
        iterator=values.iterator();
    }

    @Override
    public boolean hasNext() {
        boolean hasNext=iterator.hasNext();
        //System.out.println("hasNext="+hasNext);
        return iterator.hasNext();
    }

    @Override
    public double next() {
        double value=iterator.next();
        //System.out.println("next()="+value);
        setValue(value);
        return value;
    }

    @Override
    public void reset() {
        notifyObservers(RESET);
        iterator=values.iterator();
    }
    
    public int size(){
        return values.size();
    }
    
    public static void main(String[] args) {
        FileDataSource f = new FileDataSource("R:/Data/Croston1972.txt");
    }
}
