package testing.parameters;

import examples.queueing.DriverLicenseBureau;
import jsl.modeling.Experiment;
import jsl.modeling.IterativeProcess;
import jsl.modeling.Model;
import jsl.modeling.Replication;
//import jsl.modeling.Step;
import jsl.modeling.elements.variable.ResponseVariable;
import jsl.utilities.ControllableIfc;
import jsl.utilities.statistic.Statistic;
import jsl.utilities.statistic.StatisticAccessorIfc;

public class PairedT extends IterativeProcess<Replication>{
	
	private double halfWidth=Double.MAX_VALUE;
	private Replication r1;
	private Replication r2;
	private Statistic difference;
	private String responseName;
	private double desiredHalfWidth;
	
	public PairedT(Replication r1,Replication  r2,String responseName,double desiredHalfWidth){
		this.r1=r1;
		this.r2=r2;
		this.difference=new Statistic("Difference");
		this.desiredHalfWidth=desiredHalfWidth;
		this.responseName=responseName;
		//r1.initialize();
		//r2.initialize();
	}
	
	@Override
	protected boolean hasNext() {
		return halfWidth>desiredHalfWidth;
	}

	@Override
	protected Replication next() {
		return null;
	}

	@Override
	protected void runStep() {
		//System.out.println(r1.getLengthOfReplication());
		//System.out.println(r1.getLengthOfWarmUp());
		//System.out.println(r1.isCompleted());
		//System.out.println(r1.getM);
		r1.runAll();
		r2.runAll();
		double e1Mean=((ResponseVariable)r1.getModel().getModelElement(responseName)).getWithinReplicationAverage();
		double e2Mean=((ResponseVariable)r2.getModel().getModelElement(responseName)).getWithinReplicationAverage();
		double differenceVal=e1Mean-e2Mean;
		if(Double.isNaN(differenceVal))
			throw new RuntimeException();
		System.out.println("diff="+differenceVal+"\t"+e1Mean+"\t"+e2Mean);
		difference.collect(e1Mean-e2Mean);
		if(difference.getCount()>=2)
			halfWidth=difference.getHalfWidth();
		r1.initialize();
		r2.initialize();
	
	}
	
	@Override
	protected void setId() {
				
	}
	
	public StatisticAccessorIfc getDifferenceStat(){
		return difference;
	}
	
	public static void main(String[] args) {
		/*Model m1 = Model.createModel();
		ParameterizedIfc model1=new DriverLicenseBureauParameterized(m1);
		Parameters p1=model1.getParameters();
		p1.setInt("numServers", 1);
		model1.setParameters(p1);
		System.out.println("model1 params= "+model1.getParameters().get("numServers", ""));
		Replication r1 = new Replication(m1);
		r1.setLengthOfReplication(20000.0);
		r1.setLengthOfWarmUp(5000.0);
		
		Model m2 = Model.createModel();
		ParameterizedIfc model2=new DriverLicenseBureauParameterized(m2);
		Parameters p2=model2.getParameters();
		p2.setInt("numServers", 2);
		model2.setParameters(p2);
		System.out.println("model2 params= "+model2.getParameters().get("numServers", ""));
		Replication r2 = new Replication(m2);
		r2.setLengthOfReplication(20000.0);
		r2.setLengthOfWarmUp(5000.0);
		PairedT pairT=new PairedT(r1,r2,"NQ",.01);
		pairT.runAll();
		System.out.println(pairT.getDifferenceStat().getAverage());*/
	}
}
