/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package testing.parameters;

import java.util.Arrays;
import java.util.HashMap;
import java.util.Map;
import java.util.TreeMap;

import testing.parameters.optimize.*;
import jsl.utilities.random.*;
import jsl.utilities.random.distributions.Gamma;

/**
 *
 * @author hmedal
 */
public class RQInventoryOptimization {
    public static void main(String[] args){
        double mu=.222;
        double sigmaSq=.148;
        double alpha=Math.pow(mu,2)/sigmaSq;
        double beta=sigmaSq/mu;
        Gamma betaDist=new Gamma(alpha,beta);
        RQInventoryModelParameterized rq= new RQInventoryModelParameterized(1,1,betaDist);
        rq.setUnitCost(150.0);
        rq.setHoldingCostRatePerPeriod(1.0);
        rq.setCostPerOrder(65.138);
        rq.setBackOrderCostPerUnitPerPeriod(116.5);
        rq.setCostPerStockout(40.0);
        rq.setLeadTime(30.0); // 45.0 days
        rq.setPeriodLength(365.0); // 365 days per year
        Map<String,double[]> values=new TreeMap<String,double[]>();
        values.put("Reorder Point", new double[]{1,2,3,4,5,6,7,8,9,10});
        values.put("Reorder Quantity", new double[]{1,2,3,4,5,6,7,8,9,10});
        Map<String, Double> objectiveTerms=new HashMap<String,Double>();
        objectiveTerms.put("Backorder model total cost per period", 1.0);
        objectiveTerms.put("Stockout cost per period", 1.0);
        EnumerationOptimizer e=new EnumerationOptimizer(values,rq);
        e.setWeightedObjective(objectiveTerms);
        e.addVariableConstraint("Fill rate", new GreaterOrEqual(),.95);
        e.setMinimize();
        e.optimize();
        //System.out.println(e.getBestObjectiveValue());
        System.out.println(Arrays.toString(e.getBestSolution()));
        System.out.println(e.getBestObjectiveValue());
        //System.out.println(e.getBestResponses());
    }
}
