/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package testing.parameters;

import java.util.Arrays;
import java.util.HashMap;
import java.util.Map;
import java.util.TreeMap;
import jsl.modeling.Model;
import testing.parameters.optimize.GreaterOrEqual;
import jsl.utilities.random.distributions.Constant;
import jsl.utilities.random.distributions.DistributionIfc;
import jsl.utilities.random.distributions.Exponential;
import jslx.forecasting.IntermittentDemandStatistic;
import jslx.forecasting.demandgeneration.BatchOnOffDemandGenerator;

/**
 *
 * @author hmedal
 */
public class RQSimOptimization {
    
    public static void main(String[] args){
        Model m = Model.createModel();
        DistributionIfc lt = new Constant(30.0);
        int rpt = 2;
        int qty = 1;
        int level = rpt+qty;
        double periodLength=365.0;
        FileDataSource ds=new FileDataSource("F:/ourSoftware/CID Forecaster/data/timeSeriesData/" +
                "NavSup000018343.txt");
        IntermittentDemandStatistic stat=new IntermittentDemandStatistic();
        ds.addObserver(stat);
        ds.iterateAll();
        double meannumbusyslots=stat.getIntervalBetweenZeroDemandsStat().getAverage();
        double meannumidleslots=stat.getIntervalBetweenNonZeroDemandStat().getAverage();
        double meanbatchsize=stat.getNonZeroDemandStat().getAverage();
        //System.out.println(meanbatchsize+"\t"+meannumbusyslots+"\t"+meannumidleslots);
        BatchOnOffDemandGenerator data=BatchOnOffDemandGenerator.getDefaultBatchOnOffDemandGenerator(meannumbusyslots,meannumidleslots,
                meanbatchsize, "generator");
        DataRQInventorySimParameterized rq = new DataRQInventorySimParameterized(m,lt, rpt, qty,
                level,periodLength,data);
        rq.setUnitCost(150.0);
        rq.setHoldingCostRatePerPeriod(1.0);
        rq.setCostPerOrder(65.138);
        rq.setBackOrderCostPerUnitPerPeriod(116.5);
        rq.setCostPerStockout(40.0);
        Map<String,double[]> values=new TreeMap<String,double[]>();
        values.put("Reorder Point", new double[]{1,2,3,4,5});
        values.put("Reorder Quantity", new double[]{1,2,3,4,5});
        Map<String, Double> objectiveTerms=new HashMap<String,Double>();
        objectiveTerms.put("Backorder model total cost per period", 1.0);
        objectiveTerms.put("Stockout cost per period", 1.0);
        EnumerationOptimizer e=new EnumerationOptimizer(values,rq);
        e.setWeightedObjective(objectiveTerms);
        e.addVariableConstraint("Fill rate", new GreaterOrEqual(),.95);
        e.setMinimize();
        e.optimize();
        System.out.println(Arrays.toString(e.getBestSolution()));
        System.out.println(e.getBestObjectiveValue());
        //System.out.println(e.getBestResponses());
    }
}
