package testing.parameters.optimize;

import testing.parameters.Responses;

public class Constraint {
	
	private FunctionOfModelResponsesIfc function;
	private double rhs;
	private AcceptanceCriterionIfc acceptance;
	
	public Constraint(FunctionOfModelResponsesIfc function,AcceptanceCriterionIfc acceptance,double rhs){
		this.function=function;
		this.acceptance=acceptance;
		this.rhs=rhs;
	}
	
	public boolean feasible(Responses r){
		return acceptance.feasible(function.getCombinedResponse(r), rhs);
	}
}
