package testing.parameters.optimize;

import java.util.HashMap;
import java.util.Map;
import java.util.Map.Entry;

import testing.parameters.ExperimentableIfc;
import testing.parameters.Responses;

public class WeightedFunctionOfModelResponses implements FunctionOfModelResponsesIfc{
	
	private Map<String,Double> objectiveTerms;
	
	public WeightedFunctionOfModelResponses(ExperimentableIfc model){
		objectiveTerms=new HashMap<String,Double>();
	}
	
	public void addWeightedReponse(String name,double weight){
		objectiveTerms.put(name, weight);
	}
	
	public double getCombinedResponse(Responses r) {
		double combinedObjective=0;
		for(Entry<String,Double> e:objectiveTerms.entrySet())
			combinedObjective+=e.getValue()*r.getResponse(e.getKey());
		return combinedObjective;
	}

}
