/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
*
* Copyright (c) Manuel D. Rossetti (rossetti@uark.edu)
*
* Contact:
*	Manuel D. Rossetti, Ph.D., P.E.
*	Department of Industrial Engineering
*	University of Arkansas
*	4207 Bell Engineering Center
*	Fayetteville, AR 72701
*	Phone: (479) 575-6756
*	Email: rossetti@uark.edu
*	Web: www.uark.edu/~rossetti
*
* This file is part of the JSL (a Java Simulation Library). The JSL is a framework
* of Java classes that permit the easy development and execution of discrete event
* simulation programs.
*
* The JSL is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* The JSL is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with the JSL (see file COPYING in the distribution);
* if not, write to the Free Software Foundation, Inc., 51 Franklin St, Fifth Floor,
* Boston, MA  02110-1301  USA, or see www.fsf.org
*
 */

package testing.random;

import jsl.utilities.random.distributions.Binomial;
import jsl.utilities.random.rng.RngStream;

/**
 *
 * @author rossetti
 */
public class TestBinomial {

    public static void main(String args[]) {

        test1();
        //test3();

    }

    public static void test1() {

        int n = 20;
        double p = 0.7;
        System.out.println("n = " + n);
        System.out.println("p = " + p);
        System.out.println();

//        for (int i = 0; i <= 10; i++) {
//            System.out.println("pdf(" + i + ")= " + Binomial.recursivePMF(i, n, p));
//        }
//        System.out.println();

//        for (int i = 0; i <= 10; i++) {
//            System.out.println("pdf(" + i + ")= " + Binomial.binomialPMF(i, n, p, false));
//        }
//        System.out.println();

//        for (int i = 0; i <= 10; i++) {
//            System.out.println("cdf(" + i + ")= " + Binomial.recursiveCDF(i, n, p));
//        }
//        System.out.println();

//        for (int i = 0; i <= 10; i++) {
//            System.out.println("cdf(" + i + ")= " + Binomial.binomialCDF(i, n, p, false));
//        }
//        System.out.println();

//        for (int i = 0; i <= 10; i++) {
//            System.out.println("L1(" + i + ")= " + Binomial.binomialLF1(i, n, p));
//        }
//        System.out.println();

//        for (int i = 0; i <= 10; i++) {
//            System.out.println("L2(" + i + ")= " + Binomial.binomialLF2(i, n, p));
//        }

        System.out.println();
        RngStream rng = new RngStream();

        Binomial b = new Binomial(p, n, rng);
        for (int i = 0; i <= 20; i++) {
            System.out.println("pdf(" + i + ")= " + b.pmf(i) + " \t cdf(" + i + ")= " + b.cdf(i) +
                    " \t ccdf(" + i + ")= " + b.complementaryCDF(i) + " \t L1(" + i + ")= " +
                    b.firstOrderLossFunction(i) + " \t L2(" + i + ")= " + b.secondOrderLossFunction(i));
        }

        System.out.println();
        for (int i = 1; i <= 20; i++) {
            double u = rng.randU01();
            System.out.println("invCDF(" + u + ") = " + b.invCDF(u) + " \t static: " + Binomial.binomialInvCDF(u, n, p));
        }
    }

    public static void test2() {

        int n = 200;
        double p = 0.0007;
        System.out.println("n = " + n);
        System.out.println("p = " + p);
        System.out.println();

/*
        for (int i = 0; i <= 10; i++) {
            System.out.println("pdf(" + i + ")= " + Binomial.recursivePMF(i, n, p));
        }
        System.out.println();

        for (int i = 0; i <= 10; i++) {
            System.out.println("pdf(" + i + ")= " + Binomial.binomialPMF(i, n, p, false));
        }
        System.out.println();

        for (int i = 0; i <= 10; i++) {
            System.out.println("cdf(" + i + ")= " + Binomial.recursiveCDF(i, n, p));
        }
        System.out.println();

        for (int i = 0; i <= 10; i++) {
            System.out.println("cdf(" + i + ")= " + Binomial.binomialCDF(i, n, p, false));
        }
        System.out.println();

        for (int i = 0; i <= 10; i++) {
            System.out.println("L1(" + i + ")= " + Binomial.binomialLF1(i, n, p));
        }
        System.out.println();

        for (int i = 0; i <= 10; i++) {
            System.out.println("L2(" + i + ")= " + Binomial.binomialLF2(i, n, p));
        }
*/
        System.out.println();
        RngStream rng = new RngStream();

        Binomial b = new Binomial(p, n, rng);
        for (int i = 0; i <= 10; i++) {
            System.out.println("pdf(" + i + ")= " + b.pmf(i) + " \t cdf(" + i + ")= " + b.cdf(i) +
                    " \t ccdf(" + i + ")= " + b.complementaryCDF(i) + " \t L1(" + i + ")= " +
                    b.firstOrderLossFunction(i) + " \t L2(" + i + ")= " + b.secondOrderLossFunction(i));
        }

        System.out.println();
        for (int i = 1; i <= 20; i++) {
            double u = rng.randU01();
            System.out.println("invCDF(" + u + ") = " + b.invCDF(u) + " static: " + Binomial.binomialInvCDF(u, n, p));
        }


    }

    public static void test3() {

        int n = 300;
        double p = 0.7;
        System.out.println("n = " + n);
        System.out.println("p = " + p);
        System.out.println();

/*
        for (int i = 0; i <= 10; i++) {
            System.out.println("pdf(" + i + ")= " + Binomial.recursivePMF(i, n, p));
        }
        System.out.println();

        for (int i = 0; i <= 10; i++) {
            System.out.println("pdf(" + i + ")= " + Binomial.binomialPMF(i, n, p, false));
        }
        System.out.println();

        for (int i = 0; i <= 10; i++) {
            System.out.println("cdf(" + i + ")= " + Binomial.recursiveCDF(i, n, p));
        }
        System.out.println();

        for (int i = 0; i <= 10; i++) {
            System.out.println("cdf(" + i + ")= " + Binomial.binomialCDF(i, n, p, false));
        }
        System.out.println();

        for (int i = 0; i <= 10; i++) {
            System.out.println("L1(" + i + ")= " + Binomial.binomialLF1(i, n, p));
        }
        System.out.println();

        for (int i = 0; i <= 10; i++) {
            System.out.println("L2(" + i + ")= " + Binomial.binomialLF2(i, n, p));
        }
*/
        System.out.println();
        RngStream rng = new RngStream();

        Binomial b = new Binomial(p, n, rng);
        for (int i = 0; i <= 10; i++) {
            System.out.println("pdf(" + i + ")= " + b.pmf(i) + " \t cdf(" + i + ")= " + b.cdf(i) +
                    " \t ccdf(" + i + ")= " + b.complementaryCDF(i) + " \t L1(" + i + ")= " +
                    b.firstOrderLossFunction(i) + " \t L2(" + i + ")= " + b.secondOrderLossFunction(i));
        }

        System.out.println();
        for (int i = 1; i <= 20; i++) {
            double u = rng.randU01();
            System.out.println("invCDF(" + u + ") = " + b.invCDF(u) + " static: " + Binomial.binomialInvCDF(u, n, p));
        }


    }

}
