package testing.random;

import jsl.utilities.random.*;
import jsl.utilities.random.rng.RngIfc;
import jsl.utilities.random.rng.RngStream;

public class TestStreams {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		RngIfc g1 = new RngStream();
		RngIfc g2 = new RngStream();
		System.out.println("Two different random number generators.");
		System.out.println("Note that they produce different random numbers");
		for (int i = 0; i < 5; i++) {
			System.out.println("g1 = " + g1.randU01() + "\t g2 = " + g2.randU01());
		}

		System.out.println();

		g1.resetStartStream();
		g2.resetStartStream();
		System.out.println("Resetting to the starting stream simply");
		System.out.println("causes them to repeat the above.");

		for (int i = 0; i < 5; i++) {
			System.out.println("g1 = " + g1.randU01() + "\t g2 = " + g2.randU01());
		}

		g1.resetNextSubstream();
		g1.resetNextSubstream();
		System.out.println("Resetting to the start of the next stream ");
		System.out.println("causes them to generate more independent numbers.");

		for (int i = 0; i < 5; i++) {
			System.out.println("g1 = " + g1.randU01() + "\t g2 = " + g2.randU01());
		}
		
		g1.resetStartStream();
		g2.resetStartStream();
		g1.setAntithetic(true);
		g2.setAntithetic(true);
		System.out.println("Resetting to the starting stream and turning on antithetic");
		System.out.println("causes them to produce the antithetics for the original starting stream.");

		for (int i = 0; i < 5; i++) {
			System.out.println("g1 = " + g1.randU01() + "\t g2 = " + g2.randU01());
		}
	}

}
