Wrap your .NET library easily
---

This sample demonstrates how to wrap your own library with proxygen without too much effort spent configuring it.
Look at the batch files and the run it.

1) run `generateProxies.cmd`, it will do following
- generateProxies will copy all dependencies from jni4net `lib` to `work` directory
- generateProxies will run proxygen tool to wrap 'your' `MyCSharpDemoCalc.dll`
-- proxygen: generate java proxies
-- proxygen: generate C# proxies
-- proxygen: generate `build.cmd`
-- proxygen: generate `MyCSharpDemoCalc.proxygen.xml`
- generateProxies will run `work\build.cmd` to compile all stuff generated by proxygen. 
-- `build.cmd` : run `javac` to compile java classes
-- `build.cmd` : run `jar` to package classes into .JAR file
-- `build.cmd` : run `csc` to compile C# classes and produce .DLL
-- `build.cmd` : In real life you should use Ant or something smarter.
- generateProxies will run javac to compile example of usage `MyCalcUsageInJava.java`

2) look at `MyCalcUsageInJava.java` to see how to use the new wrapper

3) you run `run.cmd` to execute sample

Your output is here:
```
work/*.dll
work/*.jar
work/*.class
work/*.txt
```

This is what you deploy.