package jslx.transportlayerFinal.test;

import jsl.modeling.Experiment;
import jsl.modeling.Model;
import jsl.modeling.elements.spatial.RectangularGridSpatialModel2D;
import jsl.modeling.elements.spatial.SpatialModel;
import jsl.modeling.elements.spatial.Vector3D;
import jsl.utilities.random.distributions.Constant;
import jsl.utilities.random.distributions.DistributionIfc;
import jsl.utilities.random.distributions.Exponential;
import jsl.utilities.reporting.JSL;
import jslx.transportlayerFinal.AbstractDispatcherFTL;
import jslx.transportlayerFinal.DispatcherFTL;
import jslx.transportlayerFinal.Lane;
import jslx.transportlayerFinal.LaneIfc;
import jslx.transportlayerFinal.LoadGenerator;
import jslx.transportlayerFinal.Location;
import jslx.transportlayerFinal.TransportationNetwork;


public class TestCase {

public static void main(String[] args){
		
		System.out.println("Simple Transportation Model");
		testCaseH();
		System.out.println("Done!");
	}
	
	public static void testCase1(){
		
		System.out.println("TruckLoad Transportation Network : Fully Connected");
		
		Model m = Model.createModel();
		
		System.out.println("Model Created");
		
		SpatialModel smodel = new RectangularGridSpatialModel2D();
				
		Location l1 = new Location(m,"Kansas City",smodel, new Vector3D(0.0,0.0,0.0));
		Location l2 = new Location(m,"Chicago",smodel,new Vector3D(1.0,2.0,3.0));
		Location l3 = new Location(m,"New York",smodel, new Vector3D(5.0,4.0,0.0));
		Location l4 = new Location(m,"Boston",smodel, new Vector3D(3.0,7.0,0.0));
		Location l5 = new Location(m,"Atlanta",smodel, new Vector3D(4.0,9.0,0.0));
		Location l6 = new Location(m,"Los Angeles",smodel, new Vector3D(3.0,4.0,0.0));
		
		DistributionIfc tl = new Exponential(1.0);
		
		TransportationNetwork t=new TransportationNetwork(m, smodel);
		
		System.out.println("Here is the Transportation Network");	
		
		l1.setLoadingTimeDistribution(new Constant (2.0));
		l2.setLoadingTimeDistribution(new Constant (2.0));
		l3.setLoadingTimeDistribution(new Constant (2.0));
		l4.setLoadingTimeDistribution(new Constant (2.0));
		l5.setLoadingTimeDistribution(new Constant (2.0));
		l6.setLoadingTimeDistribution(new Constant (2.0));
		
		l1.setUnloadingTimeDistribution(new Constant (1.0));
		l2.setUnloadingTimeDistribution(new Constant (1.0));
		l3.setUnloadingTimeDistribution(new Constant (1.0));
		l4.setUnloadingTimeDistribution(new Constant (1.0));
		l5.setUnloadingTimeDistribution(new Constant (1.0));
		l6.setUnloadingTimeDistribution(new Constant (1.0));
		
		LaneIfc lane12= new Lane(t,l1,l2,Math.sqrt(5));
		LaneIfc lane13= new Lane(t,l1,l3,Math.sqrt(41));
		LaneIfc lane14= new Lane(t,l1,l4,Math.sqrt(58));
		LaneIfc lane15= new Lane(t,l1,l5,Math.sqrt(97));
		LaneIfc lane16= new Lane(t,l1,l6,Math.sqrt(25));
		
		LaneIfc lane21= new Lane(t,l2,l1,Math.sqrt(5));
		LaneIfc lane23= new Lane(t,l2,l3,Math.sqrt(20));
		LaneIfc lane24= new Lane(t,l2,l4,Math.sqrt(29));
		LaneIfc lane25= new Lane(t,l2,l5,Math.sqrt(58));
		LaneIfc lane26= new Lane(t,l2,l6,Math.sqrt(8));
		
		LaneIfc lane31= new Lane(t,l3,l1,Math.sqrt(41));
		LaneIfc lane32= new Lane(t,l3,l2,Math.sqrt(20));
		LaneIfc lane34= new Lane(t,l3,l4,Math.sqrt(13));
		LaneIfc lane35= new Lane(t,l3,l5,Math.sqrt(26));
		LaneIfc lane36= new Lane(t,l3,l6,Math.sqrt(4));
		
		LaneIfc lane41= new Lane(t,l4,l1,Math.sqrt(58));
		LaneIfc lane42= new Lane(t,l4,l2,Math.sqrt(29));
		LaneIfc lane43= new Lane(t,l4,l3,Math.sqrt(13));
		LaneIfc lane45= new Lane(t,l4,l5,Math.sqrt(5));
		LaneIfc lane46= new Lane(t,l4,l6,Math.sqrt(9));
		
		LaneIfc lane51= new Lane(t,l5,l1,Math.sqrt(97));
		LaneIfc lane52= new Lane(t,l5,l2,Math.sqrt(58));
		LaneIfc lane53= new Lane(t,l5,l3,Math.sqrt(26));
		LaneIfc lane54= new Lane(t,l5,l4,Math.sqrt(5));
		LaneIfc lane56= new Lane(t,l5,l6,Math.sqrt(26));
		
		LaneIfc lane61= new Lane(t,l6,l1,Math.sqrt(25));
		LaneIfc lane62= new Lane(t,l6,l2,Math.sqrt(8));
		LaneIfc lane63= new Lane(t,l6,l3,Math.sqrt(4));
		LaneIfc lane64= new Lane(t,l6,l4,Math.sqrt(9));
		LaneIfc lane65= new Lane(t,l6,l5,Math.sqrt(26));
		
		t.addLane(lane12);
		t.addLane(lane13);
		t.addLane(lane14);
		t.addLane(lane15);
		t.addLane(lane16);
		
		t.addLane(lane21);
		t.addLane(lane23);
		t.addLane(lane24);
		t.addLane(lane25);
		t.addLane(lane26);
		
		t.addLane(lane31);
		t.addLane(lane32);
		t.addLane(lane34);
		t.addLane(lane35);
		t.addLane(lane36);
		
		t.addLane(lane41);
		t.addLane(lane42);
		t.addLane(lane43);
		t.addLane(lane45);
		t.addLane(lane46);
		
		t.addLane(lane51);
		t.addLane(lane52);
		t.addLane(lane53);
		t.addLane(lane54);
		t.addLane(lane56);
		
		t.addLane(lane61);
		t.addLane(lane62);
		t.addLane(lane63);
		t.addLane(lane64);
		t.addLane(lane65);
		
		System.out.println(t);
		
		AbstractDispatcherFTL d = new DispatcherFTL(m,t,6.0);
		
		d.addDriver(l1,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),new Constant(1.0));
		d.addDriver(l2,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),new Constant(1.0));
		d.addDriver(l3,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),new Constant(1.0));
		d.addDriver(l4,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),new Constant(1.0));
		d.addDriver(l5,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),new Constant(1.0));
		d.addDriver(l6,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),new Constant(1.0));
		
		d.addTrailer(l1);
		d.addTrailer(l2);
		d.addTrailer(l3);
		d.addTrailer(l4);
		d.addTrailer(l5);
		d.addTrailer(l6);
		
		d.addTruck(l1);
		d.addTruck(l2);
		d.addTruck(l3);
		d.addTruck(l4);
		d.addTruck(l5);
		d.addTruck(l6);
		
		//Create the Load generator
		LoadGenerator lg = new LoadGenerator(m,t,tl,tl);
		System.out.println("Here is the load generator");
		
		lg.setOriginProbability(l1, 0.2);
		lg.setOriginProbability(l2, 0.2);
		lg.setOriginProbability(l3, 0.1);
		lg.setOriginProbability(l4, 0.1);
		lg.setOriginProbability(l5, 0.1);
		lg.setLastOriginProbability(l6);
		
		System.out.println("origin probability set");
		
		lg.setDestinationProbability(lane12,0.2);
		lg.setDestinationProbability(lane13,0.2);
		lg.setDestinationProbability(lane14,0.2);
		lg.setDestinationProbability(lane15,0.1);
		lg.setLastDestinationProbability(lane16);
		
		lg.setDestinationProbability(lane21,0.2);
		lg.setDestinationProbability(lane23,0.1);
		lg.setDestinationProbability(lane24,0.2);
		lg.setDestinationProbability(lane25,0.1);
		lg.setLastDestinationProbability(lane26);
		
		lg.setDestinationProbability(lane31,0.2);
		lg.setDestinationProbability(lane32,0.1);
		lg.setDestinationProbability(lane34,0.2);
		lg.setDestinationProbability(lane35,0.1);
		lg.setLastDestinationProbability(lane36);
		
		lg.setDestinationProbability(lane41,0.2);
		lg.setDestinationProbability(lane42,0.1);
		lg.setDestinationProbability(lane43,0.2);
		lg.setDestinationProbability(lane45,0.1);
		lg.setLastDestinationProbability(lane46);
		
		lg.setDestinationProbability(lane51,0.1);
		lg.setDestinationProbability(lane52,0.1);
		lg.setDestinationProbability(lane53,0.1);
		lg.setDestinationProbability(lane54,0.1);
		lg.setLastDestinationProbability(lane56);
		
		lg.setDestinationProbability(lane61,0.2);
		lg.setDestinationProbability(lane62,0.1);
		lg.setDestinationProbability(lane63,0.2);
		lg.setDestinationProbability(lane64,0.1);
		lg.setLastDestinationProbability(lane65);
		
		System.out.println("destination probability set");
		
		m.turnOnLogReport();
		
		// create the experiment to run the model
		Experiment e = new Experiment(m);
		
		// set the parameters of the experiment
		e.setNumberOfReplications(2);
		e.setLengthOfReplication(200);
		e.setLengthOfWarmUp(0.0);
		
		// turn on the desired reporting
			e.turnOnBatchReport(); 
		 e.turnOnExperimentReport();
		 e.turnOnReplicationReport();
	//	 e.turnOnExperimentConsoleOutput();
		
		// tell the experiment to run
		e.runAll();
	}

	public static void testCase2(){
		
		System.out.println("Test Case for Driver");
		
		Model m = Model.createModel();
		
		System.out.println("Model Created");
		
		DistributionIfc tl = new Exponential(1.0);
		
		SpatialModel smodel = new RectangularGridSpatialModel2D();
		
		TransportationNetwork t=new TransportationNetwork(m, smodel);
		
		System.out.println("Here is the Transportation Network");		
		
		Location k = new Location(m,"Kansas City",smodel, new Vector3D(0.0,0.0,0.0));
		Location c = new Location(m,"Chicago",smodel,new Vector3D(1.0,2.0,3.0));
		Location n = new Location(m,"New York",smodel, new Vector3D(5.0,4.0,0.0));
		Location b = new Location(m,"Boston",smodel, new Vector3D(3.0,7.0,0.0));
		Location a = new Location(m,"Atlanta",smodel, new Vector3D(4.0,9.0,0.0));
		Location l = new Location(m,"Los Angeles",smodel, new Vector3D(3.0,4.0,0.0));
		
		k.setLoadingTimeDistribution(new Constant (1.0));
		c.setLoadingTimeDistribution(new Constant (1.0));
		n.setLoadingTimeDistribution(new Constant (1.0));
		b.setLoadingTimeDistribution(new Constant (1.0));
		a.setLoadingTimeDistribution(new Constant (1.0));
		l.setLoadingTimeDistribution(new Constant (1.0));
		
		k.setUnloadingTimeDistribution(new Constant (1.0));
		c.setUnloadingTimeDistribution(new Constant (1.0));
		n.setUnloadingTimeDistribution(new Constant (1.0));
		b.setUnloadingTimeDistribution(new Constant (1.0));
		a.setUnloadingTimeDistribution(new Constant (1.0));
		l.setUnloadingTimeDistribution(new Constant (1.0));
		
		//LaneIfc kc= new Lane(t,k,c,Math.sqrt(5));
		LaneIfc kc= new Lane(t,k,c,Math.sqrt(4));
		LaneIfc cn = new Lane(t,c,n,Math.sqrt(25));
		LaneIfc nb = new Lane(t,n,b,Math.sqrt(169));
		LaneIfc bn = new Lane(t,b,n,Math.sqrt(169));
//		LaneIfc ab = new Lane(t,a,b,Math.sqrt(5));
		LaneIfc ab = new Lane(t,a,b,Math.sqrt(81));
		LaneIfc al= new Lane(t,a,l,Math.sqrt(25));
		LaneIfc cl= new Lane(t,c,l,Math.sqrt(81));
//		LaneIfc lk= new Lane(t,l,k,Math.sqrt(25));
		LaneIfc lk= new Lane(t,l,k,Math.sqrt(169));
//		LaneIfc lk= new Lane(t,l,k,Math.sqrt(9));
		LaneIfc nc = new Lane(t,n,c,Math.sqrt(25));
		LaneIfc la = new Lane(t,l,a,Math.sqrt(25));
		
		t.addLane(kc);
		t.addLane(cn);
		t.addLane(nb);
		t.addLane(bn);
		t.addLane(ab);
		t.addLane(al);
		t.addLane(cl);
		t.addLane(lk);
		t.addLane(nc);
		t.addLane(la);
		
		System.out.println(t);
		
		AbstractDispatcherFTL d = new DispatcherFTL(m,t,20.0);
		
		d.addDriver(k,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),new Constant(1.0));
		d.addDriver(c,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),new Constant(1.0));
		d.addDriver(c,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),new Constant(1.0));
		d.addDriver(n,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),new Constant(1.0));
		d.addDriver(b,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),new Constant(1.0));
		d.addDriver(a,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),new Constant(1.0));
//		d.addDriver(a,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),new Constant(1.0));
		d.addDriver(l,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),new Constant(1.0));
		
		d.addTrailer(k);
		d.addTrailer(c);
	//	d.addTrailer(n);
		d.addTrailer(b);
	//	d.addTrailer(a);//	put trailer
		d.addTrailer(l);// remove trailer
		
		d.addTruck(k);
		d.addTruck(c);
		d.addTruck(n);
		d.addTruck(b);
	//	d.addTruck(a);//remove
		d.addTruck(l);
		
		//	Create the Load generator
	//	LoadGenerator lg = new LoadGenerator(m,t,tl,tl); 
		
		LoadGenerator lg = new LoadGenerator(m,t,tl,tl,0," "); 
		
		System.out.println("Here is the load generator");
		
		lg.setOriginProbability(k, 0.2);
		lg.setOriginProbability(c, 0.2);
		lg.setOriginProbability(n, 0.1);
		lg.setOriginProbability(b, 0.1);
		lg.setOriginProbability(a, 0.1);
		lg.setLastOriginProbability(l);
		
		System.out.println("origin probability set");
		
		lg.setLastDestinationProbability(kc);
		
		lg.setLastDestinationProbability(la);
		
		lg.setDestinationProbability(cn,0.2);
		lg.setLastDestinationProbability(cl);
		
		lg.setLastDestinationProbability(nb);
		
		lg.setLastDestinationProbability(bn);
		
		lg.setLastDestinationProbability(nc);
		
		lg.setDestinationProbability(ab,0.5);
		lg.setLastDestinationProbability(al);
		
		lg.setLastDestinationProbability(lk);
		
		System.out.println("destination probability set");
		
		m.turnOnLogReport();
		
		// create the experiment to run the model
		Experiment e = new Experiment(m);
		
		// set the parameters of the experiment
		e.setNumberOfReplications(3);
		e.setLengthOfReplication(40);
		e.setLengthOfWarmUp(0.0);
		
		// turn on the desired reporting
		e.turnOnBatchReport(); 
		e.turnOnExperimentReport();
		e.turnOnReplicationReport();
	//	e.turnOnExperimentConsoleOutput();
		
		// tell the experiment to run
		e.runAll();
	}
	
public static void testCase(){
		
		System.out.println("Test Case For Truckload Transportation Model : JBHT:Base Case");
		
		Model m = Model.createModel();
		
		System.out.println("Model Created");
		
		DistributionIfc tl = new Exponential(1.0);
		
		SpatialModel smodel = new RectangularGridSpatialModel2D();
		
		TransportationNetwork t=new TransportationNetwork(m, smodel);
		
		System.out.println("Here is the Transportation Network");		
		
		Location atlanta = new Location(m,"Atlanta,GA",smodel, new Vector3D(0.0,0.0,0.0));
		Location louisville = new Location(m,"Louisville,KY",smodel,new Vector3D(1.0,2.0,3.0));
		Location detroit = new Location(m,"Detroit,MI",smodel, new Vector3D(5.0,4.0,0.0));
		Location chicago = new Location(m,"Chicago,IL",smodel, new Vector3D(3.0,7.0,0.0));
		Location kansascity = new Location(m,"Kansas City,MO",smodel, new Vector3D(4.0,9.0,0.0));
		Location littlerock = new Location(m,"Little Rock,AR",smodel, new Vector3D(58.0,28.0,0.0));
		Location memphis = new Location(m,"Memphis,TN",smodel, new Vector3D(3.0,5.0,0.0));
		Location lowell = new Location(m,"Lowell,AR",smodel, new Vector3D(3.0,6.0,0.0));
		Location oklacity = new Location(m,"Okla City,OK",smodel, new Vector3D(3.0,7.0,0.0));
		Location dallas = new Location(m,"Dallas,TX",smodel, new Vector3D(3.0,4.0,0.0));
		Location houston = new Location(m,"Houston,TX",smodel, new Vector3D(3.0,8.0,0.0));
	
		atlanta.setLoadingTimeDistribution(new Constant (1.0));
		louisville.setLoadingTimeDistribution(new Constant (1.0));
		detroit.setLoadingTimeDistribution(new Constant (1.0));
		chicago.setLoadingTimeDistribution(new Constant (1.0));
		kansascity.setLoadingTimeDistribution(new Constant (1.0));
		littlerock.setLoadingTimeDistribution(new Constant (1.0));
		memphis.setLoadingTimeDistribution(new Constant (1.0));
		lowell.setLoadingTimeDistribution(new Constant (1.0));
		oklacity.setLoadingTimeDistribution(new Constant (1.0));
		dallas.setLoadingTimeDistribution(new Constant (1.0));
		houston.setLoadingTimeDistribution(new Constant (1.0));
				
		atlanta.setUnloadingTimeDistribution(new Constant (1.0));
		louisville.setUnloadingTimeDistribution(new Constant (1.0));
		detroit.setUnloadingTimeDistribution(new Constant (1.0));
		chicago.setUnloadingTimeDistribution(new Constant (1.0));
		kansascity.setUnloadingTimeDistribution(new Constant (1.0));
		littlerock.setUnloadingTimeDistribution(new Constant (1.0));
		memphis.setUnloadingTimeDistribution(new Constant (1.0));
		lowell.setUnloadingTimeDistribution(new Constant (1.0));
		oklacity.setUnloadingTimeDistribution(new Constant (1.0));
		dallas.setUnloadingTimeDistribution(new Constant (1.0));
		houston.setUnloadingTimeDistribution(new Constant (1.0));
		
		LaneIfc ab= new Lane(t,atlanta,louisville,436);
		LaneIfc ae= new Lane(t,atlanta,kansascity,862);
		LaneIfc af = new Lane(t,atlanta,littlerock,538);
		LaneIfc ai = new Lane(t,atlanta,oklacity,869);
		LaneIfc aj = new Lane(t,atlanta,dallas,804);
		LaneIfc ak = new Lane(t,atlanta,houston,814);
		
		LaneIfc ba = new Lane(t,louisville,atlanta,436);
		LaneIfc bc = new Lane(t,louisville,detroit,355);
		LaneIfc bd = new Lane(t,louisville,chicago,324);
		LaneIfc bf = new Lane(t,louisville,littlerock,513);
		
		LaneIfc cb = new Lane(t,detroit,louisville,355);
		LaneIfc cd = new Lane(t,detroit,chicago,265);
		
		LaneIfc db= new Lane(t,chicago,louisville,324);
		LaneIfc dc= new Lane(t,chicago,detroit,265);
		LaneIfc dh= new Lane(t,chicago,lowell,610);
		LaneIfc dj= new Lane(t,chicago,dallas,899);

		LaneIfc ea = new Lane(t,kansascity,atlanta,862);
		LaneIfc ef = new Lane(t,kansascity,littlerock,470);
		LaneIfc eh = new Lane(t,kansascity,lowell,289);
		
		LaneIfc fa = new Lane(t,littlerock,atlanta,538);
		LaneIfc fb = new Lane(t,littlerock,louisville,513);
		LaneIfc fe = new Lane(t,littlerock,kansascity,470);
		LaneIfc fj = new Lane(t,littlerock,dallas,341);
		LaneIfc fk = new Lane(t,littlerock,houston,481);
		
		LaneIfc gk = new Lane(t,memphis,houston,575);
		
		LaneIfc hd = new Lane(t,lowell,chicago,610);
		LaneIfc he = new Lane(t,lowell,kansascity,289);
		LaneIfc hj = new Lane(t,lowell,dallas,328);
		
		LaneIfc ia = new Lane(t,oklacity,atlanta,869);
		LaneIfc ij = new Lane(t,oklacity,dallas,233);
		LaneIfc ik = new Lane(t,oklacity,houston,476);
		
		LaneIfc ja = new Lane(t,dallas,atlanta,804);
		LaneIfc jd = new Lane(t,dallas,chicago,899);
		LaneIfc jf = new Lane(t,dallas,littlerock,341);
		LaneIfc jh = new Lane(t,dallas,lowell,328);
		LaneIfc ji = new Lane(t,dallas,oklacity,233);
		LaneIfc jk = new Lane(t,dallas,houston,258);
		
		LaneIfc ka = new Lane(t,houston,atlanta,814);
		LaneIfc kf = new Lane(t,houston,littlerock,481);
		LaneIfc kg = new Lane(t,houston,memphis,575);
		LaneIfc ki = new Lane(t,houston,oklacity,476);
		LaneIfc kj = new Lane(t,houston,dallas,258);
		
		t.addLane(ab);
		t.addLane(ae);
		t.addLane(af);
		t.addLane(ai);
		t.addLane(aj);
		t.addLane(ak);
		
		t.addLane(ba);
		t.addLane(bc);
		t.addLane(bd);
		t.addLane(bf);
		
		t.addLane(cb);
		t.addLane(cd);
		
		t.addLane(db);
		t.addLane(dc);
		t.addLane(dh);
		t.addLane(dj);
		
		t.addLane(ea);
		t.addLane(ef);
		t.addLane(eh);
		
		t.addLane(fa);
		t.addLane(fb);
		t.addLane(fe);
		t.addLane(fj);
		t.addLane(fk);
			
		t.addLane(gk);
		t.addLane(hd);
		t.addLane(he);
		t.addLane(hj);
		
		t.addLane(ia);
		t.addLane(ij);
		t.addLane(ik);
		
		t.addLane(ja);
		t.addLane(jd);
		t.addLane(jf);
		t.addLane(jh);
		t.addLane(ji);
		t.addLane(jk);
		
		t.addLane(ka);
		t.addLane(kf);
		t.addLane(kg);
		t.addLane(ki);
		t.addLane(kj);
		
		System.out.println(t);
		
		AbstractDispatcherFTL d = new DispatcherFTL(m,t,1000.0);//DHBT user defined range is 1000 miles
		
		DistributionIfc driverSpeed = new Constant(60.0);
//		 8 drivers for atlanta
		d.addDriver(atlanta,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
		d.addDriver(atlanta,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
		d.addDriver(atlanta,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
		d.addDriver(atlanta,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
		d.addDriver(atlanta,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
		d.addDriver(atlanta,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
		d.addDriver(atlanta,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
		d.addDriver(atlanta,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
		
		//7 drivers for louisville
		d.addDriver(louisville,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
		d.addDriver(louisville,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
		d.addDriver(louisville,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
		d.addDriver(louisville,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
		d.addDriver(louisville,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
		d.addDriver(louisville,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
		d.addDriver(louisville,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
		
		//7 drivers for detroit
		d.addDriver(detroit,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
		d.addDriver(detroit,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
		d.addDriver(detroit,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
		d.addDriver(detroit,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
		d.addDriver(detroit,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
		d.addDriver(detroit,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
		d.addDriver(detroit,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
		
		//8 drivers for chicago
		d.addDriver(chicago,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
		d.addDriver(chicago,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
		d.addDriver(chicago,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
		d.addDriver(chicago,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
		d.addDriver(chicago,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
		d.addDriver(chicago,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
		d.addDriver(chicago,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
		d.addDriver(chicago,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
		
		//6 drivers for kansas city
		d.addDriver(kansascity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
		d.addDriver(kansascity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
		d.addDriver(kansascity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
		d.addDriver(kansascity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
		d.addDriver(kansascity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
		d.addDriver(kansascity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
		
		//10 drivers for little rock
		d.addDriver(littlerock,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
		d.addDriver(littlerock,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
		d.addDriver(littlerock,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
		d.addDriver(littlerock,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
		d.addDriver(littlerock,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
		d.addDriver(littlerock,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
		d.addDriver(littlerock,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
		d.addDriver(littlerock,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
		d.addDriver(littlerock,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
		d.addDriver(littlerock,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
		
		// 3 drivers for memphis
		d.addDriver(memphis,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
		d.addDriver(memphis,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
		d.addDriver(memphis,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
		
		//7 drivers for lowell
		d.addDriver(lowell,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
		d.addDriver(lowell,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
		d.addDriver(lowell,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
		d.addDriver(lowell,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
		d.addDriver(lowell,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
		d.addDriver(lowell,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
		d.addDriver(lowell,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
		
		// 6 drivers for okla city
		d.addDriver(oklacity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
		d.addDriver(oklacity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
		d.addDriver(oklacity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
		d.addDriver(oklacity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
		d.addDriver(oklacity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
		d.addDriver(oklacity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
		
		// 9 drivers for dallas
		d.addDriver(dallas,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
		d.addDriver(dallas,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
		d.addDriver(dallas,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
		d.addDriver(dallas,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
		d.addDriver(dallas,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
		d.addDriver(dallas,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
		d.addDriver(dallas,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
		d.addDriver(dallas,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
		d.addDriver(dallas,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
		
		// 9 drivers for houston
		d.addDriver(houston,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
		d.addDriver(houston,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
		d.addDriver(houston,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
		d.addDriver(houston,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
		d.addDriver(houston,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
		d.addDriver(houston,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
		d.addDriver(houston,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
		d.addDriver(houston,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
		d.addDriver(houston,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
		
		//12 trucks at atlanta
				
		d.addTruck(atlanta);
		d.addTruck(atlanta);
		d.addTruck(atlanta);
		d.addTruck(atlanta);
		d.addTruck(atlanta);
		d.addTruck(atlanta);
		d.addTruck(atlanta);
		d.addTruck(atlanta);
		d.addTruck(atlanta);
		d.addTruck(atlanta);
		d.addTruck(atlanta);
		d.addTruck(atlanta);
		
//		11 trucks at louisville
		d.addTruck(louisville);
		d.addTruck(louisville);
		d.addTruck(louisville);
		d.addTruck(louisville);
		d.addTruck(louisville);
		d.addTruck(louisville);
		d.addTruck(louisville);
		d.addTruck(louisville);
		d.addTruck(louisville);
		d.addTruck(louisville);
		d.addTruck(louisville);
		
//		11 trucks at detroit
		d.addTruck(detroit);
		d.addTruck(detroit);
		d.addTruck(detroit);
		d.addTruck(detroit);
		d.addTruck(detroit);
		d.addTruck(detroit);
		d.addTruck(detroit);
		d.addTruck(detroit);
		d.addTruck(detroit);
		d.addTruck(detroit);
		d.addTruck(detroit);
		
//		12 trucks at chicago
		d.addTruck(chicago);
		d.addTruck(chicago);
		d.addTruck(chicago);
		d.addTruck(chicago);
		d.addTruck(chicago);
		d.addTruck(chicago);
		d.addTruck(chicago);
		d.addTruck(chicago);
		d.addTruck(chicago);
		d.addTruck(chicago);
		d.addTruck(chicago);
		d.addTruck(chicago);
		
		//		10 trucks at kansas city
		d.addTruck(kansascity);	
		d.addTruck(kansascity);	
		d.addTruck(kansascity);	
		d.addTruck(kansascity);	
		d.addTruck(kansascity);	
		d.addTruck(kansascity);	
		d.addTruck(kansascity);	
		d.addTruck(kansascity);	
		d.addTruck(kansascity);	
		d.addTruck(kansascity);	
		
//		14 trucks at littlerock
		d.addTruck(littlerock);
		d.addTruck(littlerock);
		d.addTruck(littlerock);
		d.addTruck(littlerock);
		d.addTruck(littlerock);
		d.addTruck(littlerock);
		d.addTruck(littlerock);
		d.addTruck(littlerock);
		d.addTruck(littlerock);
		d.addTruck(littlerock);
		d.addTruck(littlerock);
		d.addTruck(littlerock);
		d.addTruck(littlerock);
		d.addTruck(littlerock);
		
//		7 trucks at memphis
		d.addTruck(memphis);
		d.addTruck(memphis);
		d.addTruck(memphis);
		d.addTruck(memphis);
		d.addTruck(memphis);
		d.addTruck(memphis);
		d.addTruck(memphis);
		
//		11 trucks at lowell
		d.addTruck(lowell);
		d.addTruck(lowell);
		d.addTruck(lowell);
		d.addTruck(lowell);
		d.addTruck(lowell);
		d.addTruck(lowell);
		d.addTruck(lowell);
		d.addTruck(lowell);
		d.addTruck(lowell);
		d.addTruck(lowell);
		d.addTruck(lowell);
		
		
//		10 trucks at oklacity
		d.addTruck(oklacity);	
		d.addTruck(oklacity);	
		d.addTruck(oklacity);	
		d.addTruck(oklacity);	
		d.addTruck(oklacity);	
		d.addTruck(oklacity);	
		d.addTruck(oklacity);	
		d.addTruck(oklacity);	
		d.addTruck(oklacity);	
		d.addTruck(oklacity);	
		
//		13 trucks at dallas
		d.addTruck(dallas);
		d.addTruck(dallas);
		d.addTruck(dallas);
		d.addTruck(dallas);
		d.addTruck(dallas);
		d.addTruck(dallas);
		d.addTruck(dallas);
		d.addTruck(dallas);
		d.addTruck(dallas);
		d.addTruck(dallas);
		d.addTruck(dallas);
		d.addTruck(dallas);
		d.addTruck(dallas);
		
		
//		13 trucks at houston
		d.addTruck(houston);
		d.addTruck(houston);
		d.addTruck(houston);
		d.addTruck(houston);
		d.addTruck(houston);
		d.addTruck(houston);
		d.addTruck(houston);
		d.addTruck(houston);
		d.addTruck(houston);
		d.addTruck(houston);
		d.addTruck(houston);
		d.addTruck(houston);
		d.addTruck(houston);
		
//		14 trailers at atlanta		
		d.addTrailer(atlanta);
		d.addTrailer(atlanta);
		d.addTrailer(atlanta);
		d.addTrailer(atlanta);
		d.addTrailer(atlanta);
		d.addTrailer(atlanta);
		d.addTrailer(atlanta);
		d.addTrailer(atlanta);
		d.addTrailer(atlanta);
		d.addTrailer(atlanta);
		d.addTrailer(atlanta);
		d.addTrailer(atlanta);
		d.addTrailer(atlanta);
		d.addTrailer(atlanta);
		
//		13 trailers at louisville
		d.addTrailer(louisville);
		d.addTrailer(louisville);
		d.addTrailer(louisville);
		d.addTrailer(louisville);
		d.addTrailer(louisville);
		d.addTrailer(louisville);
		d.addTrailer(louisville);
		d.addTrailer(louisville);
		d.addTrailer(louisville);
		d.addTrailer(louisville);
		d.addTrailer(louisville);
		d.addTrailer(louisville);
		d.addTrailer(louisville);
		
		
//		13 trailers at detroit
		d.addTrailer(detroit);
		d.addTrailer(detroit);
		d.addTrailer(detroit);
		d.addTrailer(detroit);
		d.addTrailer(detroit);
		d.addTrailer(detroit);
		d.addTrailer(detroit);
		d.addTrailer(detroit);
		d.addTrailer(detroit);
		d.addTrailer(detroit);
		d.addTrailer(detroit);
		d.addTrailer(detroit);
		d.addTrailer(detroit);
		
//		14 trailers at chicago
		d.addTrailer(chicago);
		d.addTrailer(chicago);
		d.addTrailer(chicago);
		d.addTrailer(chicago);
		d.addTrailer(chicago);
		d.addTrailer(chicago);
		d.addTrailer(chicago);
		d.addTrailer(chicago);
		d.addTrailer(chicago);
		d.addTrailer(chicago);
		d.addTrailer(chicago);
		d.addTrailer(chicago);
		d.addTrailer(chicago);
		d.addTrailer(chicago);
		
//		12 trailers at kansas city
		d.addTrailer(kansascity);
		d.addTrailer(kansascity);
		d.addTrailer(kansascity);
		d.addTrailer(kansascity);
		d.addTrailer(kansascity);
		d.addTrailer(kansascity);
		d.addTrailer(kansascity);
		d.addTrailer(kansascity);
		d.addTrailer(kansascity);
		d.addTrailer(kansascity);
		d.addTrailer(kansascity);
		d.addTrailer(kansascity);
		
//		16 trailers at littlerock
		d.addTrailer(littlerock);
		d.addTrailer(littlerock);
		d.addTrailer(littlerock);
		d.addTrailer(littlerock);
		d.addTrailer(littlerock);
		d.addTrailer(littlerock);
		d.addTrailer(littlerock);
		d.addTrailer(littlerock);
		d.addTrailer(littlerock);
		d.addTrailer(littlerock);
		d.addTrailer(littlerock);
		d.addTrailer(littlerock);
		d.addTrailer(littlerock);
		d.addTrailer(littlerock);
		d.addTrailer(littlerock);
		d.addTrailer(littlerock);
		
//		9 trailers at memphis
		d.addTrailer(memphis);
		d.addTrailer(memphis);
		d.addTrailer(memphis);
		d.addTrailer(memphis);
		d.addTrailer(memphis);
		d.addTrailer(memphis);
		d.addTrailer(memphis);
		d.addTrailer(memphis);
		d.addTrailer(memphis);
		
//		13 trailers at lowell
		d.addTrailer(lowell);
		d.addTrailer(lowell);
		d.addTrailer(lowell);
		d.addTrailer(lowell);
		d.addTrailer(lowell);
		d.addTrailer(lowell);
		d.addTrailer(lowell);
		d.addTrailer(lowell);
		d.addTrailer(lowell);
		d.addTrailer(lowell);
		d.addTrailer(lowell);
		d.addTrailer(lowell);
		d.addTrailer(lowell);
		
//		12 trailers at okla city
		d.addTrailer(oklacity);
		d.addTrailer(oklacity);
		d.addTrailer(oklacity);
		d.addTrailer(oklacity);
		d.addTrailer(oklacity);
		d.addTrailer(oklacity);
		d.addTrailer(oklacity);
		d.addTrailer(oklacity);
		d.addTrailer(oklacity);
		d.addTrailer(oklacity);
		d.addTrailer(oklacity);
		d.addTrailer(oklacity);
		
//		15 trailers at dallas
		d.addTrailer(dallas);
		d.addTrailer(dallas);
		d.addTrailer(dallas);
		d.addTrailer(dallas);
		d.addTrailer(dallas);
		d.addTrailer(dallas);
		d.addTrailer(dallas);
		d.addTrailer(dallas);
		d.addTrailer(dallas);
		d.addTrailer(dallas);
		d.addTrailer(dallas);
		d.addTrailer(dallas);
		d.addTrailer(dallas);
		d.addTrailer(dallas);
		d.addTrailer(dallas);
		
//		15 trailers at houston
		d.addTrailer(houston);
		d.addTrailer(houston);
		d.addTrailer(houston);
		d.addTrailer(houston);
		d.addTrailer(houston);
		d.addTrailer(houston);
		d.addTrailer(houston);
		d.addTrailer(houston);
		d.addTrailer(houston);
		d.addTrailer(houston);
		d.addTrailer(houston);
		d.addTrailer(houston);
		d.addTrailer(houston);
		d.addTrailer(houston);
		d.addTrailer(houston);
		
		//	Create the Load generator
	//	LoadGenerator lg = new LoadGenerator(m,t,tl,tl,new Constant(3000.0)," "); 
		LoadGenerator lg = new LoadGenerator(m,t,tl,tl); 
		
		System.out.println("Here is the load generator");
		
		lg.setOriginProbability(atlanta, 0.097);
		lg.setOriginProbability(louisville, 0.066);
		lg.setOriginProbability(detroit, 0.057);
		lg.setOriginProbability(chicago, 0.082);
		lg.setOriginProbability(kansascity, 0.032);
		lg.setOriginProbability(littlerock, 0.201);
		lg.setOriginProbability(memphis, 0.004);
		lg.setOriginProbability(lowell, 0.052);
		lg.setOriginProbability(oklacity, 0.019);
		lg.setOriginProbability(dallas, 0.272);
		lg.setLastOriginProbability(houston);
		
		System.out.println("origin probability set");
		
		lg.setDestinationProbability(ab,0.087);
		lg.setDestinationProbability(ae,0.072);
		lg.setDestinationProbability(af,0.373);
		lg.setDestinationProbability(ai,0.057);
		lg.setDestinationProbability(aj,0.303);
		lg.setLastDestinationProbability(ak);
			
		lg.setDestinationProbability(ba,0.194);
		lg.setDestinationProbability(bc,0.388);
		lg.setDestinationProbability(bd,0.377);
		lg.setLastDestinationProbability(bf);
		
		lg.setDestinationProbability(cb,0.458);
		lg.setLastDestinationProbability(cd);
		
		lg.setDestinationProbability(db,0.357);
		lg.setDestinationProbability(dc,0.378);
		lg.setDestinationProbability(dh,0.13);
		lg.setLastDestinationProbability(dj);
		
		lg.setDestinationProbability(ea,0.217);
		lg.setDestinationProbability(ef,0.515);
		lg.setLastDestinationProbability(eh);
		
		lg.setDestinationProbability(fa,0.071);
		lg.setDestinationProbability(fb,0.013);
		lg.setDestinationProbability(fe,0.036);
		lg.setDestinationProbability(fj,0.635);
		lg.setLastDestinationProbability(fk);
		
		lg.setLastDestinationProbability(gk);
		
		lg.setDestinationProbability(hd,0.336);
		lg.setDestinationProbability(he,0.342);
		lg.setLastDestinationProbability(hj);
		
		lg.setDestinationProbability(ia,0.374);
		lg.setDestinationProbability(ij,0.245);
		lg.setLastDestinationProbability(ik);
		
		lg.setDestinationProbability(ja,0.148);
		lg.setDestinationProbability(jd,0.032);
		lg.setDestinationProbability(jf,0.488);
		lg.setDestinationProbability(jh,0.12);
		lg.setDestinationProbability(ji,0.04);
		lg.setLastDestinationProbability(jk);
	
		lg.setDestinationProbability(ka,0.132);
		lg.setDestinationProbability(kf,0.107);
		lg.setDestinationProbability(kg,0.034);
		lg.setDestinationProbability(ki,0.023);
		lg.setLastDestinationProbability(kj);
		
		System.out.println("destination probability set");
		
		m.turnOnLogReport();
		
		// create the experiment to run the model
		Experiment e = new Experiment(m);
		
		// set the parameters of the experiment
		e.setNumberOfReplications(10);
		e.setLengthOfReplication(10000);//15000 - 10 days duration
		e.setLengthOfWarmUp(500.0);
				
		// turn on the desired reporting
		e.turnOnBatchReport(); 
		e.turnOnExperimentReport();
		e.turnOnReplicationReport();
	//	e.turnOnExperimentConsoleOutput();
		
	// tell the experiment to run
		e.runAll();
	}
public static void testCaseA(){
	
	System.out.println("Test Case For Truckload Transportation Model : JBHT: Sensitivity Test Case 1");
	
	Model m = Model.createModel();
	
	System.out.println("Model Created");
	
	DistributionIfc tl = new Exponential(1.0);
	
	SpatialModel smodel = new RectangularGridSpatialModel2D();
	
	TransportationNetwork t=new TransportationNetwork(m, smodel);
	
	System.out.println("Here is the Transportation Network");		
	
	Location atlanta = new Location(m,"Atlanta,GA",smodel, new Vector3D(0.0,0.0,0.0));
	Location louisville = new Location(m,"Louisville,KY",smodel,new Vector3D(1.0,2.0,3.0));
	Location detroit = new Location(m,"Detroit,MI",smodel, new Vector3D(5.0,4.0,0.0));
	Location chicago = new Location(m,"Chicago,IL",smodel, new Vector3D(3.0,7.0,0.0));
	Location kansascity = new Location(m,"Kansas City,MO",smodel, new Vector3D(4.0,9.0,0.0));
	Location littlerock = new Location(m,"Little Rock,AR",smodel, new Vector3D(58.0,28.0,0.0));
	Location memphis = new Location(m,"Memphis,TN",smodel, new Vector3D(3.0,5.0,0.0));
	Location lowell = new Location(m,"Lowell,AR",smodel, new Vector3D(3.0,6.0,0.0));
	Location oklacity = new Location(m,"Okla City,OK",smodel, new Vector3D(3.0,7.0,0.0));
	Location dallas = new Location(m,"Dallas,TX",smodel, new Vector3D(3.0,4.0,0.0));
	Location houston = new Location(m,"Houston,TX",smodel, new Vector3D(3.0,8.0,0.0));

	atlanta.setLoadingTimeDistribution(new Constant (1.0));
	louisville.setLoadingTimeDistribution(new Constant (1.0));
	detroit.setLoadingTimeDistribution(new Constant (1.0));
	chicago.setLoadingTimeDistribution(new Constant (1.0));
	kansascity.setLoadingTimeDistribution(new Constant (1.0));
	littlerock.setLoadingTimeDistribution(new Constant (1.0));
	memphis.setLoadingTimeDistribution(new Constant (1.0));
	lowell.setLoadingTimeDistribution(new Constant (1.0));
	oklacity.setLoadingTimeDistribution(new Constant (1.0));
	dallas.setLoadingTimeDistribution(new Constant (1.0));
	houston.setLoadingTimeDistribution(new Constant (1.0));
			
	atlanta.setUnloadingTimeDistribution(new Constant (1.0));
	louisville.setUnloadingTimeDistribution(new Constant (1.0));
	detroit.setUnloadingTimeDistribution(new Constant (1.0));
	chicago.setUnloadingTimeDistribution(new Constant (1.0));
	kansascity.setUnloadingTimeDistribution(new Constant (1.0));
	littlerock.setUnloadingTimeDistribution(new Constant (1.0));
	memphis.setUnloadingTimeDistribution(new Constant (1.0));
	lowell.setUnloadingTimeDistribution(new Constant (1.0));
	oklacity.setUnloadingTimeDistribution(new Constant (1.0));
	dallas.setUnloadingTimeDistribution(new Constant (1.0));
	houston.setUnloadingTimeDistribution(new Constant (1.0));
	
	LaneIfc ab= new Lane(t,atlanta,louisville,436);
	LaneIfc ae= new Lane(t,atlanta,kansascity,862);
	LaneIfc af = new Lane(t,atlanta,littlerock,538);
	LaneIfc ai = new Lane(t,atlanta,oklacity,869);
	LaneIfc aj = new Lane(t,atlanta,dallas,804);
	LaneIfc ak = new Lane(t,atlanta,houston,814);
	
	LaneIfc ba = new Lane(t,louisville,atlanta,436);
	LaneIfc bc = new Lane(t,louisville,detroit,355);
	LaneIfc bd = new Lane(t,louisville,chicago,324);
	LaneIfc bf = new Lane(t,louisville,littlerock,513);
	
	LaneIfc cb = new Lane(t,detroit,louisville,355);
	LaneIfc cd = new Lane(t,detroit,chicago,265);
	
	LaneIfc db= new Lane(t,chicago,louisville,324);
	LaneIfc dc= new Lane(t,chicago,detroit,265);
	LaneIfc dh= new Lane(t,chicago,lowell,610);
	LaneIfc dj= new Lane(t,chicago,dallas,899);

	LaneIfc ea = new Lane(t,kansascity,atlanta,862);
	LaneIfc ef = new Lane(t,kansascity,littlerock,470);
	LaneIfc eh = new Lane(t,kansascity,lowell,289);
	
	LaneIfc fa = new Lane(t,littlerock,atlanta,538);
	LaneIfc fb = new Lane(t,littlerock,louisville,513);
	LaneIfc fe = new Lane(t,littlerock,kansascity,470);
	LaneIfc fj = new Lane(t,littlerock,dallas,341);
	LaneIfc fk = new Lane(t,littlerock,houston,481);
	
	LaneIfc gk = new Lane(t,memphis,houston,575);
	
	LaneIfc hd = new Lane(t,lowell,chicago,610);
	LaneIfc he = new Lane(t,lowell,kansascity,289);
	LaneIfc hj = new Lane(t,lowell,dallas,328);
	
	LaneIfc ia = new Lane(t,oklacity,atlanta,869);
	LaneIfc ij = new Lane(t,oklacity,dallas,233);
	LaneIfc ik = new Lane(t,oklacity,houston,476);
	
	LaneIfc ja = new Lane(t,dallas,atlanta,804);
	LaneIfc jd = new Lane(t,dallas,chicago,899);
	LaneIfc jf = new Lane(t,dallas,littlerock,341);
	LaneIfc jh = new Lane(t,dallas,lowell,328);
	LaneIfc ji = new Lane(t,dallas,oklacity,233);
	LaneIfc jk = new Lane(t,dallas,houston,258);
	
	LaneIfc ka = new Lane(t,houston,atlanta,814);
	LaneIfc kf = new Lane(t,houston,littlerock,481);
	LaneIfc kg = new Lane(t,houston,memphis,575);
	LaneIfc ki = new Lane(t,houston,oklacity,476);
	LaneIfc kj = new Lane(t,houston,dallas,258);
	
	t.addLane(ab);
	t.addLane(ae);
	t.addLane(af);
	t.addLane(ai);
	t.addLane(aj);
	t.addLane(ak);
	
	t.addLane(ba);
	t.addLane(bc);
	t.addLane(bd);
	t.addLane(bf);
	
	t.addLane(cb);
	t.addLane(cd);
	
	t.addLane(db);
	t.addLane(dc);
	t.addLane(dh);
	t.addLane(dj);
	
	t.addLane(ea);
	t.addLane(ef);
	t.addLane(eh);
	
	t.addLane(fa);
	t.addLane(fb);
	t.addLane(fe);
	t.addLane(fj);
	t.addLane(fk);
		
	t.addLane(gk);
	t.addLane(hd);
	t.addLane(he);
	t.addLane(hj);
	
	t.addLane(ia);
	t.addLane(ij);
	t.addLane(ik);
	
	t.addLane(ja);
	t.addLane(jd);
	t.addLane(jf);
	t.addLane(jh);
	t.addLane(ji);
	t.addLane(jk);
	
	t.addLane(ka);
	t.addLane(kf);
	t.addLane(kg);
	t.addLane(ki);
	t.addLane(kj);
	
	System.out.println(t);
	
	AbstractDispatcherFTL d = new DispatcherFTL(m,t,1000.0);
	
	DistributionIfc driverSpeed = new Constant(60.0);
//	 16 drivers for atlanta
	d.addDriver(atlanta,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(atlanta,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(atlanta,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(atlanta,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(atlanta,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(atlanta,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(atlanta,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(atlanta,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(atlanta,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(atlanta,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(atlanta,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(atlanta,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(atlanta,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(atlanta,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(atlanta,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(atlanta,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	
	//14 drivers for louisville
	d.addDriver(louisville,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(louisville,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(louisville,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(louisville,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(louisville,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(louisville,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(louisville,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(louisville,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(louisville,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(louisville,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(louisville,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(louisville,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(louisville,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(louisville,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	
	//14 drivers for detroit
	d.addDriver(detroit,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(detroit,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(detroit,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(detroit,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(detroit,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(detroit,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(detroit,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(detroit,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(detroit,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(detroit,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(detroit,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(detroit,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(detroit,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(detroit,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	
	//16 drivers for chicago
	d.addDriver(chicago,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(chicago,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(chicago,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(chicago,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(chicago,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(chicago,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(chicago,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(chicago,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(chicago,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(chicago,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(chicago,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(chicago,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(chicago,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(chicago,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(chicago,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(chicago,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	
	//12 drivers for kansas city
	d.addDriver(kansascity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(kansascity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(kansascity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(kansascity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(kansascity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(kansascity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(kansascity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(kansascity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(kansascity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(kansascity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(kansascity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(kansascity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	
	//20 drivers for little rock
	d.addDriver(littlerock,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(littlerock,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(littlerock,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(littlerock,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(littlerock,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(littlerock,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(littlerock,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(littlerock,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(littlerock,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(littlerock,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(littlerock,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(littlerock,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(littlerock,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(littlerock,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(littlerock,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(littlerock,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(littlerock,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(littlerock,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(littlerock,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(littlerock,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	
	// 6 drivers for memphis
	d.addDriver(memphis,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(memphis,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(memphis,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(memphis,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(memphis,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(memphis,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	
	//14 drivers for lowell
	d.addDriver(lowell,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(lowell,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(lowell,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(lowell,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(lowell,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(lowell,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(lowell,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(lowell,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(lowell,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(lowell,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(lowell,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(lowell,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(lowell,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(lowell,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	
	// 12 drivers for okla city
	d.addDriver(oklacity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(oklacity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(oklacity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(oklacity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(oklacity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(oklacity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(oklacity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(oklacity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(oklacity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(oklacity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(oklacity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(oklacity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	
	// 18 drivers for dallas
	d.addDriver(dallas,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(dallas,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(dallas,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(dallas,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(dallas,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(dallas,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(dallas,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(dallas,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(dallas,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(dallas,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(dallas,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(dallas,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(dallas,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(dallas,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(dallas,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(dallas,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(dallas,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(dallas,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	
	// 18 drivers for houston
	d.addDriver(houston,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(houston,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(houston,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(houston,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(houston,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(houston,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(houston,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(houston,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(houston,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(houston,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(houston,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(houston,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(houston,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(houston,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(houston,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(houston,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(houston,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(houston,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	
	//24 trucks at atlanta
			
	d.addTruck(atlanta);
	d.addTruck(atlanta);
	d.addTruck(atlanta);
	d.addTruck(atlanta);
	d.addTruck(atlanta);
	d.addTruck(atlanta);
	d.addTruck(atlanta);
	d.addTruck(atlanta);
	d.addTruck(atlanta);
	d.addTruck(atlanta);
	d.addTruck(atlanta);
	d.addTruck(atlanta);
	d.addTruck(atlanta);
	d.addTruck(atlanta);
	d.addTruck(atlanta);
	d.addTruck(atlanta);
	d.addTruck(atlanta);
	d.addTruck(atlanta);
	d.addTruck(atlanta);
	d.addTruck(atlanta);
	d.addTruck(atlanta);
	d.addTruck(atlanta);
	d.addTruck(atlanta);
	d.addTruck(atlanta);
	
//	22 trucks at louisville
	d.addTruck(louisville);
	d.addTruck(louisville);
	d.addTruck(louisville);
	d.addTruck(louisville);
	d.addTruck(louisville);
	d.addTruck(louisville);
	d.addTruck(louisville);
	d.addTruck(louisville);
	d.addTruck(louisville);
	d.addTruck(louisville);
	d.addTruck(louisville);
	d.addTruck(louisville);
	d.addTruck(louisville);
	d.addTruck(louisville);
	d.addTruck(louisville);
	d.addTruck(louisville);
	d.addTruck(louisville);
	d.addTruck(louisville);
	d.addTruck(louisville);
	d.addTruck(louisville);
	d.addTruck(louisville);
	d.addTruck(louisville);
	
//	22 trucks at detroit
	d.addTruck(detroit);
	d.addTruck(detroit);
	d.addTruck(detroit);
	d.addTruck(detroit);
	d.addTruck(detroit);
	d.addTruck(detroit);
	d.addTruck(detroit);
	d.addTruck(detroit);
	d.addTruck(detroit);
	d.addTruck(detroit);
	d.addTruck(detroit);
	d.addTruck(detroit);
	d.addTruck(detroit);
	d.addTruck(detroit);
	d.addTruck(detroit);
	d.addTruck(detroit);
	d.addTruck(detroit);
	d.addTruck(detroit);
	d.addTruck(detroit);
	d.addTruck(detroit);
	d.addTruck(detroit);
	d.addTruck(detroit);
	
//	24 trucks at chicago
	d.addTruck(chicago);
	d.addTruck(chicago);
	d.addTruck(chicago);
	d.addTruck(chicago);
	d.addTruck(chicago);
	d.addTruck(chicago);
	d.addTruck(chicago);
	d.addTruck(chicago);
	d.addTruck(chicago);
	d.addTruck(chicago);
	d.addTruck(chicago);
	d.addTruck(chicago);
	d.addTruck(chicago);
	d.addTruck(chicago);
	d.addTruck(chicago);
	d.addTruck(chicago);
	d.addTruck(chicago);
	d.addTruck(chicago);
	d.addTruck(chicago);
	d.addTruck(chicago);
	d.addTruck(chicago);
	d.addTruck(chicago);
	d.addTruck(chicago);
	d.addTruck(chicago);
	
	//		20 trucks at kansas city
	d.addTruck(kansascity);	
	d.addTruck(kansascity);	
	d.addTruck(kansascity);	
	d.addTruck(kansascity);	
	d.addTruck(kansascity);	
	d.addTruck(kansascity);	
	d.addTruck(kansascity);	
	d.addTruck(kansascity);	
	d.addTruck(kansascity);	
	d.addTruck(kansascity);	
	d.addTruck(kansascity);	
	d.addTruck(kansascity);	
	d.addTruck(kansascity);	
	d.addTruck(kansascity);	
	d.addTruck(kansascity);	
	d.addTruck(kansascity);	
	d.addTruck(kansascity);	
	d.addTruck(kansascity);	
	d.addTruck(kansascity);	
	d.addTruck(kansascity);	
	
//	28 trucks at littlerock
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	
//	14 trucks at memphis
	d.addTruck(memphis);
	d.addTruck(memphis);
	d.addTruck(memphis);
	d.addTruck(memphis);
	d.addTruck(memphis);
	d.addTruck(memphis);
	d.addTruck(memphis);
	d.addTruck(memphis);
	d.addTruck(memphis);
	d.addTruck(memphis);
	d.addTruck(memphis);
	d.addTruck(memphis);
	d.addTruck(memphis);
	d.addTruck(memphis);
	
//	22 trucks at lowell
	d.addTruck(lowell);
	d.addTruck(lowell);
	d.addTruck(lowell);
	d.addTruck(lowell);
	d.addTruck(lowell);
	d.addTruck(lowell);
	d.addTruck(lowell);
	d.addTruck(lowell);
	d.addTruck(lowell);
	d.addTruck(lowell);
	d.addTruck(lowell);
	d.addTruck(lowell);
	d.addTruck(lowell);
	d.addTruck(lowell);
	d.addTruck(lowell);
	d.addTruck(lowell);
	d.addTruck(lowell);
	d.addTruck(lowell);
	d.addTruck(lowell);
	d.addTruck(lowell);
	d.addTruck(lowell);
	d.addTruck(lowell);
	
	
//	20 trucks at oklacity
	d.addTruck(oklacity);	
	d.addTruck(oklacity);	
	d.addTruck(oklacity);	
	d.addTruck(oklacity);	
	d.addTruck(oklacity);	
	d.addTruck(oklacity);	
	d.addTruck(oklacity);	
	d.addTruck(oklacity);	
	d.addTruck(oklacity);	
	d.addTruck(oklacity);
	d.addTruck(oklacity);	
	d.addTruck(oklacity);	
	d.addTruck(oklacity);	
	d.addTruck(oklacity);	
	d.addTruck(oklacity);	
	d.addTruck(oklacity);	
	d.addTruck(oklacity);	
	d.addTruck(oklacity);	
	d.addTruck(oklacity);	
	d.addTruck(oklacity);	
	
//	26 trucks at dallas
	d.addTruck(dallas);
	d.addTruck(dallas);
	d.addTruck(dallas);
	d.addTruck(dallas);
	d.addTruck(dallas);
	d.addTruck(dallas);
	d.addTruck(dallas);
	d.addTruck(dallas);
	d.addTruck(dallas);
	d.addTruck(dallas);
	d.addTruck(dallas);
	d.addTruck(dallas);
	d.addTruck(dallas);
	d.addTruck(dallas);
	d.addTruck(dallas);
	d.addTruck(dallas);
	d.addTruck(dallas);
	d.addTruck(dallas);
	d.addTruck(dallas);
	d.addTruck(dallas);
	d.addTruck(dallas);
	d.addTruck(dallas);
	d.addTruck(dallas);
	d.addTruck(dallas);
	d.addTruck(dallas);
	d.addTruck(dallas);
	
	
//	26 trucks at houston
	d.addTruck(houston);
	d.addTruck(houston);
	d.addTruck(houston);
	d.addTruck(houston);
	d.addTruck(houston);
	d.addTruck(houston);
	d.addTruck(houston);
	d.addTruck(houston);
	d.addTruck(houston);
	d.addTruck(houston);
	d.addTruck(houston);
	d.addTruck(houston);
	d.addTruck(houston);
	d.addTruck(houston);
	d.addTruck(houston);
	d.addTruck(houston);
	d.addTruck(houston);
	d.addTruck(houston);
	d.addTruck(houston);
	d.addTruck(houston);
	d.addTruck(houston);
	d.addTruck(houston);
	d.addTruck(houston);
	d.addTruck(houston);
	d.addTruck(houston);
	d.addTruck(houston);
	
//	28 trailers at atlanta		
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	
//	26 trailers at louisville
	d.addTrailer(louisville);
	d.addTrailer(louisville);
	d.addTrailer(louisville);
	d.addTrailer(louisville);
	d.addTrailer(louisville);
	d.addTrailer(louisville);
	d.addTrailer(louisville);
	d.addTrailer(louisville);
	d.addTrailer(louisville);
	d.addTrailer(louisville);
	d.addTrailer(louisville);
	d.addTrailer(louisville);
	d.addTrailer(louisville);
	d.addTrailer(louisville);
	d.addTrailer(louisville);
	d.addTrailer(louisville);
	d.addTrailer(louisville);
	d.addTrailer(louisville);
	d.addTrailer(louisville);
	d.addTrailer(louisville);
	d.addTrailer(louisville);
	d.addTrailer(louisville);
	d.addTrailer(louisville);
	d.addTrailer(louisville);
	d.addTrailer(louisville);
	d.addTrailer(louisville);
	
//	26 trailers at detroit
	d.addTrailer(detroit);
	d.addTrailer(detroit);
	d.addTrailer(detroit);
	d.addTrailer(detroit);
	d.addTrailer(detroit);
	d.addTrailer(detroit);
	d.addTrailer(detroit);
	d.addTrailer(detroit);
	d.addTrailer(detroit);
	d.addTrailer(detroit);
	d.addTrailer(detroit);
	d.addTrailer(detroit);
	d.addTrailer(detroit);
	d.addTrailer(detroit);
	d.addTrailer(detroit);
	d.addTrailer(detroit);
	d.addTrailer(detroit);
	d.addTrailer(detroit);
	d.addTrailer(detroit);
	d.addTrailer(detroit);
	d.addTrailer(detroit);
	d.addTrailer(detroit);
	d.addTrailer(detroit);
	d.addTrailer(detroit);
	d.addTrailer(detroit);
	d.addTrailer(detroit);
	
//	28 trailers at chicago
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	
//	24 trailers at kansas city
	d.addTrailer(kansascity);
	d.addTrailer(kansascity);
	d.addTrailer(kansascity);
	d.addTrailer(kansascity);
	d.addTrailer(kansascity);
	d.addTrailer(kansascity);
	d.addTrailer(kansascity);
	d.addTrailer(kansascity);
	d.addTrailer(kansascity);
	d.addTrailer(kansascity);
	d.addTrailer(kansascity);
	d.addTrailer(kansascity);
	d.addTrailer(kansascity);
	d.addTrailer(kansascity);
	d.addTrailer(kansascity);
	d.addTrailer(kansascity);
	d.addTrailer(kansascity);
	d.addTrailer(kansascity);
	d.addTrailer(kansascity);
	d.addTrailer(kansascity);
	d.addTrailer(kansascity);
	d.addTrailer(kansascity);
	d.addTrailer(kansascity);
	d.addTrailer(kansascity);
	
//	32 trailers at littlerock
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	
//	18 trailers at memphis
	d.addTrailer(memphis);
	d.addTrailer(memphis);
	d.addTrailer(memphis);
	d.addTrailer(memphis);
	d.addTrailer(memphis);
	d.addTrailer(memphis);
	d.addTrailer(memphis);
	d.addTrailer(memphis);
	d.addTrailer(memphis);
	d.addTrailer(memphis);
	d.addTrailer(memphis);
	d.addTrailer(memphis);
	d.addTrailer(memphis);
	d.addTrailer(memphis);
	d.addTrailer(memphis);
	d.addTrailer(memphis);
	d.addTrailer(memphis);
	d.addTrailer(memphis);
	
//	26 trailers at lowell
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	
//	24 trailers at okla city
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	
//	30 trailers at dallas
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	
//	30 trailers at houston
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	
	//	Create the Load generator
//	LoadGenerator lg = new LoadGenerator(m,t,tl,tl,new Constant(3000.0)," "); 
	LoadGenerator lg = new LoadGenerator(m,t,tl,tl); 
	
	System.out.println("Here is the load generator");
	
	lg.setOriginProbability(atlanta, 0.097);
	lg.setOriginProbability(louisville, 0.066);
	lg.setOriginProbability(detroit, 0.057);
	lg.setOriginProbability(chicago, 0.082);
	lg.setOriginProbability(kansascity, 0.032);
	lg.setOriginProbability(littlerock, 0.201);
	lg.setOriginProbability(memphis, 0.004);
	lg.setOriginProbability(lowell, 0.052);
	lg.setOriginProbability(oklacity, 0.019);
	lg.setOriginProbability(dallas, 0.272);
	lg.setLastOriginProbability(houston);
	
	System.out.println("origin probability set");
	
	lg.setDestinationProbability(ab,0.087);
	lg.setDestinationProbability(ae,0.072);
	lg.setDestinationProbability(af,0.373);
	lg.setDestinationProbability(ai,0.057);
	lg.setDestinationProbability(aj,0.303);
	lg.setLastDestinationProbability(ak);
		
	lg.setDestinationProbability(ba,0.194);
	lg.setDestinationProbability(bc,0.388);
	lg.setDestinationProbability(bd,0.377);
	lg.setLastDestinationProbability(bf);
	
	lg.setDestinationProbability(cb,0.458);
	lg.setLastDestinationProbability(cd);
	
	lg.setDestinationProbability(db,0.357);
	lg.setDestinationProbability(dc,0.378);
	lg.setDestinationProbability(dh,0.13);
	lg.setLastDestinationProbability(dj);
	
	lg.setDestinationProbability(ea,0.217);
	lg.setDestinationProbability(ef,0.515);
	lg.setLastDestinationProbability(eh);
	
	lg.setDestinationProbability(fa,0.071);
	lg.setDestinationProbability(fb,0.013);
	lg.setDestinationProbability(fe,0.036);
	lg.setDestinationProbability(fj,0.635);
	lg.setLastDestinationProbability(fk);
	
	lg.setLastDestinationProbability(gk);
	
	lg.setDestinationProbability(hd,0.336);
	lg.setDestinationProbability(he,0.342);
	lg.setLastDestinationProbability(hj);
	
	lg.setDestinationProbability(ia,0.374);
	lg.setDestinationProbability(ij,0.245);
	lg.setLastDestinationProbability(ik);
	
	lg.setDestinationProbability(ja,0.148);
	lg.setDestinationProbability(jd,0.032);
	lg.setDestinationProbability(jf,0.488);
	lg.setDestinationProbability(jh,0.12);
	lg.setDestinationProbability(ji,0.04);
	lg.setLastDestinationProbability(jk);

	lg.setDestinationProbability(ka,0.132);
	lg.setDestinationProbability(kf,0.107);
	lg.setDestinationProbability(kg,0.034);
	lg.setDestinationProbability(ki,0.023);
	lg.setLastDestinationProbability(kj);
	
	System.out.println("destination probability set");
	
	m.turnOnLogReport();
	
	// create the experiment to run the model
	Experiment e = new Experiment(m);
	
	// set the parameters of the experiment
	e.setNumberOfReplications(10);
	e.setLengthOfReplication(10000);//15000 - 10 days duration
	e.setLengthOfWarmUp(500.0);
	
	
	// turn on the desired reporting
	e.turnOnBatchReport(); 
	e.turnOnExperimentReport();
	e.turnOnReplicationReport();
//	e.turnOnExperimentConsoleOutput();
	
// tell the experiment to run
	e.runAll();
}
public static void testCaseB(){
	
	System.out.println("Test Case For Truckload Transportation Model : JBHT:Sensitivity Test Case 8");
	
	Model m = Model.createModel();
	
	System.out.println("Model Created");
	
	DistributionIfc tl = new Exponential(1.0);
	
	SpatialModel smodel = new RectangularGridSpatialModel2D();
	
	TransportationNetwork t=new TransportationNetwork(m, smodel);
	
	System.out.println("Here is the Transportation Network");		
	
	Location atlanta = new Location(m,"Atlanta,GA",smodel, new Vector3D(0.0,0.0,0.0));
	Location louisville = new Location(m,"Louisville,KY",smodel,new Vector3D(1.0,2.0,3.0));
	Location detroit = new Location(m,"Detroit,MI",smodel, new Vector3D(5.0,4.0,0.0));
	Location chicago = new Location(m,"Chicago,IL",smodel, new Vector3D(3.0,7.0,0.0));
	Location kansascity = new Location(m,"Kansas City,MO",smodel, new Vector3D(4.0,9.0,0.0));
	Location littlerock = new Location(m,"Little Rock,AR",smodel, new Vector3D(58.0,28.0,0.0));
	Location memphis = new Location(m,"Memphis,TN",smodel, new Vector3D(3.0,5.0,0.0));
	Location lowell = new Location(m,"Lowell,AR",smodel, new Vector3D(3.0,6.0,0.0));
	Location oklacity = new Location(m,"Okla City,OK",smodel, new Vector3D(3.0,7.0,0.0));
	Location dallas = new Location(m,"Dallas,TX",smodel, new Vector3D(3.0,4.0,0.0));
	Location houston = new Location(m,"Houston,TX",smodel, new Vector3D(3.0,8.0,0.0));

	atlanta.setLoadingTimeDistribution(new Constant (1.0));
	louisville.setLoadingTimeDistribution(new Constant (1.0));
	detroit.setLoadingTimeDistribution(new Constant (1.0));
	chicago.setLoadingTimeDistribution(new Constant (1.0));
	kansascity.setLoadingTimeDistribution(new Constant (1.0));
	littlerock.setLoadingTimeDistribution(new Constant (1.0));
	memphis.setLoadingTimeDistribution(new Constant (1.0));
	lowell.setLoadingTimeDistribution(new Constant (1.0));
	oklacity.setLoadingTimeDistribution(new Constant (1.0));
	dallas.setLoadingTimeDistribution(new Constant (1.0));
	houston.setLoadingTimeDistribution(new Constant (1.0));
			
	atlanta.setUnloadingTimeDistribution(new Constant (1.0));
	louisville.setUnloadingTimeDistribution(new Constant (1.0));
	detroit.setUnloadingTimeDistribution(new Constant (1.0));
	chicago.setUnloadingTimeDistribution(new Constant (1.0));
	kansascity.setUnloadingTimeDistribution(new Constant (1.0));
	littlerock.setUnloadingTimeDistribution(new Constant (1.0));
	memphis.setUnloadingTimeDistribution(new Constant (1.0));
	lowell.setUnloadingTimeDistribution(new Constant (1.0));
	oklacity.setUnloadingTimeDistribution(new Constant (1.0));
	dallas.setUnloadingTimeDistribution(new Constant (1.0));
	houston.setUnloadingTimeDistribution(new Constant (1.0));
	
	LaneIfc ab= new Lane(t,atlanta,louisville,436);
	LaneIfc ae= new Lane(t,atlanta,kansascity,862);
	LaneIfc af = new Lane(t,atlanta,littlerock,538);
	LaneIfc ai = new Lane(t,atlanta,oklacity,869);
	LaneIfc aj = new Lane(t,atlanta,dallas,804);
	LaneIfc ak = new Lane(t,atlanta,houston,814);
	
	LaneIfc ba = new Lane(t,louisville,atlanta,436);
	LaneIfc bc = new Lane(t,louisville,detroit,355);
	LaneIfc bd = new Lane(t,louisville,chicago,324);
	LaneIfc bf = new Lane(t,louisville,littlerock,513);
	
	LaneIfc cb = new Lane(t,detroit,louisville,355);
	LaneIfc cd = new Lane(t,detroit,chicago,265);
	
	LaneIfc db= new Lane(t,chicago,louisville,324);
	LaneIfc dc= new Lane(t,chicago,detroit,265);
	LaneIfc dh= new Lane(t,chicago,lowell,610);
	LaneIfc dj= new Lane(t,chicago,dallas,899);

	LaneIfc ea = new Lane(t,kansascity,atlanta,862);
	LaneIfc ef = new Lane(t,kansascity,littlerock,470);
	LaneIfc eh = new Lane(t,kansascity,lowell,289);
	
	LaneIfc fa = new Lane(t,littlerock,atlanta,538);
	LaneIfc fb = new Lane(t,littlerock,louisville,513);
	LaneIfc fe = new Lane(t,littlerock,kansascity,470);
	LaneIfc fj = new Lane(t,littlerock,dallas,341);
	LaneIfc fk = new Lane(t,littlerock,houston,481);
	
	LaneIfc gk = new Lane(t,memphis,houston,575);
	
	LaneIfc hd = new Lane(t,lowell,chicago,610);
	LaneIfc he = new Lane(t,lowell,kansascity,289);
	LaneIfc hj = new Lane(t,lowell,dallas,328);
	
	LaneIfc ia = new Lane(t,oklacity,atlanta,869);
	LaneIfc ij = new Lane(t,oklacity,dallas,233);
	LaneIfc ik = new Lane(t,oklacity,houston,476);
	
	LaneIfc ja = new Lane(t,dallas,atlanta,804);
	LaneIfc jd = new Lane(t,dallas,chicago,899);
	LaneIfc jf = new Lane(t,dallas,littlerock,341);
	LaneIfc jh = new Lane(t,dallas,lowell,328);
	LaneIfc ji = new Lane(t,dallas,oklacity,233);
	LaneIfc jk = new Lane(t,dallas,houston,258);
	
	LaneIfc ka = new Lane(t,houston,atlanta,814);
	LaneIfc kf = new Lane(t,houston,littlerock,481);
	LaneIfc kg = new Lane(t,houston,memphis,575);
	LaneIfc ki = new Lane(t,houston,oklacity,476);
	LaneIfc kj = new Lane(t,houston,dallas,258);
	
	t.addLane(ab);
	t.addLane(ae);
	t.addLane(af);
	t.addLane(ai);
	t.addLane(aj);
	t.addLane(ak);
	
	t.addLane(ba);
	t.addLane(bc);
	t.addLane(bd);
	t.addLane(bf);
	
	t.addLane(cb);
	t.addLane(cd);
	
	t.addLane(db);
	t.addLane(dc);
	t.addLane(dh);
	t.addLane(dj);
	
	t.addLane(ea);
	t.addLane(ef);
	t.addLane(eh);
	
	t.addLane(fa);
	t.addLane(fb);
	t.addLane(fe);
	t.addLane(fj);
	t.addLane(fk);
		
	t.addLane(gk);
	t.addLane(hd);
	t.addLane(he);
	t.addLane(hj);
	
	t.addLane(ia);
	t.addLane(ij);
	t.addLane(ik);
	
	t.addLane(ja);
	t.addLane(jd);
	t.addLane(jf);
	t.addLane(jh);
	t.addLane(ji);
	t.addLane(jk);
	
	t.addLane(ka);
	t.addLane(kf);
	t.addLane(kg);
	t.addLane(ki);
	t.addLane(kj);
	
	System.out.println(t);
	
	AbstractDispatcherFTL d = new DispatcherFTL(m,t,1000.0);
	
	DistributionIfc driverSpeed = new Constant(60.0);
//	 4 drivers for atlanta
	d.addDriver(atlanta,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(atlanta,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(atlanta,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(atlanta,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
/*	d.addDriver(atlanta,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(atlanta,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(atlanta,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(atlanta,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
*/	
	//3 drivers for louisville
	d.addDriver(louisville,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(louisville,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(louisville,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	/*d.addDriver(louisville,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(louisville,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(louisville,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(louisville,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	*/
	//4 drivers for detroit
	d.addDriver(detroit,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(detroit,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(detroit,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(detroit,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
/*	d.addDriver(detroit,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(detroit,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(detroit,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
*/	
	//4 drivers for chicago
/*	d.addDriver(chicago,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(chicago,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(chicago,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(chicago,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	*/d.addDriver(chicago,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(chicago,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(chicago,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(chicago,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	
	//3 drivers for kansas city
//	d.addDriver(kansascity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
//	d.addDriver(kansascity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
//	d.addDriver(kansascity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(kansascity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(kansascity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(kansascity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	
	//5 drivers for little rock
/*	d.addDriver(littlerock,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(littlerock,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(littlerock,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(littlerock,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(littlerock,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
*/	d.addDriver(littlerock,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(littlerock,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(littlerock,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(littlerock,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(littlerock,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	
	// 1 drivers for memphis
	//d.addDriver(memphis,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
//	d.addDriver(memphis,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(memphis,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	
	//4 drivers for lowell
//	d.addDriver(lowell,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
//	d.addDriver(lowell,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
//	d.addDriver(lowell,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(lowell,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(lowell,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(lowell,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(lowell,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	
	// 3 drivers for okla city
//	d.addDriver(oklacity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
//	d.addDriver(oklacity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
//	d.addDriver(oklacity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(oklacity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(oklacity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(oklacity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	
	// 5 drivers for dallas
//	d.addDriver(dallas,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
//	d.addDriver(dallas,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
//	d.addDriver(dallas,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
//	d.addDriver(dallas,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(dallas,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(dallas,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(dallas,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(dallas,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(dallas,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	
	// 4 drivers for houston
//	d.addDriver(houston,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
//	d.addDriver(houston,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
// d.addDriver(houston,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
//	d.addDriver(houston,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
//	d.addDriver(houston,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(houston,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(houston,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(houston,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(houston,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	
	//12 trucks at atlanta
			
/*	d.addTruck(atlanta);
	d.addTruck(atlanta);
	d.addTruck(atlanta);
	d.addTruck(atlanta);
	d.addTruck(atlanta);
	d.addTruck(atlanta);
*/	d.addTruck(atlanta);
	d.addTruck(atlanta);
	d.addTruck(atlanta);
	d.addTruck(atlanta);
	d.addTruck(atlanta);
	d.addTruck(atlanta);
	
//	5 trucks at louisville
/*	d.addTruck(louisville);
	d.addTruck(louisville);
	d.addTruck(louisville);
	d.addTruck(louisville);
	d.addTruck(louisville);
	d.addTruck(louisville);
*/	d.addTruck(louisville);
	d.addTruck(louisville);
	d.addTruck(louisville);
	d.addTruck(louisville);
	d.addTruck(louisville);
	
//	6 trucks at detroit
/*	d.addTruck(detroit);
	d.addTruck(detroit);
	d.addTruck(detroit);
	d.addTruck(detroit);
	d.addTruck(detroit);
*/	d.addTruck(detroit);
	d.addTruck(detroit);
	d.addTruck(detroit);
	d.addTruck(detroit);
	d.addTruck(detroit);
	d.addTruck(detroit);
	
//	6 trucks at chicago
/*	d.addTruck(chicago);
	d.addTruck(chicago);
	d.addTruck(chicago);
	d.addTruck(chicago);
	d.addTruck(chicago);
	d.addTruck(chicago);
*/	d.addTruck(chicago);
	d.addTruck(chicago);
	d.addTruck(chicago);
	d.addTruck(chicago);
	d.addTruck(chicago);
	d.addTruck(chicago);
	
	//		5 trucks at kansas city
/*	d.addTruck(kansascity);	
	d.addTruck(kansascity);	
	d.addTruck(kansascity);	
	d.addTruck(kansascity);	
	d.addTruck(kansascity);	
*/	d.addTruck(kansascity);	
	d.addTruck(kansascity);	
	d.addTruck(kansascity);	
	d.addTruck(kansascity);	
	d.addTruck(kansascity);	
	
//	7 trucks at littlerock
/*	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	*/d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	
//	3 trucks at memphis
	d.addTruck(memphis);
	d.addTruck(memphis);
	d.addTruck(memphis);
/*	d.addTruck(memphis);
	d.addTruck(memphis);
	d.addTruck(memphis);
	d.addTruck(memphis);
*/	
//	6 trucks at lowell
	d.addTruck(lowell);
	d.addTruck(lowell);
	d.addTruck(lowell);
	d.addTruck(lowell);
	d.addTruck(lowell);
	d.addTruck(lowell);
/*	d.addTruck(lowell);
	d.addTruck(lowell);
	d.addTruck(lowell);
	d.addTruck(lowell);
	d.addTruck(lowell);
	*/
	
//	5 trucks at oklacity
//	d.addTruck(oklacity);	
	//d.addTruck(oklacity);	
//	d.addTruck(oklacity);	
//	d.addTruck(oklacity);	
//	d.addTruck(oklacity);	
	d.addTruck(oklacity);	
	d.addTruck(oklacity);	
	d.addTruck(oklacity);	
	d.addTruck(oklacity);	
	d.addTruck(oklacity);	
	
//	6 trucks at dallas
	d.addTruck(dallas);
	d.addTruck(dallas);
	d.addTruck(dallas);
	d.addTruck(dallas);
	d.addTruck(dallas);
	d.addTruck(dallas);
/*	d.addTruck(dallas);
	d.addTruck(dallas);
	d.addTruck(dallas);
	d.addTruck(dallas);
	d.addTruck(dallas);
	d.addTruck(dallas);
	d.addTruck(dallas);
*/	
	
//	7 trucks at houston
	d.addTruck(houston);
	d.addTruck(houston);
	d.addTruck(houston);
	d.addTruck(houston);
	d.addTruck(houston);
	d.addTruck(houston);
	d.addTruck(houston);
/*	d.addTruck(houston);
	d.addTruck(houston);
	d.addTruck(houston);
	d.addTruck(houston);
	d.addTruck(houston);
	d.addTruck(houston);
*/	
//	7 trailers at atlanta		
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
/*	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
*/	
//	6 trailers at louisville
	d.addTrailer(louisville);
	d.addTrailer(louisville);
	d.addTrailer(louisville);
	d.addTrailer(louisville);
	d.addTrailer(louisville);
	d.addTrailer(louisville);
/*	d.addTrailer(louisville);
	d.addTrailer(louisville);
	d.addTrailer(louisville);
	d.addTrailer(louisville);
	d.addTrailer(louisville);
	d.addTrailer(louisville);
	d.addTrailer(louisville);
	*/
	
//	7 trailers at detroit
	d.addTrailer(detroit);
	d.addTrailer(detroit);
	d.addTrailer(detroit);
	d.addTrailer(detroit);
	d.addTrailer(detroit);
	d.addTrailer(detroit);
	d.addTrailer(detroit);
	/*d.addTrailer(detroit);
	d.addTrailer(detroit);
	d.addTrailer(detroit);
	d.addTrailer(detroit);
	d.addTrailer(detroit);
	d.addTrailer(detroit);
*/	
//	7 trailers at chicago
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
/*	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
*/	
//	6 trailers at kansas city
	d.addTrailer(kansascity);
	d.addTrailer(kansascity);
	d.addTrailer(kansascity);
	d.addTrailer(kansascity);
	d.addTrailer(kansascity);
	d.addTrailer(kansascity);
/*	d.addTrailer(kansascity);
	d.addTrailer(kansascity);
	d.addTrailer(kansascity);
	d.addTrailer(kansascity);
	d.addTrailer(kansascity);
	d.addTrailer(kansascity);
	*/
//	8 trailers at littlerock
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
/*	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
*/	
//	4 trailers at memphis
	d.addTrailer(memphis);
	d.addTrailer(memphis);
	d.addTrailer(memphis);
	d.addTrailer(memphis);
/*	d.addTrailer(memphis);
	d.addTrailer(memphis);
	d.addTrailer(memphis);
	d.addTrailer(memphis);
	d.addTrailer(memphis);
*/	
//	7 trailers at lowell
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
/*	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
*/	
//	6 trailers at okla city
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
/*	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
*/	
//	7 trailers at dallas
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
/*	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
*/	
//	8 trailers at houston
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
/*	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
*/	
	//	Create the Load generator
//	LoadGenerator lg = new LoadGenerator(m,t,tl,tl,new Constant(3000.0)," "); 
	LoadGenerator lg = new LoadGenerator(m,t,tl,tl); 
	
	System.out.println("Here is the load generator");
	
	lg.setOriginProbability(atlanta, 0.097);
	lg.setOriginProbability(louisville, 0.066);
	lg.setOriginProbability(detroit, 0.057);
	lg.setOriginProbability(chicago, 0.082);
	lg.setOriginProbability(kansascity, 0.032);
	lg.setOriginProbability(littlerock, 0.201);
	lg.setOriginProbability(memphis, 0.004);
	lg.setOriginProbability(lowell, 0.052);
	lg.setOriginProbability(oklacity, 0.019);
	lg.setOriginProbability(dallas, 0.272);
	lg.setLastOriginProbability(houston);
	
	System.out.println("origin probability set");
	
	lg.setDestinationProbability(ab,0.087);
	lg.setDestinationProbability(ae,0.072);
	lg.setDestinationProbability(af,0.373);
	lg.setDestinationProbability(ai,0.057);
	lg.setDestinationProbability(aj,0.303);
	lg.setLastDestinationProbability(ak);
		
	lg.setDestinationProbability(ba,0.194);
	lg.setDestinationProbability(bc,0.388);
	lg.setDestinationProbability(bd,0.377);
	lg.setLastDestinationProbability(bf);
	
	lg.setDestinationProbability(cb,0.458);
	lg.setLastDestinationProbability(cd);
	
	lg.setDestinationProbability(db,0.357);
	lg.setDestinationProbability(dc,0.378);
	lg.setDestinationProbability(dh,0.13);
	lg.setLastDestinationProbability(dj);
	
	lg.setDestinationProbability(ea,0.217);
	lg.setDestinationProbability(ef,0.515);
	lg.setLastDestinationProbability(eh);
	
	lg.setDestinationProbability(fa,0.071);
	lg.setDestinationProbability(fb,0.013);
	lg.setDestinationProbability(fe,0.036);
	lg.setDestinationProbability(fj,0.635);
	lg.setLastDestinationProbability(fk);
	
	lg.setLastDestinationProbability(gk);
	
	lg.setDestinationProbability(hd,0.336);
	lg.setDestinationProbability(he,0.342);
	lg.setLastDestinationProbability(hj);
	
	lg.setDestinationProbability(ia,0.374);
	lg.setDestinationProbability(ij,0.245);
	lg.setLastDestinationProbability(ik);
	
	lg.setDestinationProbability(ja,0.148);
	lg.setDestinationProbability(jd,0.032);
	lg.setDestinationProbability(jf,0.488);
	lg.setDestinationProbability(jh,0.12);
	lg.setDestinationProbability(ji,0.04);
	lg.setLastDestinationProbability(jk);

	lg.setDestinationProbability(ka,0.132);
	lg.setDestinationProbability(kf,0.107);
	lg.setDestinationProbability(kg,0.034);
	lg.setDestinationProbability(ki,0.023);
	lg.setLastDestinationProbability(kj);
	
	System.out.println("destination probability set");
	
	m.turnOnLogReport();
	
	// create the experiment to run the model
	Experiment e = new Experiment(m);
	
	// set the parameters of the experiment
	e.setNumberOfReplications(1);
	e.setLengthOfReplication(10000);//15000 - 10 days duration
	e.setLengthOfWarmUp(500.0);
	
	
	// turn on the desired reporting
	e.turnOnBatchReport(); 
	e.turnOnExperimentReport();
	e.turnOnReplicationReport();
//	e.turnOnExperimentConsoleOutput();
	
// tell the experiment to run
	e.runAll();
}

public static void testCaseC(){
	
	System.out.println("Test Case For Truckload Transportation Model : JBHT: Sensitivity Test Case 2");
	
	Model m = Model.createModel();
	
	System.out.println("Model Created");
	
	DistributionIfc tl = new Exponential(1.0);
	
	SpatialModel smodel = new RectangularGridSpatialModel2D();
	
	TransportationNetwork t=new TransportationNetwork(m, smodel);
	
	System.out.println("Here is the Transportation Network");		
	
	Location atlanta = new Location(m,"Atlanta,GA",smodel, new Vector3D(0.0,0.0,0.0));
	Location louisville = new Location(m,"Louisville,KY",smodel,new Vector3D(1.0,2.0,3.0));
	Location detroit = new Location(m,"Detroit,MI",smodel, new Vector3D(5.0,4.0,0.0));
	Location chicago = new Location(m,"Chicago,IL",smodel, new Vector3D(3.0,7.0,0.0));
	Location kansascity = new Location(m,"Kansas City,MO",smodel, new Vector3D(4.0,9.0,0.0));
	Location littlerock = new Location(m,"Little Rock,AR",smodel, new Vector3D(58.0,28.0,0.0));
	Location memphis = new Location(m,"Memphis,TN",smodel, new Vector3D(3.0,5.0,0.0));
	Location lowell = new Location(m,"Lowell,AR",smodel, new Vector3D(3.0,6.0,0.0));
	Location oklacity = new Location(m,"Okla City,OK",smodel, new Vector3D(3.0,7.0,0.0));
	Location dallas = new Location(m,"Dallas,TX",smodel, new Vector3D(3.0,4.0,0.0));
	Location houston = new Location(m,"Houston,TX",smodel, new Vector3D(3.0,8.0,0.0));

	atlanta.setLoadingTimeDistribution(new Constant (1.0));
	louisville.setLoadingTimeDistribution(new Constant (1.0));
	detroit.setLoadingTimeDistribution(new Constant (1.0));
	chicago.setLoadingTimeDistribution(new Constant (1.0));
	kansascity.setLoadingTimeDistribution(new Constant (1.0));
	littlerock.setLoadingTimeDistribution(new Constant (1.0));
	memphis.setLoadingTimeDistribution(new Constant (1.0));
	lowell.setLoadingTimeDistribution(new Constant (1.0));
	oklacity.setLoadingTimeDistribution(new Constant (1.0));
	dallas.setLoadingTimeDistribution(new Constant (1.0));
	houston.setLoadingTimeDistribution(new Constant (1.0));
			
	atlanta.setUnloadingTimeDistribution(new Constant (1.0));
	louisville.setUnloadingTimeDistribution(new Constant (1.0));
	detroit.setUnloadingTimeDistribution(new Constant (1.0));
	chicago.setUnloadingTimeDistribution(new Constant (1.0));
	kansascity.setUnloadingTimeDistribution(new Constant (1.0));
	littlerock.setUnloadingTimeDistribution(new Constant (1.0));
	memphis.setUnloadingTimeDistribution(new Constant (1.0));
	lowell.setUnloadingTimeDistribution(new Constant (1.0));
	oklacity.setUnloadingTimeDistribution(new Constant (1.0));
	dallas.setUnloadingTimeDistribution(new Constant (1.0));
	houston.setUnloadingTimeDistribution(new Constant (1.0));
	
	LaneIfc ab= new Lane(t,atlanta,louisville,436);
	LaneIfc ae= new Lane(t,atlanta,kansascity,862);
	LaneIfc af = new Lane(t,atlanta,littlerock,538);
	LaneIfc ai = new Lane(t,atlanta,oklacity,869);
	LaneIfc aj = new Lane(t,atlanta,dallas,804);
	LaneIfc ak = new Lane(t,atlanta,houston,814);
	
	LaneIfc ba = new Lane(t,louisville,atlanta,436);
	LaneIfc bc = new Lane(t,louisville,detroit,355);
	LaneIfc bd = new Lane(t,louisville,chicago,324);
	LaneIfc bf = new Lane(t,louisville,littlerock,513);
	
	LaneIfc cb = new Lane(t,detroit,louisville,355);
	LaneIfc cd = new Lane(t,detroit,chicago,265);
	
	LaneIfc db= new Lane(t,chicago,louisville,324);
	LaneIfc dc= new Lane(t,chicago,detroit,265);
	LaneIfc dh= new Lane(t,chicago,lowell,610);
	LaneIfc dj= new Lane(t,chicago,dallas,899);

	LaneIfc ea = new Lane(t,kansascity,atlanta,862);
	LaneIfc ef = new Lane(t,kansascity,littlerock,470);
	LaneIfc eh = new Lane(t,kansascity,lowell,289);
	
	LaneIfc fa = new Lane(t,littlerock,atlanta,538);
	LaneIfc fb = new Lane(t,littlerock,louisville,513);
	LaneIfc fe = new Lane(t,littlerock,kansascity,470);
	LaneIfc fj = new Lane(t,littlerock,dallas,341);
	LaneIfc fk = new Lane(t,littlerock,houston,481);
	
	LaneIfc gk = new Lane(t,memphis,houston,575);
	
	LaneIfc hd = new Lane(t,lowell,chicago,610);
	LaneIfc he = new Lane(t,lowell,kansascity,289);
	LaneIfc hj = new Lane(t,lowell,dallas,328);
	
	LaneIfc ia = new Lane(t,oklacity,atlanta,869);
	LaneIfc ij = new Lane(t,oklacity,dallas,233);
	LaneIfc ik = new Lane(t,oklacity,houston,476);
	
	LaneIfc ja = new Lane(t,dallas,atlanta,804);
	LaneIfc jd = new Lane(t,dallas,chicago,899);
	LaneIfc jf = new Lane(t,dallas,littlerock,341);
	LaneIfc jh = new Lane(t,dallas,lowell,328);
	LaneIfc ji = new Lane(t,dallas,oklacity,233);
	LaneIfc jk = new Lane(t,dallas,houston,258);
	
	LaneIfc ka = new Lane(t,houston,atlanta,814);
	LaneIfc kf = new Lane(t,houston,littlerock,481);
	LaneIfc kg = new Lane(t,houston,memphis,575);
	LaneIfc ki = new Lane(t,houston,oklacity,476);
	LaneIfc kj = new Lane(t,houston,dallas,258);
	
	t.addLane(ab);
	t.addLane(ae);
	t.addLane(af);
	t.addLane(ai);
	t.addLane(aj);
	t.addLane(ak);
	
	t.addLane(ba);
	t.addLane(bc);
	t.addLane(bd);
	t.addLane(bf);
	
	t.addLane(cb);
	t.addLane(cd);
	
	t.addLane(db);
	t.addLane(dc);
	t.addLane(dh);
	t.addLane(dj);
	
	t.addLane(ea);
	t.addLane(ef);
	t.addLane(eh);
	
	t.addLane(fa);
	t.addLane(fb);
	t.addLane(fe);
	t.addLane(fj);
	t.addLane(fk);
		
	t.addLane(gk);
	t.addLane(hd);
	t.addLane(he);
	t.addLane(hj);
	
	t.addLane(ia);
	t.addLane(ij);
	t.addLane(ik);
	
	t.addLane(ja);
	t.addLane(jd);
	t.addLane(jf);
	t.addLane(jh);
	t.addLane(ji);
	t.addLane(jk);
	
	t.addLane(ka);
	t.addLane(kf);
	t.addLane(kg);
	t.addLane(ki);
	t.addLane(kj);
	
	System.out.println(t);
	
	AbstractDispatcherFTL d = new DispatcherFTL(m,t,1000.0);
	
	DistributionIfc driverSpeed = new Constant(60.0);
	
//	 4 drivers for atlanta
	d.addDriver(atlanta,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(atlanta,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(atlanta,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(atlanta,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
/*	d.addDriver(atlanta,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(atlanta,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(atlanta,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(atlanta,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
*/	
	//3 drivers for louisville
	d.addDriver(louisville,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(louisville,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(louisville,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	/*d.addDriver(louisville,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(louisville,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(louisville,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(louisville,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	*/
	//4 drivers for detroit
	d.addDriver(detroit,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(detroit,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(detroit,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(detroit,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
/*	d.addDriver(detroit,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(detroit,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(detroit,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
*/	
	//4 drivers for chicago
/*	d.addDriver(chicago,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(chicago,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(chicago,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(chicago,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	*/d.addDriver(chicago,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(chicago,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(chicago,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(chicago,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	
	//3 drivers for kansas city
//	d.addDriver(kansascity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
//	d.addDriver(kansascity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
//	d.addDriver(kansascity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(kansascity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(kansascity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(kansascity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	
	//5 drivers for little rock
/*	d.addDriver(littlerock,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(littlerock,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(littlerock,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(littlerock,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(littlerock,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
*/	d.addDriver(littlerock,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(littlerock,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(littlerock,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(littlerock,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(littlerock,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	
	// 1 drivers for memphis
	//d.addDriver(memphis,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
//	d.addDriver(memphis,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(memphis,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	
	//4 drivers for lowell
//	d.addDriver(lowell,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
//	d.addDriver(lowell,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
//	d.addDriver(lowell,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(lowell,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(lowell,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(lowell,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(lowell,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	
	// 3 drivers for okla city
//	d.addDriver(oklacity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
//	d.addDriver(oklacity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
//	d.addDriver(oklacity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(oklacity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(oklacity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(oklacity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	
	// 5 drivers for dallas
//	d.addDriver(dallas,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
//	d.addDriver(dallas,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
//	d.addDriver(dallas,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
//	d.addDriver(dallas,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(dallas,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(dallas,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(dallas,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(dallas,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(dallas,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	
	// 4 drivers for houston
//	d.addDriver(houston,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
//	d.addDriver(houston,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
// d.addDriver(houston,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
//	d.addDriver(houston,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
//	d.addDriver(houston,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(houston,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(houston,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(houston,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(houston,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	//24 trucks at atlanta
			
	d.addTruck(atlanta);
	d.addTruck(atlanta);
	d.addTruck(atlanta);
	d.addTruck(atlanta);
	d.addTruck(atlanta);
	d.addTruck(atlanta);
	d.addTruck(atlanta);
	d.addTruck(atlanta);
	d.addTruck(atlanta);
	d.addTruck(atlanta);
	d.addTruck(atlanta);
	d.addTruck(atlanta);
	d.addTruck(atlanta);
	d.addTruck(atlanta);
	d.addTruck(atlanta);
	d.addTruck(atlanta);
	d.addTruck(atlanta);
	d.addTruck(atlanta);
	d.addTruck(atlanta);
	d.addTruck(atlanta);
	d.addTruck(atlanta);
	d.addTruck(atlanta);
	d.addTruck(atlanta);
	d.addTruck(atlanta);
	
//	22 trucks at louisville
	d.addTruck(louisville);
	d.addTruck(louisville);
	d.addTruck(louisville);
	d.addTruck(louisville);
	d.addTruck(louisville);
	d.addTruck(louisville);
	d.addTruck(louisville);
	d.addTruck(louisville);
	d.addTruck(louisville);
	d.addTruck(louisville);
	d.addTruck(louisville);
	d.addTruck(louisville);
	d.addTruck(louisville);
	d.addTruck(louisville);
	d.addTruck(louisville);
	d.addTruck(louisville);
	d.addTruck(louisville);
	d.addTruck(louisville);
	d.addTruck(louisville);
	d.addTruck(louisville);
	d.addTruck(louisville);
	d.addTruck(louisville);
	
//	22 trucks at detroit
	d.addTruck(detroit);
	d.addTruck(detroit);
	d.addTruck(detroit);
	d.addTruck(detroit);
	d.addTruck(detroit);
	d.addTruck(detroit);
	d.addTruck(detroit);
	d.addTruck(detroit);
	d.addTruck(detroit);
	d.addTruck(detroit);
	d.addTruck(detroit);
	d.addTruck(detroit);
	d.addTruck(detroit);
	d.addTruck(detroit);
	d.addTruck(detroit);
	d.addTruck(detroit);
	d.addTruck(detroit);
	d.addTruck(detroit);
	d.addTruck(detroit);
	d.addTruck(detroit);
	d.addTruck(detroit);
	d.addTruck(detroit);
	
//	24 trucks at chicago
	d.addTruck(chicago);
	d.addTruck(chicago);
	d.addTruck(chicago);
	d.addTruck(chicago);
	d.addTruck(chicago);
	d.addTruck(chicago);
	d.addTruck(chicago);
	d.addTruck(chicago);
	d.addTruck(chicago);
	d.addTruck(chicago);
	d.addTruck(chicago);
	d.addTruck(chicago);
	d.addTruck(chicago);
	d.addTruck(chicago);
	d.addTruck(chicago);
	d.addTruck(chicago);
	d.addTruck(chicago);
	d.addTruck(chicago);
	d.addTruck(chicago);
	d.addTruck(chicago);
	d.addTruck(chicago);
	d.addTruck(chicago);
	d.addTruck(chicago);
	d.addTruck(chicago);
	
	//		20 trucks at kansas city
	d.addTruck(kansascity);	
	d.addTruck(kansascity);	
	d.addTruck(kansascity);	
	d.addTruck(kansascity);	
	d.addTruck(kansascity);	
	d.addTruck(kansascity);	
	d.addTruck(kansascity);	
	d.addTruck(kansascity);	
	d.addTruck(kansascity);	
	d.addTruck(kansascity);	
	d.addTruck(kansascity);	
	d.addTruck(kansascity);	
	d.addTruck(kansascity);	
	d.addTruck(kansascity);	
	d.addTruck(kansascity);	
	d.addTruck(kansascity);	
	d.addTruck(kansascity);	
	d.addTruck(kansascity);	
	d.addTruck(kansascity);	
	d.addTruck(kansascity);	
	
//	28 trucks at littlerock
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	
//	14 trucks at memphis
	d.addTruck(memphis);
	d.addTruck(memphis);
	d.addTruck(memphis);
	d.addTruck(memphis);
	d.addTruck(memphis);
	d.addTruck(memphis);
	d.addTruck(memphis);
	d.addTruck(memphis);
	d.addTruck(memphis);
	d.addTruck(memphis);
	d.addTruck(memphis);
	d.addTruck(memphis);
	d.addTruck(memphis);
	d.addTruck(memphis);
	
//	22 trucks at lowell
	d.addTruck(lowell);
	d.addTruck(lowell);
	d.addTruck(lowell);
	d.addTruck(lowell);
	d.addTruck(lowell);
	d.addTruck(lowell);
	d.addTruck(lowell);
	d.addTruck(lowell);
	d.addTruck(lowell);
	d.addTruck(lowell);
	d.addTruck(lowell);
	d.addTruck(lowell);
	d.addTruck(lowell);
	d.addTruck(lowell);
	d.addTruck(lowell);
	d.addTruck(lowell);
	d.addTruck(lowell);
	d.addTruck(lowell);
	d.addTruck(lowell);
	d.addTruck(lowell);
	d.addTruck(lowell);
	d.addTruck(lowell);
	
	
//	20 trucks at oklacity
	d.addTruck(oklacity);	
	d.addTruck(oklacity);	
	d.addTruck(oklacity);	
	d.addTruck(oklacity);	
	d.addTruck(oklacity);	
	d.addTruck(oklacity);	
	d.addTruck(oklacity);	
	d.addTruck(oklacity);	
	d.addTruck(oklacity);	
	d.addTruck(oklacity);
	d.addTruck(oklacity);	
	d.addTruck(oklacity);	
	d.addTruck(oklacity);	
	d.addTruck(oklacity);	
	d.addTruck(oklacity);	
	d.addTruck(oklacity);	
	d.addTruck(oklacity);	
	d.addTruck(oklacity);	
	d.addTruck(oklacity);	
	d.addTruck(oklacity);	
	
//	26 trucks at dallas
	d.addTruck(dallas);
	d.addTruck(dallas);
	d.addTruck(dallas);
	d.addTruck(dallas);
	d.addTruck(dallas);
	d.addTruck(dallas);
	d.addTruck(dallas);
	d.addTruck(dallas);
	d.addTruck(dallas);
	d.addTruck(dallas);
	d.addTruck(dallas);
	d.addTruck(dallas);
	d.addTruck(dallas);
	d.addTruck(dallas);
	d.addTruck(dallas);
	d.addTruck(dallas);
	d.addTruck(dallas);
	d.addTruck(dallas);
	d.addTruck(dallas);
	d.addTruck(dallas);
	d.addTruck(dallas);
	d.addTruck(dallas);
	d.addTruck(dallas);
	d.addTruck(dallas);
	d.addTruck(dallas);
	d.addTruck(dallas);
	
	
//	26 trucks at houston
	d.addTruck(houston);
	d.addTruck(houston);
	d.addTruck(houston);
	d.addTruck(houston);
	d.addTruck(houston);
	d.addTruck(houston);
	d.addTruck(houston);
	d.addTruck(houston);
	d.addTruck(houston);
	d.addTruck(houston);
	d.addTruck(houston);
	d.addTruck(houston);
	d.addTruck(houston);
	d.addTruck(houston);
	d.addTruck(houston);
	d.addTruck(houston);
	d.addTruck(houston);
	d.addTruck(houston);
	d.addTruck(houston);
	d.addTruck(houston);
	d.addTruck(houston);
	d.addTruck(houston);
	d.addTruck(houston);
	d.addTruck(houston);
	d.addTruck(houston);
	d.addTruck(houston);
	
//	28 trailers at atlanta		
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	
//	26 trailers at louisville
	d.addTrailer(louisville);
	d.addTrailer(louisville);
	d.addTrailer(louisville);
	d.addTrailer(louisville);
	d.addTrailer(louisville);
	d.addTrailer(louisville);
	d.addTrailer(louisville);
	d.addTrailer(louisville);
	d.addTrailer(louisville);
	d.addTrailer(louisville);
	d.addTrailer(louisville);
	d.addTrailer(louisville);
	d.addTrailer(louisville);
	d.addTrailer(louisville);
	d.addTrailer(louisville);
	d.addTrailer(louisville);
	d.addTrailer(louisville);
	d.addTrailer(louisville);
	d.addTrailer(louisville);
	d.addTrailer(louisville);
	d.addTrailer(louisville);
	d.addTrailer(louisville);
	d.addTrailer(louisville);
	d.addTrailer(louisville);
	d.addTrailer(louisville);
	d.addTrailer(louisville);
	
//	26 trailers at detroit
	d.addTrailer(detroit);
	d.addTrailer(detroit);
	d.addTrailer(detroit);
	d.addTrailer(detroit);
	d.addTrailer(detroit);
	d.addTrailer(detroit);
	d.addTrailer(detroit);
	d.addTrailer(detroit);
	d.addTrailer(detroit);
	d.addTrailer(detroit);
	d.addTrailer(detroit);
	d.addTrailer(detroit);
	d.addTrailer(detroit);
	d.addTrailer(detroit);
	d.addTrailer(detroit);
	d.addTrailer(detroit);
	d.addTrailer(detroit);
	d.addTrailer(detroit);
	d.addTrailer(detroit);
	d.addTrailer(detroit);
	d.addTrailer(detroit);
	d.addTrailer(detroit);
	d.addTrailer(detroit);
	d.addTrailer(detroit);
	d.addTrailer(detroit);
	d.addTrailer(detroit);
	
//	28 trailers at chicago
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	
//	24 trailers at kansas city
	d.addTrailer(kansascity);
	d.addTrailer(kansascity);
	d.addTrailer(kansascity);
	d.addTrailer(kansascity);
	d.addTrailer(kansascity);
	d.addTrailer(kansascity);
	d.addTrailer(kansascity);
	d.addTrailer(kansascity);
	d.addTrailer(kansascity);
	d.addTrailer(kansascity);
	d.addTrailer(kansascity);
	d.addTrailer(kansascity);
	d.addTrailer(kansascity);
	d.addTrailer(kansascity);
	d.addTrailer(kansascity);
	d.addTrailer(kansascity);
	d.addTrailer(kansascity);
	d.addTrailer(kansascity);
	d.addTrailer(kansascity);
	d.addTrailer(kansascity);
	d.addTrailer(kansascity);
	d.addTrailer(kansascity);
	d.addTrailer(kansascity);
	d.addTrailer(kansascity);
	
//	32 trailers at littlerock
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	
//	18 trailers at memphis
	d.addTrailer(memphis);
	d.addTrailer(memphis);
	d.addTrailer(memphis);
	d.addTrailer(memphis);
	d.addTrailer(memphis);
	d.addTrailer(memphis);
	d.addTrailer(memphis);
	d.addTrailer(memphis);
	d.addTrailer(memphis);
	d.addTrailer(memphis);
	d.addTrailer(memphis);
	d.addTrailer(memphis);
	d.addTrailer(memphis);
	d.addTrailer(memphis);
	d.addTrailer(memphis);
	d.addTrailer(memphis);
	d.addTrailer(memphis);
	d.addTrailer(memphis);
	
//	26 trailers at lowell
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	
//	24 trailers at okla city
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	
//	30 trailers at dallas
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	
//	30 trailers at houston
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	
	//	Create the Load generator
//	LoadGenerator lg = new LoadGenerator(m,t,tl,tl,new Constant(3000.0)," "); 
	LoadGenerator lg = new LoadGenerator(m,t,tl,tl); 
	
	System.out.println("Here is the load generator");
	
	lg.setOriginProbability(atlanta, 0.097);
	lg.setOriginProbability(louisville, 0.066);
	lg.setOriginProbability(detroit, 0.057);
	lg.setOriginProbability(chicago, 0.082);
	lg.setOriginProbability(kansascity, 0.032);
	lg.setOriginProbability(littlerock, 0.201);
	lg.setOriginProbability(memphis, 0.004);
	lg.setOriginProbability(lowell, 0.052);
	lg.setOriginProbability(oklacity, 0.019);
	lg.setOriginProbability(dallas, 0.272);
	lg.setLastOriginProbability(houston);
	
	System.out.println("origin probability set");
	
	lg.setDestinationProbability(ab,0.087);
	lg.setDestinationProbability(ae,0.072);
	lg.setDestinationProbability(af,0.373);
	lg.setDestinationProbability(ai,0.057);
	lg.setDestinationProbability(aj,0.303);
	lg.setLastDestinationProbability(ak);
		
	lg.setDestinationProbability(ba,0.194);
	lg.setDestinationProbability(bc,0.388);
	lg.setDestinationProbability(bd,0.377);
	lg.setLastDestinationProbability(bf);
	
	lg.setDestinationProbability(cb,0.458);
	lg.setLastDestinationProbability(cd);
	
	lg.setDestinationProbability(db,0.357);
	lg.setDestinationProbability(dc,0.378);
	lg.setDestinationProbability(dh,0.13);
	lg.setLastDestinationProbability(dj);
	
	lg.setDestinationProbability(ea,0.217);
	lg.setDestinationProbability(ef,0.515);
	lg.setLastDestinationProbability(eh);
	
	lg.setDestinationProbability(fa,0.071);
	lg.setDestinationProbability(fb,0.013);
	lg.setDestinationProbability(fe,0.036);
	lg.setDestinationProbability(fj,0.635);
	lg.setLastDestinationProbability(fk);
	
	lg.setLastDestinationProbability(gk);
	
	lg.setDestinationProbability(hd,0.336);
	lg.setDestinationProbability(he,0.342);
	lg.setLastDestinationProbability(hj);
	
	lg.setDestinationProbability(ia,0.374);
	lg.setDestinationProbability(ij,0.245);
	lg.setLastDestinationProbability(ik);
	
	lg.setDestinationProbability(ja,0.148);
	lg.setDestinationProbability(jd,0.032);
	lg.setDestinationProbability(jf,0.488);
	lg.setDestinationProbability(jh,0.12);
	lg.setDestinationProbability(ji,0.04);
	lg.setLastDestinationProbability(jk);

	lg.setDestinationProbability(ka,0.132);
	lg.setDestinationProbability(kf,0.107);
	lg.setDestinationProbability(kg,0.034);
	lg.setDestinationProbability(ki,0.023);
	lg.setLastDestinationProbability(kj);
	
	System.out.println("destination probability set");
	
	m.turnOnLogReport();
	
	// create the experiment to run the model
	Experiment e = new Experiment(m);
	
	// set the parameters of the experiment
	e.setNumberOfReplications(1);
	e.setLengthOfReplication(10000);//15000 - 10 days duration
	e.setLengthOfWarmUp(500.0);
	
	
	// turn on the desired reporting
	e.turnOnBatchReport(); 
	e.turnOnExperimentReport();
	e.turnOnReplicationReport();
//	e.turnOnExperimentConsoleOutput();
	
// tell the experiment to run
	e.runAll();
}
public static void testCaseD(){
	
	System.out.println("Test Case For Truckload Transportation Model : JBHT: Sensitivity Test Case 3");
	
	Model m = Model.createModel();
	
	System.out.println("Model Created");
	
	DistributionIfc tl = new Exponential(1.0);
	
	SpatialModel smodel = new RectangularGridSpatialModel2D();
	
	TransportationNetwork t=new TransportationNetwork(m, smodel);
	
	System.out.println("Here is the Transportation Network");		
	
	Location atlanta = new Location(m,"Atlanta,GA",smodel, new Vector3D(0.0,0.0,0.0));
	Location louisville = new Location(m,"Louisville,KY",smodel,new Vector3D(1.0,2.0,3.0));
	Location detroit = new Location(m,"Detroit,MI",smodel, new Vector3D(5.0,4.0,0.0));
	Location chicago = new Location(m,"Chicago,IL",smodel, new Vector3D(3.0,7.0,0.0));
	Location kansascity = new Location(m,"Kansas City,MO",smodel, new Vector3D(4.0,9.0,0.0));
	Location littlerock = new Location(m,"Little Rock,AR",smodel, new Vector3D(58.0,28.0,0.0));
	Location memphis = new Location(m,"Memphis,TN",smodel, new Vector3D(3.0,5.0,0.0));
	Location lowell = new Location(m,"Lowell,AR",smodel, new Vector3D(3.0,6.0,0.0));
	Location oklacity = new Location(m,"Okla City,OK",smodel, new Vector3D(3.0,7.0,0.0));
	Location dallas = new Location(m,"Dallas,TX",smodel, new Vector3D(3.0,4.0,0.0));
	Location houston = new Location(m,"Houston,TX",smodel, new Vector3D(3.0,8.0,0.0));

	atlanta.setLoadingTimeDistribution(new Constant (1.0));
	louisville.setLoadingTimeDistribution(new Constant (1.0));
	detroit.setLoadingTimeDistribution(new Constant (1.0));
	chicago.setLoadingTimeDistribution(new Constant (1.0));
	kansascity.setLoadingTimeDistribution(new Constant (1.0));
	littlerock.setLoadingTimeDistribution(new Constant (1.0));
	memphis.setLoadingTimeDistribution(new Constant (1.0));
	lowell.setLoadingTimeDistribution(new Constant (1.0));
	oklacity.setLoadingTimeDistribution(new Constant (1.0));
	dallas.setLoadingTimeDistribution(new Constant (1.0));
	houston.setLoadingTimeDistribution(new Constant (1.0));
			
	atlanta.setUnloadingTimeDistribution(new Constant (1.0));
	louisville.setUnloadingTimeDistribution(new Constant (1.0));
	detroit.setUnloadingTimeDistribution(new Constant (1.0));
	chicago.setUnloadingTimeDistribution(new Constant (1.0));
	kansascity.setUnloadingTimeDistribution(new Constant (1.0));
	littlerock.setUnloadingTimeDistribution(new Constant (1.0));
	memphis.setUnloadingTimeDistribution(new Constant (1.0));
	lowell.setUnloadingTimeDistribution(new Constant (1.0));
	oklacity.setUnloadingTimeDistribution(new Constant (1.0));
	dallas.setUnloadingTimeDistribution(new Constant (1.0));
	houston.setUnloadingTimeDistribution(new Constant (1.0));
	
	LaneIfc ab= new Lane(t,atlanta,louisville,436);
	LaneIfc ae= new Lane(t,atlanta,kansascity,862);
	LaneIfc af = new Lane(t,atlanta,littlerock,538);
	LaneIfc ai = new Lane(t,atlanta,oklacity,869);
	LaneIfc aj = new Lane(t,atlanta,dallas,804);
	LaneIfc ak = new Lane(t,atlanta,houston,814);
	
	LaneIfc ba = new Lane(t,louisville,atlanta,436);
	LaneIfc bc = new Lane(t,louisville,detroit,355);
	LaneIfc bd = new Lane(t,louisville,chicago,324);
	LaneIfc bf = new Lane(t,louisville,littlerock,513);
	
	LaneIfc cb = new Lane(t,detroit,louisville,355);
	LaneIfc cd = new Lane(t,detroit,chicago,265);
	
	LaneIfc db= new Lane(t,chicago,louisville,324);
	LaneIfc dc= new Lane(t,chicago,detroit,265);
	LaneIfc dh= new Lane(t,chicago,lowell,610);
	LaneIfc dj= new Lane(t,chicago,dallas,899);

	LaneIfc ea = new Lane(t,kansascity,atlanta,862);
	LaneIfc ef = new Lane(t,kansascity,littlerock,470);
	LaneIfc eh = new Lane(t,kansascity,lowell,289);
	
	LaneIfc fa = new Lane(t,littlerock,atlanta,538);
	LaneIfc fb = new Lane(t,littlerock,louisville,513);
	LaneIfc fe = new Lane(t,littlerock,kansascity,470);
	LaneIfc fj = new Lane(t,littlerock,dallas,341);
	LaneIfc fk = new Lane(t,littlerock,houston,481);
	
	LaneIfc gk = new Lane(t,memphis,houston,575);
	
	LaneIfc hd = new Lane(t,lowell,chicago,610);
	LaneIfc he = new Lane(t,lowell,kansascity,289);
	LaneIfc hj = new Lane(t,lowell,dallas,328);
	
	LaneIfc ia = new Lane(t,oklacity,atlanta,869);
	LaneIfc ij = new Lane(t,oklacity,dallas,233);
	LaneIfc ik = new Lane(t,oklacity,houston,476);
	
	LaneIfc ja = new Lane(t,dallas,atlanta,804);
	LaneIfc jd = new Lane(t,dallas,chicago,899);
	LaneIfc jf = new Lane(t,dallas,littlerock,341);
	LaneIfc jh = new Lane(t,dallas,lowell,328);
	LaneIfc ji = new Lane(t,dallas,oklacity,233);
	LaneIfc jk = new Lane(t,dallas,houston,258);
	
	LaneIfc ka = new Lane(t,houston,atlanta,814);
	LaneIfc kf = new Lane(t,houston,littlerock,481);
	LaneIfc kg = new Lane(t,houston,memphis,575);
	LaneIfc ki = new Lane(t,houston,oklacity,476);
	LaneIfc kj = new Lane(t,houston,dallas,258);
	
	t.addLane(ab);
	t.addLane(ae);
	t.addLane(af);
	t.addLane(ai);
	t.addLane(aj);
	t.addLane(ak);
	
	t.addLane(ba);
	t.addLane(bc);
	t.addLane(bd);
	t.addLane(bf);
	
	t.addLane(cb);
	t.addLane(cd);
	
	t.addLane(db);
	t.addLane(dc);
	t.addLane(dh);
	t.addLane(dj);
	
	t.addLane(ea);
	t.addLane(ef);
	t.addLane(eh);
	
	t.addLane(fa);
	t.addLane(fb);
	t.addLane(fe);
	t.addLane(fj);
	t.addLane(fk);
		
	t.addLane(gk);
	t.addLane(hd);
	t.addLane(he);
	t.addLane(hj);
	
	t.addLane(ia);
	t.addLane(ij);
	t.addLane(ik);
	
	t.addLane(ja);
	t.addLane(jd);
	t.addLane(jf);
	t.addLane(jh);
	t.addLane(ji);
	t.addLane(jk);
	
	t.addLane(ka);
	t.addLane(kf);
	t.addLane(kg);
	t.addLane(ki);
	t.addLane(kj);
	
	System.out.println(t);
	
	AbstractDispatcherFTL d = new DispatcherFTL(m,t,1000.0);
	
	DistributionIfc driverSpeed = new Constant(60.0);
//	 16 drivers for atlanta
	d.addDriver(atlanta,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(atlanta,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(atlanta,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(atlanta,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(atlanta,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(atlanta,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(atlanta,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(atlanta,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(atlanta,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(atlanta,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(atlanta,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(atlanta,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(atlanta,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(atlanta,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(atlanta,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(atlanta,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	
	//14 drivers for louisville
	d.addDriver(louisville,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(louisville,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(louisville,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(louisville,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(louisville,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(louisville,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(louisville,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(louisville,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(louisville,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(louisville,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(louisville,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(louisville,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(louisville,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(louisville,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	
	//14 drivers for detroit
	d.addDriver(detroit,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(detroit,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(detroit,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(detroit,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(detroit,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(detroit,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(detroit,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(detroit,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(detroit,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(detroit,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(detroit,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(detroit,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(detroit,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(detroit,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	
	//16 drivers for chicago
	d.addDriver(chicago,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(chicago,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(chicago,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(chicago,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(chicago,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(chicago,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(chicago,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(chicago,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(chicago,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(chicago,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(chicago,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(chicago,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(chicago,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(chicago,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(chicago,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(chicago,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	
	//12 drivers for kansas city
	d.addDriver(kansascity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(kansascity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(kansascity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(kansascity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(kansascity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(kansascity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(kansascity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(kansascity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(kansascity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(kansascity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(kansascity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(kansascity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	
	//20 drivers for little rock
	d.addDriver(littlerock,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(littlerock,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(littlerock,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(littlerock,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(littlerock,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(littlerock,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(littlerock,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(littlerock,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(littlerock,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(littlerock,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(littlerock,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(littlerock,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(littlerock,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(littlerock,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(littlerock,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(littlerock,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(littlerock,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(littlerock,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(littlerock,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(littlerock,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	
	// 6 drivers for memphis
	d.addDriver(memphis,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(memphis,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(memphis,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(memphis,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(memphis,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(memphis,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	
	//14 drivers for lowell
	d.addDriver(lowell,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(lowell,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(lowell,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(lowell,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(lowell,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(lowell,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(lowell,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(lowell,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(lowell,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(lowell,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(lowell,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(lowell,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(lowell,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(lowell,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	
	// 12 drivers for okla city
	d.addDriver(oklacity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(oklacity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(oklacity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(oklacity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(oklacity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(oklacity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(oklacity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(oklacity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(oklacity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(oklacity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(oklacity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(oklacity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	
	// 18 drivers for dallas
	d.addDriver(dallas,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(dallas,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(dallas,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(dallas,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(dallas,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(dallas,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(dallas,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(dallas,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(dallas,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(dallas,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(dallas,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(dallas,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(dallas,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(dallas,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(dallas,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(dallas,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(dallas,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(dallas,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	
	// 18 drivers for houston
	d.addDriver(houston,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(houston,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(houston,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(houston,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(houston,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(houston,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(houston,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(houston,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(houston,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(houston,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(houston,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(houston,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(houston,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(houston,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(houston,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(houston,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(houston,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(houston,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	
	//12 trucks at atlanta
	
	d.addTruck(atlanta);
	d.addTruck(atlanta);
	d.addTruck(atlanta);
	d.addTruck(atlanta);
	d.addTruck(atlanta);
	d.addTruck(atlanta);
	d.addTruck(atlanta);
	d.addTruck(atlanta);
	d.addTruck(atlanta);
	d.addTruck(atlanta);
	d.addTruck(atlanta);
	d.addTruck(atlanta);
	
//	11 trucks at louisville
	d.addTruck(louisville);
	d.addTruck(louisville);
	d.addTruck(louisville);
	d.addTruck(louisville);
	d.addTruck(louisville);
	d.addTruck(louisville);
	d.addTruck(louisville);
	d.addTruck(louisville);
	d.addTruck(louisville);
	d.addTruck(louisville);
	d.addTruck(louisville);
	
//	11 trucks at detroit
	d.addTruck(detroit);
	d.addTruck(detroit);
	d.addTruck(detroit);
	d.addTruck(detroit);
	d.addTruck(detroit);
	d.addTruck(detroit);
	d.addTruck(detroit);
	d.addTruck(detroit);
	d.addTruck(detroit);
	d.addTruck(detroit);
	d.addTruck(detroit);
	
//	12 trucks at chicago
	d.addTruck(chicago);
	d.addTruck(chicago);
	d.addTruck(chicago);
	d.addTruck(chicago);
	d.addTruck(chicago);
	d.addTruck(chicago);
	d.addTruck(chicago);
	d.addTruck(chicago);
	d.addTruck(chicago);
	d.addTruck(chicago);
	d.addTruck(chicago);
	d.addTruck(chicago);
	
	//		10 trucks at kansas city
	d.addTruck(kansascity);	
	d.addTruck(kansascity);	
	d.addTruck(kansascity);	
	d.addTruck(kansascity);	
	d.addTruck(kansascity);	
	d.addTruck(kansascity);	
	d.addTruck(kansascity);	
	d.addTruck(kansascity);	
	d.addTruck(kansascity);	
	d.addTruck(kansascity);	
	
//	14 trucks at littlerock
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	
//	7 trucks at memphis
	d.addTruck(memphis);
	d.addTruck(memphis);
	d.addTruck(memphis);
	d.addTruck(memphis);
	d.addTruck(memphis);
	d.addTruck(memphis);
	d.addTruck(memphis);
	
//	11 trucks at lowell
	d.addTruck(lowell);
	d.addTruck(lowell);
	d.addTruck(lowell);
	d.addTruck(lowell);
	d.addTruck(lowell);
	d.addTruck(lowell);
	d.addTruck(lowell);
	d.addTruck(lowell);
	d.addTruck(lowell);
	d.addTruck(lowell);
	d.addTruck(lowell);
	
	
//	10 trucks at oklacity
	d.addTruck(oklacity);	
	d.addTruck(oklacity);	
	d.addTruck(oklacity);	
	d.addTruck(oklacity);	
	d.addTruck(oklacity);	
	d.addTruck(oklacity);	
	d.addTruck(oklacity);	
	d.addTruck(oklacity);	
	d.addTruck(oklacity);	
	d.addTruck(oklacity);	
	
//	13 trucks at dallas
	d.addTruck(dallas);
	d.addTruck(dallas);
	d.addTruck(dallas);
	d.addTruck(dallas);
	d.addTruck(dallas);
	d.addTruck(dallas);
	d.addTruck(dallas);
	d.addTruck(dallas);
	d.addTruck(dallas);
	d.addTruck(dallas);
	d.addTruck(dallas);
	d.addTruck(dallas);
	d.addTruck(dallas);
	
	
//	13 trucks at houston
	d.addTruck(houston);
	d.addTruck(houston);
	d.addTruck(houston);
	d.addTruck(houston);
	d.addTruck(houston);
	d.addTruck(houston);
	d.addTruck(houston);
	d.addTruck(houston);
	d.addTruck(houston);
	d.addTruck(houston);
	d.addTruck(houston);
	d.addTruck(houston);
	d.addTruck(houston);
	
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	
//	26 trailers at louisville
	d.addTrailer(louisville);
	d.addTrailer(louisville);
	d.addTrailer(louisville);
	d.addTrailer(louisville);
	d.addTrailer(louisville);
	d.addTrailer(louisville);
	d.addTrailer(louisville);
	d.addTrailer(louisville);
	d.addTrailer(louisville);
	d.addTrailer(louisville);
	d.addTrailer(louisville);
	d.addTrailer(louisville);
	d.addTrailer(louisville);
	d.addTrailer(louisville);
	d.addTrailer(louisville);
	d.addTrailer(louisville);
	d.addTrailer(louisville);
	d.addTrailer(louisville);
	d.addTrailer(louisville);
	d.addTrailer(louisville);
	d.addTrailer(louisville);
	d.addTrailer(louisville);
	d.addTrailer(louisville);
	d.addTrailer(louisville);
	d.addTrailer(louisville);
	d.addTrailer(louisville);
	
//	26 trailers at detroit
	d.addTrailer(detroit);
	d.addTrailer(detroit);
	d.addTrailer(detroit);
	d.addTrailer(detroit);
	d.addTrailer(detroit);
	d.addTrailer(detroit);
	d.addTrailer(detroit);
	d.addTrailer(detroit);
	d.addTrailer(detroit);
	d.addTrailer(detroit);
	d.addTrailer(detroit);
	d.addTrailer(detroit);
	d.addTrailer(detroit);
	d.addTrailer(detroit);
	d.addTrailer(detroit);
	d.addTrailer(detroit);
	d.addTrailer(detroit);
	d.addTrailer(detroit);
	d.addTrailer(detroit);
	d.addTrailer(detroit);
	d.addTrailer(detroit);
	d.addTrailer(detroit);
	d.addTrailer(detroit);
	d.addTrailer(detroit);
	d.addTrailer(detroit);
	d.addTrailer(detroit);
	
//	28 trailers at chicago
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	
//	24 trailers at kansas city
	d.addTrailer(kansascity);
	d.addTrailer(kansascity);
	d.addTrailer(kansascity);
	d.addTrailer(kansascity);
	d.addTrailer(kansascity);
	d.addTrailer(kansascity);
	d.addTrailer(kansascity);
	d.addTrailer(kansascity);
	d.addTrailer(kansascity);
	d.addTrailer(kansascity);
	d.addTrailer(kansascity);
	d.addTrailer(kansascity);
	d.addTrailer(kansascity);
	d.addTrailer(kansascity);
	d.addTrailer(kansascity);
	d.addTrailer(kansascity);
	d.addTrailer(kansascity);
	d.addTrailer(kansascity);
	d.addTrailer(kansascity);
	d.addTrailer(kansascity);
	d.addTrailer(kansascity);
	d.addTrailer(kansascity);
	d.addTrailer(kansascity);
	d.addTrailer(kansascity);
	
//	32 trailers at littlerock
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	
//	18 trailers at memphis
	d.addTrailer(memphis);
	d.addTrailer(memphis);
	d.addTrailer(memphis);
	d.addTrailer(memphis);
	d.addTrailer(memphis);
	d.addTrailer(memphis);
	d.addTrailer(memphis);
	d.addTrailer(memphis);
	d.addTrailer(memphis);
	d.addTrailer(memphis);
	d.addTrailer(memphis);
	d.addTrailer(memphis);
	d.addTrailer(memphis);
	d.addTrailer(memphis);
	d.addTrailer(memphis);
	d.addTrailer(memphis);
	d.addTrailer(memphis);
	d.addTrailer(memphis);
	
//	26 trailers at lowell
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	
//	24 trailers at okla city
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	
//	30 trailers at dallas
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	
//	30 trailers at houston
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	
	
	//	Create the Load generator
//	LoadGenerator lg = new LoadGenerator(m,t,tl,tl,new Constant(3000.0)," "); 
	LoadGenerator lg = new LoadGenerator(m,t,tl,tl); 
	
	System.out.println("Here is the load generator");
	
	lg.setOriginProbability(atlanta, 0.097);
	lg.setOriginProbability(louisville, 0.066);
	lg.setOriginProbability(detroit, 0.057);
	lg.setOriginProbability(chicago, 0.082);
	lg.setOriginProbability(kansascity, 0.032);
	lg.setOriginProbability(littlerock, 0.201);
	lg.setOriginProbability(memphis, 0.004);
	lg.setOriginProbability(lowell, 0.052);
	lg.setOriginProbability(oklacity, 0.019);
	lg.setOriginProbability(dallas, 0.272);
	lg.setLastOriginProbability(houston);
	
	System.out.println("origin probability set");
	
	lg.setDestinationProbability(ab,0.087);
	lg.setDestinationProbability(ae,0.072);
	lg.setDestinationProbability(af,0.373);
	lg.setDestinationProbability(ai,0.057);
	lg.setDestinationProbability(aj,0.303);
	lg.setLastDestinationProbability(ak);
		
	lg.setDestinationProbability(ba,0.194);
	lg.setDestinationProbability(bc,0.388);
	lg.setDestinationProbability(bd,0.377);
	lg.setLastDestinationProbability(bf);
	
	lg.setDestinationProbability(cb,0.458);
	lg.setLastDestinationProbability(cd);
	
	lg.setDestinationProbability(db,0.357);
	lg.setDestinationProbability(dc,0.378);
	lg.setDestinationProbability(dh,0.13);
	lg.setLastDestinationProbability(dj);
	
	lg.setDestinationProbability(ea,0.217);
	lg.setDestinationProbability(ef,0.515);
	lg.setLastDestinationProbability(eh);
	
	lg.setDestinationProbability(fa,0.071);
	lg.setDestinationProbability(fb,0.013);
	lg.setDestinationProbability(fe,0.036);
	lg.setDestinationProbability(fj,0.635);
	lg.setLastDestinationProbability(fk);
	
	lg.setLastDestinationProbability(gk);
	
	lg.setDestinationProbability(hd,0.336);
	lg.setDestinationProbability(he,0.342);
	lg.setLastDestinationProbability(hj);
	
	lg.setDestinationProbability(ia,0.374);
	lg.setDestinationProbability(ij,0.245);
	lg.setLastDestinationProbability(ik);
	
	lg.setDestinationProbability(ja,0.148);
	lg.setDestinationProbability(jd,0.032);
	lg.setDestinationProbability(jf,0.488);
	lg.setDestinationProbability(jh,0.12);
	lg.setDestinationProbability(ji,0.04);
	lg.setLastDestinationProbability(jk);

	lg.setDestinationProbability(ka,0.132);
	lg.setDestinationProbability(kf,0.107);
	lg.setDestinationProbability(kg,0.034);
	lg.setDestinationProbability(ki,0.023);
	lg.setLastDestinationProbability(kj);
	
	System.out.println("destination probability set");
	
	m.turnOnLogReport();
	
	// create the experiment to run the model
	Experiment e = new Experiment(m);
	
	// set the parameters of the experiment
	e.setNumberOfReplications(10);
	e.setLengthOfReplication(10000);//15000 - 10 days duration
	e.setLengthOfWarmUp(500.0);
	
	
	// turn on the desired reporting
	e.turnOnBatchReport(); 
	e.turnOnExperimentReport();
	e.turnOnReplicationReport();
//	e.turnOnExperimentConsoleOutput();
	
// tell the experiment to run
	e.runAll();
}
public static void testCaseE(){
	
	System.out.println("Test Case For Truckload Transportation Model : JBHT: Sensitivity Test Case 4");
	
	Model m = Model.createModel();
	
	System.out.println("Model Created");
	
	DistributionIfc tl = new Exponential(1.0);
	
	SpatialModel smodel = new RectangularGridSpatialModel2D();
	
	TransportationNetwork t=new TransportationNetwork(m, smodel);
	
	System.out.println("Here is the Transportation Network");		
	
	Location atlanta = new Location(m,"Atlanta,GA",smodel, new Vector3D(0.0,0.0,0.0));
	Location louisville = new Location(m,"Louisville,KY",smodel,new Vector3D(1.0,2.0,3.0));
	Location detroit = new Location(m,"Detroit,MI",smodel, new Vector3D(5.0,4.0,0.0));
	Location chicago = new Location(m,"Chicago,IL",smodel, new Vector3D(3.0,7.0,0.0));
	Location kansascity = new Location(m,"Kansas City,MO",smodel, new Vector3D(4.0,9.0,0.0));
	Location littlerock = new Location(m,"Little Rock,AR",smodel, new Vector3D(58.0,28.0,0.0));
	Location memphis = new Location(m,"Memphis,TN",smodel, new Vector3D(3.0,5.0,0.0));
	Location lowell = new Location(m,"Lowell,AR",smodel, new Vector3D(3.0,6.0,0.0));
	Location oklacity = new Location(m,"Okla City,OK",smodel, new Vector3D(3.0,7.0,0.0));
	Location dallas = new Location(m,"Dallas,TX",smodel, new Vector3D(3.0,4.0,0.0));
	Location houston = new Location(m,"Houston,TX",smodel, new Vector3D(3.0,8.0,0.0));

	atlanta.setLoadingTimeDistribution(new Constant (1.0));
	louisville.setLoadingTimeDistribution(new Constant (1.0));
	detroit.setLoadingTimeDistribution(new Constant (1.0));
	chicago.setLoadingTimeDistribution(new Constant (1.0));
	kansascity.setLoadingTimeDistribution(new Constant (1.0));
	littlerock.setLoadingTimeDistribution(new Constant (1.0));
	memphis.setLoadingTimeDistribution(new Constant (1.0));
	lowell.setLoadingTimeDistribution(new Constant (1.0));
	oklacity.setLoadingTimeDistribution(new Constant (1.0));
	dallas.setLoadingTimeDistribution(new Constant (1.0));
	houston.setLoadingTimeDistribution(new Constant (1.0));
			
	atlanta.setUnloadingTimeDistribution(new Constant (1.0));
	louisville.setUnloadingTimeDistribution(new Constant (1.0));
	detroit.setUnloadingTimeDistribution(new Constant (1.0));
	chicago.setUnloadingTimeDistribution(new Constant (1.0));
	kansascity.setUnloadingTimeDistribution(new Constant (1.0));
	littlerock.setUnloadingTimeDistribution(new Constant (1.0));
	memphis.setUnloadingTimeDistribution(new Constant (1.0));
	lowell.setUnloadingTimeDistribution(new Constant (1.0));
	oklacity.setUnloadingTimeDistribution(new Constant (1.0));
	dallas.setUnloadingTimeDistribution(new Constant (1.0));
	houston.setUnloadingTimeDistribution(new Constant (1.0));
	
	LaneIfc ab= new Lane(t,atlanta,louisville,436);
	LaneIfc ae= new Lane(t,atlanta,kansascity,862);
	LaneIfc af = new Lane(t,atlanta,littlerock,538);
	LaneIfc ai = new Lane(t,atlanta,oklacity,869);
	LaneIfc aj = new Lane(t,atlanta,dallas,804);
	LaneIfc ak = new Lane(t,atlanta,houston,814);
	
	LaneIfc ba = new Lane(t,louisville,atlanta,436);
	LaneIfc bc = new Lane(t,louisville,detroit,355);
	LaneIfc bd = new Lane(t,louisville,chicago,324);
	LaneIfc bf = new Lane(t,louisville,littlerock,513);
	
	LaneIfc cb = new Lane(t,detroit,louisville,355);
	LaneIfc cd = new Lane(t,detroit,chicago,265);
	
	LaneIfc db= new Lane(t,chicago,louisville,324);
	LaneIfc dc= new Lane(t,chicago,detroit,265);
	LaneIfc dh= new Lane(t,chicago,lowell,610);
	LaneIfc dj= new Lane(t,chicago,dallas,899);

	LaneIfc ea = new Lane(t,kansascity,atlanta,862);
	LaneIfc ef = new Lane(t,kansascity,littlerock,470);
	LaneIfc eh = new Lane(t,kansascity,lowell,289);
	
	LaneIfc fa = new Lane(t,littlerock,atlanta,538);
	LaneIfc fb = new Lane(t,littlerock,louisville,513);
	LaneIfc fe = new Lane(t,littlerock,kansascity,470);
	LaneIfc fj = new Lane(t,littlerock,dallas,341);
	LaneIfc fk = new Lane(t,littlerock,houston,481);
	
	LaneIfc gk = new Lane(t,memphis,houston,575);
	
	LaneIfc hd = new Lane(t,lowell,chicago,610);
	LaneIfc he = new Lane(t,lowell,kansascity,289);
	LaneIfc hj = new Lane(t,lowell,dallas,328);
	
	LaneIfc ia = new Lane(t,oklacity,atlanta,869);
	LaneIfc ij = new Lane(t,oklacity,dallas,233);
	LaneIfc ik = new Lane(t,oklacity,houston,476);
	
	LaneIfc ja = new Lane(t,dallas,atlanta,804);
	LaneIfc jd = new Lane(t,dallas,chicago,899);
	LaneIfc jf = new Lane(t,dallas,littlerock,341);
	LaneIfc jh = new Lane(t,dallas,lowell,328);
	LaneIfc ji = new Lane(t,dallas,oklacity,233);
	LaneIfc jk = new Lane(t,dallas,houston,258);
	
	LaneIfc ka = new Lane(t,houston,atlanta,814);
	LaneIfc kf = new Lane(t,houston,littlerock,481);
	LaneIfc kg = new Lane(t,houston,memphis,575);
	LaneIfc ki = new Lane(t,houston,oklacity,476);
	LaneIfc kj = new Lane(t,houston,dallas,258);
	
	t.addLane(ab);
	t.addLane(ae);
	t.addLane(af);
	t.addLane(ai);
	t.addLane(aj);
	t.addLane(ak);
	
	t.addLane(ba);
	t.addLane(bc);
	t.addLane(bd);
	t.addLane(bf);
	
	t.addLane(cb);
	t.addLane(cd);
	
	t.addLane(db);
	t.addLane(dc);
	t.addLane(dh);
	t.addLane(dj);
	
	t.addLane(ea);
	t.addLane(ef);
	t.addLane(eh);
	
	t.addLane(fa);
	t.addLane(fb);
	t.addLane(fe);
	t.addLane(fj);
	t.addLane(fk);
		
	t.addLane(gk);
	t.addLane(hd);
	t.addLane(he);
	t.addLane(hj);
	
	t.addLane(ia);
	t.addLane(ij);
	t.addLane(ik);
	
	t.addLane(ja);
	t.addLane(jd);
	t.addLane(jf);
	t.addLane(jh);
	t.addLane(ji);
	t.addLane(jk);
	
	t.addLane(ka);
	t.addLane(kf);
	t.addLane(kg);
	t.addLane(ki);
	t.addLane(kj);
	
	System.out.println(t);
	
	AbstractDispatcherFTL d = new DispatcherFTL(m,t,1000.0);
	
	DistributionIfc driverSpeed = new Constant(60.0);
//	 16 drivers for atlanta
	d.addDriver(atlanta,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(atlanta,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(atlanta,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(atlanta,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(atlanta,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(atlanta,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(atlanta,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(atlanta,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(atlanta,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(atlanta,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(atlanta,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(atlanta,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(atlanta,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(atlanta,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(atlanta,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(atlanta,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	
	//14 drivers for louisville
	d.addDriver(louisville,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(louisville,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(louisville,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(louisville,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(louisville,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(louisville,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(louisville,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(louisville,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(louisville,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(louisville,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(louisville,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(louisville,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(louisville,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(louisville,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	
	//14 drivers for detroit
	d.addDriver(detroit,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(detroit,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(detroit,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(detroit,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(detroit,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(detroit,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(detroit,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(detroit,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(detroit,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(detroit,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(detroit,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(detroit,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(detroit,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(detroit,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	
	//16 drivers for chicago
	d.addDriver(chicago,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(chicago,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(chicago,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(chicago,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(chicago,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(chicago,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(chicago,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(chicago,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(chicago,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(chicago,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(chicago,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(chicago,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(chicago,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(chicago,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(chicago,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(chicago,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	
	//12 drivers for kansas city
	d.addDriver(kansascity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(kansascity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(kansascity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(kansascity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(kansascity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(kansascity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(kansascity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(kansascity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(kansascity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(kansascity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(kansascity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(kansascity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	
	//20 drivers for little rock
	d.addDriver(littlerock,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(littlerock,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(littlerock,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(littlerock,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(littlerock,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(littlerock,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(littlerock,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(littlerock,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(littlerock,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(littlerock,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(littlerock,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(littlerock,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(littlerock,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(littlerock,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(littlerock,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(littlerock,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(littlerock,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(littlerock,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(littlerock,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(littlerock,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	
	// 6 drivers for memphis
	d.addDriver(memphis,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(memphis,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(memphis,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(memphis,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(memphis,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(memphis,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	
	//14 drivers for lowell
	d.addDriver(lowell,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(lowell,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(lowell,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(lowell,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(lowell,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(lowell,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(lowell,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(lowell,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(lowell,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(lowell,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(lowell,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(lowell,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(lowell,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(lowell,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	
	// 12 drivers for okla city
	d.addDriver(oklacity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(oklacity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(oklacity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(oklacity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(oklacity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(oklacity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(oklacity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(oklacity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(oklacity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(oklacity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(oklacity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(oklacity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	
	// 18 drivers for dallas
	d.addDriver(dallas,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(dallas,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(dallas,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(dallas,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(dallas,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(dallas,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(dallas,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(dallas,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(dallas,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(dallas,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(dallas,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(dallas,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(dallas,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(dallas,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(dallas,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(dallas,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(dallas,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(dallas,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	
	// 18 drivers for houston
	d.addDriver(houston,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(houston,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(houston,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(houston,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(houston,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(houston,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(houston,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(houston,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(houston,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(houston,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(houston,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(houston,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(houston,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(houston,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(houston,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(houston,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(houston,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(houston,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	
//	24 trucks at atlanta
	
	d.addTruck(atlanta);
	d.addTruck(atlanta);
	d.addTruck(atlanta);
	d.addTruck(atlanta);
	d.addTruck(atlanta);
	d.addTruck(atlanta);
	d.addTruck(atlanta);
	d.addTruck(atlanta);
	d.addTruck(atlanta);
	d.addTruck(atlanta);
	d.addTruck(atlanta);
	d.addTruck(atlanta);
	d.addTruck(atlanta);
	d.addTruck(atlanta);
	d.addTruck(atlanta);
	d.addTruck(atlanta);
	d.addTruck(atlanta);
	d.addTruck(atlanta);
	d.addTruck(atlanta);
	d.addTruck(atlanta);
	d.addTruck(atlanta);
	d.addTruck(atlanta);
	d.addTruck(atlanta);
	d.addTruck(atlanta);
	
//	22 trucks at louisville
	d.addTruck(louisville);
	d.addTruck(louisville);
	d.addTruck(louisville);
	d.addTruck(louisville);
	d.addTruck(louisville);
	d.addTruck(louisville);
	d.addTruck(louisville);
	d.addTruck(louisville);
	d.addTruck(louisville);
	d.addTruck(louisville);
	d.addTruck(louisville);
	d.addTruck(louisville);
	d.addTruck(louisville);
	d.addTruck(louisville);
	d.addTruck(louisville);
	d.addTruck(louisville);
	d.addTruck(louisville);
	d.addTruck(louisville);
	d.addTruck(louisville);
	d.addTruck(louisville);
	d.addTruck(louisville);
	d.addTruck(louisville);
	
//	22 trucks at detroit
	d.addTruck(detroit);
	d.addTruck(detroit);
	d.addTruck(detroit);
	d.addTruck(detroit);
	d.addTruck(detroit);
	d.addTruck(detroit);
	d.addTruck(detroit);
	d.addTruck(detroit);
	d.addTruck(detroit);
	d.addTruck(detroit);
	d.addTruck(detroit);
	d.addTruck(detroit);
	d.addTruck(detroit);
	d.addTruck(detroit);
	d.addTruck(detroit);
	d.addTruck(detroit);
	d.addTruck(detroit);
	d.addTruck(detroit);
	d.addTruck(detroit);
	d.addTruck(detroit);
	d.addTruck(detroit);
	d.addTruck(detroit);
	
//	24 trucks at chicago
	d.addTruck(chicago);
	d.addTruck(chicago);
	d.addTruck(chicago);
	d.addTruck(chicago);
	d.addTruck(chicago);
	d.addTruck(chicago);
	d.addTruck(chicago);
	d.addTruck(chicago);
	d.addTruck(chicago);
	d.addTruck(chicago);
	d.addTruck(chicago);
	d.addTruck(chicago);
	d.addTruck(chicago);
	d.addTruck(chicago);
	d.addTruck(chicago);
	d.addTruck(chicago);
	d.addTruck(chicago);
	d.addTruck(chicago);
	d.addTruck(chicago);
	d.addTruck(chicago);
	d.addTruck(chicago);
	d.addTruck(chicago);
	d.addTruck(chicago);
	d.addTruck(chicago);
	
	//		20 trucks at kansas city
	d.addTruck(kansascity);	
	d.addTruck(kansascity);	
	d.addTruck(kansascity);	
	d.addTruck(kansascity);	
	d.addTruck(kansascity);	
	d.addTruck(kansascity);	
	d.addTruck(kansascity);	
	d.addTruck(kansascity);	
	d.addTruck(kansascity);	
	d.addTruck(kansascity);	
	d.addTruck(kansascity);	
	d.addTruck(kansascity);	
	d.addTruck(kansascity);	
	d.addTruck(kansascity);	
	d.addTruck(kansascity);	
	d.addTruck(kansascity);	
	d.addTruck(kansascity);	
	d.addTruck(kansascity);	
	d.addTruck(kansascity);	
	d.addTruck(kansascity);	
	
//	28 trucks at littlerock
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	
//	14 trucks at memphis
	d.addTruck(memphis);
	d.addTruck(memphis);
	d.addTruck(memphis);
	d.addTruck(memphis);
	d.addTruck(memphis);
	d.addTruck(memphis);
	d.addTruck(memphis);
	d.addTruck(memphis);
	d.addTruck(memphis);
	d.addTruck(memphis);
	d.addTruck(memphis);
	d.addTruck(memphis);
	d.addTruck(memphis);
	d.addTruck(memphis);
	
//	22 trucks at lowell
	d.addTruck(lowell);
	d.addTruck(lowell);
	d.addTruck(lowell);
	d.addTruck(lowell);
	d.addTruck(lowell);
	d.addTruck(lowell);
	d.addTruck(lowell);
	d.addTruck(lowell);
	d.addTruck(lowell);
	d.addTruck(lowell);
	d.addTruck(lowell);
	d.addTruck(lowell);
	d.addTruck(lowell);
	d.addTruck(lowell);
	d.addTruck(lowell);
	d.addTruck(lowell);
	d.addTruck(lowell);
	d.addTruck(lowell);
	d.addTruck(lowell);
	d.addTruck(lowell);
	d.addTruck(lowell);
	d.addTruck(lowell);
	
	
//	20 trucks at oklacity
	d.addTruck(oklacity);	
	d.addTruck(oklacity);	
	d.addTruck(oklacity);	
	d.addTruck(oklacity);	
	d.addTruck(oklacity);	
	d.addTruck(oklacity);	
	d.addTruck(oklacity);	
	d.addTruck(oklacity);	
	d.addTruck(oklacity);	
	d.addTruck(oklacity);
	d.addTruck(oklacity);	
	d.addTruck(oklacity);	
	d.addTruck(oklacity);	
	d.addTruck(oklacity);	
	d.addTruck(oklacity);	
	d.addTruck(oklacity);	
	d.addTruck(oklacity);	
	d.addTruck(oklacity);	
	d.addTruck(oklacity);	
	d.addTruck(oklacity);	
	
//	26 trucks at dallas
	d.addTruck(dallas);
	d.addTruck(dallas);
	d.addTruck(dallas);
	d.addTruck(dallas);
	d.addTruck(dallas);
	d.addTruck(dallas);
	d.addTruck(dallas);
	d.addTruck(dallas);
	d.addTruck(dallas);
	d.addTruck(dallas);
	d.addTruck(dallas);
	d.addTruck(dallas);
	d.addTruck(dallas);
	d.addTruck(dallas);
	d.addTruck(dallas);
	d.addTruck(dallas);
	d.addTruck(dallas);
	d.addTruck(dallas);
	d.addTruck(dallas);
	d.addTruck(dallas);
	d.addTruck(dallas);
	d.addTruck(dallas);
	d.addTruck(dallas);
	d.addTruck(dallas);
	d.addTruck(dallas);
	d.addTruck(dallas);
	
	
//	26 trucks at houston
	d.addTruck(houston);
	d.addTruck(houston);
	d.addTruck(houston);
	d.addTruck(houston);
	d.addTruck(houston);
	d.addTruck(houston);
	d.addTruck(houston);
	d.addTruck(houston);
	d.addTruck(houston);
	d.addTruck(houston);
	d.addTruck(houston);
	d.addTruck(houston);
	d.addTruck(houston);
	d.addTruck(houston);
	d.addTruck(houston);
	d.addTruck(houston);
	d.addTruck(houston);
	d.addTruck(houston);
	d.addTruck(houston);
	d.addTruck(houston);
	d.addTruck(houston);
	d.addTruck(houston);
	d.addTruck(houston);
	d.addTruck(houston);
	d.addTruck(houston);
	d.addTruck(houston);
	
//	7 trailers at atlanta		
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
/*	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
*/	
//	6 trailers at louisville
	d.addTrailer(louisville);
	d.addTrailer(louisville);
	d.addTrailer(louisville);
	d.addTrailer(louisville);
	d.addTrailer(louisville);
	d.addTrailer(louisville);
/*	d.addTrailer(louisville);
	d.addTrailer(louisville);
	d.addTrailer(louisville);
	d.addTrailer(louisville);
	d.addTrailer(louisville);
	d.addTrailer(louisville);
	d.addTrailer(louisville);
	*/
	
//	7 trailers at detroit
	d.addTrailer(detroit);
	d.addTrailer(detroit);
	d.addTrailer(detroit);
	d.addTrailer(detroit);
	d.addTrailer(detroit);
	d.addTrailer(detroit);
	d.addTrailer(detroit);
	/*d.addTrailer(detroit);
	d.addTrailer(detroit);
	d.addTrailer(detroit);
	d.addTrailer(detroit);
	d.addTrailer(detroit);
	d.addTrailer(detroit);
*/	
//	7 trailers at chicago
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
/*	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
*/	
//	6 trailers at kansas city
	d.addTrailer(kansascity);
	d.addTrailer(kansascity);
	d.addTrailer(kansascity);
	d.addTrailer(kansascity);
	d.addTrailer(kansascity);
	d.addTrailer(kansascity);
/*	d.addTrailer(kansascity);
	d.addTrailer(kansascity);
	d.addTrailer(kansascity);
	d.addTrailer(kansascity);
	d.addTrailer(kansascity);
	d.addTrailer(kansascity);
	*/
//	8 trailers at littlerock
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
/*	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
*/	
//	4 trailers at memphis
	d.addTrailer(memphis);
	d.addTrailer(memphis);
	d.addTrailer(memphis);
	d.addTrailer(memphis);
/*	d.addTrailer(memphis);
	d.addTrailer(memphis);
	d.addTrailer(memphis);
	d.addTrailer(memphis);
	d.addTrailer(memphis);
*/	
//	7 trailers at lowell
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
/*	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
*/	
//	6 trailers at okla city
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
/*	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
*/	
//	7 trailers at dallas
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
/*	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
*/	
//	8 trailers at houston
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
/*	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
*/	
	
	//	Create the Load generator
	LoadGenerator lg = new LoadGenerator(m,t,tl,tl); 
	
	System.out.println("Here is the load generator");
	
	lg.setOriginProbability(atlanta, 0.097);
	lg.setOriginProbability(louisville, 0.066);
	lg.setOriginProbability(detroit, 0.057);
	lg.setOriginProbability(chicago, 0.082);
	lg.setOriginProbability(kansascity, 0.032);
	lg.setOriginProbability(littlerock, 0.201);
	lg.setOriginProbability(memphis, 0.004);
	lg.setOriginProbability(lowell, 0.052);
	lg.setOriginProbability(oklacity, 0.019);
	lg.setOriginProbability(dallas, 0.272);
	lg.setLastOriginProbability(houston);
	
	System.out.println("origin probability set");
	
	lg.setDestinationProbability(ab,0.087);
	lg.setDestinationProbability(ae,0.072);
	lg.setDestinationProbability(af,0.373);
	lg.setDestinationProbability(ai,0.057);
	lg.setDestinationProbability(aj,0.303);
	lg.setLastDestinationProbability(ak);
		
	lg.setDestinationProbability(ba,0.194);
	lg.setDestinationProbability(bc,0.388);
	lg.setDestinationProbability(bd,0.377);
	lg.setLastDestinationProbability(bf);
	
	lg.setDestinationProbability(cb,0.458);
	lg.setLastDestinationProbability(cd);
	
	lg.setDestinationProbability(db,0.357);
	lg.setDestinationProbability(dc,0.378);
	lg.setDestinationProbability(dh,0.13);
	lg.setLastDestinationProbability(dj);
	
	lg.setDestinationProbability(ea,0.217);
	lg.setDestinationProbability(ef,0.515);
	lg.setLastDestinationProbability(eh);
	
	lg.setDestinationProbability(fa,0.071);
	lg.setDestinationProbability(fb,0.013);
	lg.setDestinationProbability(fe,0.036);
	lg.setDestinationProbability(fj,0.635);
	lg.setLastDestinationProbability(fk);
	
	lg.setLastDestinationProbability(gk);
	
	lg.setDestinationProbability(hd,0.336);
	lg.setDestinationProbability(he,0.342);
	lg.setLastDestinationProbability(hj);
	
	lg.setDestinationProbability(ia,0.374);
	lg.setDestinationProbability(ij,0.245);
	lg.setLastDestinationProbability(ik);
	
	lg.setDestinationProbability(ja,0.148);
	lg.setDestinationProbability(jd,0.032);
	lg.setDestinationProbability(jf,0.488);
	lg.setDestinationProbability(jh,0.12);
	lg.setDestinationProbability(ji,0.04);
	lg.setLastDestinationProbability(jk);

	lg.setDestinationProbability(ka,0.132);
	lg.setDestinationProbability(kf,0.107);
	lg.setDestinationProbability(kg,0.034);
	lg.setDestinationProbability(ki,0.023);
	lg.setLastDestinationProbability(kj);
	
	System.out.println("destination probability set");
	
	m.turnOnLogReport();
	
	// create the experiment to run the model
	Experiment e = new Experiment(m);
	
	// set the parameters of the experiment
	e.setNumberOfReplications(10);
	e.setLengthOfReplication(10000);//15000 - 10 days duration
	e.setLengthOfWarmUp(500.0);
	
	
	// turn on the desired reporting
	e.turnOnBatchReport(); 
	e.turnOnExperimentReport();
	e.turnOnReplicationReport();
//	e.turnOnExperimentConsoleOutput();
	
// tell the experiment to run
	e.runAll();
}
public static void testCaseF(){
	
	System.out.println("Test Case For Truckload Transportation Model : JBHT:Sensitivity Test Case 5");
	
	Model m = Model.createModel();
	
	System.out.println("Model Created");
	
	DistributionIfc tl = new Exponential(1.0);
	
	SpatialModel smodel = new RectangularGridSpatialModel2D();
	
	TransportationNetwork t=new TransportationNetwork(m, smodel);
	
	System.out.println("Here is the Transportation Network");		
	
	Location atlanta = new Location(m,"Atlanta,GA",smodel, new Vector3D(0.0,0.0,0.0));
	Location louisville = new Location(m,"Louisville,KY",smodel,new Vector3D(1.0,2.0,3.0));
	Location detroit = new Location(m,"Detroit,MI",smodel, new Vector3D(5.0,4.0,0.0));
	Location chicago = new Location(m,"Chicago,IL",smodel, new Vector3D(3.0,7.0,0.0));
	Location kansascity = new Location(m,"Kansas City,MO",smodel, new Vector3D(4.0,9.0,0.0));
	Location littlerock = new Location(m,"Little Rock,AR",smodel, new Vector3D(58.0,28.0,0.0));
	Location memphis = new Location(m,"Memphis,TN",smodel, new Vector3D(3.0,5.0,0.0));
	Location lowell = new Location(m,"Lowell,AR",smodel, new Vector3D(3.0,6.0,0.0));
	Location oklacity = new Location(m,"Okla City,OK",smodel, new Vector3D(3.0,7.0,0.0));
	Location dallas = new Location(m,"Dallas,TX",smodel, new Vector3D(3.0,4.0,0.0));
	Location houston = new Location(m,"Houston,TX",smodel, new Vector3D(3.0,8.0,0.0));

	atlanta.setLoadingTimeDistribution(new Constant (1.0));
	louisville.setLoadingTimeDistribution(new Constant (1.0));
	detroit.setLoadingTimeDistribution(new Constant (1.0));
	chicago.setLoadingTimeDistribution(new Constant (1.0));
	kansascity.setLoadingTimeDistribution(new Constant (1.0));
	littlerock.setLoadingTimeDistribution(new Constant (1.0));
	memphis.setLoadingTimeDistribution(new Constant (1.0));
	lowell.setLoadingTimeDistribution(new Constant (1.0));
	oklacity.setLoadingTimeDistribution(new Constant (1.0));
	dallas.setLoadingTimeDistribution(new Constant (1.0));
	houston.setLoadingTimeDistribution(new Constant (1.0));
			
	atlanta.setUnloadingTimeDistribution(new Constant (1.0));
	louisville.setUnloadingTimeDistribution(new Constant (1.0));
	detroit.setUnloadingTimeDistribution(new Constant (1.0));
	chicago.setUnloadingTimeDistribution(new Constant (1.0));
	kansascity.setUnloadingTimeDistribution(new Constant (1.0));
	littlerock.setUnloadingTimeDistribution(new Constant (1.0));
	memphis.setUnloadingTimeDistribution(new Constant (1.0));
	lowell.setUnloadingTimeDistribution(new Constant (1.0));
	oklacity.setUnloadingTimeDistribution(new Constant (1.0));
	dallas.setUnloadingTimeDistribution(new Constant (1.0));
	houston.setUnloadingTimeDistribution(new Constant (1.0));
	
	LaneIfc ab= new Lane(t,atlanta,louisville,436);
	LaneIfc ae= new Lane(t,atlanta,kansascity,862);
	LaneIfc af = new Lane(t,atlanta,littlerock,538);
	LaneIfc ai = new Lane(t,atlanta,oklacity,869);
	LaneIfc aj = new Lane(t,atlanta,dallas,804);
	LaneIfc ak = new Lane(t,atlanta,houston,814);
	
	LaneIfc ba = new Lane(t,louisville,atlanta,436);
	LaneIfc bc = new Lane(t,louisville,detroit,355);
	LaneIfc bd = new Lane(t,louisville,chicago,324);
	LaneIfc bf = new Lane(t,louisville,littlerock,513);
	
	LaneIfc cb = new Lane(t,detroit,louisville,355);
	LaneIfc cd = new Lane(t,detroit,chicago,265);
	
	LaneIfc db= new Lane(t,chicago,louisville,324);
	LaneIfc dc= new Lane(t,chicago,detroit,265);
	LaneIfc dh= new Lane(t,chicago,lowell,610);
	LaneIfc dj= new Lane(t,chicago,dallas,899);

	LaneIfc ea = new Lane(t,kansascity,atlanta,862);
	LaneIfc ef = new Lane(t,kansascity,littlerock,470);
	LaneIfc eh = new Lane(t,kansascity,lowell,289);
	
	LaneIfc fa = new Lane(t,littlerock,atlanta,538);
	LaneIfc fb = new Lane(t,littlerock,louisville,513);
	LaneIfc fe = new Lane(t,littlerock,kansascity,470);
	LaneIfc fj = new Lane(t,littlerock,dallas,341);
	LaneIfc fk = new Lane(t,littlerock,houston,481);
	
	LaneIfc gk = new Lane(t,memphis,houston,575);
	
	LaneIfc hd = new Lane(t,lowell,chicago,610);
	LaneIfc he = new Lane(t,lowell,kansascity,289);
	LaneIfc hj = new Lane(t,lowell,dallas,328);
	
	LaneIfc ia = new Lane(t,oklacity,atlanta,869);
	LaneIfc ij = new Lane(t,oklacity,dallas,233);
	LaneIfc ik = new Lane(t,oklacity,houston,476);
	
	LaneIfc ja = new Lane(t,dallas,atlanta,804);
	LaneIfc jd = new Lane(t,dallas,chicago,899);
	LaneIfc jf = new Lane(t,dallas,littlerock,341);
	LaneIfc jh = new Lane(t,dallas,lowell,328);
	LaneIfc ji = new Lane(t,dallas,oklacity,233);
	LaneIfc jk = new Lane(t,dallas,houston,258);
	
	LaneIfc ka = new Lane(t,houston,atlanta,814);
	LaneIfc kf = new Lane(t,houston,littlerock,481);
	LaneIfc kg = new Lane(t,houston,memphis,575);
	LaneIfc ki = new Lane(t,houston,oklacity,476);
	LaneIfc kj = new Lane(t,houston,dallas,258);
	
	t.addLane(ab);
	t.addLane(ae);
	t.addLane(af);
	t.addLane(ai);
	t.addLane(aj);
	t.addLane(ak);
	
	t.addLane(ba);
	t.addLane(bc);
	t.addLane(bd);
	t.addLane(bf);
	
	t.addLane(cb);
	t.addLane(cd);
	
	t.addLane(db);
	t.addLane(dc);
	t.addLane(dh);
	t.addLane(dj);
	
	t.addLane(ea);
	t.addLane(ef);
	t.addLane(eh);
	
	t.addLane(fa);
	t.addLane(fb);
	t.addLane(fe);
	t.addLane(fj);
	t.addLane(fk);
		
	t.addLane(gk);
	t.addLane(hd);
	t.addLane(he);
	t.addLane(hj);
	
	t.addLane(ia);
	t.addLane(ij);
	t.addLane(ik);
	
	t.addLane(ja);
	t.addLane(jd);
	t.addLane(jf);
	t.addLane(jh);
	t.addLane(ji);
	t.addLane(jk);
	
	t.addLane(ka);
	t.addLane(kf);
	t.addLane(kg);
	t.addLane(ki);
	t.addLane(kj);
	
	System.out.println(t);
	
	AbstractDispatcherFTL d = new DispatcherFTL(m,t,1000.0);
	
	DistributionIfc driverSpeed = new Constant(60.0);
//	 4 drivers for atlanta
	d.addDriver(atlanta,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(atlanta,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(atlanta,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(atlanta,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
/*	d.addDriver(atlanta,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(atlanta,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(atlanta,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(atlanta,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
*/	
	//3 drivers for louisville
	d.addDriver(louisville,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(louisville,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(louisville,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	/*d.addDriver(louisville,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(louisville,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(louisville,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(louisville,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	*/
	//4 drivers for detroit
	d.addDriver(detroit,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(detroit,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(detroit,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(detroit,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
/*	d.addDriver(detroit,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(detroit,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(detroit,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
*/	
	//4 drivers for chicago
/*	d.addDriver(chicago,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(chicago,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(chicago,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(chicago,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	*/d.addDriver(chicago,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(chicago,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(chicago,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(chicago,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	
	//3 drivers for kansas city
//	d.addDriver(kansascity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
//	d.addDriver(kansascity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
//	d.addDriver(kansascity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(kansascity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(kansascity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(kansascity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	
	//5 drivers for little rock
/*	d.addDriver(littlerock,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(littlerock,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(littlerock,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(littlerock,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(littlerock,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
*/	d.addDriver(littlerock,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(littlerock,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(littlerock,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(littlerock,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(littlerock,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	
	// 1 drivers for memphis
	//d.addDriver(memphis,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
//	d.addDriver(memphis,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(memphis,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	
	//4 drivers for lowell
//	d.addDriver(lowell,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
//	d.addDriver(lowell,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
//	d.addDriver(lowell,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(lowell,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(lowell,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(lowell,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(lowell,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	
	// 3 drivers for okla city
//	d.addDriver(oklacity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
//	d.addDriver(oklacity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
//	d.addDriver(oklacity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(oklacity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(oklacity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(oklacity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	
	// 5 drivers for dallas
//	d.addDriver(dallas,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
//	d.addDriver(dallas,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
//	d.addDriver(dallas,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
//	d.addDriver(dallas,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(dallas,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(dallas,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(dallas,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(dallas,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(dallas,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	
	// 4 drivers for houston
//	d.addDriver(houston,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
//	d.addDriver(houston,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
// d.addDriver(houston,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
//	d.addDriver(houston,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
//	d.addDriver(houston,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(houston,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(houston,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(houston,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(houston,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	
	//12 trucks at atlanta
			
/*	d.addTruck(atlanta);
	d.addTruck(atlanta);
	d.addTruck(atlanta);
	d.addTruck(atlanta);
	d.addTruck(atlanta);
	d.addTruck(atlanta);
*/	d.addTruck(atlanta);
	d.addTruck(atlanta);
	d.addTruck(atlanta);
	d.addTruck(atlanta);
	d.addTruck(atlanta);
	d.addTruck(atlanta);
	
//	5 trucks at louisville
/*	d.addTruck(louisville);
	d.addTruck(louisville);
	d.addTruck(louisville);
	d.addTruck(louisville);
	d.addTruck(louisville);
	d.addTruck(louisville);
*/	d.addTruck(louisville);
	d.addTruck(louisville);
	d.addTruck(louisville);
	d.addTruck(louisville);
	d.addTruck(louisville);
	
//	6 trucks at detroit
/*	d.addTruck(detroit);
	d.addTruck(detroit);
	d.addTruck(detroit);
	d.addTruck(detroit);
	d.addTruck(detroit);
*/	d.addTruck(detroit);
	d.addTruck(detroit);
	d.addTruck(detroit);
	d.addTruck(detroit);
	d.addTruck(detroit);
	d.addTruck(detroit);
	
//	6 trucks at chicago
/*	d.addTruck(chicago);
	d.addTruck(chicago);
	d.addTruck(chicago);
	d.addTruck(chicago);
	d.addTruck(chicago);
	d.addTruck(chicago);
*/	d.addTruck(chicago);
	d.addTruck(chicago);
	d.addTruck(chicago);
	d.addTruck(chicago);
	d.addTruck(chicago);
	d.addTruck(chicago);
	
	//		5 trucks at kansas city
/*	d.addTruck(kansascity);	
	d.addTruck(kansascity);	
	d.addTruck(kansascity);	
	d.addTruck(kansascity);	
	d.addTruck(kansascity);	
*/	d.addTruck(kansascity);	
	d.addTruck(kansascity);	
	d.addTruck(kansascity);	
	d.addTruck(kansascity);	
	d.addTruck(kansascity);	
	
//	7 trucks at littlerock
/*	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	*/d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	
//	3 trucks at memphis
	d.addTruck(memphis);
	d.addTruck(memphis);
	d.addTruck(memphis);
/*	d.addTruck(memphis);
	d.addTruck(memphis);
	d.addTruck(memphis);
	d.addTruck(memphis);
*/	
//	6 trucks at lowell
	d.addTruck(lowell);
	d.addTruck(lowell);
	d.addTruck(lowell);
	d.addTruck(lowell);
	d.addTruck(lowell);
	d.addTruck(lowell);
/*	d.addTruck(lowell);
	d.addTruck(lowell);
	d.addTruck(lowell);
	d.addTruck(lowell);
	d.addTruck(lowell);
	*/
	
//	5 trucks at oklacity
//	d.addTruck(oklacity);	
	//d.addTruck(oklacity);	
//	d.addTruck(oklacity);	
//	d.addTruck(oklacity);	
//	d.addTruck(oklacity);	
	d.addTruck(oklacity);	
	d.addTruck(oklacity);	
	d.addTruck(oklacity);	
	d.addTruck(oklacity);	
	d.addTruck(oklacity);	
	
//	6 trucks at dallas
	d.addTruck(dallas);
	d.addTruck(dallas);
	d.addTruck(dallas);
	d.addTruck(dallas);
	d.addTruck(dallas);
	d.addTruck(dallas);
/*	d.addTruck(dallas);
	d.addTruck(dallas);
	d.addTruck(dallas);
	d.addTruck(dallas);
	d.addTruck(dallas);
	d.addTruck(dallas);
	d.addTruck(dallas);
*/	
	
//	7 trucks at houston
	d.addTruck(houston);
	d.addTruck(houston);
	d.addTruck(houston);
	d.addTruck(houston);
	d.addTruck(houston);
	d.addTruck(houston);
	d.addTruck(houston);
/*	d.addTruck(houston);
	d.addTruck(houston);
	d.addTruck(houston);
	d.addTruck(houston);
	d.addTruck(houston);
	d.addTruck(houston);
*/	
//	28 trailers at atlanta		
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	
//	26 trailers at louisville
	d.addTrailer(louisville);
	d.addTrailer(louisville);
	d.addTrailer(louisville);
	d.addTrailer(louisville);
	d.addTrailer(louisville);
	d.addTrailer(louisville);
	d.addTrailer(louisville);
	d.addTrailer(louisville);
	d.addTrailer(louisville);
	d.addTrailer(louisville);
	d.addTrailer(louisville);
	d.addTrailer(louisville);
	d.addTrailer(louisville);
	d.addTrailer(louisville);
	d.addTrailer(louisville);
	d.addTrailer(louisville);
	d.addTrailer(louisville);
	d.addTrailer(louisville);
	d.addTrailer(louisville);
	d.addTrailer(louisville);
	d.addTrailer(louisville);
	d.addTrailer(louisville);
	d.addTrailer(louisville);
	d.addTrailer(louisville);
	d.addTrailer(louisville);
	d.addTrailer(louisville);
	
//	26 trailers at detroit
	d.addTrailer(detroit);
	d.addTrailer(detroit);
	d.addTrailer(detroit);
	d.addTrailer(detroit);
	d.addTrailer(detroit);
	d.addTrailer(detroit);
	d.addTrailer(detroit);
	d.addTrailer(detroit);
	d.addTrailer(detroit);
	d.addTrailer(detroit);
	d.addTrailer(detroit);
	d.addTrailer(detroit);
	d.addTrailer(detroit);
	d.addTrailer(detroit);
	d.addTrailer(detroit);
	d.addTrailer(detroit);
	d.addTrailer(detroit);
	d.addTrailer(detroit);
	d.addTrailer(detroit);
	d.addTrailer(detroit);
	d.addTrailer(detroit);
	d.addTrailer(detroit);
	d.addTrailer(detroit);
	d.addTrailer(detroit);
	d.addTrailer(detroit);
	d.addTrailer(detroit);
	
//	28 trailers at chicago
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	
//	24 trailers at kansas city
	d.addTrailer(kansascity);
	d.addTrailer(kansascity);
	d.addTrailer(kansascity);
	d.addTrailer(kansascity);
	d.addTrailer(kansascity);
	d.addTrailer(kansascity);
	d.addTrailer(kansascity);
	d.addTrailer(kansascity);
	d.addTrailer(kansascity);
	d.addTrailer(kansascity);
	d.addTrailer(kansascity);
	d.addTrailer(kansascity);
	d.addTrailer(kansascity);
	d.addTrailer(kansascity);
	d.addTrailer(kansascity);
	d.addTrailer(kansascity);
	d.addTrailer(kansascity);
	d.addTrailer(kansascity);
	d.addTrailer(kansascity);
	d.addTrailer(kansascity);
	d.addTrailer(kansascity);
	d.addTrailer(kansascity);
	d.addTrailer(kansascity);
	d.addTrailer(kansascity);
	
//	32 trailers at littlerock
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	
//	18 trailers at memphis
	d.addTrailer(memphis);
	d.addTrailer(memphis);
	d.addTrailer(memphis);
	d.addTrailer(memphis);
	d.addTrailer(memphis);
	d.addTrailer(memphis);
	d.addTrailer(memphis);
	d.addTrailer(memphis);
	d.addTrailer(memphis);
	d.addTrailer(memphis);
	d.addTrailer(memphis);
	d.addTrailer(memphis);
	d.addTrailer(memphis);
	d.addTrailer(memphis);
	d.addTrailer(memphis);
	d.addTrailer(memphis);
	d.addTrailer(memphis);
	d.addTrailer(memphis);
	
//	26 trailers at lowell
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	
//	24 trailers at okla city
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	
//	30 trailers at dallas
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	
//	30 trailers at houston
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	//	Create the Load generator
//	LoadGenerator lg = new LoadGenerator(m,t,tl,tl,new Constant(3000.0)," "); 
	LoadGenerator lg = new LoadGenerator(m,t,tl,tl); 
	
	System.out.println("Here is the load generator");
	
	lg.setOriginProbability(atlanta, 0.097);
	lg.setOriginProbability(louisville, 0.066);
	lg.setOriginProbability(detroit, 0.057);
	lg.setOriginProbability(chicago, 0.082);
	lg.setOriginProbability(kansascity, 0.032);
	lg.setOriginProbability(littlerock, 0.201);
	lg.setOriginProbability(memphis, 0.004);
	lg.setOriginProbability(lowell, 0.052);
	lg.setOriginProbability(oklacity, 0.019);
	lg.setOriginProbability(dallas, 0.272);
	lg.setLastOriginProbability(houston);
	
	System.out.println("origin probability set");
	
	lg.setDestinationProbability(ab,0.087);
	lg.setDestinationProbability(ae,0.072);
	lg.setDestinationProbability(af,0.373);
	lg.setDestinationProbability(ai,0.057);
	lg.setDestinationProbability(aj,0.303);
	lg.setLastDestinationProbability(ak);
		
	lg.setDestinationProbability(ba,0.194);
	lg.setDestinationProbability(bc,0.388);
	lg.setDestinationProbability(bd,0.377);
	lg.setLastDestinationProbability(bf);
	
	lg.setDestinationProbability(cb,0.458);
	lg.setLastDestinationProbability(cd);
	
	lg.setDestinationProbability(db,0.357);
	lg.setDestinationProbability(dc,0.378);
	lg.setDestinationProbability(dh,0.13);
	lg.setLastDestinationProbability(dj);
	
	lg.setDestinationProbability(ea,0.217);
	lg.setDestinationProbability(ef,0.515);
	lg.setLastDestinationProbability(eh);
	
	lg.setDestinationProbability(fa,0.071);
	lg.setDestinationProbability(fb,0.013);
	lg.setDestinationProbability(fe,0.036);
	lg.setDestinationProbability(fj,0.635);
	lg.setLastDestinationProbability(fk);
	
	lg.setLastDestinationProbability(gk);
	
	lg.setDestinationProbability(hd,0.336);
	lg.setDestinationProbability(he,0.342);
	lg.setLastDestinationProbability(hj);
	
	lg.setDestinationProbability(ia,0.374);
	lg.setDestinationProbability(ij,0.245);
	lg.setLastDestinationProbability(ik);
	
	lg.setDestinationProbability(ja,0.148);
	lg.setDestinationProbability(jd,0.032);
	lg.setDestinationProbability(jf,0.488);
	lg.setDestinationProbability(jh,0.12);
	lg.setDestinationProbability(ji,0.04);
	lg.setLastDestinationProbability(jk);

	lg.setDestinationProbability(ka,0.132);
	lg.setDestinationProbability(kf,0.107);
	lg.setDestinationProbability(kg,0.034);
	lg.setDestinationProbability(ki,0.023);
	lg.setLastDestinationProbability(kj);
	
	System.out.println("destination probability set");
	
	m.turnOnLogReport();
	
	// create the experiment to run the model
	Experiment e = new Experiment(m);
	
	// set the parameters of the experiment
	e.setNumberOfReplications(1);
	e.setLengthOfReplication(10000);//15000 - 10 days duration
	e.setLengthOfWarmUp(500.0);
	
	
	// turn on the desired reporting
	e.turnOnBatchReport(); 
	e.turnOnExperimentReport();
	e.turnOnReplicationReport();
//	e.turnOnExperimentConsoleOutput();
	
// tell the experiment to run
	e.runAll();
}
public static void testCaseG(){
	
	System.out.println("Test Case For Truckload Transportation Model : JBHT:Sensitivity Test Case 6");
	
	Model m = Model.createModel();
	
	System.out.println("Model Created");
	
	DistributionIfc tl = new Exponential(1.0);
	
	SpatialModel smodel = new RectangularGridSpatialModel2D();
	
	TransportationNetwork t=new TransportationNetwork(m, smodel);
	
	System.out.println("Here is the Transportation Network");		
	
	Location atlanta = new Location(m,"Atlanta,GA",smodel, new Vector3D(0.0,0.0,0.0));
	Location louisville = new Location(m,"Louisville,KY",smodel,new Vector3D(1.0,2.0,3.0));
	Location detroit = new Location(m,"Detroit,MI",smodel, new Vector3D(5.0,4.0,0.0));
	Location chicago = new Location(m,"Chicago,IL",smodel, new Vector3D(3.0,7.0,0.0));
	Location kansascity = new Location(m,"Kansas City,MO",smodel, new Vector3D(4.0,9.0,0.0));
	Location littlerock = new Location(m,"Little Rock,AR",smodel, new Vector3D(58.0,28.0,0.0));
	Location memphis = new Location(m,"Memphis,TN",smodel, new Vector3D(3.0,5.0,0.0));
	Location lowell = new Location(m,"Lowell,AR",smodel, new Vector3D(3.0,6.0,0.0));
	Location oklacity = new Location(m,"Okla City,OK",smodel, new Vector3D(3.0,7.0,0.0));
	Location dallas = new Location(m,"Dallas,TX",smodel, new Vector3D(3.0,4.0,0.0));
	Location houston = new Location(m,"Houston,TX",smodel, new Vector3D(3.0,8.0,0.0));

	atlanta.setLoadingTimeDistribution(new Constant (1.0));
	louisville.setLoadingTimeDistribution(new Constant (1.0));
	detroit.setLoadingTimeDistribution(new Constant (1.0));
	chicago.setLoadingTimeDistribution(new Constant (1.0));
	kansascity.setLoadingTimeDistribution(new Constant (1.0));
	littlerock.setLoadingTimeDistribution(new Constant (1.0));
	memphis.setLoadingTimeDistribution(new Constant (1.0));
	lowell.setLoadingTimeDistribution(new Constant (1.0));
	oklacity.setLoadingTimeDistribution(new Constant (1.0));
	dallas.setLoadingTimeDistribution(new Constant (1.0));
	houston.setLoadingTimeDistribution(new Constant (1.0));
			
	atlanta.setUnloadingTimeDistribution(new Constant (1.0));
	louisville.setUnloadingTimeDistribution(new Constant (1.0));
	detroit.setUnloadingTimeDistribution(new Constant (1.0));
	chicago.setUnloadingTimeDistribution(new Constant (1.0));
	kansascity.setUnloadingTimeDistribution(new Constant (1.0));
	littlerock.setUnloadingTimeDistribution(new Constant (1.0));
	memphis.setUnloadingTimeDistribution(new Constant (1.0));
	lowell.setUnloadingTimeDistribution(new Constant (1.0));
	oklacity.setUnloadingTimeDistribution(new Constant (1.0));
	dallas.setUnloadingTimeDistribution(new Constant (1.0));
	houston.setUnloadingTimeDistribution(new Constant (1.0));
	
	LaneIfc ab= new Lane(t,atlanta,louisville,436);
	LaneIfc ae= new Lane(t,atlanta,kansascity,862);
	LaneIfc af = new Lane(t,atlanta,littlerock,538);
	LaneIfc ai = new Lane(t,atlanta,oklacity,869);
	LaneIfc aj = new Lane(t,atlanta,dallas,804);
	LaneIfc ak = new Lane(t,atlanta,houston,814);
	
	LaneIfc ba = new Lane(t,louisville,atlanta,436);
	LaneIfc bc = new Lane(t,louisville,detroit,355);
	LaneIfc bd = new Lane(t,louisville,chicago,324);
	LaneIfc bf = new Lane(t,louisville,littlerock,513);
	
	LaneIfc cb = new Lane(t,detroit,louisville,355);
	LaneIfc cd = new Lane(t,detroit,chicago,265);
	
	LaneIfc db= new Lane(t,chicago,louisville,324);
	LaneIfc dc= new Lane(t,chicago,detroit,265);
	LaneIfc dh= new Lane(t,chicago,lowell,610);
	LaneIfc dj= new Lane(t,chicago,dallas,899);

	LaneIfc ea = new Lane(t,kansascity,atlanta,862);
	LaneIfc ef = new Lane(t,kansascity,littlerock,470);
	LaneIfc eh = new Lane(t,kansascity,lowell,289);
	
	LaneIfc fa = new Lane(t,littlerock,atlanta,538);
	LaneIfc fb = new Lane(t,littlerock,louisville,513);
	LaneIfc fe = new Lane(t,littlerock,kansascity,470);
	LaneIfc fj = new Lane(t,littlerock,dallas,341);
	LaneIfc fk = new Lane(t,littlerock,houston,481);
	
	LaneIfc gk = new Lane(t,memphis,houston,575);
	
	LaneIfc hd = new Lane(t,lowell,chicago,610);
	LaneIfc he = new Lane(t,lowell,kansascity,289);
	LaneIfc hj = new Lane(t,lowell,dallas,328);
	
	LaneIfc ia = new Lane(t,oklacity,atlanta,869);
	LaneIfc ij = new Lane(t,oklacity,dallas,233);
	LaneIfc ik = new Lane(t,oklacity,houston,476);
	
	LaneIfc ja = new Lane(t,dallas,atlanta,804);
	LaneIfc jd = new Lane(t,dallas,chicago,899);
	LaneIfc jf = new Lane(t,dallas,littlerock,341);
	LaneIfc jh = new Lane(t,dallas,lowell,328);
	LaneIfc ji = new Lane(t,dallas,oklacity,233);
	LaneIfc jk = new Lane(t,dallas,houston,258);
	
	LaneIfc ka = new Lane(t,houston,atlanta,814);
	LaneIfc kf = new Lane(t,houston,littlerock,481);
	LaneIfc kg = new Lane(t,houston,memphis,575);
	LaneIfc ki = new Lane(t,houston,oklacity,476);
	LaneIfc kj = new Lane(t,houston,dallas,258);
	
	t.addLane(ab);
	t.addLane(ae);
	t.addLane(af);
	t.addLane(ai);
	t.addLane(aj);
	t.addLane(ak);
	
	t.addLane(ba);
	t.addLane(bc);
	t.addLane(bd);
	t.addLane(bf);
	
	t.addLane(cb);
	t.addLane(cd);
	
	t.addLane(db);
	t.addLane(dc);
	t.addLane(dh);
	t.addLane(dj);
	
	t.addLane(ea);
	t.addLane(ef);
	t.addLane(eh);
	
	t.addLane(fa);
	t.addLane(fb);
	t.addLane(fe);
	t.addLane(fj);
	t.addLane(fk);
		
	t.addLane(gk);
	t.addLane(hd);
	t.addLane(he);
	t.addLane(hj);
	
	t.addLane(ia);
	t.addLane(ij);
	t.addLane(ik);
	
	t.addLane(ja);
	t.addLane(jd);
	t.addLane(jf);
	t.addLane(jh);
	t.addLane(ji);
	t.addLane(jk);
	
	t.addLane(ka);
	t.addLane(kf);
	t.addLane(kg);
	t.addLane(ki);
	t.addLane(kj);
	
	System.out.println(t);
	
	AbstractDispatcherFTL d = new DispatcherFTL(m,t,1000.0);
	
	DistributionIfc driverSpeed = new Constant(60.0);
//	 4 drivers for atlanta
	d.addDriver(atlanta,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(atlanta,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(atlanta,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(atlanta,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
/*	d.addDriver(atlanta,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(atlanta,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(atlanta,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(atlanta,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
*/	
	//3 drivers for louisville
	d.addDriver(louisville,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(louisville,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(louisville,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	/*d.addDriver(louisville,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(louisville,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(louisville,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(louisville,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	*/
	//4 drivers for detroit
	d.addDriver(detroit,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(detroit,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(detroit,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(detroit,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
/*	d.addDriver(detroit,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(detroit,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(detroit,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
*/	
	//4 drivers for chicago
/*	d.addDriver(chicago,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(chicago,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(chicago,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(chicago,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	*/d.addDriver(chicago,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(chicago,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(chicago,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(chicago,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	
	//3 drivers for kansas city
//	d.addDriver(kansascity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
//	d.addDriver(kansascity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
//	d.addDriver(kansascity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(kansascity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(kansascity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(kansascity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	
	//5 drivers for little rock
/*	d.addDriver(littlerock,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(littlerock,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(littlerock,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(littlerock,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(littlerock,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
*/	d.addDriver(littlerock,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(littlerock,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(littlerock,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(littlerock,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(littlerock,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	
	// 1 drivers for memphis
	//d.addDriver(memphis,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
//	d.addDriver(memphis,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(memphis,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	
	//4 drivers for lowell
//	d.addDriver(lowell,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
//	d.addDriver(lowell,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
//	d.addDriver(lowell,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(lowell,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(lowell,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(lowell,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(lowell,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	
	// 3 drivers for okla city
//	d.addDriver(oklacity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
//	d.addDriver(oklacity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
//	d.addDriver(oklacity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(oklacity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(oklacity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(oklacity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	
	// 5 drivers for dallas
//	d.addDriver(dallas,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
//	d.addDriver(dallas,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
//	d.addDriver(dallas,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
//	d.addDriver(dallas,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(dallas,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(dallas,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(dallas,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(dallas,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(dallas,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	
	// 4 drivers for houston
//	d.addDriver(houston,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
//	d.addDriver(houston,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
// d.addDriver(houston,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
//	d.addDriver(houston,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
//	d.addDriver(houston,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(houston,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(houston,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(houston,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(houston,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	
//	24 trucks at atlanta
	
	d.addTruck(atlanta);
	d.addTruck(atlanta);
	d.addTruck(atlanta);
	d.addTruck(atlanta);
	d.addTruck(atlanta);
	d.addTruck(atlanta);
	d.addTruck(atlanta);
	d.addTruck(atlanta);
	d.addTruck(atlanta);
	d.addTruck(atlanta);
	d.addTruck(atlanta);
	d.addTruck(atlanta);
	d.addTruck(atlanta);
	d.addTruck(atlanta);
	d.addTruck(atlanta);
	d.addTruck(atlanta);
	d.addTruck(atlanta);
	d.addTruck(atlanta);
	d.addTruck(atlanta);
	d.addTruck(atlanta);
	d.addTruck(atlanta);
	d.addTruck(atlanta);
	d.addTruck(atlanta);
	d.addTruck(atlanta);
	
//	22 trucks at louisville
	d.addTruck(louisville);
	d.addTruck(louisville);
	d.addTruck(louisville);
	d.addTruck(louisville);
	d.addTruck(louisville);
	d.addTruck(louisville);
	d.addTruck(louisville);
	d.addTruck(louisville);
	d.addTruck(louisville);
	d.addTruck(louisville);
	d.addTruck(louisville);
	d.addTruck(louisville);
	d.addTruck(louisville);
	d.addTruck(louisville);
	d.addTruck(louisville);
	d.addTruck(louisville);
	d.addTruck(louisville);
	d.addTruck(louisville);
	d.addTruck(louisville);
	d.addTruck(louisville);
	d.addTruck(louisville);
	d.addTruck(louisville);
	
//	22 trucks at detroit
	d.addTruck(detroit);
	d.addTruck(detroit);
	d.addTruck(detroit);
	d.addTruck(detroit);
	d.addTruck(detroit);
	d.addTruck(detroit);
	d.addTruck(detroit);
	d.addTruck(detroit);
	d.addTruck(detroit);
	d.addTruck(detroit);
	d.addTruck(detroit);
	d.addTruck(detroit);
	d.addTruck(detroit);
	d.addTruck(detroit);
	d.addTruck(detroit);
	d.addTruck(detroit);
	d.addTruck(detroit);
	d.addTruck(detroit);
	d.addTruck(detroit);
	d.addTruck(detroit);
	d.addTruck(detroit);
	d.addTruck(detroit);
	
//	24 trucks at chicago
	d.addTruck(chicago);
	d.addTruck(chicago);
	d.addTruck(chicago);
	d.addTruck(chicago);
	d.addTruck(chicago);
	d.addTruck(chicago);
	d.addTruck(chicago);
	d.addTruck(chicago);
	d.addTruck(chicago);
	d.addTruck(chicago);
	d.addTruck(chicago);
	d.addTruck(chicago);
	d.addTruck(chicago);
	d.addTruck(chicago);
	d.addTruck(chicago);
	d.addTruck(chicago);
	d.addTruck(chicago);
	d.addTruck(chicago);
	d.addTruck(chicago);
	d.addTruck(chicago);
	d.addTruck(chicago);
	d.addTruck(chicago);
	d.addTruck(chicago);
	d.addTruck(chicago);
	
	//		20 trucks at kansas city
	d.addTruck(kansascity);	
	d.addTruck(kansascity);	
	d.addTruck(kansascity);	
	d.addTruck(kansascity);	
	d.addTruck(kansascity);	
	d.addTruck(kansascity);	
	d.addTruck(kansascity);	
	d.addTruck(kansascity);	
	d.addTruck(kansascity);	
	d.addTruck(kansascity);	
	d.addTruck(kansascity);	
	d.addTruck(kansascity);	
	d.addTruck(kansascity);	
	d.addTruck(kansascity);	
	d.addTruck(kansascity);	
	d.addTruck(kansascity);	
	d.addTruck(kansascity);	
	d.addTruck(kansascity);	
	d.addTruck(kansascity);	
	d.addTruck(kansascity);	
	
//	28 trucks at littlerock
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	
//	14 trucks at memphis
	d.addTruck(memphis);
	d.addTruck(memphis);
	d.addTruck(memphis);
	d.addTruck(memphis);
	d.addTruck(memphis);
	d.addTruck(memphis);
	d.addTruck(memphis);
	d.addTruck(memphis);
	d.addTruck(memphis);
	d.addTruck(memphis);
	d.addTruck(memphis);
	d.addTruck(memphis);
	d.addTruck(memphis);
	d.addTruck(memphis);
	
//	22 trucks at lowell
	d.addTruck(lowell);
	d.addTruck(lowell);
	d.addTruck(lowell);
	d.addTruck(lowell);
	d.addTruck(lowell);
	d.addTruck(lowell);
	d.addTruck(lowell);
	d.addTruck(lowell);
	d.addTruck(lowell);
	d.addTruck(lowell);
	d.addTruck(lowell);
	d.addTruck(lowell);
	d.addTruck(lowell);
	d.addTruck(lowell);
	d.addTruck(lowell);
	d.addTruck(lowell);
	d.addTruck(lowell);
	d.addTruck(lowell);
	d.addTruck(lowell);
	d.addTruck(lowell);
	d.addTruck(lowell);
	d.addTruck(lowell);
	
	
//	20 trucks at oklacity
	d.addTruck(oklacity);	
	d.addTruck(oklacity);	
	d.addTruck(oklacity);	
	d.addTruck(oklacity);	
	d.addTruck(oklacity);	
	d.addTruck(oklacity);	
	d.addTruck(oklacity);	
	d.addTruck(oklacity);	
	d.addTruck(oklacity);	
	d.addTruck(oklacity);
	d.addTruck(oklacity);	
	d.addTruck(oklacity);	
	d.addTruck(oklacity);	
	d.addTruck(oklacity);	
	d.addTruck(oklacity);	
	d.addTruck(oklacity);	
	d.addTruck(oklacity);	
	d.addTruck(oklacity);	
	d.addTruck(oklacity);	
	d.addTruck(oklacity);	
	
//	26 trucks at dallas
	d.addTruck(dallas);
	d.addTruck(dallas);
	d.addTruck(dallas);
	d.addTruck(dallas);
	d.addTruck(dallas);
	d.addTruck(dallas);
	d.addTruck(dallas);
	d.addTruck(dallas);
	d.addTruck(dallas);
	d.addTruck(dallas);
	d.addTruck(dallas);
	d.addTruck(dallas);
	d.addTruck(dallas);
	d.addTruck(dallas);
	d.addTruck(dallas);
	d.addTruck(dallas);
	d.addTruck(dallas);
	d.addTruck(dallas);
	d.addTruck(dallas);
	d.addTruck(dallas);
	d.addTruck(dallas);
	d.addTruck(dallas);
	d.addTruck(dallas);
	d.addTruck(dallas);
	d.addTruck(dallas);
	d.addTruck(dallas);
	
	
//	26 trucks at houston
	d.addTruck(houston);
	d.addTruck(houston);
	d.addTruck(houston);
	d.addTruck(houston);
	d.addTruck(houston);
	d.addTruck(houston);
	d.addTruck(houston);
	d.addTruck(houston);
	d.addTruck(houston);
	d.addTruck(houston);
	d.addTruck(houston);
	d.addTruck(houston);
	d.addTruck(houston);
	d.addTruck(houston);
	d.addTruck(houston);
	d.addTruck(houston);
	d.addTruck(houston);
	d.addTruck(houston);
	d.addTruck(houston);
	d.addTruck(houston);
	d.addTruck(houston);
	d.addTruck(houston);
	d.addTruck(houston);
	d.addTruck(houston);
	d.addTruck(houston);
	d.addTruck(houston);
//	7 trailers at atlanta		
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
/*	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
*/	
//	6 trailers at louisville
	d.addTrailer(louisville);
	d.addTrailer(louisville);
	d.addTrailer(louisville);
	d.addTrailer(louisville);
	d.addTrailer(louisville);
	d.addTrailer(louisville);
/*	d.addTrailer(louisville);
	d.addTrailer(louisville);
	d.addTrailer(louisville);
	d.addTrailer(louisville);
	d.addTrailer(louisville);
	d.addTrailer(louisville);
	d.addTrailer(louisville);
	*/
	
//	7 trailers at detroit
	d.addTrailer(detroit);
	d.addTrailer(detroit);
	d.addTrailer(detroit);
	d.addTrailer(detroit);
	d.addTrailer(detroit);
	d.addTrailer(detroit);
	d.addTrailer(detroit);
	/*d.addTrailer(detroit);
	d.addTrailer(detroit);
	d.addTrailer(detroit);
	d.addTrailer(detroit);
	d.addTrailer(detroit);
	d.addTrailer(detroit);
*/	
//	7 trailers at chicago
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
/*	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
*/	
//	6 trailers at kansas city
	d.addTrailer(kansascity);
	d.addTrailer(kansascity);
	d.addTrailer(kansascity);
	d.addTrailer(kansascity);
	d.addTrailer(kansascity);
	d.addTrailer(kansascity);
/*	d.addTrailer(kansascity);
	d.addTrailer(kansascity);
	d.addTrailer(kansascity);
	d.addTrailer(kansascity);
	d.addTrailer(kansascity);
	d.addTrailer(kansascity);
	*/
//	8 trailers at littlerock
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
/*	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
*/	
//	4 trailers at memphis
	d.addTrailer(memphis);
	d.addTrailer(memphis);
	d.addTrailer(memphis);
	d.addTrailer(memphis);
/*	d.addTrailer(memphis);
	d.addTrailer(memphis);
	d.addTrailer(memphis);
	d.addTrailer(memphis);
	d.addTrailer(memphis);
*/	
//	7 trailers at lowell
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
/*	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
*/	
//	6 trailers at okla city
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
/*	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
*/	
//	7 trailers at dallas
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
/*	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
*/	
//	8 trailers at houston
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
/*	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
*/	
	//	Create the Load generator
//	LoadGenerator lg = new LoadGenerator(m,t,tl,tl,new Constant(3000.0)," "); 
	LoadGenerator lg = new LoadGenerator(m,t,tl,tl); 
	
	System.out.println("Here is the load generator");
	
	lg.setOriginProbability(atlanta, 0.097);
	lg.setOriginProbability(louisville, 0.066);
	lg.setOriginProbability(detroit, 0.057);
	lg.setOriginProbability(chicago, 0.082);
	lg.setOriginProbability(kansascity, 0.032);
	lg.setOriginProbability(littlerock, 0.201);
	lg.setOriginProbability(memphis, 0.004);
	lg.setOriginProbability(lowell, 0.052);
	lg.setOriginProbability(oklacity, 0.019);
	lg.setOriginProbability(dallas, 0.272);
	lg.setLastOriginProbability(houston);
	
	System.out.println("origin probability set");
	
	lg.setDestinationProbability(ab,0.087);
	lg.setDestinationProbability(ae,0.072);
	lg.setDestinationProbability(af,0.373);
	lg.setDestinationProbability(ai,0.057);
	lg.setDestinationProbability(aj,0.303);
	lg.setLastDestinationProbability(ak);
		
	lg.setDestinationProbability(ba,0.194);
	lg.setDestinationProbability(bc,0.388);
	lg.setDestinationProbability(bd,0.377);
	lg.setLastDestinationProbability(bf);
	
	lg.setDestinationProbability(cb,0.458);
	lg.setLastDestinationProbability(cd);
	
	lg.setDestinationProbability(db,0.357);
	lg.setDestinationProbability(dc,0.378);
	lg.setDestinationProbability(dh,0.13);
	lg.setLastDestinationProbability(dj);
	
	lg.setDestinationProbability(ea,0.217);
	lg.setDestinationProbability(ef,0.515);
	lg.setLastDestinationProbability(eh);
	
	lg.setDestinationProbability(fa,0.071);
	lg.setDestinationProbability(fb,0.013);
	lg.setDestinationProbability(fe,0.036);
	lg.setDestinationProbability(fj,0.635);
	lg.setLastDestinationProbability(fk);
	
	lg.setLastDestinationProbability(gk);
	
	lg.setDestinationProbability(hd,0.336);
	lg.setDestinationProbability(he,0.342);
	lg.setLastDestinationProbability(hj);
	
	lg.setDestinationProbability(ia,0.374);
	lg.setDestinationProbability(ij,0.245);
	lg.setLastDestinationProbability(ik);
	
	lg.setDestinationProbability(ja,0.148);
	lg.setDestinationProbability(jd,0.032);
	lg.setDestinationProbability(jf,0.488);
	lg.setDestinationProbability(jh,0.12);
	lg.setDestinationProbability(ji,0.04);
	lg.setLastDestinationProbability(jk);

	lg.setDestinationProbability(ka,0.132);
	lg.setDestinationProbability(kf,0.107);
	lg.setDestinationProbability(kg,0.034);
	lg.setDestinationProbability(ki,0.023);
	lg.setLastDestinationProbability(kj);
	
	System.out.println("destination probability set");
	
	m.turnOnLogReport();
	
	// create the experiment to run the model
	Experiment e = new Experiment(m);
	
	// set the parameters of the experiment
	e.setNumberOfReplications(1);
	e.setLengthOfReplication(10000);//15000 - 10 days duration
	e.setLengthOfWarmUp(500.0);
	
	
	// turn on the desired reporting
	e.turnOnBatchReport(); 
	e.turnOnExperimentReport();
	e.turnOnReplicationReport();
//	e.turnOnExperimentConsoleOutput();
	
// tell the experiment to run
	e.runAll();
}

public static void testCaseH(){
	
	System.out.println("Test Case For Truckload Transportation Model : JBHT:Sensitivity Test Case 7");
	
	Model m = Model.createModel();
	
	System.out.println("Model Created");
	
	DistributionIfc tl = new Exponential(1.0);
	
	SpatialModel smodel = new RectangularGridSpatialModel2D();
	
	TransportationNetwork t=new TransportationNetwork(m, smodel);
	
	System.out.println("Here is the Transportation Network");		
	
	Location atlanta = new Location(m,"Atlanta,GA",smodel, new Vector3D(0.0,0.0,0.0));
	Location louisville = new Location(m,"Louisville,KY",smodel,new Vector3D(1.0,2.0,3.0));
	Location detroit = new Location(m,"Detroit,MI",smodel, new Vector3D(5.0,4.0,0.0));
	Location chicago = new Location(m,"Chicago,IL",smodel, new Vector3D(3.0,7.0,0.0));
	Location kansascity = new Location(m,"Kansas City,MO",smodel, new Vector3D(4.0,9.0,0.0));
	Location littlerock = new Location(m,"Little Rock,AR",smodel, new Vector3D(58.0,28.0,0.0));
	Location memphis = new Location(m,"Memphis,TN",smodel, new Vector3D(3.0,5.0,0.0));
	Location lowell = new Location(m,"Lowell,AR",smodel, new Vector3D(3.0,6.0,0.0));
	Location oklacity = new Location(m,"Okla City,OK",smodel, new Vector3D(3.0,7.0,0.0));
	Location dallas = new Location(m,"Dallas,TX",smodel, new Vector3D(3.0,4.0,0.0));
	Location houston = new Location(m,"Houston,TX",smodel, new Vector3D(3.0,8.0,0.0));

	atlanta.setLoadingTimeDistribution(new Constant (1.0));
	louisville.setLoadingTimeDistribution(new Constant (1.0));
	detroit.setLoadingTimeDistribution(new Constant (1.0));
	chicago.setLoadingTimeDistribution(new Constant (1.0));
	kansascity.setLoadingTimeDistribution(new Constant (1.0));
	littlerock.setLoadingTimeDistribution(new Constant (1.0));
	memphis.setLoadingTimeDistribution(new Constant (1.0));
	lowell.setLoadingTimeDistribution(new Constant (1.0));
	oklacity.setLoadingTimeDistribution(new Constant (1.0));
	dallas.setLoadingTimeDistribution(new Constant (1.0));
	houston.setLoadingTimeDistribution(new Constant (1.0));
			
	atlanta.setUnloadingTimeDistribution(new Constant (1.0));
	louisville.setUnloadingTimeDistribution(new Constant (1.0));
	detroit.setUnloadingTimeDistribution(new Constant (1.0));
	chicago.setUnloadingTimeDistribution(new Constant (1.0));
	kansascity.setUnloadingTimeDistribution(new Constant (1.0));
	littlerock.setUnloadingTimeDistribution(new Constant (1.0));
	memphis.setUnloadingTimeDistribution(new Constant (1.0));
	lowell.setUnloadingTimeDistribution(new Constant (1.0));
	oklacity.setUnloadingTimeDistribution(new Constant (1.0));
	dallas.setUnloadingTimeDistribution(new Constant (1.0));
	houston.setUnloadingTimeDistribution(new Constant (1.0));
	
	LaneIfc ab= new Lane(t,atlanta,louisville,436);
	LaneIfc ae= new Lane(t,atlanta,kansascity,862);
	LaneIfc af = new Lane(t,atlanta,littlerock,538);
	LaneIfc ai = new Lane(t,atlanta,oklacity,869);
	LaneIfc aj = new Lane(t,atlanta,dallas,804);
	LaneIfc ak = new Lane(t,atlanta,houston,814);
	
	LaneIfc ba = new Lane(t,louisville,atlanta,436);
	LaneIfc bc = new Lane(t,louisville,detroit,355);
	LaneIfc bd = new Lane(t,louisville,chicago,324);
	LaneIfc bf = new Lane(t,louisville,littlerock,513);
	
	LaneIfc cb = new Lane(t,detroit,louisville,355);
	LaneIfc cd = new Lane(t,detroit,chicago,265);
	
	LaneIfc db= new Lane(t,chicago,louisville,324);
	LaneIfc dc= new Lane(t,chicago,detroit,265);
	LaneIfc dh= new Lane(t,chicago,lowell,610);
	LaneIfc dj= new Lane(t,chicago,dallas,899);

	LaneIfc ea = new Lane(t,kansascity,atlanta,862);
	LaneIfc ef = new Lane(t,kansascity,littlerock,470);
	LaneIfc eh = new Lane(t,kansascity,lowell,289);
	
	LaneIfc fa = new Lane(t,littlerock,atlanta,538);
	LaneIfc fb = new Lane(t,littlerock,louisville,513);
	LaneIfc fe = new Lane(t,littlerock,kansascity,470);
	LaneIfc fj = new Lane(t,littlerock,dallas,341);
	LaneIfc fk = new Lane(t,littlerock,houston,481);
	
	LaneIfc gk = new Lane(t,memphis,houston,575);
	
	LaneIfc hd = new Lane(t,lowell,chicago,610);
	LaneIfc he = new Lane(t,lowell,kansascity,289);
	LaneIfc hj = new Lane(t,lowell,dallas,328);
	
	LaneIfc ia = new Lane(t,oklacity,atlanta,869);
	LaneIfc ij = new Lane(t,oklacity,dallas,233);
	LaneIfc ik = new Lane(t,oklacity,houston,476);
	
	LaneIfc ja = new Lane(t,dallas,atlanta,804);
	LaneIfc jd = new Lane(t,dallas,chicago,899);
	LaneIfc jf = new Lane(t,dallas,littlerock,341);
	LaneIfc jh = new Lane(t,dallas,lowell,328);
	LaneIfc ji = new Lane(t,dallas,oklacity,233);
	LaneIfc jk = new Lane(t,dallas,houston,258);
	
	LaneIfc ka = new Lane(t,houston,atlanta,814);
	LaneIfc kf = new Lane(t,houston,littlerock,481);
	LaneIfc kg = new Lane(t,houston,memphis,575);
	LaneIfc ki = new Lane(t,houston,oklacity,476);
	LaneIfc kj = new Lane(t,houston,dallas,258);
	
	t.addLane(ab);
	t.addLane(ae);
	t.addLane(af);
	t.addLane(ai);
	t.addLane(aj);
	t.addLane(ak);
	
	t.addLane(ba);
	t.addLane(bc);
	t.addLane(bd);
	t.addLane(bf);
	
	t.addLane(cb);
	t.addLane(cd);
	
	t.addLane(db);
	t.addLane(dc);
	t.addLane(dh);
	t.addLane(dj);
	
	t.addLane(ea);
	t.addLane(ef);
	t.addLane(eh);
	
	t.addLane(fa);
	t.addLane(fb);
	t.addLane(fe);
	t.addLane(fj);
	t.addLane(fk);
		
	t.addLane(gk);
	t.addLane(hd);
	t.addLane(he);
	t.addLane(hj);
	
	t.addLane(ia);
	t.addLane(ij);
	t.addLane(ik);
	
	t.addLane(ja);
	t.addLane(jd);
	t.addLane(jf);
	t.addLane(jh);
	t.addLane(ji);
	t.addLane(jk);
	
	t.addLane(ka);
	t.addLane(kf);
	t.addLane(kg);
	t.addLane(ki);
	t.addLane(kj);
	
	System.out.println(t);
	
	AbstractDispatcherFTL d = new DispatcherFTL(m,t,1000.0);
	
	DistributionIfc driverSpeed = new Constant(60.0);
//	 16 drivers for atlanta
	d.addDriver(atlanta,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(atlanta,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(atlanta,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(atlanta,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(atlanta,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(atlanta,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(atlanta,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(atlanta,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(atlanta,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(atlanta,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(atlanta,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(atlanta,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(atlanta,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(atlanta,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(atlanta,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(atlanta,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	
	//14 drivers for louisville
	d.addDriver(louisville,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(louisville,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(louisville,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(louisville,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(louisville,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(louisville,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(louisville,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(louisville,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(louisville,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(louisville,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(louisville,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(louisville,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(louisville,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(louisville,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	
	//14 drivers for detroit
	d.addDriver(detroit,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(detroit,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(detroit,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(detroit,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(detroit,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(detroit,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(detroit,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(detroit,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(detroit,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(detroit,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(detroit,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(detroit,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(detroit,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(detroit,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	
	//16 drivers for chicago
	d.addDriver(chicago,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(chicago,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(chicago,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(chicago,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(chicago,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(chicago,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(chicago,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(chicago,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(chicago,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(chicago,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(chicago,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(chicago,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(chicago,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(chicago,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(chicago,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(chicago,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	
	//12 drivers for kansas city
	d.addDriver(kansascity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(kansascity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(kansascity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(kansascity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(kansascity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(kansascity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(kansascity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(kansascity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(kansascity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(kansascity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(kansascity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(kansascity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	
	//20 drivers for little rock
	d.addDriver(littlerock,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(littlerock,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(littlerock,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(littlerock,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(littlerock,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(littlerock,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(littlerock,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(littlerock,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(littlerock,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(littlerock,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(littlerock,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(littlerock,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(littlerock,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(littlerock,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(littlerock,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(littlerock,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(littlerock,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(littlerock,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(littlerock,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(littlerock,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	
	// 6 drivers for memphis
	d.addDriver(memphis,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(memphis,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(memphis,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(memphis,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(memphis,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(memphis,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	
	//14 drivers for lowell
	d.addDriver(lowell,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(lowell,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(lowell,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(lowell,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(lowell,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(lowell,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(lowell,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(lowell,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(lowell,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(lowell,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(lowell,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(lowell,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(lowell,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(lowell,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	
	// 12 drivers for okla city
	d.addDriver(oklacity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(oklacity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(oklacity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(oklacity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(oklacity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(oklacity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(oklacity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(oklacity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(oklacity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(oklacity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(oklacity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(oklacity,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	
	// 18 drivers for dallas
	d.addDriver(dallas,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(dallas,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(dallas,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(dallas,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(dallas,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(dallas,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(dallas,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(dallas,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(dallas,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(dallas,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(dallas,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(dallas,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(dallas,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(dallas,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(dallas,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(dallas,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(dallas,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(dallas,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	
	// 18 drivers for houston
	d.addDriver(houston,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(houston,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(houston,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(houston,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(houston,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(houston,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(houston,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(houston,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(houston,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(houston,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(houston,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(houston,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(houston,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(houston,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(houston,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(houston,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(houston,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	d.addDriver(houston,14.0,11.0,70.0,new Constant(14.0),new Constant(10.0),new Constant (34.0),driverSpeed);
	
	//12 trucks at atlanta
			
/*	d.addTruck(atlanta);
	d.addTruck(atlanta);
	d.addTruck(atlanta);
	d.addTruck(atlanta);
	d.addTruck(atlanta);
	d.addTruck(atlanta);
*/	d.addTruck(atlanta);
	d.addTruck(atlanta);
	d.addTruck(atlanta);
	d.addTruck(atlanta);
	d.addTruck(atlanta);
	d.addTruck(atlanta);
	
//	5 trucks at louisville
/*	d.addTruck(louisville);
	d.addTruck(louisville);
	d.addTruck(louisville);
	d.addTruck(louisville);
	d.addTruck(louisville);
	d.addTruck(louisville);
*/	d.addTruck(louisville);
	d.addTruck(louisville);
	d.addTruck(louisville);
	d.addTruck(louisville);
	d.addTruck(louisville);
	
//	6 trucks at detroit
/*	d.addTruck(detroit);
	d.addTruck(detroit);
	d.addTruck(detroit);
	d.addTruck(detroit);
	d.addTruck(detroit);
*/	d.addTruck(detroit);
	d.addTruck(detroit);
	d.addTruck(detroit);
	d.addTruck(detroit);
	d.addTruck(detroit);
	d.addTruck(detroit);
	
//	6 trucks at chicago
/*	d.addTruck(chicago);
	d.addTruck(chicago);
	d.addTruck(chicago);
	d.addTruck(chicago);
	d.addTruck(chicago);
	d.addTruck(chicago);
*/	d.addTruck(chicago);
	d.addTruck(chicago);
	d.addTruck(chicago);
	d.addTruck(chicago);
	d.addTruck(chicago);
	d.addTruck(chicago);
	
	//		5 trucks at kansas city
/*	d.addTruck(kansascity);	
	d.addTruck(kansascity);	
	d.addTruck(kansascity);	
	d.addTruck(kansascity);	
	d.addTruck(kansascity);	
*/	d.addTruck(kansascity);	
	d.addTruck(kansascity);	
	d.addTruck(kansascity);	
	d.addTruck(kansascity);	
	d.addTruck(kansascity);	
	
//	7 trucks at littlerock
/*	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	*/d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	d.addTruck(littlerock);
	
//	3 trucks at memphis
	d.addTruck(memphis);
	d.addTruck(memphis);
	d.addTruck(memphis);
/*	d.addTruck(memphis);
	d.addTruck(memphis);
	d.addTruck(memphis);
	d.addTruck(memphis);
*/	
//	6 trucks at lowell
	d.addTruck(lowell);
	d.addTruck(lowell);
	d.addTruck(lowell);
	d.addTruck(lowell);
	d.addTruck(lowell);
	d.addTruck(lowell);
/*	d.addTruck(lowell);
	d.addTruck(lowell);
	d.addTruck(lowell);
	d.addTruck(lowell);
	d.addTruck(lowell);
	*/
	
//	5 trucks at oklacity
//	d.addTruck(oklacity);	
	//d.addTruck(oklacity);	
//	d.addTruck(oklacity);	
//	d.addTruck(oklacity);	
//	d.addTruck(oklacity);	
	d.addTruck(oklacity);	
	d.addTruck(oklacity);	
	d.addTruck(oklacity);	
	d.addTruck(oklacity);	
	d.addTruck(oklacity);	
	
//	6 trucks at dallas
	d.addTruck(dallas);
	d.addTruck(dallas);
	d.addTruck(dallas);
	d.addTruck(dallas);
	d.addTruck(dallas);
	d.addTruck(dallas);
/*	d.addTruck(dallas);
	d.addTruck(dallas);
	d.addTruck(dallas);
	d.addTruck(dallas);
	d.addTruck(dallas);
	d.addTruck(dallas);
	d.addTruck(dallas);
*/	
	
//	7 trucks at houston
	d.addTruck(houston);
	d.addTruck(houston);
	d.addTruck(houston);
	d.addTruck(houston);
	d.addTruck(houston);
	d.addTruck(houston);
	d.addTruck(houston);
/*	d.addTruck(houston);
	d.addTruck(houston);
	d.addTruck(houston);
	d.addTruck(houston);
	d.addTruck(houston);
	d.addTruck(houston);
*/	
//	7 trailers at atlanta		
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
/*	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
	d.addTrailer(atlanta);
*/	
//	6 trailers at louisville
	d.addTrailer(louisville);
	d.addTrailer(louisville);
	d.addTrailer(louisville);
	d.addTrailer(louisville);
	d.addTrailer(louisville);
	d.addTrailer(louisville);
/*	d.addTrailer(louisville);
	d.addTrailer(louisville);
	d.addTrailer(louisville);
	d.addTrailer(louisville);
	d.addTrailer(louisville);
	d.addTrailer(louisville);
	d.addTrailer(louisville);
	*/
	
//	7 trailers at detroit
	d.addTrailer(detroit);
	d.addTrailer(detroit);
	d.addTrailer(detroit);
	d.addTrailer(detroit);
	d.addTrailer(detroit);
	d.addTrailer(detroit);
	d.addTrailer(detroit);
	/*d.addTrailer(detroit);
	d.addTrailer(detroit);
	d.addTrailer(detroit);
	d.addTrailer(detroit);
	d.addTrailer(detroit);
	d.addTrailer(detroit);
*/	
//	7 trailers at chicago
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
/*	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
	d.addTrailer(chicago);
*/	
//	6 trailers at kansas city
	d.addTrailer(kansascity);
	d.addTrailer(kansascity);
	d.addTrailer(kansascity);
	d.addTrailer(kansascity);
	d.addTrailer(kansascity);
	d.addTrailer(kansascity);
/*	d.addTrailer(kansascity);
	d.addTrailer(kansascity);
	d.addTrailer(kansascity);
	d.addTrailer(kansascity);
	d.addTrailer(kansascity);
	d.addTrailer(kansascity);
	*/
//	8 trailers at littlerock
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
/*	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
	d.addTrailer(littlerock);
*/	
//	4 trailers at memphis
	d.addTrailer(memphis);
	d.addTrailer(memphis);
	d.addTrailer(memphis);
	d.addTrailer(memphis);
/*	d.addTrailer(memphis);
	d.addTrailer(memphis);
	d.addTrailer(memphis);
	d.addTrailer(memphis);
	d.addTrailer(memphis);
*/	
//	7 trailers at lowell
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
/*	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
*/	
//	6 trailers at okla city
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
/*	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
	d.addTrailer(lowell);
*/	
//	7 trailers at dallas
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
/*	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
	d.addTrailer(dallas);
*/	
//	8 trailers at houston
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
/*	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
	d.addTrailer(houston);
*/	
	//	Create the Load generator
//	LoadGenerator lg = new LoadGenerator(m,t,tl,tl,new Constant(3000.0)," "); 
	LoadGenerator lg = new LoadGenerator(m,t,tl,tl); 
	
	System.out.println("Here is the load generator");
	
	lg.setOriginProbability(atlanta, 0.097);
	lg.setOriginProbability(louisville, 0.066);
	lg.setOriginProbability(detroit, 0.057);
	lg.setOriginProbability(chicago, 0.082);
	lg.setOriginProbability(kansascity, 0.032);
	lg.setOriginProbability(littlerock, 0.201);
	lg.setOriginProbability(memphis, 0.004);
	lg.setOriginProbability(lowell, 0.052);
	lg.setOriginProbability(oklacity, 0.019);
	lg.setOriginProbability(dallas, 0.272);
	lg.setLastOriginProbability(houston);
	
	System.out.println("origin probability set");
	
	lg.setDestinationProbability(ab,0.087);
	lg.setDestinationProbability(ae,0.072);
	lg.setDestinationProbability(af,0.373);
	lg.setDestinationProbability(ai,0.057);
	lg.setDestinationProbability(aj,0.303);
	lg.setLastDestinationProbability(ak);
		
	lg.setDestinationProbability(ba,0.194);
	lg.setDestinationProbability(bc,0.388);
	lg.setDestinationProbability(bd,0.377);
	lg.setLastDestinationProbability(bf);
	
	lg.setDestinationProbability(cb,0.458);
	lg.setLastDestinationProbability(cd);
	
	lg.setDestinationProbability(db,0.357);
	lg.setDestinationProbability(dc,0.378);
	lg.setDestinationProbability(dh,0.13);
	lg.setLastDestinationProbability(dj);
	
	lg.setDestinationProbability(ea,0.217);
	lg.setDestinationProbability(ef,0.515);
	lg.setLastDestinationProbability(eh);
	
	lg.setDestinationProbability(fa,0.071);
	lg.setDestinationProbability(fb,0.013);
	lg.setDestinationProbability(fe,0.036);
	lg.setDestinationProbability(fj,0.635);
	lg.setLastDestinationProbability(fk);
	
	lg.setLastDestinationProbability(gk);
	
	lg.setDestinationProbability(hd,0.336);
	lg.setDestinationProbability(he,0.342);
	lg.setLastDestinationProbability(hj);
	
	lg.setDestinationProbability(ia,0.374);
	lg.setDestinationProbability(ij,0.245);
	lg.setLastDestinationProbability(ik);
	
	lg.setDestinationProbability(ja,0.148);
	lg.setDestinationProbability(jd,0.032);
	lg.setDestinationProbability(jf,0.488);
	lg.setDestinationProbability(jh,0.12);
	lg.setDestinationProbability(ji,0.04);
	lg.setLastDestinationProbability(jk);

	lg.setDestinationProbability(ka,0.132);
	lg.setDestinationProbability(kf,0.107);
	lg.setDestinationProbability(kg,0.034);
	lg.setDestinationProbability(ki,0.023);
	lg.setLastDestinationProbability(kj);
	
	System.out.println("destination probability set");
	
	m.turnOnLogReport();
	
	// create the experiment to run the model
	Experiment e = new Experiment(m);
	
	// set the parameters of the experiment
	e.setNumberOfReplications(10);
	e.setLengthOfReplication(10000);//15000 - 10 days duration
	e.setLengthOfWarmUp(500.0);
	
	
	// turn on the desired reporting
	e.turnOnBatchReport(); 
	e.turnOnExperimentReport();
	e.turnOnReplicationReport();
//	e.turnOnExperimentConsoleOutput();
	
// tell the experiment to run
	e.runAll();
}
}



